{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gFEditor;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Grids, StdCtrls, Buttons, ComCtrls;

type
  TFEditForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    FESGrid: TStringGrid;
    Panel1: TPanel;
    SizeRGroup: TRadioGroup;
    ClearBtn: TBitBtn;
    FilletBtn: TBitBtn;
    CurrentFilter: TRadioGroup;
    LoadBtn: TBitBtn;
    SaveBtn: TBitBtn;
    HelpBtn: TBitBtn;
    CloseBtn: TBitBtn;
    FilterType: TRadioGroup;
    FullRBtn: TBitBtn;
    phingbtn: TBitBtn;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    FiledFiltersRG: TRadioGroup;
    SpeedButton1: TSpeedButton;
    TabSheet3: TTabSheet;
    RadioGroup2: TRadioGroup;
    TabSheet4: TTabSheet;
    MinEdit: TEdit;
    MaxEdit: TEdit;
    OpenEdit: TEdit;
    OpenEdit2: TEdit;
    CloseEdit: TEdit;
    CloseEdit2: TEdit;
    MedianEdit: TEdit;
    TopHatEdit: TEdit;
    TopHatEdit2: TEdit;
    RollingBallEdit: TEdit;
    RollingBallEdit2: TEdit;
    IRTopHatEdit: TEdit;
    IRTopHatEdit2: TEdit;
    IRRollingBallEdit: TEdit;
    IRRollingBallEdit2: TEdit;
    RangeEdit: TEdit;
    LowRangeEdit: TEdit;
    VarianceEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    FFHelpBtn: TBitBtn;
    FFCloseBtn: TBitBtn;
    FEREHelpBtn: TBitBtn;
    FERECloseBtn: TBitBtn;
    Label6: TLabel;
    FETCloseBtn: TBitBtn;
    FETHelpBtn: TBitBtn;
    AdaptiveEdit1: TEdit;
    AdaptiveEdit2: TEdit;
    redrumEdit1: TEdit;
    redrumEdit2: TEdit;
    redrumEdit3: TEdit;
    GeneralLeeEdit1: TEdit;
    GeneralLeeEdit2: TEdit;
    GeneralLeeEdit3: TEdit;
    GaussianEdit1: TEdit;
    GaussianEdit2: TEdit;
    FractalEdit1: TEdit;
    FractalEdit2: TEdit;
    LowRangeEdit1: TEdit;
    LowRangeEdit2: TEdit;
    RangeEdit1: TEdit;
    RangeEdit2: TEdit;
    VarianceEdit1: TEdit;
    VarianceEdit2: TEdit;
    ASMEdit1: TEdit;
    ASMEdit2: TEdit;
    AVOMNLDEdit1: TEdit;
    AVOMNLDEdit2: TEdit;
    HaralickTexturesBtn: TButton;
    GaussianBtn: TButton;
    FractalBtn: TButton;
    LowRangeBtn: TButton;
    RangeBtn: TButton;
    VarianceBtn: TButton;
    ASMBtn: TButton;
    AVOMNLDBtn: TButton;
    AdaptiveBtn: TButton;
    GeneralLeeBtn: TButton;
    RidgeredrumFinderBtn: TButton;
    RadioGroup1: TRadioGroup;
    FERE_Min: TButton;
    FERE_Max: TButton;
    FERE_Open: TButton;
    FERE_Close: TButton;
    FERE_Median: TButton;
    FERE_Range: TButton;
    FERE_LowRange: TButton;
    FERE_Variance: TButton;
    FERE_TopHat: TButton;
    FERE_RollingBall: TButton;
    FERE_IRTopHat: TButton;
    FERE_IRRollingBall: TButton;
    RR9ingBtn: TBitBtn;
    FilenameLabel: TLabel;
    PhingEdit: TEdit;
    FiledFRG: TRadioGroup;
    StandardTexturesBtn: TButton;
    TogglesRG: TRadioGroup;
    procedure SizeRGroupClick(Sender: TObject);
    procedure Clear;
    procedure CloseBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure FilletBtnClick(Sender: TObject);
    procedure FilterTypeClick(Sender: TObject);
    procedure CurrentFilterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FESGridClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FERE_MinBtnClick(Sender: TObject);
    procedure FERE_MaxBtnClick(Sender: TObject);
    procedure FERE_OpenBtnClick(Sender: TObject);
    procedure FERE_CloseBtnClick(Sender: TObject);
    procedure FERE_MedianBtnClick(Sender: TObject);
    procedure FERE_TopHatBtnClick(Sender: TObject);
    procedure FERE_IRTopHatBtnClick(Sender: TObject);
    procedure FERE_RollingBallBtnClick(Sender: TObject);
    procedure FERE_IRRollingBallBtnClick(Sender: TObject);
    procedure FET_AdaptiveBtnClick(Sender: TObject);
    procedure FERE_VarianceBtnClick(Sender: TObject);
    procedure FERE_RangeBtnClick(Sender: TObject);
    procedure FERE_LowRangeBtnClick(Sender: TObject);
    procedure FFHelpBtnClick(Sender: TObject);
    procedure FETHelpBtnClick(Sender: TObject);
    procedure FEREHelpBtnClick(Sender: TObject);
    procedure FullRBtnClick(Sender: TObject);
    procedure phingbtnClick(Sender: TObject);
    procedure RR9ingBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TogglesRGClick(Sender: TObject);

  private
    { Private declarations }
    procedure SizeR(InSizer: Integer);
    procedure DoLoader(FType: Integer);
    procedure ChangeFilter(iStage: Integer);
  public
    { Public declarations }
  end;
var FEditForm: TFEditForm;


implementation

{$R *.DFM}
uses gGlobal, guTexture, guIPFilter, gMacro, gPBands, gGrip;

var
  IClassFile: file of Integer;
  RClassFile: file of Double; { Files saved with data input }
  Filter3, Filter4, Filter5, Filter6, Filter7, Filter8,
    Filter1, Filter2: array[1..81] of Double;
  ScoreI: array[1..81] of Integer;

{Rower, Counter:Integer;}
  bLoaded, bReal, bInteger, bRotate, bSobel: Boolean;
  iRotate8 {, iSobel }: Integer;

procedure TFEditForm.FormClose(Sender: TObject; var Action:
  TCloseAction);
begin
  FEditFormX := FEditForm.left;
  FEditFormY := FEditForm.top;
  DoSaver;
  FormControl:=8;  
  GRIPForm.FreeForm;  
end;

procedure TFEditForm.CloseBtnClick(Sender: TObject);
begin {ProcessFilter;}
  Close;
end;

procedure TFEditForm.FormCreate(Sender: TObject);
var i: Integer;
begin
  left := FEditFormX;
  top := FEditFormY;
  bReal := True; bInteger := False; bSobel := False; bRotate :=
  False;
  FExt := 'RR3';
  bLoaded := False;
{  OpenDialog1.filter:='Filter files|*.RR?';
  OpenDialog1.DefaultExt:='.RR?';}
  FilterType.ItemIndex := 0;
  CurrentFilter.Color := clBtnFace;
  CurrentFilter.ItemIndex := 0;
  SizeRGroup.ItemIndex := 0;
  iRotate8 := 0;
  for i := 1 to 81 do begin
    Filter1[i] := 0; Filter2[i] := 0; Filter3[i] := 0; Filter4[i] :=
    0;
    Filter5[i] := 0; Filter6[i] := 0; Filter7[i] := 0; Filter8[i] :=
    0;
  end;
end;

procedure TFEditForm.FormShow(Sender: TObject);
begin
  bReal := True; bInteger := False; bSobel := False; bRotate :=
  False;
  bLoaded := False;
  OpenDialog1.filter := 'Filter files|*.RR?';
  OpenDialog1.DefaultExt := '.RR?';
  FilterType.ItemIndex := 0;
  CurrentFilter.Color := clBtnFace;
  CurrentFilter.ItemIndex := 0;
  SizeRGroup.ItemIndex := 0;
  if (Do_Ex_com = True) then TogglesRG.ItemIndex := 1 else
    if (BelowZero = True) then TogglesRG.ItemIndex := 2 else
      if (AutoRange = True) then TogglesRG.ItemIndex := 3 else
      begin ClipR := True; TogglesRG.ItemIndex := 0; end;
end;


procedure TFEditForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(9100); {9100 Call help:Topics}
end;

procedure TFEditForm.FFHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(9200); {9200 Call help:Topics}
end;

procedure TFEditForm.FETHelpBtnClick(Sender: TObject);
begin
{Call help:Topics}
end;

procedure TFEditForm.FEREHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(9400); {9400 Call help:Topics}
end;



procedure TFEditForm.SizeRGroupClick(Sender: TObject);
begin
  SizeR(SizeRGroup.ItemIndex);
end;

procedure TFEditForm.SizeR(InSizer: Integer);
begin
{Process which button was clicked and resize}
  if (not bLoaded) then begin
    case InSizer of
      0: begin {3x3}
          if bInteger then FExt := 'RL3'
          else if bReal then FExt := 'RR3'
          else if bSobel then FExt := 'R23'
          else if bRotate then FExt := 'R83';
          FESGrid.ColCount := 3;
          FESGrid.RowCount := 3;
          FESGrid.DefaultRowHeight := 90;
          FESGrid.DefaultColWidth := 90;
          Clear;
{      FESGrid.Cells[0,1]:= clBlue;;      }
        end;
      1: begin {5x5}
          if bInteger then FExt := 'RL5'
          else if bReal then FExt := 'RR5'
          else if bSobel then FExt := 'R25'
          else if bRotate then FExt := 'R85';
          FESGrid.ColCount := 5;
          FESGrid.RowCount := 5;
          FESGrid.DefaultRowHeight := 54;
          FESGrid.DefaultColWidth := 54;
          Clear;
        end;
      2: begin {7x7}
          if bInteger then FExt := 'RL7'
          else if bReal then FExt := 'RR7'
          else if bSobel then FExt := 'R27'
          else if bRotate then FExt := 'R87';
          FESGrid.ColCount := 7;
          FESGrid.RowCount := 7;
          FESGrid.DefaultRowHeight := 38;
          FESGrid.DefaultColWidth := 38;
          Clear;
        end;
      3: begin {9x9}
          if bInteger then FExt := 'RL9'
          else if bReal then FExt := 'RR9'
          else if bSobel then FExt := 'R29'
          else if bRotate then FExt := 'R89';
          FESGrid.ColCount := 9;
          FESGrid.RowCount := 9;
          FESGrid.DefaultRowHeight := 30;
          FESGrid.DefaultColWidth := 30;
          Clear;
        end; end; {of case}
  end else DoMessages(23);
end;


procedure TFEditForm.ClearBtnClick(Sender: TObject);
begin
  bLoaded := False;
  Clear;
end;

procedure TFEditForm.Clear;
var {CC,CR,}  Rower, Counter: Integer; {ValueS:String;}
begin
{CC:=1;CR:=1;     }
  for Counter := 0 to FESGrid.RowCount - 1 do begin {Down}
    for Rower := 0 to FESGrid.ColCount - 1 do begin {Across}
{Str(CC,ValueS);inc(cc);}
      FESGrid.Cells[Counter, Rower] := '0'; {ValueS;}
    end; end;
end;



procedure TFEditForm.LoadBtnClick(Sender: TObject);
begin
  if bInteger then begin
    OpenDialog1.filter :=
      'Integer Filter files|*.RL3;*.RL5;*.RL7;*.RL9|3x3|*.RL3|5x5|*.RL5|7x7|*.RL7|9x9|*.RL9';
    OpenDialog1.InitialDir := FilterPath;
    DoLoader(1);
  end;
  if bReal then begin
    OpenDialog1.filter :=
      'Real Filter files|*.RR3;*.RR5;*.RR7;*.RR9|3x3|*.RR3|5x5|*.RR5|7x7|*.RR7|9x9|*.RR9';
    OpenDialog1.InitialDir := FilterPath;
    DoLoader(2);
  end;
  if bSobel then begin
    OpenDialog1.filter :=
      'Sobel Filter files|*.R23;*.R25;*.R27;*.R29|3x3|*.R23|5x5|*.R25|7x7|*.R27|9x9|*.R29';
    OpenDialog1.InitialDir := FilterPath;
    DoLoader(3);
  end;
  if bRotate then begin
    OpenDialog1.filter :=
      'Rotate8 Filter files|*.R83;*.R85;*.R87;*.R89|3x3|*.R83|5x5|*.R85|7x7|*.R87|9x9|*.R89';
    OpenDialog1.InitialDir := FilterPath;
    DoLoader(4);
  end;
end;


procedure TFEditForm.DoLoader(FType: Integer);
var InValueS: string; RInValue: Double; IInValue, i: integer;
  Rower, Counter: Integer;
begin
  if OpenDialog1.execute then begin
    FEFilename := OpenDialog1.filename;
    FilenameLabel.Caption := extractfilename(FEFilename);
    bLoaded := False;
    HowMany := WhatsMySize(FEFilename);
    if HowMany = 3 then SizeR(0) else
      if HowMany = 5 then SizeR(1) else
        if HowMany = 7 then SizeR(2) else
          if HowMany = 9 then SizeR(3);
    Application.ProcessMessages;
    bLoaded := True;
    if bInteger then begin
      AssignFile(IClassFile, FEFilename);
      Reset(IClassFile);
      for i := 1 to (HowMany * HowMany) do
        {  While Not Eof(ClassFile) Do}
      begin
        Read(IClassFile, IInValue);
{    Str(IInValue,InValueS);
MessageDlg(InValueS,mtInformation,[mbOk], 0);}
        ScoreI[i] := IInValue;
{           NumberOfScores:=i;}
      end;
      CloseFile(IClassFile);
      i := 1;
      for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
        for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
          IInValue := ScoreI[i]; inc(i);
          Str(IInValue, InValueS);
          FESGrid.Cells[Counter, Rower] := InValueS;
        end;
      end;
    end; {of Integer}
    if bReal then begin
      AssignFile(RClassFile, FEFilename);
      Reset(RClassFile);
      for i := 1 to (HowMany * HowMany) do
        {  While Not Eof(ClassFile) Do}
      begin
        Read(RClassFile, RInValue);
        Filter1[i] := RInValue;
{           NumberOfScores:=i;}
      end;
      CloseFile(RClassFile);
      i := 1;
      for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
        for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
          RInValue := Filter1[i]; inc(i);
          Str(RInValue: 6: 3, InValueS);
          FESGrid.Cells[Counter, Rower] := InValueS;
        end;
      end;
    end; {of Real}
    if bSobel then begin
      AssignFile(RClassFile, FEFilename);
      Reset(RClassFile);
      for i := 1 to (HowMany * HowMany) do
        {  While Not Eof(ClassFile) Do}
      begin
        Read(RClassFile, RInValue);
{    Str(RInValue,InValueS);
MessageDlg(InValueS,mtInformation,[mbOk], 0);}
        Filter1[i] := RInValue;
      end;
      for i := 1 to (HowMany * HowMany) do
        {  While Not Eof(ClassFile) Do}
      begin
        Read(RClassFile, RInValue);
 {   Str(RInValue,InValueS);
MessageDlg(InValueS,mtInformation,[mbOk], 0);}
        Filter2[i] := RInValue;
      end;
      CloseFile(RClassFile);
      i := 1;
      CurrentFilter.ItemIndex := 0;
      for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
        for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
          RInValue := Filter1[i]; inc(i);
          Str(RInValue: 6: 3, InValueS);
          FESGrid.Cells[Counter, Rower] := InValueS;
        end;
      end;
    end; {of Sobel F2*}
    if bRotate then begin
      AssignFile(RClassFile, FEFilename);
      Reset(RClassFile);
      for i := 1 to (HowMany * HowMany) do
        {  While Not Eof(ClassFile) Do}
      begin
        Read(RClassFile, RInValue);
{    Str(RInValue,InValueS);
MessageDlg(InValueS,mtInformation,[mbOk], 0);}
        Filter1[i] := RInValue;
      end;
      for i := 1 to (HowMany * HowMany) do
      begin
        Read(RClassFile, RInValue);
        Filter2[i] := RInValue;
      end;
      for i := 1 to (HowMany * HowMany) do
      begin
        Read(RClassFile, RInValue);
        Filter3[i] := RInValue;
      end;
      for i := 1 to (HowMany * HowMany) do
      begin
        Read(RClassFile, RInValue);
        Filter4[i] := RInValue;
      end;
      for i := 1 to (HowMany * HowMany) do
      begin
        Read(RClassFile, RInValue);
        Filter5[i] := RInValue;
      end;
      for i := 1 to (HowMany * HowMany) do
      begin
        Read(RClassFile, RInValue);
        Filter6[i] := RInValue;
      end;
      for i := 1 to (HowMany * HowMany) do
      begin
        Read(RClassFile, RInValue);
        Filter7[i] := RInValue;
      end;
      for i := 1 to (HowMany * HowMany) do
      begin
        Read(RClassFile, RInValue);
        Filter8[i] := RInValue;
      end;
      CloseFile(RClassFile);
      i := 1;
      CurrentFilter.ItemIndex := 0;
      for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
        for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
          RInValue := Filter1[i]; inc(i);
          Str(RInValue: 6: 3, InValueS);
          FESGrid.Cells[Counter, Rower] := InValueS;
        end;
      end;
    end; {of ROTATE F8*}
  end; end;


procedure TFEditForm.SaveBtnClick(Sender: TObject);
var
  IInValue, i, code, {CC, CR,} Rower, Counter: Integer;
 {Sqrtleft : Extended;} RInValue: Double;
{Left,} InValueS {,ValueS}: string;
begin
  if bInteger then begin
    if FExt = 'RL3' then begin
      SaveDialog1.filter := 'Integer 3x3 files|*.RL3';
      SaveDialog1.DefaultExt := 'RL3';
    end else
      if FExt = 'RL5' then begin
        SaveDialog1.filter := 'Integer 5x5 files|*.RL5';
        SaveDialog1.DefaultExt := 'RL5';
      end else
        if FExt = 'RL7' then begin
          SaveDialog1.filter := 'Integer 7x7 files|*.RL7';
          SaveDialog1.DefaultExt := 'RL7';
        end else
          if FExt = 'RL9' then begin
            SaveDialog1.filter := 'Integer 9x9 files|*.RL9';
            SaveDialog1.DefaultExt := 'RL9';
          end;
    OpenDialog1.InitialDir := FilterPath;
    if SaveDialog1.Execute then begin {Save it}
      FEFilename := (SaveDialog1.Filename);
      HowMany := WhatsMySize(FEFilename);
      i := 1;
      for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
        for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
          InValueS := FESGrid.Cells[Counter, Rower];
          Val(InValueS, IInValue, Code);
          ScoreI[i] := IInValue; inc(i);
        end;
      end;
      AssignFile(IClassFile, FEFilename);
{   If FileExists(FEFilename)then
      Reset(ClassFile)else}
      Rewrite(IClassFile);
      for i := 1 to (HowMany * HowMany) do
        {  While Not Eof(ClassFile) Do}
      begin
        IInValue := ScoreI[i];
        Write(IClassFile, IInValue);
{    Str(IInValue,InValueS);
MessageDlg(InValueS,mtInformation,[mbOk], 0);}
      end;
      CloseFile(IClassFile);
    end;
  end else {integer}
    if bReal then begin
      if FExt = 'RR3' then begin
        SaveDialog1.filter := 'Real 3x3 files|*.RR3';
        SaveDialog1.DefaultExt := 'RR3';
      end else
        if FExt = 'RR5' then begin
          SaveDialog1.filter := 'Real 5x5 files|*.RR5';
          SaveDialog1.DefaultExt := 'RR5';
        end else
          if FExt = 'RR7' then begin
            SaveDialog1.filter := 'Real 7x7 files|*.RR7';
            SaveDialog1.DefaultExt := 'RR7';
          end else
            if FExt = 'RR9' then begin
              SaveDialog1.filter := 'Real 9x9 files|*.RR9';
              SaveDialog1.DefaultExt := 'RR9';
            end;
      OpenDialog1.InitialDir := FilterPath;
      if SaveDialog1.Execute then begin {Save it}
        FEFilename := (SaveDialog1.Filename);
        HowMany := WhatsMySize(FEFilename);
        i := 1;
        for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
          for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
            InValueS := FESGrid.Cells[Counter, Rower];
            Val(InValueS, RInValue, Code);
            Filter1[i] := RInValue; inc(i);
          end;
        end;
        AssignFile(RClassFile, FEFilename);
{   If FileExists(FEFilename)then
      Reset(ClassFile)else}
        Rewrite(RClassFile);
        for i := 1 to (HowMany * HowMany) do
          {  While Not Eof(ClassFile) Do}
        begin
          RInValue := Filter1[i];
          Write(RClassFile, RInValue);
        end;
        CloseFile(RClassFile);
      end;
    end else {Real}
      if bSobel then begin
        if FExt = 'R23' then begin
          SaveDialog1.filter := 'Sobel 3x3 files|*.R23';
          SaveDialog1.DefaultExt := 'R23';
        end else
          if FExt = 'R25' then begin
            SaveDialog1.filter := 'Sobel 5x5 files|*.R25';
            SaveDialog1.DefaultExt := 'R25';
          end else
            if FExt = 'R27' then begin
              SaveDialog1.filter := 'Sobel 7x7 files|*.R27';
              SaveDialog1.DefaultExt := 'R27';
            end else
              if FExt = 'R29' then begin
                SaveDialog1.filter := 'Sobel 9x9 files|*.R29';
                SaveDialog1.DefaultExt := 'R29';
              end;
        OpenDialog1.InitialDir := FilterPath;
        if SaveDialog1.Execute then begin {Save it}
          FEFilename := (SaveDialog1.Filename);
          HowMany := WhatsMySize(FEFilename);
{   if CurrentFilter.ItemIndex=1 then begin
   ChangeFilter(0);CurrentFilter.ItemIndex:=0;end;
   Application.ProcessMessages;
   ChangeFilter(1);CurrentFilter.ItemIndex:=1;}
(*   i:=1;
   for Rower := 0 to FESGrid.RowCount-1 do Begin {Down}
    for Counter := 0 to FESGrid.ColCount-1 do Begin {Across}
    InValueS:=FESGrid.Cells[Counter,Rower];
    Val(InValueS,RInValue,Code);
    Filter1[i]:=RInValue;inc(i);
    end;
   end;
   ChangeFilter(1);CurrentFilter.ItemIndex:=1;
   i:=1;
   for Rower := 0 to FESGrid.RowCount-1 do Begin {Down}
    for Counter := 0 to FESGrid.ColCount-1 do Begin {Across}
    InValueS:=FESGrid.Cells[Counter,Rower];
    Val(InValueS,RInValue,Code);
    Filter2[i]:=RInValue;inc(i);
    end;
   end;*)
          AssignFile(RClassFile, FEFilename);
{   If FileExists(FEFilename)then
      Reset(ClassFile)else}
          Rewrite(RClassFile);
          for i := 1 to (HowMany * HowMany) do
            {  While Not Eof(ClassFile) Do}
          begin
            RInValue := Filter1[i];
{    Str(RInValue,InValueS);
MessageDlg(InValueS,mtInformation,[mbOk], 0);}
            Write(RClassFile, RInValue);
          end;
          for i := 1 to (HowMany * HowMany) do
            {  While Not Eof(ClassFile) Do}
          begin
            RInValue := Filter2[i];
{    Str(RInValue,InValueS);
MessageDlg(InValueS,mtInformation,[mbOk], 0);}
            Write(RClassFile, RInValue);
          end;
          CloseFile(RClassFile);
        end;
      end else {SOBEL}
        if bRotate then begin
          if FExt = 'R83' then begin
            SaveDialog1.filter := 'Rotate 8 3x3 files|*.R83';
            SaveDialog1.DefaultExt := 'R83';
          end else
            if FExt = 'R85' then begin
              SaveDialog1.filter := 'Rotate 8 5x5 files|*.R85';
              SaveDialog1.DefaultExt := 'R85';
            end else
              if FExt = 'R87' then begin
                SaveDialog1.filter := 'Rotate 8 7x7 files|*.R87';
                SaveDialog1.DefaultExt := 'R87';
              end else
                if FExt = 'R89' then begin
                  SaveDialog1.filter := 'Rotate 8 9x9 files|*.R89';
                  SaveDialog1.DefaultExt := 'R89';
                end;
          OpenDialog1.InitialDir := FilterPath;
          if SaveDialog1.Execute then begin {Save it}
            FEFilename := (SaveDialog1.Filename);
            HowMany := WhatsMySize(FEFilename);
{   if CurrentFilter.ItemIndex=1 then begin
   ChangeFilter(0);CurrentFilter.ItemIndex:=0;end;
   Application.ProcessMessages;
   ChangeFilter(1);CurrentFilter.ItemIndex:=1;}
(*   i:=1;
   for Rower := 0 to FESGrid.RowCount-1 do Begin {Down}
    for Counter := 0 to FESGrid.ColCount-1 do Begin {Across}
    InValueS:=FESGrid.Cells[Counter,Rower];
    Val(InValueS,RInValue,Code);
    Filter1[i]:=RInValue;inc(i);
    end;
   end;
   ChangeFilter(1);CurrentFilter.ItemIndex:=1;
   i:=1;
   for Rower := 0 to FESGrid.RowCount-1 do Begin {Down}
    for Counter := 0 to FESGrid.ColCount-1 do Begin {Across}
    InValueS:=FESGrid.Cells[Counter,Rower];
    Val(InValueS,RInValue,Code);
    Filter2[i]:=RInValue;inc(i);
    end;
   end;*)
            AssignFile(RClassFile, FEFilename);
{   If FileExists(FEFilename)then
      Reset(ClassFile)else}
            Rewrite(RClassFile);
            for i := 1 to (HowMany * HowMany) do
              {  While Not Eof(ClassFile) Do}
            begin
              RInValue := Filter1[i];
{    Str(RInValue,InValueS);
MessageDlg(InValueS,mtInformation,[mbOk], 0);}
              Write(RClassFile, RInValue);
            end;
            for i := 1 to (HowMany * HowMany) do
            begin
              RInValue := Filter2[i];
              Write(RClassFile, RInValue);
            end;
            for i := 1 to (HowMany * HowMany) do
            begin
              RInValue := Filter3[i];
              Write(RClassFile, RInValue);
            end;
            for i := 1 to (HowMany * HowMany) do
            begin
              RInValue := Filter4[i];
              Write(RClassFile, RInValue);
            end;
            for i := 1 to (HowMany * HowMany) do
            begin
              RInValue := Filter5[i];
              Write(RClassFile, RInValue);
            end;
            for i := 1 to (HowMany * HowMany) do
            begin
              RInValue := Filter6[i];
              Write(RClassFile, RInValue);
            end;
            for i := 1 to (HowMany * HowMany) do
            begin
              RInValue := Filter7[i];
              Write(RClassFile, RInValue);
            end;
            for i := 1 to (HowMany * HowMany) do
            begin
              RInValue := Filter8[i];
              Write(RClassFile, RInValue);
            end;
            CloseFile(RClassFile);
          end;
        end; {ROTATE}
end;

procedure TFEditForm.FilletBtnClick(Sender: TObject);
var
  code, Sign: Integer;
  Left {,ValueS}: string;
  Sqrtleft: Extended;
begin
  if ((FExt = 'RR3') or (FExt = 'R23') or (FExt = 'R83')) then begin
    Left := FESGrid.Cells[1, 0];
    val(left, Sqrtleft, code);
    if (code = 0) then begin
      if (Sqrtleft > 0) then Sign := 1 else sign := -1;
      Str((Sqrtleft): 5: 4, left);
      FESGrid.Cells[0, 1] := Left;
      FESGrid.Cells[2, 1] := Left;
      FESGrid.Cells[1, 0] := Left;
      FESGrid.Cells[1, 2] := Left;
{       val(left,Sqrtleft,code);}
      if (sign < 0) then
        Str((Sqrt(abs(Sqrtleft))): 5: 4, left) else
        Str((-1 * Sqrt(abs(Sqrtleft))): 5: 4, left);
      FESGrid.Cells[0, 0] := Left;
      FESGrid.Cells[0, 2] := Left;
      FESGrid.Cells[2, 0] := Left;
      FESGrid.Cells[2, 2] := Left;
       {CENTER}
{        Multe:=(-2 * Sqrtleft);  }
      Str((-2 * Sqrtleft): 5: 4, left);
      FESGrid.Cells[1, 1] := Left;
{        if (sign < 0) then
Sqrtleft:=( (4*Sqrtleft) + (4*(Sqrt(abs(Sqrtleft)))))
       else
Sqrtleft:=( (4*Sqrtleft) + (-4*(Sqrt(abs(Sqrtleft)))));
       Str((-Sqrtleft):5:4, left);
          FESGrid.Cells[1,1]:=Left;}
    end else DoMessages(24);
  end;
end;


procedure TFEditForm.FullRBtnClick(Sender: TObject);
var
  code, Sign: Integer;
  Left {,ValueS}: string;
  Multe, Sqrt2, Sqrtleft: Extended;
begin
  if ((FExt = 'RR5') or (FExt = 'R25') or (FExt = 'R85')) then begin
    Left := FESGrid.Cells[2, 0];
    val(left, Sqrtleft, code);
    if (code = 0) then begin
      if (Sqrtleft > 0) then Sign := 1 else sign := -1;
      FESGrid.Cells[0, 2] := Left; {outer}
      FESGrid.Cells[4, 2] := Left;
      FESGrid.Cells[2, 0] := Left;
      FESGrid.Cells[2, 4] := Left;
      Multe := (-sign * abs(Sqrtleft));
      Str(Multe: 5: 4, left);
      FESGrid.Cells[1, 2] := Left; {inner}
      FESGrid.Cells[3, 2] := Left;
      FESGrid.Cells[2, 1] := Left;
      FESGrid.Cells[2, 3] := Left;
       {CENTER}
      Multe := (-2 * Sqrtleft);
      Str(Multe: 5: 4, left);
      FESGrid.Cells[2, 2] := Left;
      Sqrt2 := sign * Sqrt(abs(Sqrtleft));
      Str(Sqrt2: 5: 4, left);
      FESGrid.Cells[0, 1] := Left; {outer}
      FESGrid.Cells[0, 3] := Left;
      FESGrid.Cells[1, 0] := Left;
      FESGrid.Cells[1, 4] := Left;
      FESGrid.Cells[3, 0] := Left;
      FESGrid.Cells[3, 4] := Left;
      FESGrid.Cells[4, 1] := Left;
      FESGrid.Cells[4, 3] := Left;
      Multe := (-sign * abs(Sqrt2));
      Str(Multe: 5: 4, left);
      FESGrid.Cells[1, 1] := Left; {inner}
      FESGrid.Cells[1, 3] := Left;
      FESGrid.Cells[3, 1] := Left;
      FESGrid.Cells[3, 3] := Left;
{Sqrtleft:=( (sign *Sqrtleft) + ((-sign *Sqrt(abs(Sqrtleft)))));
       Str((sign *Sqrtleft):5:4, left);
          FESGrid.Cells[2,2]:=Left;}
    end else DoMessages(24);
  end;
end;

procedure TFEditForm.phingbtnClick(Sender: TObject);
var
  phingphactor, code, X, Z: Integer;
  Totaler, R, Y: Extended; left: string;
begin
  Totaler := 0;
  if ((FExt = 'RR3') or (FExt = 'R23') or (FExt = 'R83')) then begin
    left := PhingEdit.Text;
    val(left, phingphactor, code);
    for X := 0 to 2 do begin
      for Z := 0 to 2 do begin
        R := SQRT(sqr(X - 1) + sqr(Z - 1)) * phingphactor;
        if ((X = 1) and (Z = 1)) then Y := 0 else begin
          Y := (SIN(R) / R);
          Totaler := Totaler + Y;
        end;
        Str(Y: 5: 4, left);
        FESGrid.Cells[X, Z] := Left;
      end; end;
    Str((-1 * Totaler): 5: 4, left);
    FESGrid.Cells[1, 1] := left;
  end else
    if ((FExt = 'RR5') or (FExt = 'R25') or (FExt = 'R85')) then begin
      left := PhingEdit.Text;
      val(left, phingphactor, code);
      for X := 0 to 4 do begin
        for Z := 0 to 4 do begin
          R := SQRT(sqr(X - 2) + sqr(Z - 2)) * phingphactor;
          if ((X = 2) and (Z = 2)) then Y := 0 else begin
            Y := (SIN(R) / R);
            Totaler := Totaler + Y;
          end;
          Str(Y: 5: 4, left);
          FESGrid.Cells[X, Z] := Left;
        end; end;
      Str((-1 * Totaler): 5: 4, left);
      FESGrid.Cells[2, 2] := left;
    end else
      if ((FExt = 'RR7') or (FExt = 'R27') or (FExt = 'R87')) then
      begin
        left := PhingEdit.Text;
        val(left, phingphactor, code);
        for X := 0 to 6 do begin
          for Z := 0 to 6 do begin
            R := SQRT(sqr(X - 3) + sqr(Z - 3)) * phingphactor;
            if ((X = 3) and (Z = 3)) then Y := 0 else begin
              Y := (SIN(R) / R);
              Totaler := Totaler + Y;
            end;
            Str(Y: 5: 4, left);
            FESGrid.Cells[X, Z] := Left;
          end; end;
        Str((-1 * Totaler): 5: 4, left);
        FESGrid.Cells[3, 3] := left;
      end else
        if ((FExt = 'RR9') or (FExt = 'R29') or (FExt = 'R89')) then
        begin
          left := PhingEdit.Text;
          val(left, phingphactor, code);
          for X := 0 to 8 do begin
            for Z := 0 to 8 do begin
              R := SQRT(sqr(X - 4) + sqr(Z - 4)) * phingphactor;
              if ((X = 4) and (Z = 4)) then Y := 0 else begin
                Y := (SIN(R) / R);
                Totaler := Totaler + Y;
              end;
              Str(Y: 5: 4, left);
              FESGrid.Cells[X, Z] := Left;
            end; end;
          Str((-1 * Totaler): 5: 4, left);
          FESGrid.Cells[4, 4] := left;
        end;
end;

procedure TFEditForm.RR9ingBtnClick(Sender: TObject);
var
  phingphactor, code, X, Z: Integer;
  Totaler, R, Y: Extended; left: string;
begin
  Totaler := 0;
  if ((FExt = 'RR3') or (FExt = 'R23') or (FExt = 'R83')) then begin
    left := PhingEdit.Text;
    val(left, phingphactor, code);
    for X := 0 to 2 do begin
      for Z := 0 to 2 do begin
        R := SQRT(sqr(X - 1) + sqr(Z - 1)) * phingphactor;
        if ((X = 1) and (Z = 1)) then Y := 0 else begin
          Y := (COS(R) / R);
          Totaler := Totaler + Y;
        end;
        Str(Y: 5: 4, left);
        FESGrid.Cells[X, Z] := Left;
      end; end;
    Str((-1 * Totaler): 5: 4, left);
    FESGrid.Cells[1, 1] := left;
  end else
    if ((FExt = 'RR5') or (FExt = 'R25') or (FExt = 'R85')) then begin
      left := PhingEdit.Text;
      val(left, phingphactor, code);
      for X := 0 to 4 do begin
        for Z := 0 to 4 do begin
          R := SQRT(sqr(X - 2) + sqr(Z - 2)) * phingphactor;
          if ((X = 2) and (Z = 2)) then Y := 0 else begin
            Y := (COS(R) / R);
            Totaler := Totaler + Y;
          end;
          Str(Y: 5: 4, left);
          FESGrid.Cells[X, Z] := Left;
        end; end;
      Str((-1 * Totaler): 5: 4, left);
      FESGrid.Cells[2, 2] := left;
    end else
      if ((FExt = 'RR7') or (FExt = 'R27') or (FExt = 'R87')) then
      begin
        left := PhingEdit.Text;
        val(left, phingphactor, code);
        for X := 0 to 6 do begin
          for Z := 0 to 6 do begin
            R := SQRT(sqr(X - 3) + sqr(Z - 3)) * phingphactor;
            if ((X = 3) and (Z = 3)) then Y := 0 else begin
              Y := (COS(R) / R);
              Totaler := Totaler + Y;
            end;
            Str(Y: 5: 4, left);
            FESGrid.Cells[X, Z] := Left;
          end; end;
        Str((-1 * Totaler): 5: 4, left);
        FESGrid.Cells[3, 3] := left;
      end else
        if ((FExt = 'RR9') or (FExt = 'R29') or (FExt = 'R89')) then
        begin
          left := PhingEdit.Text;
          val(left, phingphactor, code);
          for X := 0 to 8 do begin
            for Z := 0 to 8 do begin
              R := SQRT(sqr(X - 4) + sqr(Z - 4)) * phingphactor;
              if ((X = 4) and (Z = 4)) then Y := 0 else begin
                Y := (COS(R) / R);
                Totaler := Totaler + Y;
              end;
              Str(Y: 5: 4, left);
              FESGrid.Cells[X, Z] := Left;
            end; end;
          Str((-1 * Totaler): 5: 4, left);
          FESGrid.Cells[4, 4] := left;
        end;
end;


procedure TFEditForm.FilterTypeClick(Sender: TObject);
var Incoming, FilterI: Integer;
begin
  Incoming := FilterType.ItemIndex;
  if (not bLoaded) then begin
    FilterI := FilterType.ItemIndex;
    case FilterI of
      0: begin {Real}
          bReal := True; bInteger := False; bSobel := False; bRotate
          := False;
          if bReal then CurrentFilter.Color := clBtnFace;
          CurrentFilter.ItemIndex := 0;
        end;
      1: begin {Integer}
          bReal := False; bInteger := True; bSobel := False; bRotate
          := False;
          if bInteger then CurrentFilter.Color := clBtnFace;
          CurrentFilter.ItemIndex := 0;
        end;
      2: begin {Sobel 2}
          bReal := False; bInteger := False; bSobel := True; bRotate
          := False;
          if bSobel then CurrentFilter.Color := clRed else
            CurrentFilter.Color := clBtnFace;
          CurrentFilter.ItemIndex := 0;
        end;
      3: begin {Rotate 8}
          bReal := False; bInteger := False; bSobel := False; bRotate
          := True;
          if bRotate then CurrentFilter.Color := clRed else
            CurrentFilter.Color := clBtnFace;
          CurrentFilter.ItemIndex := 0;
        end;
    end; {of Case}
    SizeR(SizeRGroup.ItemIndex);
  end else begin
    FilterType.ItemIndex := Incoming;
    DoMessages(23);
  end;
end;

procedure TFEditForm.CurrentFilterClick(Sender: TObject);
var iFilter: Integer;
begin
  if bLoaded then begin
    iFilter := CurrentFilter.ItemIndex;
    case iFilter of
      0: begin {1}
          ChangeFilter(0);
        end;
      1: begin {1}
          if (bSobel or bRotate) then ChangeFilter(1)
          else begin
            DoMessages(22);
            CurrentFilter.ItemIndex := 0;
          end;
        end;
      2: begin {1}
          if (not bRotate) then begin
            CurrentFilter.ItemIndex := 0;
      {Message that Sobel has only 2 Stages}
            DoMessages(21);
          end;
          if bRotate then ChangeFilter(2);
        end;
      3: begin {1}
          if (not bRotate) then begin
            CurrentFilter.ItemIndex := 0;
      {Message that Sobel has only 2 Stages}
            DoMessages(21);
          end else if bRotate then ChangeFilter(3);
        end;
      4: begin {1}
          if (not bRotate) then begin
            CurrentFilter.ItemIndex := 0;
      {Message that Sobel has only 2 Stages}
            DoMessages(21);
          end else if bRotate then ChangeFilter(4);
        end;
      5: begin {1}
          if (not bRotate) then begin
            CurrentFilter.ItemIndex := 0;
      {Message that Sobel has only 2 Stages}
            DoMessages(21);
          end else if bRotate then ChangeFilter(5);
        end;
      6: begin {1}
          if (not bRotate) then begin
            CurrentFilter.ItemIndex := 0;
      {Message that Sobel has only 2 Stages}
            DoMessages(21);
          end else if bRotate then ChangeFilter(6);
        end;
      7: begin {1}
          if (not bRotate) then begin
            CurrentFilter.ItemIndex := 0;
      {Message that Sobel has only 2 Stages}
            DoMessages(21);
          end else if bRotate then ChangeFilter(7);
        end;
    end; {of case}
  end else DoMessages(20);
end;


procedure TFEditForm.FESGridClick(Sender: TObject);
begin
  bLoaded := True;
end;


procedure TFEditForm.ChangeFilter(iStage: Integer);
var
  Code, i {,IInValue,  CC, CR,}, Rower, Counter: Integer;
{Sqrtleft : Extended;  } RInValue: Double;
{ValueS,Left,} InValueS: string;
begin
  if bSobel then begin
    case iStage of
      0: begin
          i := 1;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              InValueS := FESGrid.Cells[Counter, Rower];
              Val(InValueS, RInValue, Code);
              Filter2[i] := RInValue; inc(i);
            end;
          end;
          i := 1;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              RInValue := Filter1[i]; inc(i);
              Str(RInValue: 6: 3, InValueS);
              FESGrid.Cells[Counter, Rower] := InValueS;
            end;
          end;
        end;
      1: begin
          i := 1;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              InValueS := FESGrid.Cells[Counter, Rower];
              Val(InValueS, RInValue, Code);
              Filter1[i] := RInValue; inc(i);
            end;
          end;
          i := 1;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              RInValue := Filter2[i]; inc(i);
              Str(RInValue: 6: 3, InValueS);
              FESGrid.Cells[Counter, Rower] := InValueS;
            end;
          end;
        end;
    end; {of case} end {of Sobel}
  else if bRotate then begin
    case iRotate8 of
      0: begin
          i := 1;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              InValueS := FESGrid.Cells[Counter, Rower];
              Val(InValueS, RInValue, Code);
              Filter1[i] := RInValue; inc(i);
            end;
          end; end;
      1: begin
          i := 1;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              InValueS := FESGrid.Cells[Counter, Rower];
              Val(InValueS, RInValue, Code);
              Filter2[i] := RInValue; inc(i);
            end;
          end; end;
      2: begin
          i := 1;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              InValueS := FESGrid.Cells[Counter, Rower];
              Val(InValueS, RInValue, Code);
              Filter3[i] := RInValue; inc(i);
            end;
          end; end;
      3: begin
          i := 1;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              InValueS := FESGrid.Cells[Counter, Rower];
              Val(InValueS, RInValue, Code);
              Filter4[i] := RInValue; inc(i);
            end;
          end; end;
      4: begin
          i := 1;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              InValueS := FESGrid.Cells[Counter, Rower];
              Val(InValueS, RInValue, Code);
              Filter5[i] := RInValue; inc(i);
            end;
          end; end;
      5: begin
          i := 1;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              InValueS := FESGrid.Cells[Counter, Rower];
              Val(InValueS, RInValue, Code);
              Filter6[i] := RInValue; inc(i);
            end;
          end; end;
      6: begin
          i := 1;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              InValueS := FESGrid.Cells[Counter, Rower];
              Val(InValueS, RInValue, Code);
              Filter7[i] := RInValue; inc(i);
            end;
          end; end;
      7: begin
          i := 1;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              InValueS := FESGrid.Cells[Counter, Rower];
              Val(InValueS, RInValue, Code);
              Filter8[i] := RInValue; inc(i);
            end;
          end; end;
    end; {of case}
    case iStage of
      0: begin
          i := 1; iRotate8 := 0;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              RInValue := Filter1[i]; inc(i);
              Str(RInValue: 6: 3, InValueS);
              FESGrid.Cells[Counter, Rower] := InValueS;
            end;
          end;
        end;
      1: begin
          i := 1; iRotate8 := 1;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              RInValue := Filter2[i]; inc(i);
              Str(RInValue: 6: 3, InValueS);
              FESGrid.Cells[Counter, Rower] := InValueS;
            end;
          end;
        end;
      2: begin
          i := 1; iRotate8 := 2;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              RInValue := Filter3[i]; inc(i);
              Str(RInValue: 6: 3, InValueS);
              FESGrid.Cells[Counter, Rower] := InValueS;
            end;
          end;
        end;
      3: begin
          i := 1; iRotate8 := 3;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              RInValue := Filter4[i]; inc(i);
              Str(RInValue: 6: 3, InValueS);
              FESGrid.Cells[Counter, Rower] := InValueS;
            end;
          end;
        end;
      4: begin
          i := 1; iRotate8 := 4;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              RInValue := Filter5[i]; inc(i);
              Str(RInValue: 6: 3, InValueS);
              FESGrid.Cells[Counter, Rower] := InValueS;
            end;
          end;
        end;
      5: begin
          i := 1; iRotate8 := 5;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              RInValue := Filter6[i]; inc(i);
              Str(RInValue: 6: 3, InValueS);
              FESGrid.Cells[Counter, Rower] := InValueS;
            end;
          end;
        end;
      6: begin
          i := 1; iRotate8 := 6;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              RInValue := Filter7[i]; inc(i);
              Str(RInValue: 6: 3, InValueS);
              FESGrid.Cells[Counter, Rower] := InValueS;
            end;
          end;
        end;
      7: begin
          i := 1; iRotate8 := 7;
          for Rower := 0 to FESGrid.RowCount - 1 do begin {Down}
            for Counter := 0 to FESGrid.ColCount - 1 do begin {Across}
              RInValue := Filter8[i]; inc(i);
              Str(RInValue: 6: 3, InValueS);
              FESGrid.Cells[Counter, Rower] := InValueS;
            end;
          end;
        end;
    end; {of case} end; {of ROTATE 8}
end;

procedure TFEditForm.SpeedButton1Click(Sender: TObject);
var Choosy, Choice: Integer;
begin
  Choosy := FiledFRG.ItemIndex;
  case Choosy of
    0: begin
        Image_Add := False;
        Image_Subtract := False;
      end;
    1: begin
        Image_Add := True;
        Image_Subtract := False;
      end;
    2: begin
        Image_Add := False;
        Image_Subtract := True;
      end;
  end;

  Choice := FiledFiltersRG.ItemIndex;
  case Choice of
    0: begin
        OpenDialog1.filter :=
          'Integer Filter files|*.RL3;*.RL5;*.RL7;*.RL9|3x3|*.RL3|5x5|*.RL5|7x7|*.RL7|9x9|*.RL9';
        OpenDialog1.InitialDir := FilterPath;
        if OpenDialog1.execute then begin
          Screen.Cursor := CRHOURGLASS;
          FilterPath := ExtractFilePath(OpenDialog1.filename);
          if LoggingToMacro then
          begin
            MacroForm.MacroRE.Lines.Add('=0301  Do_IntegerFile');
            MacroForm.MacroRE.Lines.Add(FilterPath);
            MacroForm.MacroRE.Lines.Add(OpenDialog1.filename);
            MacroForm.MacroRE.Lines.Add(IntToStr(Choosy));
            if AUTORANGE then MacroForm.MacroRE.Lines.Add(IntToStr(1))
            else MacroForm.MacroRE.Lines.Add(IntToStr(0));
          end;
          if LoggingToDIP then
          begin
            PBands.DIPMemo.Lines.Add('=0301  Do_IntegerFile');
            PBands.DIPMemo.Lines.Add(FilterPath);
            PBands.DIPMemo.Lines.Add(OpenDialog1.filename);
            PBands.DIPMemo.Lines.Add(IntToStr(Choosy));
            if AUTORANGE then PBands.DIPMemo.Lines.Add(IntToStr(1))
            else PBands.DIPMemo.Lines.Add(IntToStr(0));
            PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
            PBands.DIPSaveIt;
          end;
          if AUTORANGE then Do_IntegerFile(OpenDialog1.filename, 1)
          else Do_IntegerFile(OpenDialog1.filename, 0);
          Screen.Cursor := CRDEFAULT;
        end;
      end;
    1: begin
        OpenDialog1.filter :=
          'Real Filter files|*.RR3;*.RR5;*.RR7;*.RR9|3x3|*.RR3|5x5|*.RR5|7x7|*.RR7|9x9|*.RR9';
        OpenDialog1.InitialDir := FilterPath;
        if OpenDialog1.execute then begin
          Screen.Cursor := CRHOURGLASS;
          FilterPath := ExtractFilePath(OpenDialog1.filename);
          if LoggingToMacro then
          begin
            MacroForm.MacroRE.Lines.Add('=0302  Do_RealFile');
            MacroForm.MacroRE.Lines.Add(FilterPath);
            MacroForm.MacroRE.Lines.Add(OpenDialog1.filename);
            MacroForm.MacroRE.Lines.Add(IntToStr(Choosy));
            if AUTORANGE then MacroForm.MacroRE.Lines.Add(IntToStr(1))
            else MacroForm.MacroRE.Lines.Add(IntToStr(0));
          end;
          if AUTORANGE then Do_RealFile(OpenDialog1.filename, 1)
          else Do_RealFile(OpenDialog1.filename, 0);
          Screen.Cursor := CRDEFAULT;
        end;
      end;
    2: begin
        OpenDialog1.filter :=
          'Sobel Filter files|*.R23;*.R25;*.R27;*.R29|3x3|*.R23|5x5|*.R25|7x7|*.R27|9x9|*.R29';
        OpenDialog1.InitialDir := FilterPath;
        if OpenDialog1.execute then begin
          Screen.Cursor := CRHOURGLASS;
          FilterPath := ExtractFilePath(OpenDialog1.filename);
          if LoggingToMacro then
          begin
            MacroForm.MacroRE.Lines.Add('=0303  Do_SobelFile');
            MacroForm.MacroRE.Lines.Add(FilterPath);
            MacroForm.MacroRE.Lines.Add(OpenDialog1.filename);
            MacroForm.MacroRE.Lines.Add(IntToStr(Choosy));
            if AUTORANGE then MacroForm.MacroRE.Lines.Add(IntToStr(1))
            else MacroForm.MacroRE.Lines.Add(IntToStr(0));
          end;
          if AUTORANGE then Do_SobelFile(OpenDialog1.filename, 1)
          else Do_SobelFile(OpenDialog1.filename, 0);
          Screen.Cursor := CRDEFAULT;
        end;
      end;
    3: begin
  {ISF_SobelsDOG}
        OpenDialog1.filter :=
          'Sobel Filter files|*.R23;*.R25;*.R27;*.R29|3x3|*.R23|5x5|*.R25|7x7|*.R27|9x9|*.R29';
        OpenDialog1.InitialDir := FilterPath;
        if OpenDialog1.execute then begin
          Screen.Cursor := CRHOURGLASS;
          FilterPath := ExtractFilePath(OpenDialog1.filename);
          if LoggingToMacro then
          begin
            MacroForm.MacroRE.Lines.Add('=0304  Do_SoDogFile');
            MacroForm.MacroRE.Lines.Add(FilterPath);
            MacroForm.MacroRE.Lines.Add(OpenDialog1.filename);
            MacroForm.MacroRE.Lines.Add(IntToStr(Choosy));
            if AUTORANGE then MacroForm.MacroRE.Lines.Add(IntToStr(1))
            else MacroForm.MacroRE.Lines.Add(IntToStr(0));
          end;
          if AUTORANGE then Do_SoDogFile(OpenDialog1.filename, 1)
          else Do_SoDogFile(OpenDialog1.filename, 0);
          Screen.Cursor := CRDEFAULT;
        end;
      end;
    4: begin
{ISF_Rotate8SQRT}
        OpenDialog1.filter :=
          'Rotate8 Filter files|*.R83;*.R85;*.R87;*.R89|3x3|*.R83|5x5|*.R85|7x7|*.R87|9x9|*.R89';
        OpenDialog1.InitialDir := FilterPath;
        if OpenDialog1.execute then begin
          Screen.Cursor := CRHOURGLASS;
          FilterPath := ExtractFilePath(OpenDialog1.filename);
          if LoggingToMacro then
          begin
            MacroForm.MacroRE.Lines.Add('=0305  Do_Rotate8SQRTFile');
            MacroForm.MacroRE.Lines.Add(FilterPath);
            MacroForm.MacroRE.Lines.Add(OpenDialog1.filename);
            MacroForm.MacroRE.Lines.Add(IntToStr(Choosy));
            if AUTORANGE then MacroForm.MacroRE.Lines.Add(IntToStr(1))
            else MacroForm.MacroRE.Lines.Add(IntToStr(0));
          end;
  {Filtername, 1 is autorange 0 is NOT autorange}
 {Range , Threshold foe >255}{Normal ,or Blast it}
 {InRanger , InRangette: Normal is 255,255; 1024,255;  255,0}
          if AUTORANGE then
            Do_Rotate8SQRTFile(OpenDialog1.filename, 1, 255, 255)
          else Do_Rotate8SQRTFile(OpenDialog1.filename, 0, 255, 255);
          Screen.Cursor := CRDEFAULT;
        end;
      end;
    5: begin
 {ISF_Rotate8Max}
        OpenDialog1.filter :=
          'Rotate8 Filter files|*.R83;*.R85;*.R87;*.R89|3x3|*.R83|5x5|*.R85|7x7|*.R87|9x9|*.R89';
        OpenDialog1.InitialDir := FilterPath;
        if OpenDialog1.execute then begin
          Screen.Cursor := CRHOURGLASS;
          FilterPath := ExtractFilePath(OpenDialog1.filename);
          if LoggingToMacro then
          begin
            MacroForm.MacroRE.Lines.Add('=0306  Do_Rotate8MaxFile');
            MacroForm.MacroRE.Lines.Add(FilterPath);
            MacroForm.MacroRE.Lines.Add(OpenDialog1.filename);
            MacroForm.MacroRE.Lines.Add(IntToStr(Choosy));
            if AUTORANGE then MacroForm.MacroRE.Lines.Add(IntToStr(1))
            else MacroForm.MacroRE.Lines.Add(IntToStr(0));
          end;
          if AUTORANGE then Do_Rotate8MaxFile(OpenDialog1.filename, 1)
          else Do_Rotate8MaxFile(OpenDialog1.filename, 0);
          Screen.Cursor := CRDEFAULT;
        end;
      end;
    6: begin
        OpenDialog1.filter :=
          'Ratio Filter files|*.RR3;*.RR5;*.RR7;*.RR9|3x3|*.RR3|5x5|*.RR5|7x7|*.RR7|9x9|*.RR9';
{  OpenDialog1.filter:='Ratio Filter files|*.RL3;*.RL5;*.RL7;*.RL9|3x3|*.RL3|5x5|*.RL5|7x7|*.RL7|9x9|*.RL9';}
        OpenDialog1.InitialDir := FilterPath;
        if OpenDialog1.execute then begin
          Screen.Cursor := CRHOURGLASS;
          FilterPath := ExtractFilePath(OpenDialog1.filename);
          if LoggingToMacro then
          begin
            MacroForm.MacroRE.Lines.Add('=0307  Ratboy');
            MacroForm.MacroRE.Lines.Add(FilterPath);
            MacroForm.MacroRE.Lines.Add(OpenDialog1.filename);
            MacroForm.MacroRE.Lines.Add(IntToStr(Choosy));
            if AUTORANGE then MacroForm.MacroRE.Lines.Add(IntToStr(1))
            else MacroForm.MacroRE.Lines.Add(IntToStr(0));
          end;

          if AUTORANGE then Ratboy(OpenDialog1.filename, 1)
          else Ratboy(OpenDialog1.filename, 0);
          Screen.Cursor := CRDEFAULT;
        end;
      end;
    7: begin
{ISF_RatioMax}
        OpenDialog1.filter :=
          'Ratio Filter files|*.RR3;*.RR5;*.RR7;*.RR9|3x3|*.RR3|5x5|*.RR5|7x7|*.RR7|9x9|*.RR9';
{  OpenDialog1.filter:='Ratio Filter files|*.RL3;*.RL5;*.RL7;*.RL9|3x3|*.RL3|5x5|*.RL5|7x7|*.RL7|9x9|*.RL9';}
        OpenDialog1.InitialDir := FilterPath;
        if OpenDialog1.execute then begin
          Screen.Cursor := CRHOURGLASS;
          FilterPath := ExtractFilePath(OpenDialog1.filename);
          if LoggingToMacro then
          begin
            MacroForm.MacroRE.Lines.Add('=0308  Batgirl');
            MacroForm.MacroRE.Lines.Add(FilterPath);
            MacroForm.MacroRE.Lines.Add(OpenDialog1.filename);
            MacroForm.MacroRE.Lines.Add(IntToStr(Choosy));
            if AUTORANGE then MacroForm.MacroRE.Lines.Add(IntToStr(1))
            else MacroForm.MacroRE.Lines.Add(IntToStr(0));
          end;
          if AUTORANGE then Batgirl(OpenDialog1.filename, 1)
          else Batgirl(OpenDialog1.filename, 0);
          Screen.Cursor := CRDEFAULT;
        end;
      end;
    8: begin
{ISF_Slope2}
        OpenDialog1.filter :=
          'Slope 2 s_r_.r2? Filter files|*.R23;*.R25;*.R27;*.R29|3x3|*.R23|5x5|*.R25|7x7|*.R27|9x9|*.R29';
        OpenDialog1.InitialDir := FilterPath;
        if OpenDialog1.execute then begin
          Screen.Cursor := CRHOURGLASS;
          FilterPath := ExtractFilePath(OpenDialog1.filename);
          if LoggingToMacro then
          begin
            MacroForm.MacroRE.Lines.Add('=0309  Do_SlopeFile8');
            MacroForm.MacroRE.Lines.Add(FilterPath);
            MacroForm.MacroRE.Lines.Add(OpenDialog1.filename);
            MacroForm.MacroRE.Lines.Add(IntToStr(Choosy));
            if AUTORANGE then MacroForm.MacroRE.Lines.Add(IntToStr(1))
            else MacroForm.MacroRE.Lines.Add(IntToStr(0));
          end;

          if AUTORANGE then
            Do_SlopeFile(OpenDialog1.filename, 1, 8 {8})
          else Do_SlopeFile(OpenDialog1.filename, 0, 8 {8});
          Screen.Cursor := CRDEFAULT;
        end;
      end;
    9: begin
  {ISF_Slope6}
        OpenDialog1.filter :=
          'Slope 6 s_r_.r2? Filter files|*.R23;*.R25;*.R27;*.R29|3x3|*.R23|5x5|*.R25|7x7|*.R27|9x9|*.R29';
        OpenDialog1.InitialDir := FilterPath;
        if OpenDialog1.execute then begin
          Screen.Cursor := CRHOURGLASS;
          FilterPath := ExtractFilePath(OpenDialog1.filename);
          if LoggingToMacro then
          begin
            MacroForm.MacroRE.Lines.Add('=0310  Do_SlopeFile6');
            MacroForm.MacroRE.Lines.Add(FilterPath);
            MacroForm.MacroRE.Lines.Add(OpenDialog1.filename);
            MacroForm.MacroRE.Lines.Add(IntToStr(Choosy));
            if AUTORANGE then MacroForm.MacroRE.Lines.Add(IntToStr(1))
            else MacroForm.MacroRE.Lines.Add(IntToStr(0));
          end;

          if AUTORANGE then Do_SlopeFile(OpenDialog1.filename, 1, 6)
          else Do_SlopeFile(OpenDialog1.filename, 0, 6);
          Screen.Cursor := CRDEFAULT;
        end;
      end;
    10: begin
 {ISF_Slope8}
        OpenDialog1.filter :=
          'Slope 8 s_r_.r2? Filter files|*.R23;*.R25;*.R27;*.R29|3x3|*.R23|5x5|*.R25|7x7|*.R27|9x9|*.R29';
        OpenDialog1.InitialDir := FilterPath;
        if OpenDialog1.execute then begin
          Screen.Cursor := CRHOURGLASS;
          FilterPath := ExtractFilePath(OpenDialog1.filename);
          if LoggingToMacro then
          begin
            MacroForm.MacroRE.Lines.Add('=0311  Do_SlopeFile r2 8');
            MacroForm.MacroRE.Lines.Add(FilterPath);
            MacroForm.MacroRE.Lines.Add(OpenDialog1.filename);
            MacroForm.MacroRE.Lines.Add(IntToStr(Choosy));
            if AUTORANGE then MacroForm.MacroRE.Lines.Add(IntToStr(1))
            else MacroForm.MacroRE.Lines.Add(IntToStr(0));
          end;

          if AUTORANGE then Do_SlopeFile(OpenDialog1.filename, 1, 8)
          else Do_SlopeFile(OpenDialog1.filename, 0, 8);
          Screen.Cursor := CRDEFAULT;
        end;
      end;
    11: begin
(*  In Ranked Edge
procedure TRasterForm.ISF_SlopeDirClick(Sender: TObject);
begin
{ ISF_SlopeDir}
end;*)
{ ISF_SlopeDir}
        if LoggingToMacro then
        begin
          MacroForm.MacroRE.Lines.Add('=0312  Do_SlopeDir');
          MacroForm.MacroRE.Lines.Add(IntToStr(Choosy));
        end;
        Do_SlopeDir;
      end;
  end;
end;

procedure TFEditForm.FERE_MinBtnClick(Sender: TObject);
var RS: string; TextureSize, ErrorPos: Integer;
begin
  RS := MinEdit.Text;
  Val(RS, TextureSize, ErrorPos);
  if ((TextureSize mod 2) = 0) then TextureSize := (TextureSize + 1);
  if TextureSize > 9 then TextureSize := 9;
  if TextureSize < 3 then TextureSize := 3;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0351  Do_Texture Min');
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureSize));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0351  Do_Texture Min');
    PBands.DIPMemo.Lines.Add(IntToStr(TextureSize));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_Texture(1, TextureSize);
end;

procedure TFEditForm.FERE_MaxBtnClick(Sender: TObject);
var RS: string; TextureSize, ErrorPos: Integer;
begin
  RS := MaxEdit.Text;
  Val(RS, TextureSize, ErrorPos);
  if ((TextureSize mod 2) = 0) then TextureSize := (TextureSize + 1);
  if TextureSize > 9 then TextureSize := 9;
  if TextureSize < 3 then TextureSize := 3;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0352  Do_Texture Max');
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureSize));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0352  Do_Texture Max');
    PBands.DIPMemo.Lines.Add(IntToStr(TextureSize));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_Texture(2, TextureSize);
end;

procedure TFEditForm.FERE_OpenBtnClick(Sender: TObject);
var GS, RS: string; TextureSize, TextureSizeG, ErrorPos: Integer;
begin {do max then min}
  RS := OpenEdit.Text;
  Val(RS, TextureSize, ErrorPos);
  if ((TextureSize mod 2) = 0) then TextureSize := (TextureSize + 1);
  if TextureSize > 9 then TextureSize := 9;
  if TextureSize < 3 then TextureSize := 3;
  Do_Texture(2, TextureSize);
{4&5 are Range Do_Texture(6,TextureSize);}
  GS := OpenEdit2.Text;
  Val(GS, TextureSizeG, ErrorPos);
  if ((TextureSizeG mod 2) = 0) then
    TextureSizeG := (TextureSizeG + 1);
  if TextureSizeG > 9 then TextureSizeG := 9;
  if TextureSizeG < 3 then TextureSizeG := 3;
  Do_Texture(1, TextureSizeG);
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0353  Do_Texture Open');
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureSize));
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureSizeG));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0353  Do_Texture Open');
    PBands.DIPMemo.Lines.Add(IntToStr(TextureSize));
    PBands.DIPMemo.Lines.Add(IntToStr(TextureSizeG));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
end;

procedure TFEditForm.FERE_CloseBtnClick(Sender: TObject);
var GS, RS: string; TextureSize, TextureSizeG, ErrorPos: Integer;
begin
{do min then max}
  RS := CloseEdit.Text;
  Val(RS, TextureSize, ErrorPos);
  if ((TextureSize mod 2) = 0) then TextureSize := (TextureSize + 1);
  if TextureSize > 9 then TextureSize := 9;
  if TextureSize < 3 then TextureSize := 3;
  Do_Texture(1, TextureSize);
{4&5 are Range Do_Texture(7,TextureSize);}
  GS := CloseEdit2.Text;
  Val(GS, TextureSizeG, ErrorPos);
  if ((TextureSizeG mod 2) = 0) then
    TextureSizeG := (TextureSizeG + 1);
  if TextureSizeG > 9 then TextureSizeG := 9;
  if TextureSizeG < 3 then TextureSizeG := 3;
  Do_Texture(2, TextureSizeG);
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0354  Do_Texture Close');
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureSize));
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureSizeG));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0354  Do_Texture Close');
    PBands.DIPMemo.Lines.Add(IntToStr(TextureSize));
    PBands.DIPMemo.Lines.Add(IntToStr(TextureSizeG));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
end;

procedure TFEditForm.FERE_MedianBtnClick(Sender: TObject);
var RS: string; TextureSize, ErrorPos: Integer;
begin
  RS := MedianEdit.Text;
  Val(RS, TextureSize, ErrorPos);
  if ((TextureSize mod 2) = 0) then TextureSize := (TextureSize + 1);
  if TextureSize > 9 then TextureSize := 9;
  if TextureSize < 3 then TextureSize := 3;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0355  Do_Texture Median');
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureSize));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0355  Do_Texture Median');
    PBands.DIPMemo.Lines.Add(IntToStr(TextureSize));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_Texture(3, TextureSize);
end;

procedure TFEditForm.FERE_RangeBtnClick(Sender: TObject);
var RS: string; TextureSize, ErrorPos: Integer;
begin
  RS := RangeEdit.Text;
  Val(RS, TextureSize, ErrorPos);
  if ((TextureSize mod 2) = 0) then TextureSize := (TextureSize + 1);
  if TextureSize > 9 then TextureSize := 9;
  if TextureSize < 3 then TextureSize := 3;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0356  Do_Texture Range');
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureSize));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0356  Do_Texture Range');
    PBands.DIPMemo.Lines.Add(IntToStr(TextureSize));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_Texture(4, TextureSize); {Range}
end;

procedure TFEditForm.FERE_LowRangeBtnClick(Sender: TObject);
var RS: string; TextureSize, ErrorPos: Integer;
begin
  RS := LowRangeEdit.Text;
  Val(RS, TextureSize, ErrorPos);
  if ((TextureSize mod 2) = 0) then TextureSize := (TextureSize + 1);
  if TextureSize > 9 then TextureSize := 9;
  if TextureSize < 3 then TextureSize := 3;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0357  Do_Texture LowRange');
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureSize));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0357  Do_Texture LowRange');
    PBands.DIPMemo.Lines.Add(IntToStr(TextureSize));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_Texture(5, TextureSize);
end;

procedure TFEditForm.FERE_TopHatBtnClick(Sender: TObject);
var GS, RS: string; TextureSize, TextureHeight, ErrorPos: Integer;
begin
  RS := TopHatEdit.Text;
  Val(RS, TextureSize, ErrorPos);
  GS := TopHatEdit2.Text;
  Val(GS, TextureHeight, ErrorPos);
  if ((TextureSize mod 2) = 0) then TextureSize := (TextureSize + 1);
  if TextureSize > 9 then TextureSize := 9;
  if TextureSize < 3 then TextureSize := 3;
  if TextureHeight > 45 then TextureHeight := 45;
  if TextureHeight < 3 then TextureHeight := 3;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0359  Do_ATexture TopHat');
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureSize));
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureHeight));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0359  Do_ATexture TopHat');
    PBands.DIPMemo.Lines.Add(IntToStr(TextureSize));
    PBands.DIPMemo.Lines.Add(IntToStr(TextureHeight));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_ATexture(1, TextureSize, TextureHeight);
end;

procedure TFEditForm.FERE_IRTopHatBtnClick(Sender: TObject);
var GS, RS: string; TextureSize, TextureHeight, ErrorPos: Integer;
begin
  RS := IRTopHatEdit.Text;
  Val(RS, TextureSize, ErrorPos);
  GS := IRTopHatEdit2.Text;
  Val(GS, TextureHeight, ErrorPos);
  if ((TextureSize mod 2) = 0) then TextureSize := (TextureSize + 1);
  if TextureSize > 9 then TextureSize := 9;
  if TextureSize < 3 then TextureSize := 3;
  if TextureHeight > 45 then TextureHeight := 45;
  if TextureHeight < 3 then TextureHeight := 3;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0361  Do_ATexture IRTopHat');
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureSize));
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureHeight));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0361  Do_ATexture IRTopHat');
    PBands.DIPMemo.Lines.Add(IntToStr(TextureSize));
    PBands.DIPMemo.Lines.Add(IntToStr(TextureHeight));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_ATexture(3, TextureSize, TextureHeight);
end;

procedure TFEditForm.FERE_RollingBallBtnClick(Sender: TObject);
var GS, RS: string; TextureSize, TextureHeight, ErrorPos: Integer;
begin
  RS := RollingBallEdit.Text;
  Val(RS, TextureSize, ErrorPos);
  GS := RollingBallEdit2.Text;
  Val(GS, TextureHeight, ErrorPos);
  if ((TextureSize mod 2) = 0) then TextureSize := (TextureSize + 1);
  if TextureSize > 9 then TextureSize := 9;
  if TextureSize < 3 then TextureSize := 3;
  if TextureHeight > 45 then TextureHeight := 45;
  if TextureHeight < 3 then TextureHeight := 3;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0360  Do_ATexture RollingBall');
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureSize));
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureHeight));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0360  Do_ATexture RollingBall');
    PBands.DIPMemo.Lines.Add(IntToStr(TextureSize));
    PBands.DIPMemo.Lines.Add(IntToStr(TextureHeight));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_ATexture(2, TextureSize, TextureHeight);
end;


procedure TFEditForm.FERE_IRRollingBallBtnClick(Sender: TObject);
var GS, RS: string; TextureSize, TextureHeight, ErrorPos: Integer;
begin
  RS := IRRollingBallEdit.Text;
  Val(RS, TextureSize, ErrorPos);
  GS := IRRollingBallEdit2.Text;
  Val(GS, TextureHeight, ErrorPos);
  if ((TextureSize mod 2) = 0) then TextureSize := (TextureSize + 1);
  if TextureSize > 9 then TextureSize := 9;
  if TextureSize < 3 then TextureSize := 3;
  if TextureHeight > 45 then TextureHeight := 45;
  if TextureHeight < 3 then TextureHeight := 3;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0362  Do_ATexture IRRollingBall');
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureSize));
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureHeight));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0362  Do_ATexture IRRollingBall');
    PBands.DIPMemo.Lines.Add(IntToStr(TextureSize));
    PBands.DIPMemo.Lines.Add(IntToStr(TextureHeight));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_ATexture(4, TextureSize, TextureHeight);
end;


procedure TFEditForm.FERE_VarianceBtnClick(Sender: TObject);
var RS: string; TextureSize, ErrorPos: Integer;
begin
  RS := VarianceEdit.Text;
  Val(RS, TextureSize, ErrorPos);
  if ((TextureSize mod 2) = 0) then TextureSize := (TextureSize + 1);
  if TextureSize > 9 then TextureSize := 9;
  if TextureSize < 3 then TextureSize := 3;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0358  Do_Texture Variance');
    MacroForm.MacroRE.Lines.Add(IntToStr(TextureSize));
    if AUTORANGE then MacroForm.MacroRE.Lines.Add(IntToStr(1))
    else MacroForm.MacroRE.Lines.Add(IntToStr(0));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0358  Do_Texture Variance');
    PBands.DIPMemo.Lines.Add(IntToStr(TextureSize));
    if AUTORANGE then PBands.DIPMemo.Lines.Add(IntToStr(1))
    else PBands.DIPMemo.Lines.Add(IntToStr(0));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  if AUTORANGE then Do_Variance(1, TextureSize)
  else Do_Variance(0, TextureSize);
end;



{   RasterForm.ISMH_ASM.Enabled:=Truth;
    RasterForm.ISMH_AVOMNLD.Enabled:=Truth;
    RasterForm.ISMH_HaralickTextures.Enabled:=Truth;
    RasterForm.ISMH_Kurtosis.Enabled:=Truth;
    RasterForm.ISMH_MaxED.Enabled:=Truth;
    RasterForm.ISMH_Mean.Enabled:=Truth;
    RasterForm.ISMH_MeanED.Enabled:=Truth;
    RasterForm.ISMH_MOSNLD.Enabled:=Truth;
    RasterForm.ISMH_PSCOS.Enabled:=Truth;
    RasterForm.ISMH_Range.Enabled:=Truth;
    RasterForm.ISMH_Variance.Enabled:=Truth;}

procedure TFEditForm.FET_AdaptiveBtnClick(Sender: TObject);
begin
{Spatial}
{ChangeName('T', 'A');}
{a kind of Histogram Equalization from RUSS pp.216..224
in a 16x16 matrix sample of the image (16*16=256
Center pixel value is the count of number of pixels =< the
current value of the center pixel}
end;


procedure TFEditForm.TogglesRGClick(Sender: TObject);
begin
  ClipR := False;
  Do_Ex_com := False;
  BelowZero := False;
  AutoRange := False;
  case TogglesRG.ItemIndex of
    0: ClipR := True;
    1: Do_Ex_com := True;
    2: BelowZero := True;
    3: AutoRange := True;
  end; end;

end.
