{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
//efg too probably
unit gLinear;

interface

uses
  SysUtils, Windows, Messages, Classes,
  Graphics, Controls,
  StdCtrls, ExtCtrls, Forms, Buttons, ComCtrls, Dialogs;

type
  TLinearForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    RGBContoursBtn: TButton;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    BEdit: TEdit;
    GEdit: TEdit;
    REdit: TEdit;
    ContourRGBBtn: TButton;
    WBEdit: TEdit;
    WGEdit: TEdit;
    WREdit: TEdit;
    MeasuredBtn: TButton;
    ProfileBtn: TButton;
    SnakeBtn: TButton;
    RedEdgeFollowerBtn: TButton;
    EdgeFollowEdit: TEdit;
    EdgeFlowBtn: TButton;
    LinearRG: TRadioGroup;
    ContourIntervalBtn: TButton;
    ContourIntervalEdit: TEdit;
    LinearCloseBtn: TBitBtn;
    LinearHelpBtn: TBitBtn;
    ScrollBox1: TScrollBox;
    PreviewImage: TImage;
    Panel1: TPanel;
    WandTrackBar: TTrackBar;
    MagicWand2: TCheckBox;
    SpeedButton1: TSpeedButton;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LinearCloseBtnClick(Sender: TObject);
    procedure LinearHelpBtnClick(Sender: TObject);

    procedure RGBContoursBtnClick(Sender: TObject);
    procedure ContourRGBBtnClick(Sender: TObject);

    procedure MeasuredBtnClick(Sender: TObject);
    procedure SnakeBtnClick(Sender: TObject);
    procedure ProfileBtnClick(Sender: TObject);

    procedure EdgeFollowBtnClick(Sender: TObject);
    procedure EdgeFlowBtnClick(Sender: TObject);
    procedure ContourIntervalBtnClick(Sender: TObject);
    procedure MagicWand2Click(Sender: TObject);
    procedure PreviewImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PreviewImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PreviewImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);

  end;

var
  LinearForm: TLinearForm;

implementation

{$R *.DFM}
uses
  gGlobal,
  gLProfile, gUILinear,
  gAgfxMasks, gAgfxBasedef,
  gUEnabler, gGrip, gMacro, gPBands;

procedure TLinearForm.FormCreate(Sender: TObject);
begin
  left := LinearFormX;
  top := LinearFormY;
end;

procedure TLinearForm.LinearCloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TLinearForm.FormClose(Sender: TObject; var Action:
  TCloseAction);
begin
  StartDrawing := False;
  StartSnake := False;
  Profiling := False;
  if ImageMade = TRUE then FreeImage;
  LinearFormX := LinearForm.left;
  LinearFormY := LinearForm.top;
  DoSaver;
 { FormControl:=6;
  GRIPForm.FreeForm;}
end;

procedure TLinearForm.LinearHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(7000);
end;


procedure TLinearForm.RGBContoursBtnClick(Sender: TObject);
var RS, GS, BS: string;
  CIntervalRed, CIntervalGreen, CIntervalBlue,
    ErrorPos: Integer;
begin {ContourV} {GetContourRed;GetContourGreen;GetContourBlue;}
  RS := REdit.Text;
  Val(RS, CIntervalRed, ErrorPos);
  GS := GEdit.Text;
  Val(GS, CIntervalGreen, ErrorPos);
  BS := BEdit.Text;
  Val(BS, CIntervalBlue, ErrorPos);
  if (CIntervalRed > 255) then CIntervalRed := 255;
  if (CIntervalRed < 1) then CIntervalRed := 1;
  if (CIntervalGreen > 255) then CIntervalGreen := 255;
  if (CIntervalGreen < 1) then CIntervalGreen := 1;
  if (CIntervalBlue > 255) then CIntervalBlue := 255;
  if (CIntervalBlue < 1) then CIntervalBlue := 1;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0151  AContour');
    MacroForm.MacroRE.Lines.Add(IntToStr(CIntervalRed));
    MacroForm.MacroRE.Lines.Add(IntToStr(CIntervalGreen));
    MacroForm.MacroRE.Lines.Add(IntToStr(CIntervalBlue));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0151  AContour');
    PBands.DIPMemo.Lines.Add(IntToStr(CIntervalRed));
    PBands.DIPMemo.Lines.Add(IntToStr(CIntervalGreen));
    PBands.DIPMemo.Lines.Add(IntToStr(CIntervalBlue));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  AContour(CIntervalRed, CIntervalGreen, CIntervalBlue);
    {Do_RGBContour;}
end;


procedure TLinearForm.ContourRGBBtnClick(Sender: TObject);
var RS, GS, BS: string;
  CIntervalRed, CIntervalGreen, CIntervalBlue,
    ErrorPos: Integer;
begin {ContourV} {GetContourRed;GetContourGreen;GetContourBlue;}
  RS := WREdit.Text;
  Val(RS, CIntervalRed, ErrorPos);
  GS := WGEdit.Text;
  Val(GS, CIntervalGreen, ErrorPos);
  BS := WBEdit.Text;
  Val(BS, CIntervalBlue, ErrorPos);
  if (CIntervalRed > 255) then CIntervalRed := 255;
  if (CIntervalRed < 1) then CIntervalRed := 1;
  if (CIntervalGreen > 255) then CIntervalGreen := 255;
  if (CIntervalGreen < 1) then CIntervalGreen := 1;
  if (CIntervalBlue > 255) then CIntervalBlue := 255;
  if (CIntervalBlue < 1) then CIntervalBlue := 1;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0152  Do_Contour');
    MacroForm.MacroRE.Lines.Add(IntToStr(CIntervalRed));
    MacroForm.MacroRE.Lines.Add(IntToStr(CIntervalGreen));
    MacroForm.MacroRE.Lines.Add(IntToStr(CIntervalBlue));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0152  Do_Contour');
    PBands.DIPMemo.Lines.Add(IntToStr(CIntervalRed));
    PBands.DIPMemo.Lines.Add(IntToStr(CIntervalGreen));
    PBands.DIPMemo.Lines.Add(IntToStr(CIntervalBlue));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_Contour(CIntervalRed, CIntervalGreen, CIntervalBlue);
    {Do_RGBContour;}
end;


procedure TLinearForm.MeasuredBtnClick(Sender: TObject);
begin
  StartDrawing := TRUE;
  GRIPForm.Show;
{PixelLine grabbed from Mouse;
then sent to Get_Distance
for ground distance input from Investigator
which then sends them both to Do_Measured}
end;

procedure TLinearForm.SnakeBtnClick(Sender: TObject);
begin
  StartSnake := TRUE;
  GRIPForm.Show;
{Snake line search
ChangeName('C', 'L'); }
end;

procedure TLinearForm.EdgeFollowBtnClick(Sender: TObject);
var RS: string;
  CIntervalRed, ErrorPos: Integer;
begin {ContourV} {GetContourRed;GetContourGreen;GetContourBlue;}
  RS := EdgeFollowEdit.Text;
  Val(RS, CIntervalRed, ErrorPos);
  if (CIntervalRed > 255) then CIntervalRed := 255;
  if (CIntervalRed < 1) then CIntervalRed := 1;
 {SCALE of NAPP Photo: 1:40,000}{1" = 3333.3'}
{100 dpi : 1 pixel = 33.3'  [25 pixels = a meander]}
{200 dpi : 1 pixel = 16.7'  [50 pixels = a meander]}

  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0153  Do_EdgeFollow');
    MacroForm.MacroRE.Lines.Add(IntToStr(CIntervalRed));
    MacroForm.MacroRE.Lines.Add(IntToStr(LinearRG.ItemIndex));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0153  Do_EdgeFollow');
    PBands.DIPMemo.Lines.Add(IntToStr(CIntervalRed));
    PBands.DIPMemo.Lines.Add(IntToStr(LinearRG.ItemIndex));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_EdgeFollow(CIntervalRed);
end;

procedure TLinearForm.EdgeFlowBtnClick(Sender: TObject);
var RS: string;
  CIntervalRed, ErrorPos: Integer;
begin
{Much simpler... just find that pixel and BLEED}
  RS := EdgeFollowEdit.Text;
  Val(RS, CIntervalRed, ErrorPos);
  if (CIntervalRed > 255) then CIntervalRed := 255;
  if (CIntervalRed < 1) then CIntervalRed := 1;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0154  Do_EdgeFlow');
    MacroForm.MacroRE.Lines.Add(IntToStr(CIntervalRed));
    MacroForm.MacroRE.Lines.Add(IntToStr(LinearRG.ItemIndex));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0154  Do_EdgeFlow');
    PBands.DIPMemo.Lines.Add(IntToStr(CIntervalRed));
    PBands.DIPMemo.Lines.Add(IntToStr(LinearRG.ItemIndex));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_EdgeFlow(CIntervalRed);
end;

procedure TLinearForm.ContourIntervalBtnClick(Sender: TObject);
var RS: string;
  CIntervalRed, ErrorPos: Integer;
begin {ContourV} {GetContourRed;GetContourGreen;GetContourBlue;}
  RS := ContourIntervalEdit.Text;
  Val(RS, CIntervalRed, ErrorPos);
  if (CIntervalRed > 255) then CIntervalRed := 255;
  if (CIntervalRed < 1) then CIntervalRed := 1;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0155  ContourInterval');
    MacroForm.MacroRE.Lines.Add(IntToStr(CIntervalRed));
    MacroForm.MacroRE.Lines.Add(IntToStr(LinearRG.ItemIndex));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0155  ContourInterval');
    PBands.DIPMemo.Lines.Add(IntToStr(CIntervalRed));
    PBands.DIPMemo.Lines.Add(IntToStr(LinearRG.ItemIndex));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  ContourInterval(CIntervalRed);
{Multiple values delineated  L}
end;




{Line computed from right triangle
Length is hypotenuse
Location is x,y along line computed; which is the Profile
ChangeName('C', 'P');
Draw a RubberBand line to Get Start and End points
Get the RGB values along the line...
Place the values into a Window: 2D LOS
Graph the Values in R,G,B colors}

procedure TLinearForm.ProfileBtnClick(Sender: TObject);
begin
  MakeImage;
  if ImageMade = TRUE then
  begin
    {If (not LineProfileFormActive) then
    LineProfileForm := TLineProfileForm.Create(Application);
    LineProfileFormActive:=True; }
    LineProfileForm.Show;
    LineProfileForm.StartProfile;
    Do_LoadedEnable(False);
    Do_ExtraEnable(False);
    GRIPForm.Show;
  end else
  begin
    FreeImage;
    Do_LoadedEnable(True);
    Do_ExtraEnable(True);
  end;
end;


(*
procedure TLinearForm.WireframeBtnClick(Sender: TObject);
var RS:string;
    CIntervalRed,ErrorPos: Integer;
begin{ContourV}{GetContourRed;GetContourGreen;GetContourBlue;}
 RS:=  WireframeEdit.Text;
      Val(RS, CIntervalRed, ErrorPos);
      If (CIntervalRed  >255) Then CIntervalRed:= 255;
      If (CIntervalRed  <1) Then CIntervalRed:= 1;
  If LoggingToMacro then
  begin
  MacroForm.MacroRE.Lines.Add('=0156  DoWireframe');
  MacroForm.MacroRE.Lines.Add(IntToStr(CIntervalRed));
  MacroForm.MacroRE.Lines.Add(IntToStr(LinearRG.ItemIndex));
  end;
DoWireframe(CIntervalRed);
{Wireframe   Density  .. reduce the amount of data... wires get LARGE
Choose Red Green or Blue
Change the image into a Wireframe of the Values
Orientation, angle of View...
ChangeName('C', 'F');}
end;
*)









procedure TLinearForm.MagicWand2Click(Sender: TObject);
begin
If MagicWand2.Checked then
   begin
{   MagicWandCB.Checked :=False;
   LightWandCB.Checked :=False;}
   {PreviewImage:= GRIPForm.Image1; }
   PreviewImage.Picture.Bitmap.Assign(GRIPForm.Image1.Picture.Bitmap);
   WandingOn:=True;
   end else WandingOn:=False;
end;

procedure TLinearForm.PreviewImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  If WandingOn then exit;
end;

procedure TLinearForm.PreviewImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  If WandingOn then exit;
end;

procedure TLinearForm.PreviewImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  mask:tbool2darray;
  TempBitmap:TBitmap;
  {ind:integer;
  MyWandRect: TRect; }
{var myrect:trect;}
{xs,ys,xt,yt,i,tangle:integer;c:tcolor;drw:string; }
    {apoint:tpoint;bitmap:tbitmap;
    x1,y1,x2,y2:integer;
    dcurve:array[0..3] of tpoint;
    rgn:HRGN;
    r1,g1,b1,r2,g2,b2:byte;  }
   { r,g,b,dr,dg,db:extended;
    Acolor,pcolor:tcolor;
    pw:integer; }
begin
  If Processing then exit;
  If WandingOn then
  begin
  if MagicWand2.Checked then
  begin
    screen.cursor:=crhourglass;
    Processing:=True;
    TempBitmap:=TBitmap.Create;
    TempBitmap.Assign(PreviewImage.Picture.Bitmap);
    Maskmagicwand(TempBitmap,x,y,
                  TempBitmap.canvas.pixels[x,y],
                  WandTrackBar.Position/100,{0.3,}
                  mask);
    ShowMagicWandFrame(TempBitmap,mask);
    mask:=nil;
    PreviewImage.Picture.Bitmap.Assign(TempBitmap);
    TempBitmap.Free;
    screen.cursor:=crdefault;
  end;
  {Processing:=True;}   Processing:=False;
  end;
end;

procedure TLinearForm.SpeedButton1Click(Sender: TObject);
var tempath:string;
  Bitmap: TBitmap;
begin
  If Processing then exit;
  If WandingOn then
  begin
    SaveDialog1.InitialDir := ImagePath;
    SaveDialog1.FileName := ChangeFileExt(GRIPFileName, '.bmp');
    SaveDialog1.filter := 'BMP files|*.bmp';
    SaveDialog1.DefaultExt := 'bmp';
    if SaveDialog1.Execute then
    begin
      tempath := ExtractFileExt(SaveDialog1.FileName);
      if ((tempath = '.BMP') or (tempath = '.bmp')) then
      begin
        {Save it}
        Bitmap := TBitmap.Create;
        Bitmap.Width := PreviewImage.Picture.Graphic.Width;
        Bitmap.Height := PreviewImage.Picture.Graphic.Width;
        {Image1.Picture.}Bitmap.PixelFormat := pf24bit;
        Bitmap.Assign(PreviewImage.Picture.Bitmap);
        Bitmap.SaveToFile(SaveDialog1.Filename);
        Bitmap.Free;
      end;
    end;

  end;
end;

end.
