{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
//derived from efg probably 
unit gMagniForm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, Buttons;

type
  TMagniForm = class(TForm)
    SpinEditMagnification: TSpinEdit;
    LabelMagnifiation: TLabel;
    SpeedButton1: TSpeedButton;
    Panel1: TPanel;
    Image1: TImage;
    ExitButton: TSpeedButton;
    ShowXCB: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ShowMagnifier(xActual, yActual: INTEGER);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ExitButtonClick(Sender: TObject);
    procedure SpinEditMagnificationChange(Sender: TObject);
  private
    { Private declarations }
    MagniBitmap: TBitmap;
{    MagniBusy          :  BOOLEAN;   }
  public
    { Public declarations }

  end;

var
  MagniForm: TMagniForm;

implementation

uses gGlobal, gGrip;

{$R *.DFM}
{var IsAlwaysOnTopCB:Boolean;}
//===========================================================================

procedure TMagniForm.FormCreate(Sender: TObject);
begin
  left := MagniFormX;
  top := MagniFormY;
  MagniBitmap := TBitmap.Create;
  MagniBitmap.Width := 128;
  MagniBitmap.Height := 128;
  MagniBitmap.PixelFormat := pf24bit;
  Image1.Picture.Graphic := MagniBitmap;
  ShowXCB.Checked := True;
{  AlwaysOnTopCB.Checked:=True;
  IsAlwaysOnTopCB:=True;}
  MagniForm.Formstyle := fsStayOnTop;
  MagnifierSize := (64 div SpinEditMagnification.Value);
end;
{If (AlwaysOnTopCB.Checked) then begin
  IsAlwaysOnTopCB:=True;
  MagniForm.Formstyle:=fsStayOnTop;
end else
  IsAlwaysOnTopCB:=False;
  MagniForm.Formstyle:=fsNormal;
begin
end;}

procedure TMagniForm.ExitButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TMagniForm.FormClose(Sender: TObject; var Action:
  TCloseAction);
begin
  MagniFormX := MagniForm.left;
  MagniFormY := MagniForm.top;
  DoSaver;
  GRIPForm.IZ_ZoomWindow.Checked := False;
  ViewMagniOn := False;
{      MagniForm.Hide;}
  Screen.Cursor := crDefault;
end;

procedure TMagniForm.FormDestroy(Sender: TObject);
begin
  MagniBitmap.Free
end;

procedure TMagniForm.SpeedButton1Click(Sender: TObject);
begin
  Application.HelpContext(5000);
end;

procedure TMagniForm.SpinEditMagnificationChange(Sender: TObject);
begin
  MagnifierSize := (64 div SpinEditMagnification.Value);
end;

procedure TMagniForm.ShowMagnifier(xActual, yActual: INTEGER);
type
  pRGBTripleArray = ^TRGBTripleArray;
  TRGBTripleArray = array[0..65535] of TRGBTriple;
var
  i: INTEGER;
  j: INTEGER;
  Magnifier: INTEGER;
  RowOriginal: pRGBTRipleArray;
  RowRotated: pRGBTRipleArray;
var
  ModifiedBitmap: TBitmap;
begin
  Magnifier := MagnifierSize * 2;
  // Copy original bitmap
  ModifiedBitmap := TBitmap.Create;
  ModifiedBitmap.Width := Magnifier;
  ModifiedBitmap.Height := Magnifier;
  ModifiedBitmap.PixelFormat := pf24bit;
  try
  // Step through each row of rotated image.
    for j := Magnifier - 1 downto 0 do
    begin
      RowRotated := ModifiedBitmap.Scanline[j];
      RowOriginal := GRIPForm.Image1.Picture.Bitmap.Scanline[yActual
        + j];
      for i := Magnifier - 1 downto 0 do
      begin
        RowRotated[i] := RowOriginal[xActual + i]
      end;
    end;
    Image1.Picture.Bitmap.Canvas.StretchDraw(Rect(0,
      0,
      127,
      127),
      ModifiedBitmap);
    if ShowXCB.Checked then begin
      SetROP2(Image1.Canvas.handle, R2_BLACK);
{  SetROP2(Image1.Canvas.handle, R2_NOT);}
      Image1.Picture.Bitmap.Canvas.Moveto(63, 0);
      Image1.Picture.Bitmap.Canvas.Lineto(63, 127);
      Image1.Picture.Bitmap.Canvas.Moveto(64, 127);
      Image1.Picture.Bitmap.Canvas.Lineto(64, 0);
      Image1.Picture.Bitmap.Canvas.Moveto(0, 63);
      Image1.Picture.Bitmap.Canvas.Lineto(127, 63);
      Image1.Picture.Bitmap.Canvas.Moveto(127, 64);
      Image1.Picture.Bitmap.Canvas.Lineto(0, 64);
      SetROP2(Image1.Canvas.handle, R2_COPYPEN);
    end;
  finally
    ModifiedBitmap.Free
  end
end {ShowMagnifier};

(*
  { Binary raster ops }
  {$EXTERNALSYM R2_BLACK}
  R2_BLACK       = 1;     {  0   }
  {$EXTERNALSYM R2_NOTMERGEPEN}
  R2_NOTMERGEPEN = 2;     { DPon }
  {$EXTERNALSYM R2_MASKNOTPEN}
  R2_MASKNOTPEN  = 3;     { DPna }
  {$EXTERNALSYM R2_NOTCOPYPEN}
  R2_NOTCOPYPEN  = 4;     { PN   }
  {$EXTERNALSYM R2_MASKPENNOT}
  R2_MASKPENNOT  = 5;     { PDna }
  {$EXTERNALSYM R2_NOT}
  R2_NOT         = 6;     { Dn   }
  {$EXTERNALSYM R2_XORPEN}
  R2_XORPEN      = 7;     { DPx  }
  {$EXTERNALSYM R2_NOTMASKPEN}
  R2_NOTMASKPEN  = 8;     { DPan }
  {$EXTERNALSYM R2_MASKPEN}
  R2_MASKPEN     = 9;     { DPa  }
  {$EXTERNALSYM R2_NOTXORPEN}
  R2_NOTXORPEN   = 10;    { DPxn }
  {$EXTERNALSYM R2_NOP}
  R2_NOP         = 11;    { D    }
  {$EXTERNALSYM R2_MERGENOTPEN}
  R2_MERGENOTPEN = 12;    { DPno }
  {$EXTERNALSYM R2_COPYPEN}
  R2_COPYPEN     = 13;    { P    }
  {$EXTERNALSYM R2_MERGEPENNOT}
  R2_MERGEPENNOT = 14;    { PDno }
  {$EXTERNALSYM R2_MERGEPEN}
  R2_MERGEPEN    = 15;    { DPo  }
  {$EXTERNALSYM R2_WHITE}
  R2_WHITE       = $10;   {  1   }
  {$EXTERNALSYM R2_LAST}
  R2_LAST        = $10;


 { Ternary raster operations }
  {$EXTERNALSYM SRCCOPY}
  SRCCOPY     = $00CC0020;     { dest = source                    }
  {$EXTERNALSYM SRCPAINT}
  SRCPAINT    = $00EE0086;     { dest = source OR dest            }
  {$EXTERNALSYM SRCAND}
  SRCAND      = $008800C6;     { dest = source AND dest           }
  {$EXTERNALSYM SRCINVERT}
  SRCINVERT   = $00660046;     { dest = source XOR dest           }
  {$EXTERNALSYM SRCERASE}
  SRCERASE    = $00440328;     { dest = source AND (NOT dest )    }
  {$EXTERNALSYM NOTSRCCOPY}
  NOTSRCCOPY  = $00330008;     { dest = (NOT source)              }
  {$EXTERNALSYM NOTSRCERASE}
  NOTSRCERASE = $001100A6;     { dest = (NOT src) AND (NOT dest)  }
  {$EXTERNALSYM MERGECOPY}
  MERGECOPY   = $00C000CA;     { dest = (source AND pattern)      }
  {$EXTERNALSYM MERGEPAINT}
  MERGEPAINT  = $00BB0226;     { dest = (NOT source) OR dest      }
  {$EXTERNALSYM PATCOPY}
  PATCOPY     = $00F00021;     { dest = pattern                   }
  {$EXTERNALSYM PATPAINT}
  PATPAINT    = $00FB0A09;     { dest = DPSnoo                    }
  {$EXTERNALSYM PATINVERT}
  PATINVERT   = $005A0049;     { dest = pattern XOR dest          }
  {$EXTERNALSYM DSTINVERT}
  DSTINVERT   = $00550009;     { dest = (NOT dest)                }
  {$EXTERNALSYM BLACKNESS}
  BLACKNESS   = $00000042;     { dest = BLACK                     }
  {$EXTERNALSYM WHITENESS}
  WHITENESS   = $00FF0062;     { dest = WHITE                     }


*)






end.
