{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gUISOHO;
{TPLAT}{SOHO Stables}{DODO DIVAS}
interface

{ Place a USES declaration here }
uses
  Windows, Messages, { SysUtils,} Classes, Graphics,
  gGlobal, Controls, Forms, Dialogs,
  StdCtrls, {WinTypes,} Buttons;

{ Place CONST, TYPE, and VAR declarations here }

{ Place PROCEDURE and FUNCTION declarations here }
{190} procedure Do_SOHO_IF(ThePixel: Byte);
procedure Do_Asteroids(A_Set: Double);
procedure Do_Halley(RedSet, GreenSet, BlueSet: Double);
procedure Do_Slice(Sliced: Integer);

procedure Do_SOHO_Numb(ThePixel: Byte);
procedure Do_Europa(E_Set: Integer);

procedure Do_RedSun;
procedure Do_GreenMoon;

procedure CMIHS_AutoH;
procedure Do_ISlice(RedSet, GreenSet, BlueSet: Double; Sliced:
  Integer);

procedure Do_SetSlice(Net_Set: Byte);
procedure Do_SetandSlice(Net_Set: Byte; E_Set: Integer);
{Get Land Value}
procedure Do_Class(E_Set: Integer);

procedure Do_DODO_Numb(ThePixel: Byte);
{Get Land Value}
procedure Do_DoDo(E_Set: Integer);
{PROCEDURE GetSliceRGB36Value;}
procedure Do_SetOSlice(Net_Set: Byte);
{Get Land Value; Slice RGB36}
procedure Do_SetOSIlice(Net_Set: Byte; E_Set: Integer);
{Get Land Value}
procedure Do_DoDoClass(E_Set: Integer);

{Get Land Value}
procedure Do_Tone(E_Set: Integer); {TONE}

procedure Do_Perc(A_Perc: Byte);
implementation

var
  KBRed, KBBlue, KBGreen, BlueColor, RedColor, GreenColor: Byte;
{ Place a second USES declaration here }
{uses U__KBEntry,U__Slice;}
{ Place private LABEL, CONST, TYPE, and VAR declarations here }
{var
    CIntervalRed,CIntervalGreen,CIntervalBlue,
    MeanderDistance,KBScale,ErrorPos: Integer;
      SS,RS,GS,BS:string;
BlueColor,RedColor, GreenColor,
SliceValue, KBRed, KBBlue, KBGreen: Byte;}
{ Place PROCEDURE and FUNCTION bodies here }
(******************************************************)

procedure Do_SOHO_IF(ThePixel: Byte);
var
  SetaColor {, TheColor}: Longint;
  RedC, BlueC, GreenC,
    Total, ILStart, ILEnd, IWStart, IWEnd: Integer;
  IL, IW: DWord;
begin {Get current Window DC}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
{         TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedC:= GetRValue(TheColor);
         GreenC:= GetGValue(TheColor);
         BlueC:= GetBValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueC := lpPixelB^;
        GreenC := lpPixelG^;
        RedC := lpPixelR^;

        begin
          Total := (RedC + GreenC + BlueC);
          SetaColor := ColorWhite;
  {Water}{KM Mercury}{WATER}
          if ((BlueC < 40) and (RedC < 40) and (GreenC < 40))
            then begin
            if ((RedC < 30) and (BlueC < 30) and (GreenC < 30)
              and (BlueC >= RedC) and (BlueC >= GreenC))
              then begin {Horseshoe Lake} {KBBlue  := 255}
              if ThePixel = 1 then SetaColor := LLW else {KM Mercury}
                if ThePixel = 2 then SetaColor := LLS else {KN Venus}
                  if ThePixel = 3 then SetaColor := LLS else
                    {KO Earth}
                    if ThePixel = 4 then SetaColor := LLS else
                      {KP Mars}
                      if ThePixel = 5 then SetaColor := LLS else
                        {KQ Jupiter}
                        if ThePixel = 6 then SetaColor := LLW else
                          {KR Saturn}
                          if ThePixel = 7 then SetaColor := LLS else
                            {KS Uranus}
                            if ThePixel = 8 then
                              SetaColor := LLW else
                              {KT Neptune}
                              if ThePixel = 9 then
                                SetaColor := LLW else {KU Pluto}
            end else
              if ((RedC <= 30) and (BlueC <= 30) and (GreenC <= 30)
                and (RedC >= BlueC))
                then begin {McDonough Lake} {KBBlue  := 250}
                if ThePixel = 1 then SetaColor := MMW else
                  {KM Mercury}
                  if ThePixel = 2 then SetaColor := LLS else
                    {KN Venus}
                    if ThePixel = 3 then SetaColor := LLS else
                      {KO Earth}
                      if ThePixel = 4 then SetaColor := LLS else
                        {KP Mars}
                        if ThePixel = 5 then SetaColor := LLS else
                          {KQ Jupiter}
                          if ThePixel = 6 then SetaColor := MMW else
                            {KR Saturn}
                            if ThePixel = 7 then
                              SetaColor := LLS else
                              {KS Uranus}
                              if ThePixel = 8 then
                                SetaColor := MMW else {KT Neptune}
                                if ThePixel = 9 then
                                  SetaColor := MMW else {KU Pluto}
              end else
                if ((BlueC >= GreenC) and (BlueC >= RedC))
                  then begin {Hiway Pond} {KBBlue  := 240}
                  if ThePixel = 1 then SetaColor := DDW else
                    {KM Mercury}
                    if ThePixel = 2 then SetaColor := LLS else
                      {KN Venus}
                      if ThePixel = 3 then SetaColor := LLS else
                        {KO Earth}
                        if ThePixel = 4 then SetaColor := LLS else
                          {KP Mars}
                          if ThePixel = 5 then SetaColor := LLS else
                            {KQ Jupiter}
                            if ThePixel = 6 then
                              SetaColor := DDW else
                              {KR Saturn}
                              if ThePixel = 7 then
                                SetaColor := LLS else {KS Uranus}
                                if ThePixel = 8 then
                                  SetaColor := DDW else {KT Neptune}
                                  if ThePixel = 9 then
                                    SetaColor := DDW else {KU Pluto}
                end else
                  if ((RedC >= BlueC) and (RedC >= GreenC))
                    then begin {Edelhart Lake} {KBBlue  := 200}
                    if ThePixel = 1 then SetaColor := DMC else
                      {KM Mercury}
                      if ThePixel = 2 then SetaColor := LLS else
                        {KN Venus}
                        if ThePixel = 3 then SetaColor := LLS else
                          {KO Earth}
                          if ThePixel = 4 then SetaColor := LLS else
                            {KP Mars}
                            if ThePixel = 5 then
                              SetaColor := LLS else
                              {KQ Jupiter}
                              if ThePixel = 6 then
                                SetaColor := DMC else {KR Saturn}
                                if ThePixel = 7 then
                                  SetaColor := LLS else {KS Uranus}
                                  if ThePixel = 8 then
                                    SetaColor := DMC else {KT Neptune}
                                    if ThePixel = 9 then
                                      SetaColor := DMC else {KU Pluto}
                  end else
                    if ((GreenC >= BlueC) and (GreenC >= RedC))
                      then
                    begin {just spots: edges of water areas} {KBBlue  := 225}
                      if ThePixel = 1 then SetaColor := MMC else
                        {KM Mercury}
                        if ThePixel = 2 then SetaColor := LLS else
                          {KN Venus}
                          if ThePixel = 3 then SetaColor := LLS else
                            {KO Earth}
                            if ThePixel = 4 then
                              SetaColor := LLS else
                              {KP Mars}
                              if ThePixel = 5 then
                                SetaColor := LLS else {KQ Jupiter}
                                if ThePixel = 6 then
                                  SetaColor := MMC else {KR Saturn}
                                  if ThePixel = 7 then
                                    SetaColor := LLS else {KS Uranus}
                                    if ThePixel = 8 then
                                      SetaColor := MMC else
                                        {KT Neptune}
                                      if ThePixel = 9 then
                                        SetaColor := MMC else
                                          {KU Pluto}
                    end {of if <40 group}
          end else
            if ((BlueC < 80) and (GreenC < 60) and (RedC < 30)
              and (BlueC > GreenC) and (GreenC > RedC))
              then begin {Road Pond} {KBBlue := 164}
              if ThePixel = 1 then SetaColor := LMC else {KM Mercury}
                if ThePixel = 2 then SetaColor := LLS else {KN Venus}
                  if ThePixel = 3 then SetaColor := LLS else
                    {KO Earth}
                    if ThePixel = 4 then SetaColor := LLS else
                      {KP Mars}
                      if ThePixel = 5 then SetaColor := LLS else
                        {KQ Jupiter}
                        if ThePixel = 6 then SetaColor := LMC else
                          {KR Saturn}
                          if ThePixel = 7 then SetaColor := LLS else
                            {KS Uranus}
                            if ThePixel = 8 then
                              SetaColor := LMC else
                              {KT Neptune}
                              if ThePixel = 9 then
                                SetaColor := LMC else {KU Pluto}
            end else



{MASSIVE IR SWITCH}{Followed by non-IR}{KN Venus}{IR}
              if (RedC > (BlueC + GreenC)) then begin
                if RedC > 140 then begin {Hi Growth} {KBGreen:= 240}
                  if ThePixel = 1 then SetaColor := LLS else
                    {KM Mercury}
                    if ThePixel = 2 then SetaColor := LDA else
                      {KN Venus}
                      if ThePixel = 3 then SetaColor := LLS else
                        {KO Earth}
                        if ThePixel = 4 then SetaColor := LLS else
                          {KP Mars}
                          if ThePixel = 5 then SetaColor := LLS else
                            {KQ Jupiter}
                            if ThePixel = 6 then
                              SetaColor := LLS else
                              {KR Saturn}
                              if ThePixel = 7 then
                                SetaColor := LDA else {KS Uranus}
                                if ThePixel = 8 then
                                  SetaColor := LDA else {KT Neptune}
                                  if ThePixel = 9 then
                                    SetaColor := LDA else {KU Pluto}
                end else
                  if RedC > 105 then
                  begin {2nd Growth} {KBGreen := 220 }
                    if ThePixel = 1 then SetaColor := LLS else
                      {KM Mercury}
                      if ThePixel = 2 then SetaColor := MLA else
                        {KN Venus}
                        if ThePixel = 3 then SetaColor := LLS else
                          {KO Earth}
                          if ThePixel = 4 then SetaColor := LLS else
                            {KP Mars}
                            if ThePixel = 5 then
                              SetaColor := LLS else
                              {KQ Jupiter}
                              if ThePixel = 6 then
                                SetaColor := LLS else {KR Saturn}
                                if ThePixel = 7 then
                                  SetaColor := MLA else {KS Uranus}
                                  if ThePixel = 8 then
                                    SetaColor := MLA else {KT Neptune}
                                    if ThePixel = 9 then
                                      SetaColor := MLA else {KU Pluto}
                  end else
                    if ((RedC > 75) and (BlueC < 16))
                      then begin {medium red} {KBGreen := 170 }
                      if ThePixel = 1 then SetaColor := LLS else
                        {KM Mercury}
                        if ThePixel = 2 then SetaColor := LDA else
                          {KN Venus}
                          if ThePixel = 3 then SetaColor := LLS else
                            {KO Earth}
                            if ThePixel = 4 then
                              SetaColor := LLS else
                              {KP Mars}
                              if ThePixel = 5 then
                                SetaColor := LLS else {KQ Jupiter}
                                if ThePixel = 6 then
                                  SetaColor := LLS else {KR Saturn}
                                  if ThePixel = 7 then
                                    SetaColor := LDA else {KS Uranus}
                                    if ThePixel = 8 then
                                      SetaColor := LDA else
                                        {KT Neptune}
                                      if ThePixel = 9 then
                                        SetaColor := LDA else
                                          {KU Pluto}
                    end else
                      if ((RedC < 76) and (BlueC < 16))
                        then begin {KBGreen := 165 }
                        if ThePixel = 1 then SetaColor := LLS else
                          {KM Mercury}
                          if ThePixel = 2 then SetaColor := DLA else
                            {KN Venus}
                            if ThePixel = 3 then
                              SetaColor := LLS else
                              {KO Earth}
                              if ThePixel = 4 then
                                SetaColor := LLS else {KP Mars}
                                if ThePixel = 5 then
                                  SetaColor := LLS else {KQ Jupiter}
                                  if ThePixel = 6 then
                                    SetaColor := LLS else {KR Saturn}
                                    if ThePixel = 7 then
                                      SetaColor := DLA else
                                        {KS Uranus}
                                      if ThePixel = 8 then
                                        SetaColor := DLA else
                                        {KT Neptune}
                                        if ThePixel = 9 then
                                          SetaColor := DLA else
                                          {KU Pluto}
                      end else
                        if ((RedC > 75) and (BlueC < 30))
                          then begin {KBGreen := 200 }
                          if ThePixel = 1 then SetaColor := LLS else
                            {KM Mercury}
                            if ThePixel = 2 then
                              SetaColor := LMA else
                              {KN Venus}
                              if ThePixel = 3 then
                                SetaColor := LLS else {KO Earth}
                                if ThePixel = 4 then
                                  SetaColor := LLS else {KP Mars}
                                  if ThePixel = 5 then
                                    SetaColor := LLS else {KQ Jupiter}
                                    if ThePixel = 6 then
                                      SetaColor := LLS else
                                        {KR Saturn}
                                      if ThePixel = 7 then
                                        SetaColor := LMA else
                                        {KS Uranus}
                                        if ThePixel = 8 then
                                          SetaColor := LMA else
                                          {KT Neptune}
                                          if ThePixel = 9 then
                                            SetaColor := LMA else
                                            {KU Pluto}
                        end else
                          if ((RedC < 76) and (BlueC < 30))
                            then begin {KBGreen := 140 }
                            if ThePixel = 1 then
                              SetaColor := LLS else
                              {KM Mercury}
                              if ThePixel = 2 then
                                SetaColor := MDA else {KN Venus}
                                if ThePixel = 3 then
                                  SetaColor := LLS else {KO Earth}
                                  if ThePixel = 4 then
                                    SetaColor := LLS else {KP Mars}
                                    if ThePixel = 5 then
                                      SetaColor := LLS else
                                        {KQ Jupiter}
                                      if ThePixel = 6 then
                                        SetaColor := LLS else
                                        {KR Saturn}
                                        if ThePixel = 7 then
                                          SetaColor := MDA else
                                          {KS Uranus}
                                          if ThePixel = 8 then
                                            SetaColor := MDA else
                                            {KT Neptune}
                                            if ThePixel = 9 then
                                              SetaColor := MDA else
                                              {KU Pluto}
                          end else
                            if ((RedC > 75) and (BlueC > 29))
                              then begin {KBGreen := 160 }
                              if ThePixel = 1 then
                                SetaColor := LLS else {KM Mercury}
                                if ThePixel = 2 then
                                  SetaColor := MMA else {KN Venus}
                                  if ThePixel = 3 then
                                    SetaColor := LLS else {KO Earth}
                                    if ThePixel = 4 then
                                      SetaColor := LLS else {KP Mars}
                                      if ThePixel = 5 then
                                        SetaColor := LLS else
                                        {KQ Jupiter}
                                        if ThePixel = 6 then
                                          SetaColor := LLS else
                                          {KR Saturn}
                                          if ThePixel = 7 then
                                            SetaColor := MMA else
                                            {KS Uranus}
                                            if ThePixel = 8 then
                                              SetaColor := MMA else
                                              {KT Neptune}
                                              if ThePixel = 9 then
                                                SetaColor := MMA else
                                                {KU Pluto}
                            end else
                              if ((RedC < 76) and (BlueC > 29))
                                then begin {KBGreen := 180}
                                if ThePixel = 1 then
                                  SetaColor := LLS else {KM Mercury}
                                  if ThePixel = 2 then
                                    SetaColor := MLA else {KN Venus}
                                    if ThePixel = 3 then
                                      SetaColor := LLS else {KO Earth}
                                      if ThePixel = 4 then
                                        SetaColor := LLS else
                                          {KP Mars}
                                        if ThePixel = 5 then
                                          SetaColor := LLS else
                                          {KQ Jupiter}
                                          if ThePixel = 6 then
                                            SetaColor := LLS else
                                            {KR Saturn}
                                            if ThePixel = 7 then
                                              SetaColor := MLA else
                                              {KS Uranus}
                                              if ThePixel = 8 then
                                                SetaColor := MLA else
                                                {KT Neptune}
                                                if ThePixel = 9 then
                                                  SetaColor := MLA
                                                    else
                                                  {KU Pluto}
                              end;
              end else
{of IR SWITCH}
                if ((GreenC > 150) and (GreenC >= BlueC) and (BlueC
                  >= RedC))
                  then begin
                  if ThePixel = 1 then SetaColor := LLS else
                    {KM Mercury}
                    if ThePixel = 2 then SetaColor := LLS else
                      {KN Venus}
                      if ThePixel = 3 then SetaColor := LLS else
                        {KO Earth}
                        if ThePixel = 4 then SetaColor := LLA else
                          {KP Mars}
                          if ThePixel = 5 then SetaColor := LLS else
                            {KQ Jupiter}
                            if ThePixel = 6 then
                              SetaColor := LLS else
                              {KR Saturn}
                              if ThePixel = 7 then
                                SetaColor := LLA else {KS Uranus}
                                if ThePixel = 8 then
                                  SetaColor := LLA else {KT Neptune}
                                  if ThePixel = 9 then
                                    SetaColor := LLA else {KU Pluto}
                end else


     {Begin of Dark Switch}{KO  Earth}{FORESTS}
                  if (Total < 255) then begin
                    if ((BlueC >= GreenC) and (GreenC >= RedC))
                      then
                    begin {A LOT OF Dark 'BLUE' soil} {KBGreen := 91}
                      if ThePixel = 1 then SetaColor := LLS else
                        {KM Mercury}
                        if ThePixel = 2 then SetaColor := LLS else
                          {KN Venus}
                          if ThePixel = 3 then
                            SetaColor := LLS {UDA} else {KO Earth}
                            if ThePixel = 4 then
                              SetaColor := ULA else
                              {KP Mars}
                              if ThePixel = 5 then
                                SetaColor := LLS else {KQ Jupiter}
                                if ThePixel = 6 then
                                  SetaColor := LLS else {KR Saturn}
                                  if ThePixel = 7 then
                                    SetaColor := ULA else {KS Uranus}
                                    if ThePixel = 8 then
                                      SetaColor := ULA else
                                        {KT Neptune}
                                      if ThePixel = 9 then
                                        SetaColor := ULA else
                                          {KU Pluto}
                    end else
                      if ((BlueC >= GreenC) and (BlueC >= RedC))
                        then
                      begin {Edges of Dark, Forests?} {KBGreen := 93}
                        if ThePixel = 1 then SetaColor := LLS else
                          {KM Mercury}
                          if ThePixel = 2 then SetaColor := LLS else
                            {KN Venus}
                            if ThePixel = 3 then
                              SetaColor := LLS {DDA} else {KO Earth}
                              if ThePixel = 4 then
                                SetaColor := DDA else {KP Mars}
                                if ThePixel = 5 then
                                  SetaColor := LLS else {KQ Jupiter}
                                  if ThePixel = 6 then
                                    SetaColor := LLS else {KR Saturn}
                                    if ThePixel = 7 then
                                      SetaColor := DDA else
                                        {KS Uranus}
                                      if ThePixel = 8 then
                                        SetaColor := DDA else
                                        {KT Neptune}
                                        if ThePixel = 9 then
                                          SetaColor := DDA else
                                          {KU Pluto}
                      end else
                        if ((RedC >= GreenC) and (GreenC >= BlueC))
                          then begin {forest} {KBGreen := 51}
                          if ThePixel = 1 then SetaColor := LLS else
                            {KM Mercury}
                            if ThePixel = 2 then
                              SetaColor := LLS else
                              {KN Venus}
                              if ThePixel = 3 then
                                SetaColor := MDF else {KO Earth}
                                if ThePixel = 4 then
                                  SetaColor := LLS else {KP Mars}
                                  if ThePixel = 5 then
                                    SetaColor := LLS else {KQ Jupiter}
                                    if ThePixel = 6 then
                                      SetaColor := MDF else
                                        {KR Saturn}
                                      if ThePixel = 7 then
                                        SetaColor := LLS else
                                        {KS Uranus}
                                        if ThePixel = 8 then
                                          SetaColor := MDF else
                                          {KT Neptune}
                                          if ThePixel = 9 then
                                            SetaColor := MDF else
                                            {KU Pluto}
                        end else
                          if ((RedC >= GreenC) and (RedC >= BlueC))
                            then begin {scrub-forest} {KBGreen := 103}
                            if ThePixel = 1 then
                              SetaColor := LLS else
                              {KM Mercury}
                              if ThePixel = 2 then
                                SetaColor := LLS else {KN Venus}
                                if ThePixel = 3 then
                                  SetaColor := LLS {DMA} else
                                    {KO Earth}
                                  if ThePixel = 4 then
                                    SetaColor := DMA else {KP Mars}
                                    if ThePixel = 5 then
                                      SetaColor := LLS else
                                        {KQ Jupiter}
                                      if ThePixel = 6 then
                                        SetaColor := LLS {DMA} else
                                        {KR Saturn}
                                        if ThePixel = 7 then
                                          SetaColor := DMA else
                                          {KS Uranus}
                                          if ThePixel = 8 then
                                            SetaColor := DMA else
                                            {KT Neptune}
                                            if ThePixel = 9 then
                                              SetaColor := DMA else
                                              {KU Pluto}
                          end else
                            if ((GreenC >= RedC) and (RedC >= BlueC))
                              then begin {Tree line} {KBGreen := 115}
                              if ThePixel = 1 then
                                SetaColor := LLS else {KM Mercury}
                                if ThePixel = 2 then
                                  SetaColor := LLS else {KN Venus}
                                  if ThePixel = 3 then
                                    SetaColor := MLF else {KO Earth}
                                    if ThePixel = 4 then
                                      SetaColor := LLS else {KP Mars}
                                      if ThePixel = 5 then
                                        SetaColor := LLS else
                                        {KQ Jupiter}
                                        if ThePixel = 6 then
                                          SetaColor := MLF else
                                          {KR Saturn}
                                          if ThePixel = 7 then
                                            SetaColor := LLS else
                                            {KS Uranus}
                                            if ThePixel = 8 then
                                              SetaColor := MLF else
                                              {KT Neptune}
                                              if ThePixel = 9 then
                                                SetaColor := MLF else
                                                {KU Pluto}
                            end else
                              if ((GreenC >= BlueC) and (BlueC >=
                                RedC))
                                then begin {KBGreen := 113 }
                                if ThePixel = 1 then
                                  SetaColor := LLS else {KM Mercury}
                                  if ThePixel = 2 then
                                    SetaColor := LLS else {KN Venus}
                                    if ThePixel = 3 then
                                      SetaColor := LLS {UUA} else
                                      {KO Earth}
                                      if ThePixel = 4 then
                                        SetaColor := UMA else
                                          {KP Mars}
                                        if ThePixel = 5 then
                                          SetaColor := LLS else
                                          {KQ Jupiter}
                                          if ThePixel = 6 then
                                            SetaColor := LLS else
                                            {KR Saturn}
                                            if ThePixel = 7 then
                                              SetaColor := UMA else
                                              {KS Uranus}
                                              if ThePixel = 8 then
                                                SetaColor := UMA else
                                                {KT Neptune}
                                                if ThePixel = 9 then
                                                  SetaColor := UMA
                                                    else
                                                  {KU Pluto}
                              end;
                  end {Forests and dark fields} else


        {KP Mars}{ Soil MEANDERS, Forest-scrub, Red town}
                    if ((Total < 300) and (BlueC >= GreenC) and
                      (GreenC >= RedC))
                      then begin {KBGreen := 141}
                      if ThePixel = 1 then SetaColor := LLS else
                        {KM Mercury}
                        if ThePixel = 2 then SetaColor := LLS else
                          {KN Venus}
                          if ThePixel = 3 then SetaColor := LLS else
                            {KO Earth}
                            if ThePixel = 4 then
                              SetaColor := DDA else
                              {KP Mars}
                              if ThePixel = 5 then
                                SetaColor := LLS else {KQ Jupiter}
                                if ThePixel = 6 then
                                  SetaColor := LLS else {KR Saturn}
                                  if ThePixel = 7 then
                                    SetaColor := DDA else {KS Uranus}
                                    if ThePixel = 8 then
                                      SetaColor := DDA else
                                        {KT Neptune}
                                      if ThePixel = 9 then
                                        SetaColor := DDA else
                                          {KU Pluto}
                    end else
                      if (Total < 350) then begin
                        if ((BlueC >= GreenC) and (BlueC >= RedC))
                          then begin {KBGreen := 143}
                          if ThePixel = 1 then SetaColor := LLS else
                            {KM Mercury}
                            if ThePixel = 2 then
                              SetaColor := LLS else
                              {KN Venus}
                              if ThePixel = 3 then
                                SetaColor := LLS else {KO Earth}
                                if ThePixel = 4 then
                                  SetaColor := DLA else {KP Mars}
                                  if ThePixel = 5 then
                                    SetaColor := LLS else {KQ Jupiter}
                                    if ThePixel = 6 then
                                      SetaColor := LLS else
                                        {KR Saturn}
                                      if ThePixel = 7 then
                                        SetaColor := DLA else
                                        {KS Uranus}
                                        if ThePixel = 8 then
                                          SetaColor := DLA else
                                          {KT Neptune}
                                          if ThePixel = 9 then
                                            SetaColor := DLA else
                                            {KU Pluto}
                        end else
                          if ((RedC >= GreenC) and (RedC >= BlueC))
                            then begin {KBGreen := 143}
                            if ThePixel = 1 then
                              SetaColor := LLS else
                              {KM Mercury}
                              if ThePixel = 2 then
                                SetaColor := LLS else {KN Venus}
                                if ThePixel = 3 then
                                  SetaColor := LLS else {KO Earth}
                                  if ThePixel = 4 then
                                    SetaColor := MMA else {KP Mars}
                                    if ThePixel = 5 then
                                      SetaColor := LLS else
                                        {KQ Jupiter}
                                      if ThePixel = 6 then
                                        SetaColor := LLS else
                                        {KR Saturn}
                                        if ThePixel = 7 then
                                          SetaColor := MMA else
                                          {KS Uranus}
                                          if ThePixel = 8 then
                                            SetaColor := MMA else
                                            {KT Neptune}
                                            if ThePixel = 9 then
                                              SetaColor := MMA else
                                              {KU Pluto}
                          end else
                            if ((GreenC >= BlueC) and (GreenC >=
                              RedC))
                              then begin {KBGreen := 143}
                              if ThePixel = 1 then
                                SetaColor := LLS else {KM Mercury}
                                if ThePixel = 2 then
                                  SetaColor := LLS else {KN Venus}
                                  if ThePixel = 3 then
                                    SetaColor := LLS else {KO Earth}
                                    if ThePixel = 4 then
                                      SetaColor := DDA else {KP Mars}
                                      if ThePixel = 5 then
                                        SetaColor := LLS else
                                        {KQ Jupiter}
                                        if ThePixel = 6 then
                                          SetaColor := LLS else
                                          {KR Saturn}
                                          if ThePixel = 7 then
                                            SetaColor := DDA else
                                            {KS Uranus}
                                            if ThePixel = 8 then
                                              SetaColor := DDA else
                                              {KT Neptune}
                                              if ThePixel = 9 then
                                                SetaColor := DDA else
                                                {KU Pluto}
                            end
                      end else {OF <350}
                        if ((Total < 450)) then
                        begin
                          if ((BlueC >= GreenC) and (GreenC >= RedC))
                            then begin {KBGreen := 151}
                            if ThePixel = 1 then
                              SetaColor := LLS else
                              {KM Mercury}
                              if ThePixel = 2 then
                                SetaColor := LLS else {KN Venus}
                                if ThePixel = 3 then
                                  SetaColor := LLS else {KO Earth}
                                  if ThePixel = 4 then
                                    SetaColor := MDA else {KP Mars}
                                    if ThePixel = 5 then
                                      SetaColor := LLS else
                                        {KQ Jupiter}
                                      if ThePixel = 6 then
                                        SetaColor := LLS else
                                        {KR Saturn}
                                        if ThePixel = 7 then
                                          SetaColor := MDA else
                                          {KS Uranus}
                                          if ThePixel = 8 then
                                            SetaColor := MDA else
                                            {KT Neptune}
                                            if ThePixel = 9 then
                                              SetaColor := MDA else
                                              {KU Pluto}
                          end else
                            if ((BlueC >= GreenC) and (BlueC >= RedC))
                              then begin {KBGreen := 153}
                              if ThePixel = 1 then
                                SetaColor := LLS else {KM Mercury}
                                if ThePixel = 2 then
                                  SetaColor := LLS else {KN Venus}
                                  if ThePixel = 3 then
                                    SetaColor := LLS else {KO Earth}
                                    if ThePixel = 4 then
                                      SetaColor := MMA else {KP Mars}
                                      if ThePixel = 5 then
                                        SetaColor := LLS else
                                        {KQ Jupiter}
                                        if ThePixel = 6 then
                                          SetaColor := LLS else
                                          {KR Saturn}
                                          if ThePixel = 7 then
                                            SetaColor := MMA else
                                            {KS Uranus}
                                            if ThePixel = 8 then
                                              SetaColor := MMA else
                                              {KT Neptune}
                                              if ThePixel = 9 then
                                                SetaColor := MMA else
                                                {KU Pluto}
                            end else
                              if ((RedC >= GreenC) and (GreenC >=
                                BlueC))
                                then begin {KBGreen := 165}
                                if ThePixel = 1 then
                                  SetaColor := LLS else {KM Mercury}
                                  if ThePixel = 2 then
                                    SetaColor := LLS else {KN Venus}
                                    if ThePixel = 3 then
                                      SetaColor := LLS else {KO Earth}
                                      if ThePixel = 4 then
                                        SetaColor := MLA else
                                          {KP Mars}
                                        if ThePixel = 5 then
                                          SetaColor := LLS else
                                          {KQ Jupiter}
                                          if ThePixel = 6 then
                                            SetaColor := LLS else
                                            {KR Saturn}
                                            if ThePixel = 7 then
                                              SetaColor := MLA else
                                              {KS Uranus}
                                              if ThePixel = 8 then
                                                SetaColor := MLA else
                                                {KT Neptune}
                                                if ThePixel = 9 then
                                                  SetaColor := MLA
                                                    else
                                                  {KU Pluto}
                              end else
                                if ((RedC >= GreenC) and (RedC >=
                                  BlueC))
                                  then begin {Tree? NO?    {KBGreen := 167}
                                  if ThePixel = 1 then
                                    SetaColor := LLS else {KM Mercury}
                                    if ThePixel = 2 then
                                      SetaColor := LLS else {KN Venus}
                                      if ThePixel = 3 then
                                        SetaColor := LLS else
                                          {KO Earth}
                                        if ThePixel = 4 then
                                          SetaColor := LDA else
                                          {KP Mars}
                                          if ThePixel = 5 then
                                            SetaColor := LLS else
                                            {KQ Jupiter}
                                            if ThePixel = 6 then
                                              SetaColor := LLS else
                                              {KR Saturn}
                                              if ThePixel = 7 then
                                                SetaColor := LDA else
                                                {KS Uranus}
                                                if ThePixel = 8 then
                                                  SetaColor := LDA
                                                    else
                                                  {KT Neptune}
                                                  if ThePixel = 9
                                                    then
                                                    SetaColor := LDA
                                                  else {KU Pluto}
                                end else
                                  if ((GreenC >= BlueC) and (BlueC >=
                                    RedC))
                                    then begin {KBGreen := 137}
                                    if ThePixel = 1 then
                                      SetaColor := LLS else
                                        {KM Mercury}
                                      if ThePixel = 2 then
                                        SetaColor := LLS else
                                          {KN Venus}
                                        if ThePixel = 3 then
                                          SetaColor := LLS else
                                          {KO Earth}
                                          if ThePixel = 4 then
                                            SetaColor := DMA else
                                            {KP Mars}
                                            if ThePixel = 5 then
                                              SetaColor := LLS else
                                              {KQ Jupiter}
                                              if ThePixel = 6 then
                                                SetaColor := LLS else
                                                {KR Saturn}
                                                if ThePixel = 7 then
                                                  SetaColor := DMA
                                                    else
                                                  {KS Uranus}
                                                  if ThePixel = 8
                                                    then
                                                    SetaColor := DMA
                                                  else {KT Neptune}
                                                    if ThePixel = 9
                                                      then
                                                      SetaColor := DMA
                                                    else {KU Pluto}
                                  end else
                                    if ((GreenC >= RedC) and (GreenC
                                      >= BlueC))
                                      then begin {KBGreen := 139 }
                                      if ThePixel = 1 then
                                        SetaColor := LLS else
                                        {KM Mercury}
                                        if ThePixel = 2 then
                                          SetaColor := LLS else
                                          {KN Venus}
                                          if ThePixel = 3 then
                                            SetaColor := LLS else
                                            {KO Earth}
                                            if ThePixel = 4 then
                                              SetaColor := DLA else
                                              {KP Mars}
                                              if ThePixel = 5 then
                                                SetaColor := LLS else
                                                {KQ Jupiter}
                                                if ThePixel = 6 then
                                                  SetaColor := LLS
                                                    {DLA}
                                                else {KR Saturn}
                                                  if ThePixel = 7
                                                    then
                                                    SetaColor := DLA
                                                  else {KS Uranus}
                                                    if ThePixel = 8
                                                      then
                                                      SetaColor := DLA
                                                    else {KT Neptune}
                                                      if ThePixel = 9
                                                        then
                                                        SetaColor := DLA
                                                      else {KU Pluto}
                                    end
                        end else

 {KR Jupiter}{Bright Soils}{URBAN}{HIWAY}{255*3=765}
                          if (Total < 766) then
                          begin
                            if ((RedC = 255) and (BlueC = 255) and
                              (GreenC = 255))
                              then begin {KBRed := 255}
                              if ThePixel = 1 then
                                SetaColor := LLS else {KM Mercury}
                                if ThePixel = 2 then
                                  SetaColor := LLS else {KN Venus}
                                  if ThePixel = 3 then
                                    SetaColor := LLS else {KO Earth}
                                    if ThePixel = 4 then
                                      SetaColor := LLS else {KP Mars}
                                      if ThePixel = 5 then
                                        SetaColor := LMU else
                                        {KQ Jupiter}
                                        if ThePixel = 6 then
                                          SetaColor := LMU else
                                          {KR Saturn}
                                          if ThePixel = 7 then
                                            SetaColor := LLS else
                                            {KS Uranus}
                                            if ThePixel = 8 then
                                              SetaColor := LMU else
                                              {KT Neptune}
                                              if ThePixel = 9 then
                                                SetaColor := LMU else
                                                {KU Pluto}
                            end else {}
                              if ((RedC >= 250) and (BlueC >= 250)
                                and (GreenC >= 250))
                                then begin {KBRed := 253 }
                                if ThePixel = 1 then
                                  SetaColor := LLS else {KM Mercury}
                                  if ThePixel = 2 then
                                    SetaColor := LLS else {KN Venus}
                                    if ThePixel = 3 then
                                      SetaColor := LLS else {KO Earth}
                                      if ThePixel = 4 then
                                        SetaColor := LLS else
                                          {KP Mars}
                                        if ThePixel = 5 then
                                          SetaColor := LMU else
                                          {KQ Jupiter}
                                          if ThePixel = 6 then
                                            SetaColor := LMU else
                                            {KR Saturn}
                                            if ThePixel = 7 then
                                              SetaColor := LLS else
                                              {KS Uranus}
                                              if ThePixel = 8 then
                                                SetaColor := LMU else
                                                {KT Neptune}
                                                if ThePixel = 9 then
                                                  SetaColor := LMU
                                                    else
                                                  {KU Pluto}
                              end else {}
                                if ((RedC >= 220) and (BlueC >= 220)
                                  and (GreenC >= 220))
                                  then begin {KBRed := 251}
                                  if ThePixel = 1 then
                                    SetaColor := LLS else {KM Mercury}
                                    if ThePixel = 2 then
                                      SetaColor := LLS else {KN Venus}
                                      if ThePixel = 3 then
                                        SetaColor := LLS else
                                          {KO Earth}
                                        if ThePixel = 4 then
                                          SetaColor := LLS else
                                          {KP Mars}
                                          if ThePixel = 5 then
                                            SetaColor := LMU else
                                            {KQ Jupiter}
                                            if ThePixel = 6 then
                                              SetaColor := LMU else
                                              {KR Saturn}
                                              if ThePixel = 7 then
                                                SetaColor := LLS else
                                                {KS Uranus}
                                                if ThePixel = 8 then
                                                  SetaColor := LMU
                                                    else
                                                  {KT Neptune}
                                                  if ThePixel = 9
                                                    then
                                                    SetaColor := LMU
                                                  else {KU Pluto}
                                end else {}

                                  if ((RedC >= BlueC) and (BlueC >=
                                    GreenC))
                                    then
                                  begin {KBRed := 225} {SHOULD BE LMU??}
                                    if ThePixel = 1 then
                                      SetaColor := LLS else
                                        {KM Mercury}
                                      if ThePixel = 2 then
                                        SetaColor := LLS else
                                          {KN Venus}
                                        if ThePixel = 3 then
                                          SetaColor := LLS else
                                          {KO Earth}
                                          if ThePixel = 4 then
                                            SetaColor := LLA else
                                            {KP Mars}
                                            if ThePixel = 5 then
                                              SetaColor := LLS else
                                              {KQ Jupiter}
                                              if ThePixel = 6 then
                                                SetaColor := LLS else
                                                {KR Saturn}
                                                if ThePixel = 7 then
                                                  SetaColor := LLA
                                                    else
                                                  {KS Uranus}
                                                  if ThePixel = 8
                                                    then
                                                    SetaColor := LLU
                                                  else {KT Neptune}
                                                    if ThePixel = 9
                                                      then
                                                      SetaColor := LLA
                                                    else {KU Pluto}
                                  end else
                                    if ((RedC >= GreenC) and (RedC >=
                                      BlueC))
                                      then begin {KBRed := 200}
                                      if ThePixel = 1 then
                                        SetaColor := LLS else
                                        {KM Mercury}
                                        if ThePixel = 2 then
                                          SetaColor := LLS else
                                          {KN Venus}
                                          if ThePixel = 3 then
                                            SetaColor := LLS else
                                            {KO Earth}
                                            if ThePixel = 4 then
                                              SetaColor := LLS else
                                              {KP Mars}
                                              if ThePixel = 5 then
                                                SetaColor := MMU else
                                                {KQ Jupiter}
                                                if ThePixel = 6 then
                                                  SetaColor := MMU
                                                    else
                                                  {KR Saturn}
                                                  if ThePixel = 7
                                                    then
                                                    SetaColor := LLS
                                                  else {KS Uranus}
                                                    if ThePixel = 8
                                                      then
                                                      SetaColor := MMU
                                                    else {KT Neptune}
                                                      if ThePixel = 9
                                                        then
                                                        SetaColor := MMU
                                                      else {KU Pluto}
                                    end else
{Soils}
                                      if ((Total < 550) and (BlueC >=
                                        GreenC) and (GreenC >= RedC))
                                        then begin {KBGreen := 141}
                                        if ThePixel = 1 then
                                          SetaColor := LLS else
                                          {KM Mercury}
                                          if ThePixel = 2 then
                                            SetaColor := LLS else
                                            {KN Venus}
                                            if ThePixel = 3 then
                                              SetaColor := LLS else
                                              {KO Earth}
                                              if ThePixel = 4 then
                                                SetaColor := LDA else
                                                {KP Mars}
                                                if ThePixel = 5 then
                                                  SetaColor := LLS
                                                    else
                                                  {KQ Jupiter}
                                                  if ThePixel = 6
                                                    then
                                                    SetaColor := LLS
                                                  else {KR Saturn}
                                                    if ThePixel = 7
                                                      then
                                                      SetaColor := LDA
                                                    else {KS Uranus}
                                                      if ThePixel = 8
                                                        then
                                                        SetaColor := LDA
                                                      else {KT Neptune}
                                                        if ThePixel =
                                                          9 then
                                                          SetaColor := LDA
                                                        else {KU Pluto}
                                      end else
                                        if ((Total < 650) and (BlueC
                                          >= GreenC) and (GreenC >=
                                          RedC))
                                          then begin {KBGreen := 181}
                                          if ThePixel = 1 then
                                            SetaColor := LLS else
                                            {KM Mercury}
                                            if ThePixel = 2 then
                                              SetaColor := LLS else
                                              {KN Venus}
                                              if ThePixel = 3 then
                                                SetaColor := LLS else
                                                {KO Earth}
                                                if ThePixel = 4 then
                                                  SetaColor := LMA
                                                    else
                                                  {KP Mars}
                                                  if ThePixel = 5
                                                    then
                                                    SetaColor := LLS
                                                  else {KQ Jupiter}
                                                    if ThePixel = 6
                                                      then
                                                      SetaColor := LLS
                                                    else {KR Saturn}
                                                      if ThePixel = 7
                                                        then
                                                        SetaColor := LMA
                                                      else {KS Uranus}
                                                        if ThePixel =
                                                          8 then
                                                          SetaColor := LMA
                                                        else {KT Neptune}
                                                          if ThePixel =
                                                            9 then
                                                            SetaColor := LMA
                                                          else {KU Pluto}
                                        end else
                                          if ((BlueC >= GreenC) and
                                            (BlueC >= RedC))
                                            then begin {KBGreen := 221}
                                            if ThePixel = 1 then
                                              SetaColor := LLS else
                                              {KM Mercury}
                                              if ThePixel = 2 then
                                                SetaColor := LLS else
                                                {KN Venus}
                                                if ThePixel = 3 then
                                                  SetaColor := LLS
                                                    else
                                                  {KO Earth}
                                                  if ThePixel = 4
                                                    then
                                                    SetaColor := MLA
                                                  else {KP Mars}
                                                    if ThePixel = 5
                                                      then
                                                      SetaColor := LLS
                                                    else {KQ Jupiter}
                                                      if ThePixel = 6
                                                        then
                                                        SetaColor := LLS
                                                      else {KR Saturn}
                                                        if ThePixel =
                                                          7 then
                                                          SetaColor := MLA
                                                        else {KS Uranus}
                                                          if ThePixel =
                                                            8 then
                                                            SetaColor := MLA
                                                          else {KT Neptune}
                                                            if ThePixel =
                                                              9 then
                                                              SetaColor := MLA
                                                            else {KU Pluto}
                                          end else
                                            if ((Total < 550) and
                                              (GreenC >= BlueC) and
                                              (GreenC >= RedC))
                                              then begin {KBGreen:= 225 }
                                              if ThePixel = 1 then
                                                SetaColor := LLS else
                                                {KM Mercury}
                                                if ThePixel = 2 then
                                                  SetaColor := LLS
                                                    else
                                                  {KN Venus}
                                                  if ThePixel = 3
                                                    then
                                                    SetaColor := LLS
                                                  else {KO Earth}
                                                    if ThePixel = 4
                                                      then
                                                      SetaColor := MDA
                                                    else {KP Mars}
                                                      if ThePixel = 5
                                                        then
                                                        SetaColor := LLS
                                                      else {KQ Jupiter}
                                                        if ThePixel =
                                                          6 then
                                                          SetaColor := LLS
                                                        else {KR Saturn}
                                                          if ThePixel =
                                                            7 then
                                                            SetaColor := MDA
                                                          else {KS Uranus}
                                                            if ThePixel =
                                                              8 then
                                                              SetaColor := MDA
                                                            else {KT Neptune}
                                                              if ThePixel =
                                                                9 then
                                                                SetaColor := MDA
                                                              else {KU Pluto}
                                            end else
                                              if ((Total < 650) and
                                                (GreenC >= BlueC) and
                                                (GreenC >= RedC))
                                                then begin {KBGreen:= 225 }
                                                if ThePixel = 1 then
                                                  SetaColor := LLS
                                                    else
                                                  {KM Mercury}
                                                  if ThePixel = 2
                                                    then
                                                    SetaColor := LLS
                                                  else {KN Venus}
                                                    if ThePixel = 3
                                                      then
                                                      SetaColor := LLS
                                                    else {KO Earth}
                                                      if ThePixel = 4
                                                        then
                                                        SetaColor := MMA
                                                      else {KP Mars}
                                                        if ThePixel =
                                                          5 then
                                                          SetaColor := LLS
                                                        else {KQ Jupiter}
                                                          if ThePixel =
                                                            6 then
                                                            SetaColor := LLS
                                                          else {KR Saturn}
                                                            if ThePixel =
                                                              7 then
                                                              SetaColor := MMA
                                                            else {KS Uranus}
                                                              if ThePixel =
                                                                8 then
                                                                SetaColor := MMA
                                                              else {KT Neptune}
                                                                if ThePixel =
                                                                  9 then
                                                                  SetaColor := MMA
                                                                else {KU Pluto}
                                              end else
                                                if ((GreenC >= BlueC)
                                                  and (GreenC >=
                                                    RedC))
                                                  then begin {KBGreen:= 215}
                                                  if ThePixel = 1
                                                    then
                                                    SetaColor := LLS
                                                  else {KM Mercury}
                                                    if ThePixel = 2
                                                      then
                                                      SetaColor := LLS
                                                    else {KN Venus}
                                                      if ThePixel = 3
                                                        then
                                                        SetaColor := LLS
                                                      else {KO Earth}
                                                        if ThePixel =
                                                          4 then
                                                          SetaColor := MMA
                                                        else {KP Mars}
                                                          if ThePixel =
                                                            5 then
                                                            SetaColor := LLS
                                                          else {KQ Jupiter}
                                                            if ThePixel =
                                                              6 then
                                                              SetaColor := LLS
                                                            else {KR Saturn}
                                                              if ThePixel =
                                                                7 then
                                                                SetaColor := MMA
                                                              else {KS Uranus}
                                                                if ThePixel =
                                                                  8 then
                                                                  SetaColor := MMA
                                                                else {KT Neptune}
                                                                  if ThePixel =
                                                                    9 then
                                                                    SetaColor := MMA
                                                                  else {KU Pluto}
                                                end end else
                            SetaColor := LLS;
        end;
{SetPixel(hWorkDC, IW, IL,SetaColor);}
        BlueColor := GetBValue(SetaColor);
        RedColor := GetRValue(SetaColor);
        GreenColor := GetGValue(SetaColor);
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := BlueColor; lpPixelG^ := RedColor; lpPixelR^ :=
        RedColor;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229); }
  end; {OF MAKE BITMAP}
  SetFileName(GRIPFileName);
end; {of Do_SOHO_IF}
(******************************************************)
(******************************************************)

procedure Do_Asteroids(A_Set: Double);
var
 {A_Set,} Total: Double;
  SetaColor {, TheColor}: Longint;
  RedC, BlueC, GreenC,
    IL, IW: DWord;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
begin {Get current Window DC}
{GetLandValue;  }

  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
        { TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedC:= GetRValue(TheColor);
         GreenC:= GetGValue(TheColor);
         BlueC:= GetBValue(TheColor); }
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueC := lpPixelB^;
        GreenC := lpPixelG^;
        RedC := lpPixelR^;

        begin {of  Meander scars}
          Total := (GreenC + BlueC + RedC + 0.1);
          SetaColor := ColorWhite;
{Water}
{DMW prints lighter than MMW}{These are reversed to PRINT!}
{LLW prints lighter than UUW}{These are reversed to PRINT!}
          if ((BlueC < 40) and (RedC < 40) and (GreenC < 40))
            then begin
            if ((RedC < 30) and (BlueC < 30) and (GreenC < 30)
              and (BlueC >= RedC) and (BlueC >= GreenC))
              then SetaColor := LLW else {Horseshoe Lake}
              if ((RedC <= 30) and (BlueC <= 30) and (GreenC <= 30)
                and (RedC >= BlueC)) {Edelhart Lake}
                then SetaColor := MMW else
                if ((BlueC >= GreenC) and (BlueC >= RedC)) {Ponds}
                  then SetaColor := DDW else
                  if ((RedC >= BlueC) and (RedC >= GreenC))
                    {Edelhart Lake}
                  then SetaColor := DMC else
                    if ((GreenC >= RedC) and (GreenC >= BlueC))
                      {Edges of water}
                    then SetaColor := MMC
          end else
            if ((BlueC < 80) and (GreenC < 60) and (RedC < 30)
              and (BlueC > GreenC) and (GreenC > RedC))
              then SetaColor := LMC else

{MASSIVE IR SWITCH}{Followed by non-IR}{IR}
              if (RedC > (BlueC + GreenC)) then begin
                if RedC > 140 then SetaColor := LDA else
                  if RedC > 105 then SetaColor := MLA else
                    if ((RedC > 75) and (BlueC < 16))
                      then SetaColor := LDA else
                      if ((RedC < 76) and (BlueC < 16))
                        then SetaColor := DLA else
                        if ((RedC > 75) and (BlueC < 30))
                          then SetaColor := LMA else
                          if ((RedC < 76) and (BlueC < 30))
                            then SetaColor := MDA else
                            if ((RedC > 75) and (BlueC > 29))
                              then SetaColor := MMA else
                              if ((RedC < 76) and (BlueC > 29))
                                then SetaColor := MLA else
                                SetaColor := LMB
              end else {of IR SWITCH}

(*
IF (Total < (A_Set*2.5){125}) then Begin
   IF ((RedC >= GreenC) and (GreenC >= BlueC))
   then SetaColor:= MDF  else
   IF ((GreenC >= RedC) and (RedC >=  BlueC))
   then SetaColor:= MLF {forest}
END ELSE
*)
                if ((GreenC > (A_Set * 3)) and (GreenC >= BlueC) and
                  (BlueC >= RedC))
                  then SetaColor := LLA else

     {Begin of Dark Switch}{Forests}
                  if (Total < (A_Set * 5) {255}) then
                  begin {Dark (Blue) areas}
                    if ((BlueC >= GreenC) and (GreenC >= RedC))
                      then SetaColor := ULA else
                      if ((BlueC >= GreenC) and (BlueC >= RedC))
                        then SetaColor := DDA else

                        if ((RedC >= GreenC) and (GreenC >= BlueC))
                          then SetaColor := MDF else
                          if ((RedC >= GreenC) and (RedC >= BlueC))
                            then SetaColor := DMA else

                            if ((GreenC >= RedC) and (RedC >= BlueC))
                              then SetaColor := MLF else {forest}
                              if ((GreenC >= BlueC) and (BlueC >=
                                RedC))
                                then SetaColor := UMA
                              else SetaColor := LMB {Get any left...}
                  end {Forests and dark fields} else {Dark meanders}

                    if ((Total < (A_Set * 6) {300}) and (BlueC >=
                      GreenC) and (GreenC >= RedC) {300})
                      then SetaColor := DDA else
                      if ((Total < (A_Set * 7) {350})) then
                      begin
                        if ((BlueC >= GreenC) and (BlueC >= RedC))
                          then SetaColor := DLA else
                          if ((RedC >= GreenC) and (RedC >= BlueC))
                            then SetaColor := MMA else
                            if ((GreenC >= BlueC) and (GreenC >=
                              RedC))
                              then SetaColor := DDA
                            else SetaColor := LMB
                      end else
{end of Dark meanders}


       {OUTSIDE Light Meanders}{MANY LIGHT areas}
                        if ((Total < (A_Set * 9) {450})) then
                        begin
                          if ((BlueC >= GreenC) and (GreenC >= RedC))
                            then SetaColor := MDA else
                            if ((BlueC >= GreenC) and (BlueC >= RedC))
                              then SetaColor := MMA else

                              if ((RedC >= GreenC) and (GreenC >=
                                BlueC))
                                then SetaColor := MLA else
                                if ((RedC >= GreenC) and (RedC >=
                                  BlueC))
                                  then SetaColor := LDA else

                                  if ((GreenC >= BlueC) and (BlueC >=
                                    RedC))
                                    then SetaColor := DMA else
                                    if ((GreenC >= RedC) and (GreenC
                                      >= BlueC))
                                      then SetaColor := DLA
                                    else SetaColor := COLORWHITE
                        end else

{Hi way}
                          if ((Total < 766)) then
                          begin
                            if ((RedC = 255) and (BlueC = 255) and
                              (GreenC = 255))
                              then SetaColor := LMU else {}
                              if ((RedC >= 250) and (BlueC >= 250)
                                and (GreenC >= 250))
                                then SetaColor := LMU else {}
                                if ((RedC >= 220) and (BlueC >= 220)
                                  and (GreenC >= 220))
                                  then SetaColor := LMU else {}

                                  if ((RedC >= BlueC) and (BlueC >=
                                    GreenC))
                                    then SetaColor := LLA else
                                    if ((RedC >= GreenC) and (RedC >=
                                      BlueC))
                                      then SetaColor := MMU else
                                        {Hi roads}

                                      if ((Total < (A_Set * 11) {550})
                                        and (BlueC >= GreenC) and
                                        (GreenC >= RedC))
                                        then SetaColor := LDA else
                                        if ((Total < (A_Set * 13)
                                          {650}) and (BlueC >= GreenC)
                                          and (GreenC >= RedC))
                                          then SetaColor := LMA else
{Fills the above}
                                          if ((BlueC >= GreenC) and
                                            (BlueC >= RedC))
                                            then
                                            SetaColor := MLA else

                                            if ((Total < (A_Set * 11)
                                              {550}) and (GreenC >=
                                              BlueC) and (GreenC >=
                                              RedC))
                                              then
                                              SetaColor := MDA else
                                              if ((Total < (A_Set *
                                                13) {650}) and (GreenC
                                                >= BlueC) and (GreenC
                                                >= RedC))
                                                then
                                                SetaColor := MMA else
                                                if ((GreenC >= BlueC)
                                                  and (GreenC >=
                                                    RedC))
                                                  then
                                                  SetaColor := MMA
                                                else
                                                  SetaColor := COLORWHITE
                          end else
{END ELSE}
                          begin {turn it white} {or Purple}
                            SetaColor := ColorYELLOW;
                          end;
        end; {End of  Meander scars}
{       SetPixel(hWorkDC, IW, IL,SetaColor);}
        BlueColor := GetBValue(SetaColor);
        RedColor := GetRValue(SetaColor);
        GreenColor := GetGValue(SetaColor);
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := BlueColor; lpPixelG^ := RedColor; lpPixelR^ :=
        RedColor;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
(*ChangeName('K', 'Y');*)
end; {of Agricultural Asteroid}
(******************************************************)
(******************************************************)

procedure Do_Halley(RedSet, GreenSet, BlueSet: Double);
var
  RedC, BlueC, GreenC, Total: Double;
{  BlueSet, RedSet, GreenSet: Double;}
  SetaColor {, TheColor}: Longint;
  IL, IW: Dword;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
begin {Get current Window DC}
 { GetWaterValue;  GetIRValue;  GetLandValue;  }
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
       {  TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedC:= GetRValue(TheColor);
         GreenC:= GetGValue(TheColor);
         BlueC:= GetBValue(TheColor);  }
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueC := lpPixelB^;
        GreenC := lpPixelG^;
        RedC := lpPixelR^;

        begin {of  Meander scars}
          Total := (GreenC + BlueC + RedC + 0.01);
          SetaColor := ColorWhite;
 {Water}{Horseshoe Lake}
          if ((BlueC < (BlueSet + trunc(BlueSet / 3)))
            and (RedC < (BlueSet + trunc(BlueSet / 3)))
            and (GreenC < (BlueSet + trunc(BlueSet / 3))))
            then begin
            if ((RedC < BlueSet) and (BlueC < BlueSet) and (GreenC <
              BlueSet)
              and (BlueC >= RedC) and (BlueC >= GreenC))
              then SetaColor := LLW else
              if ((RedC <= BlueSet) and (BlueC <= BlueSet) and (GreenC
                <= BlueSet)
                and (RedC >= BlueC))
                then SetaColor := MMW else
                if ((BlueC >= GreenC) and (BlueC >= RedC))
                  then SetaColor := DDW else
                  if ((RedC >= GreenC) and (RedC >= BlueC))
                    then SetaColor := DMC else
                    if ((GreenC >= BlueC) and (GreenC >= RedC))
                      then SetaColor := MMC else
          end else
            if ((BlueC < (2 * (BlueSet + trunc(BlueSet / 3))))
              and (GreenC < (BlueSet * 2)) and (RedC < BlueSet)
              and (BlueC > GreenC) and (GreenC > RedC))
              then SetaColor := LMC else


 {MASSIVE IR SWITCH}{Followed by non-IR}
              if (RedC > (BlueC + GreenC)) then begin
                if RedC > (RedSet * 7) {140} then
                  SetaColor := LDA else
                  if RedC > (RedSet * 5) {105} then
                    SetaColor := MLA else
                    if ((RedC > (RedSet * 3.3)) {75} and (BlueC <=
                      (RedSet))) {16}
                      then SetaColor := LDA else
                      if ((RedC <= (RedSet * 3.3) {75}) and (BlueC <=
                        (RedSet) {16}))
                        then SetaColor := DLA else
                        if ((RedC > (RedSet * 3.3) {75}) and (BlueC
                          <= (RedSet * 1.5) {30}))
                          then SetaColor := LMA else
                          if ((RedC <= (RedSet * 3.3) {75}) and (BlueC
                            <= (RedSet * 1.5) {30}))
                            then SetaColor := MDA else
                            if ((RedC > (RedSet * 3.3) {75}) and
                              (BlueC > (RedSet * 1.5) {30}))
                              then SetaColor := MMA else
                              if ((RedC <= (RedSet * 3.3) {75}) and
                                (BlueC > (RedSet * 1.5) {30}))
                                then SetaColor := MLA
              end else
{of IR SWITCH}

(*  IF ((BlueC/(GreenC +0.1)) >= (GreenC / (RedC +0.1)))
   then KBGreen := 86 {Whiteout} else {forest}
*)
                if ((GreenC > (GreenSet * 3)) and (GreenC >= BlueC)
                  and (BlueC >= RedC))
                  then SetaColor := LLA else

     {Begin of Dark Switch}{Forests}
                  if (Total < (GreenSet * 5) {255}) then
                  begin {Dark (Blue) areas}
                    if ((BlueC >= GreenC) and (GreenC >= RedC))
                      then SetaColor := ULA else
                      if ((BlueC >= GreenC) and (BlueC >= RedC))
                        then SetaColor := DDA else
                        if ((RedC >= GreenC) and (GreenC >= BlueC))
                          then SetaColor := MDF else
                          if ((RedC >= GreenC) and (RedC >= BlueC))
                            then SetaColor := DMA else
                            if ((GreenC >= RedC) and (RedC >= BlueC))
                              then SetaColor := MLF else
                              if ((GreenC >= BlueC) and (BlueC >=
                                RedC))
                                then SetaColor := UMA
                  end {Forests and dark fields} else {Dark meanders}

                    if ((Total < (GreenSet * 6) {300}) and (BlueC >=
                      GreenC) and (GreenC >= RedC))
                      then SetaColor := DDA else
                      if ((Total < (GreenSet * 7) {350})) then
                      begin
                        if ((BlueC >= GreenC) and (BlueC >= RedC))
                          then SetaColor := DLA else
                          if ((RedC >= GreenC) and (RedC >= BlueC))
                            then SetaColor := MMA else
                            if ((GreenC >= BlueC) and (GreenC >=
                              RedC))
                              then SetaColor := DDA
                      end else
{end of Dark meanders}

       {OUTSIDE Light Meanders}{MANY LIGHT areas}
                        if ((Total < (GreenSet * 9) {450})) then
                        begin
                          if ((BlueC >= GreenC) and (GreenC >= RedC))
                            then SetaColor := MDA else
                            if ((BlueC >= GreenC) and (BlueC >= RedC))
                              then SetaColor := MMA else
                              if ((RedC >= GreenC) and (GreenC >=
                                BlueC))
                                then SetaColor := MLA else
                                if ((RedC >= GreenC) and (RedC >=
                                  BlueC))
                                  then SetaColor := LDA else
                                  if ((GreenC >= BlueC) and (BlueC >=
                                    RedC))
                                    then SetaColor := DMA else
                                    if ((GreenC >= RedC) and (GreenC
                                      >= BlueC))
                                      then SetaColor := DLA
                        end else

{Hi way}
                          if ((Total < 766)) then
                          begin
                            if ((RedC = 255) and (BlueC = 255) and
                              (GreenC = 255))
                              then SetaColor := LMU else {}
                              if ((RedC >= 250) and (BlueC >= 250)
                                and (GreenC >= 250))
                                then SetaColor := LMU else {}
                                if ((RedC >= 220) and (BlueC >= 220)
                                  and (GreenC >= 220))
                                  then SetaColor := LMU else {}

                                  if ((RedC >= BlueC) and (BlueC >=
                                    GreenC))
                                    then SetaColor := LLA else
                                    if ((RedC >= GreenC) and (RedC >=
                                      BlueC))
                                      then SetaColor := MMU else

                                      if ((Total < (GreenSet * 11)
                                        {550}) and (BlueC > GreenC)
                                          and
                                        (GreenC >= RedC))
                                        then SetaColor := LDA else
                                        if ((Total < (GreenSet * 13)
                                          {650}) and (BlueC > GreenC)
                                          and (GreenC >= RedC))
                                          then SetaColor := LMA else
                                          if ((BlueC > GreenC) and
                                            (BlueC >= RedC))
                                            then
                                            SetaColor := MLA else


                                            if ((Total < (GreenSet *
                                              11) {550}) and (GreenC
                                                >=
                                              BlueC) and (GreenC >=
                                              RedC))
                                              then
                                              SetaColor := MDA else
                                              if ((Total < (GreenSet
                                                * 13) {650}) and
                                                  (GreenC
                                                >= BlueC) and (GreenC
                                                >= RedC))
                                                then
                                                SetaColor := MMA else
                                                if ((GreenC >= BlueC)
                                                  and (GreenC >=
                                                    RedC))
                                                  then
                                                  SetaColor := MMA
                                                else
                          end else SetaColor := ColorWhite
        end; {End of  Meander scars}
{       SetPixel(hWorkDC, IW, IL,SetaColor);}
        BlueColor := GetBValue(SetaColor);
        RedColor := GetRValue(SetaColor);
        GreenColor := GetGValue(SetaColor);
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := BlueColor; lpPixelG^ := RedColor; lpPixelR^ :=
        RedColor;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
{Do_Error(1226,1227);ChangeName('K','S');}
end; {of Halley}
(*****************************************************)
(*****************************************************)

procedure Do_Slice(Sliced: Integer);
var
  SetaColor {, TheColor}: Longint;
  RedC, BlueC, GreenC, Total,
    ILStart, ILEnd, IWStart, IWEnd: Integer;
  IL, IW: DWord;
begin
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if (ImageMade = TRUE) then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
         {TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedC:= GetRValue(TheColor);
         GreenC:= GetGValue(TheColor);
         BlueC:= GetBValue(TheColor);   }
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueC := lpPixelB^;
        GreenC := lpPixelG^;
        RedC := lpPixelR^;

        begin {of  Meander scars}
          Total := (GreenC + BlueC + RedC);
          SetaColor := ColorWhite;
{Water}
{DDW prints lighter than LLW}{These are reversed to PRINT!}
          if ((BlueC < 40) and (RedC < 40) and (GreenC < 40))
            then begin
            if ((RedC < 30) and (BlueC < 30) and (GreenC < 30)
              and (BlueC >= RedC) and (BlueC >= GreenC))
              then
              if (Sliced = 1) {dark Horseshoe Lake EDGE & ROAD LAKE}
                then SetaColor := LLW else
                  SetaColor := ColorWhite else
              if ((RedC <= 30) and (BlueC <= 30) and (GreenC <= 30)
                and (RedC >= BlueC))
                then
                if (Sliced = 2) {McDONOUGH LAKE & H Lake Beach (IR)}
                  then SetaColor := MMW else
                SetaColor := ColorWhite else
                if ((BlueC >= GreenC) and (BlueC >= RedC))
                  then
                  if (Sliced = 3)
                    {H LAKE middle turbid->(LIGHT) & PONDS}
                  then SetaColor := DDW else
                  SetaColor := ColorWhite else
                  if ((RedC >= BlueC) and (RedC >= GreenC))
                    then if (Sliced = 4) {Edelhart Lake}
                    then SetaColor := DMC else
                    SetaColor := ColorWhite else
                    if ((GreenC >= RedC) and (GreenC >= BlueC))
                      then if (Sliced = 5) {DOTS: Edges of water}
                      then SetaColor := MMC else
                        SetaColor := ColorWhite
          end else
            if ((BlueC < 80) and (GreenC < 60) and (RedC < 30)
              and (BlueC > GreenC) and (GreenC > RedC))
              then if (Sliced = 6) {LONG ROAD POND & SMALL WET AREAS}
              then SetaColor := LMC else SetaColor := ColorWhite else

{MASSIVE IR SWITCH}{Followed by non-IR}{IR}
              if (RedC > (BlueC + GreenC)) then begin
                if RedC > 140 then
                  if (Sliced = 7) {LIGHT IR, AIRFIELD}
                    then SetaColor := LDA else
                  SetaColor := ColorWhite else
                  if RedC > 105 then
                    if (Sliced = 8) {MEDIUM IR FIELDS}
                      then SetaColor := MLA else
                    SetaColor := ColorWhite else
                    if ((RedC > 75) and (BlueC < 16))
                      then if (Sliced = 9) {MEDIUM IR}
                      then SetaColor := LDA else
                      SetaColor := ColorWhite else
                      if ((RedC < 76) and (BlueC < 16))
                        then if (Sliced = 10) {DARK IR}
                        then SetaColor := DLA else
                        SetaColor := ColorWhite else
                        if ((RedC > 75) and (BlueC < 30))
                          then if (Sliced = 11) {--MEDIUM IR}
                          then SetaColor := LMA else
                          SetaColor := ColorWhite else
                          if ((RedC < 76) and (BlueC < 30))
                            then if (Sliced = 12) {DARK IR}
                            then SetaColor := MDA else
                            SetaColor := ColorWhite else
                            if ((RedC > 75) and (BlueC > 29))
                              then if (Sliced = 13) {MEDIUM LIGHT IR}
                              then SetaColor := MMA else
                              SetaColor := ColorWhite else
                              if ((RedC < 76) and (BlueC > 29))
                                then
                                if (Sliced = 14) {SPOTS OF DARK IR}
                                  then SetaColor := MLA else
                                  SetaColor := ColorWhite
              end else {of IR SWITCH}

                if ((GreenC > 150) and (GreenC >= BlueC) and (BlueC
                  >= RedC))
                  then if (Sliced = 15) {LIGHT LINES ALONG MEANDERS}
                  then SetaColor := LLA else
                  SetaColor := ColorWhite else

                  if (Total < 255) then
                  begin {Begin of BLUE SOIL Switch}
                    if ((BlueC >= GreenC) and (GreenC >= RedC))
                      then if (Sliced = 16) {A LOT OF Dark(Blue)soils}
                      then SetaColor := ULA else
                      SetaColor := ColorWhite else
                      if ((BlueC >= GreenC) and (BlueC >= RedC))
                        then
                        if (Sliced = 17) {Edges... scrub forests?}
                          then SetaColor := DDA else
                        SetaColor := ColorWhite else

                        if ((RedC >= GreenC) and (GreenC >= BlueC))
                          then if (Sliced = 18) {Forests!}
                          then SetaColor := MDF else
                          SetaColor := ColorWhite else
                          if ((RedC >= GreenC) and (RedC >= BlueC))
                            then
                            if (Sliced = 19)
                              {Edges...   WET RED SOIL..scrub forests?}
                            then SetaColor := DMA else
                            SetaColor := ColorWhite else

                            if ((GreenC >= RedC) and (RedC >= BlueC))
                              then
                              if (Sliced = 20)
                                {Edges...MOSTLY scrub forests?
                         /W HORIZONTAL FIELD LINES SHADOWS?}
                              then SetaColor := MLF else
                              SetaColor := ColorWhite else
                              if ((GreenC >= BlueC) and (BlueC >=
                                RedC))
                                then if (Sliced = 21) {DARK SOIL}
                                then SetaColor := UMA else
                                  SetaColor := ColorWhite
                  end {Forests and dark fields} else {Dark meanders}

                    if ((Total < 300) and (BlueC >= GreenC) and
                      (GreenC >= RedC))
                      then if (Sliced = 22) {Blue soils}
                      then SetaColor := DDA else
                      SetaColor := ColorWhite else
                      if (Total < 350) then begin
                        if ((BlueC >= GreenC) and (BlueC >= RedC))
                          then
                          if (Sliced = 23) {DK grey splotchy soil}
                            then SetaColor := DLA else
                          SetaColor := ColorWhite else
                          if ((RedC >= GreenC) and (RedC >= BlueC))
                            then
                            if (Sliced = 24) {IR lawns & hook Forest}
                              then SetaColor := MMA else
                            SetaColor := ColorWhite else
                            if ((GreenC >= RedC) and (GreenC >=
                              BlueC))
                              then if (Sliced = 25) {edges & SHADOWS?}
                              then SetaColor := DDA else
                              SetaColor := ColorWhite else
                      end else


                        if (Total < 450) then
                        begin {OUTSIDE Light Meanders} {MANY LIGHT areas}
                          if ((BlueC >= GreenC) and (GreenC >= RedC))
                            then
                            if (Sliced = 26) {MD grey splotchy soil}
                              then SetaColor := MDA else
                            SetaColor := ColorWhite else
                            if ((BlueC >= GreenC) and (BlueC >= RedC))
                              then if (Sliced = 27) {light Edges?}
                              then SetaColor := MMA else
                              SetaColor := ColorWhite else

                              if ((RedC >= GreenC) and (GreenC >=
                                BlueC))
                                then if (Sliced = 28) {lawns}
                                then SetaColor := MLA else
                                SetaColor := ColorWhite else
                                if ((RedC >= GreenC) and (RedC >=
                                  BlueC))
                                  then if (Sliced = 29) {lawns }
                                  then SetaColor := LDA else
                                  SetaColor := ColorWhite else

                                  if ((GreenC >= BlueC) and (BlueC >=
                                    RedC))
                                    then if (Sliced = 30) {edges }
                                    then SetaColor := DMA else
                                    SetaColor := ColorWhite else
                                    if ((GreenC >= RedC) and (GreenC
                                      >= BlueC))
                                      then if (Sliced = 31) {edges }
                                      then SetaColor := DLA else
                                        SetaColor := ColorWhite
                        end else


                          if (Total < 766) then
                          begin {Hi way}
                            if ((RedC = 255) and (BlueC = 255) and
                              (GreenC = 255))
                              then if (Sliced = 32)
                              then SetaColor := LMU else
                              SetaColor := ColorWhite else
                              if ((RedC >= 250) and (BlueC >= 250)
                                and (GreenC >= 250))
                                then if (Sliced = 33)
                                then SetaColor := LMU else
                                SetaColor := ColorWhite else
                                if ((RedC >= 220) and (BlueC >= 220)
                                  and (GreenC >= 220))
                                  then if (Sliced = 34)
                                  then SetaColor := LMU else
                                  SetaColor := ColorWhite else

                                  if ((RedC >= BlueC) and (BlueC >=
                                    GreenC))
                                    then
                                    if (Sliced = 35)
                                      {edges, Red soils}
                                    then SetaColor := LLA else
                                    SetaColor := ColorWhite else
                                    if ((RedC >= GreenC) and (RedC >=
                                      BlueC))
                                      then
                                      if (Sliced = 36) {mostly roads}
                                        {Hi roads}
                                      then SetaColor := MMU else
                                      SetaColor := ColorWhite else

                                      if ((Total < 550) and (BlueC >=
                                        GreenC) and (GreenC >= RedC))
                                        then
                                        if (Sliced = 37) {Blue soils}
                                          then SetaColor := LDA else
                                        SetaColor := ColorWhite else
                                        if ((Total < 650) and (BlueC
                                          >= GreenC) and (GreenC >=
                                          RedC))
                                          then
                                          if (Sliced = 38)
                                            {greyBlue soils}
                                          then SetaColor := LMA else
                                            SetaColor := ColorWhite
                                        else
                                          if ((BlueC >= GreenC) and
                                            (BlueC >= RedC))
                                            then
                                            if (Sliced = 39)
                                              {ltgreyBlue soils}
                                            then
                                              SetaColor := MLA else
                                              SetaColor := ColorWhite
                                          else

                                            if ((Total < 550) and
                                              (GreenC >= BlueC) and
                                              (GreenC >= RedC))
                                              then
                                              if (Sliced = 40) {Edges}
                                                then
                                                SetaColor := MDA else
                                                SetaColor := ColorWhite
                                            else
                                              if ((Total < 650) and
                                                (GreenC >= BlueC) and
                                                (GreenC >= RedC))
                                                then
                                                if (Sliced = 41)
                                                  {light green Edges}
                                                then
                                                  SetaColor := MMA
                                                    else
                                                  SetaColor := ColorWhite
                                              else
                                                if ((GreenC >= BlueC)
                                                  and (GreenC >=
                                                    RedC))
                                                  then
                                                  if (Sliced = 42)
                                                    {DITTO?! light green Edges?}
                                                  then
                                                    SetaColor := MMA
                                                  else
                                                    SetaColor := ColorWhite
                          end else
                            SetaColor := ColorWhite; {turn it white}
        end; {End of  Meander scars}
     {  SetPixel(hWorkDC, IW, IL,SetaColor);}
        BlueColor := GetBValue(SetaColor);
        RedColor := GetRValue(SetaColor);
        GreenColor := GetGValue(SetaColor);
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := BlueColor; lpPixelG^ := RedColor; lpPixelR^ :=
        RedColor;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF (DeleteBitmap <> TRUE) THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of Slice}
(******************************************************)

procedure Do_ISlice(RedSet, GreenSet, BlueSet: Double; Sliced:
  Integer);
var
  SetaColor {, TheColor}: Longint;
  IL, IW: Dword;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
  RedC, BlueC, GreenC, Total: Double;
begin {Get current Window DC}
 { GetWaterValue;  GetIRValue;  GetLandValue;  GetSliceValue;  }
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
{         TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedC:= GetRValue(TheColor);
         GreenC:= GetGValue(TheColor);
         BlueC:= GetBValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueC := lpPixelB^;
        GreenC := lpPixelG^;
        RedC := lpPixelR^;

        begin {of  Meander scars}
          Total := (GreenC + BlueC + RedC);
          SetaColor := ColorWhite;
 {Water}{Horseshoe Lake}
          if ((BlueC < (BlueSet + trunc(BlueSet / 3)))
            and (RedC < (BlueSet + trunc(BlueSet / 3)))
            and (GreenC < (BlueSet + trunc(BlueSet / 3))))
            then begin
            if ((RedC < BlueSet) and (BlueC < BlueSet) and (GreenC <
              BlueSet)
              and (BlueC >= RedC) and (BlueC >= GreenC))
              then
              if (Sliced = 1) {dark Horseshoe Lake EDGE & ROAD LAKE}
                then SetaColor := LLW else
                  SetaColor := ColorWhite else
              if ((RedC <= BlueSet) and (BlueC <= BlueSet) and (GreenC
                <= BlueSet)
                and (RedC >= BlueC))
                then
                if (Sliced = 2) {McDONOUGH LAKE & H Lake Beach (IR)}
                  then SetaColor := MMW else
                SetaColor := ColorWhite else
                if ((BlueC >= GreenC) and (BlueC >= RedC))
                  then
                  if (Sliced = 3)
                    {H LAKE middle turbid->(LIGHT) & PONDS}
                  then SetaColor := DDW else
                  SetaColor := ColorWhite else
                  if ((RedC >= GreenC) and (RedC >= BlueC))
                    then if (Sliced = 4) {Edelhart Lake}
                    then SetaColor := DMC else
                    SetaColor := ColorWhite else
                    if ((GreenC >= BlueC) and (GreenC >= RedC))
                      then if (Sliced = 5) {DOTS: Edges of water}
                      then SetaColor := MMC else
                        SetaColor := ColorWhite
          end else
            if ((BlueC < (2 * (BlueSet + trunc(BlueSet / 3))))
              and (GreenC < (BlueSet * 2)) and (RedC < BlueSet)
              and (BlueC > GreenC) and (GreenC > RedC))
              then if (Sliced = 6) {LONG ROAD POND & SMALL WET AREAS}
              then SetaColor := LMC else SetaColor := ColorWhite else


 {MASSIVE IR SWITCH}{Followed by non-IR}
              if (RedC > (BlueC + GreenC)) then begin
                if RedC > (RedSet * 7) {140} then if (Sliced = 7)
                  then SetaColor := LDA else
                  SetaColor := ColorWhite else
                  if RedC > (RedSet * 5) {105} then if (Sliced = 8)
                    then SetaColor := MLA else
                    SetaColor := ColorWhite else
                    if ((RedC > (RedSet * 3.3)) {75} and (BlueC <=
                      (RedSet))) {16}
                      then if (Sliced = 9)
                      then SetaColor := LDA else
                      SetaColor := ColorWhite else
                      if ((RedC <= (RedSet * 3.3) {75}) and (BlueC <=
                        (RedSet) {16}))
                        then if (Sliced = 10)
                        then SetaColor := DLA else
                        SetaColor := ColorWhite else
                        if ((RedC > (RedSet * 3.3) {75}) and (BlueC
                          <= (RedSet * 1.5) {30}))
                          then if (Sliced = 11)
                          then SetaColor := LMA else
                          SetaColor := ColorWhite else
                          if ((RedC <= (RedSet * 3.3) {75}) and (BlueC
                            <= (RedSet * 1.5) {30}))
                            then if (Sliced = 12)
                            then SetaColor := MDA else
                            SetaColor := ColorWhite else
                            if ((RedC > (RedSet * 3.3) {75}) and
                              (BlueC > (RedSet * 1.5) {30}))
                              then if (Sliced = 13)
                              then SetaColor := MMA else
                              SetaColor := ColorWhite else
                              if ((RedC <= (RedSet * 3.3) {75}) and
                                (BlueC > (RedSet * 1.5) {30}))
                                then if (Sliced = 14)
                                then SetaColor := MLA else
                                  SetaColor := ColorWhite
              end else
{of IR SWITCH}

(*  IF ((BlueC/(GreenC +0.1)) >= (GreenC / (RedC +0.1)))
   then KBGreen := 86 {Whiteout} else {forest}
*)
                if ((GreenC > (GreenSet * 3)) and (GreenC >= BlueC)
                  and (BlueC >= RedC))
                  then if (Sliced = 15) {Dark(Blue)soils}
                  then SetaColor := LLA else
                  SetaColor := ColorWhite else

     {Begin of Dark Switch}{Forests}
                  if (Total < (GreenSet * 5) {255}) then
                  begin {Dark (Blue) areas}
                    if ((BlueC >= GreenC) and (GreenC >= RedC))
                      then if (Sliced = 16) {Dark(Blue)soils}
                      then SetaColor := ULA else
                      SetaColor := ColorWhite else
                      if ((BlueC >= GreenC) and (BlueC >= RedC))
                        then
                        if (Sliced = 17) {Edges... scrub forests?}
                          then SetaColor := DDA else
                        SetaColor := ColorWhite else
                        if ((RedC >= GreenC) and (GreenC >= BlueC))
                          then if (Sliced = 18) {Forests!}
                          then SetaColor := MDF else
                          SetaColor := ColorWhite else
                          if ((RedC >= GreenC) and (RedC >= BlueC))
                            then
                            if (Sliced = 19)
                              {Edges...   WET RED SOIL..scrub forests?}
                            then SetaColor := DMA else
                            SetaColor := ColorWhite else
                            if ((GreenC >= RedC) and (RedC >= BlueC))
                              then
                              if (Sliced = 20)
                                {Edges...MOSTLY scrub forests?
                         /W HORIZONTAL FIELD LINES}
                              then SetaColor := MLF else
                              SetaColor := ColorWhite else
                              if ((GreenC >= BlueC) and (BlueC >=
                                RedC))
                                then if (Sliced = 21) {DARK SOIL}
                                then SetaColor := UMA else
                                  SetaColor := ColorWhite
                  end {Forests and dark fields} else {Dark meanders}

                    if ((Total < (GreenSet * 6) {300}) and (BlueC >=
                      GreenC) and (GreenC >= RedC))
                      then if (Sliced = 22) {Blue soils}
                      then SetaColor := DDA else
                      SetaColor := ColorWhite else
                      if ((Total < (GreenSet * 7) {350})) then
                      begin
                        if ((BlueC >= GreenC) and (BlueC >= RedC))
                          then
                          if (Sliced = 23) {DK grey splotchy soil}
                            then SetaColor := DLA else
                          SetaColor := ColorWhite else
                          if ((RedC >= GreenC) and (RedC >= BlueC))
                            then
                            if (Sliced = 24) {IR lawns & hook Forest}
                              then SetaColor := MMA else
                            SetaColor := ColorWhite else
                            if ((GreenC >= BlueC) and (GreenC >=
                              RedC))
                              then if (Sliced = 25) {edges & SHADOWS?}
                              then SetaColor := DDA else
                              SetaColor := ColorWhite else
                      end else
{end of Dark meanders}

       {OUTSIDE Light Meanders}{MANY LIGHT areas}
                        if ((Total < (GreenSet * 9) {450})) then
                        begin
                          if ((BlueC >= GreenC) and (GreenC >= RedC))
                            then
                            if (Sliced = 26) {MD grey splotchy soil}
                              then SetaColor := MDA else
                            SetaColor := ColorWhite else
                            if ((BlueC >= GreenC) and (BlueC >= RedC))
                              then if (Sliced = 27) {light Edges?}
                              then SetaColor := MMA else
                              SetaColor := ColorWhite else
                              if ((RedC >= GreenC) and (GreenC >=
                                BlueC))
                                then if (Sliced = 28) {lawns}
                                then SetaColor := MLA else
                                SetaColor := ColorWhite else
                                if ((RedC >= GreenC) and (RedC >=
                                  BlueC))
                                  then if (Sliced = 29) {lawns }
                                  then SetaColor := LDA else
                                  SetaColor := ColorWhite else
                                  if ((GreenC >= BlueC) and (BlueC >=
                                    RedC))
                                    then if (Sliced = 30) {edges }
                                    then SetaColor := DMA else
                                    SetaColor := ColorWhite else
                                    if ((GreenC >= RedC) and (GreenC
                                      >= BlueC))
                                      then if (Sliced = 31) {edges }
                                      then SetaColor := DLA else
                                        SetaColor := ColorWhite
                        end else

{Hi way}
                          if ((Total < 766)) then
                          begin
                            if ((RedC = 255) and (BlueC = 255) and
                              (GreenC = 255))
                              then if (Sliced = 32)
                              then SetaColor := LMU else
                              SetaColor := ColorWhite else
                              if ((RedC >= 250) and (BlueC >= 250)
                                and (GreenC >= 250))
                                then if (Sliced = 33)
                                then SetaColor := LMU else
                                SetaColor := ColorWhite else
                                if ((RedC >= 220) and (BlueC >= 220)
                                  and (GreenC >= 220))
                                  then if (Sliced = 34)
                                  then SetaColor := LMU else
                                  SetaColor := ColorWhite else

                                  if ((RedC >= BlueC) and (BlueC >=
                                    GreenC))
                                    then
                                    if (Sliced = 35)
                                      {edges, Red soils}
                                    then SetaColor := LLA else
                                    SetaColor := ColorWhite else
                                    if ((RedC >= GreenC) and (RedC >=
                                      BlueC))
                                      then
                                      if (Sliced = 36) {mostly roads}
                                        {Hi roads}
                                      then SetaColor := MMU else
                                      SetaColor := ColorWhite else

                                      if ((Total < (GreenSet * 11)
                                        {550}) and (BlueC > GreenC)
                                          and
                                        (GreenC >= RedC))
                                        then
                                        if (Sliced = 37) {Blue soils}
                                          then SetaColor := LDA else
                                        SetaColor := ColorWhite else
                                        if ((Total < (GreenSet * 13)
                                          {650}) and (BlueC > GreenC)
                                          and (GreenC >= RedC))
                                          then
                                          if (Sliced = 38)
                                            {greyBlue soils}
                                          then SetaColor := LMA else
                                            SetaColor := ColorWhite
                                        else
                                          if ((BlueC > GreenC) and
                                            (BlueC >= RedC))
                                            then
                                            if (Sliced = 39)
                                              {ltgreyBlue soils}
                                            then
                                              SetaColor := MLA else
                                              SetaColor := ColorWhite
                                          else


                                            if ((Total < (GreenSet *
                                              11) {550}) and (GreenC
                                                >=
                                              BlueC) and (GreenC >=
                                              RedC))
                                              then
                                              if (Sliced = 40) {Edges}
                                                then
                                                SetaColor := MDA else
                                                SetaColor := ColorWhite
                                            else
                                              if ((Total < (GreenSet
                                                * 13) {650}) and
                                                  (GreenC
                                                >= BlueC) and (GreenC
                                                >= RedC))
                                                then
                                                if (Sliced = 41)
                                                  {light green Edges}
                                                then
                                                  SetaColor := MMA
                                                    else
                                                  SetaColor := ColorWhite
                                              else
                                                if ((GreenC >= BlueC)
                                                  and (GreenC >=
                                                    RedC))
                                                  then
                                                  if (Sliced = 42)
                                                    {DITTO?! light green Edges?}
                                                  then
                                                    SetaColor := MMA
                                                  else
                                                    SetaColor := ColorWhite
                          end else SetaColor := ColorWhite
        end; {End of  Meander scars}
{       SetPixel(hWorkDC, IW, IL,SetaColor);}
        BlueColor := GetBValue(SetaColor);
        RedColor := GetRValue(SetaColor);
        GreenColor := GetGValue(SetaColor);
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := BlueColor; lpPixelG^ := RedColor; lpPixelR^ :=
        RedColor;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
{Do_Error(1226,1227);ChangeName('K','S');}
end; {of ISlice}
(*****************************************************)
(******************************************************)

procedure CMIHS_AutoH;
var
  RedC, BlueC, GreenC, Total,
    BlueSet, RedSet, GreenSet: Double;
  SetaColor {, TheColor}: Longint;
  IL, IW: Dword;
begin {Get current Window DC}
  BlueSet := 30; {CIntervalBlue;}
  RedSet := 20; {CIntervalRed;}
  GreenSet := 50; {CIntervalGreen;}
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := 0 to ImageHeight do begin
      for IW := 0 to ImageWidth do begin
{         TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedC:= GetRValue(TheColor);
         GreenC:= GetGValue(TheColor);
         BlueC:= GetBValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueC := lpPixelB^;
        GreenC := lpPixelG^;
        RedC := lpPixelR^;

        begin {of  Meander scars}
          Total := (GreenC + BlueC + RedC + 0.1);
          SetaColor := ColorWhite;
 {Water}{Horseshoe Lake}
          if ((BlueC < (BlueSet + trunc(BlueSet / 3)))
            and (RedC < (BlueSet + trunc(BlueSet / 3)))
            and (GreenC < (BlueSet + trunc(BlueSet / 3))))
            then begin
            if ((RedC < BlueSet) and (BlueC < BlueSet) and (GreenC <
              BlueSet)
              and (BlueC >= RedC) and (BlueC >= GreenC))
              then SetaColor := LLW else
              if ((RedC <= BlueSet) and (BlueC <= BlueSet) and (GreenC
                <= BlueSet)
                and (RedC >= BlueC))
                then SetaColor := MMW else
                if ((BlueC >= GreenC) and (BlueC >= RedC))
                  then SetaColor := DDW else
                  if ((RedC >= GreenC) and (RedC >= BlueC))
                    then SetaColor := DMC else
                    if ((GreenC >= BlueC) and (GreenC >= RedC))
                      then SetaColor := MMC else
          end else
            if ((BlueC < (2 * (BlueSet + trunc(BlueSet / 3))))
              and (GreenC < (BlueSet * 2)) and (RedC < BlueSet)
              and (BlueC > GreenC) and (GreenC > RedC))
              then SetaColor := LMC else


 {MASSIVE IR SWITCH}{Followed by non-IR}
              if (RedC > (BlueC + GreenC)) then begin
                if RedC > (RedSet * 7) {140} then
                  SetaColor := LDA else
                  if RedC > (RedSet * 5) {105} then
                    SetaColor := MLA else
                    if ((RedC > (RedSet * 3.3)) {75} and (BlueC <=
                      (RedSet))) {16}
                      then SetaColor := LDA else
                      if ((RedC <= (RedSet * 3.3) {75}) and (BlueC <=
                        (RedSet) {16}))
                        then SetaColor := DLA else
                        if ((RedC > (RedSet * 3.3) {75}) and (BlueC
                          <= (RedSet * 1.5) {30}))
                          then SetaColor := LMA else
                          if ((RedC <= (RedSet * 3.3) {75}) and (BlueC
                            <= (RedSet * 1.5) {30}))
                            then SetaColor := MDA else
                            if ((RedC > (RedSet * 3.3) {75}) and
                              (BlueC > (RedSet * 1.5) {30}))
                              then SetaColor := MMA else
                              if ((RedC <= (RedSet * 3.3) {75}) and
                                (BlueC > (RedSet * 1.5) {30}))
                                then SetaColor := MLA
              end else
{of IR SWITCH}

(*  IF ((BlueC/(GreenC +0.1)) >= (GreenC / (RedC +0.1)))
   then KBGreen := 86 {Whiteout} else {forest}
*)
                if ((GreenC > (GreenSet * 3)) and (GreenC >= BlueC)
                  and (BlueC >= RedC))
                  then SetaColor := LLA else

     {Begin of Dark Switch}{Forests}
                  if (Total < (GreenSet * 5) {255}) then
                  begin {Dark (Blue) areas}
                    if ((BlueC >= GreenC) and (GreenC >= RedC))
                      then SetaColor := ULA else
                      if ((BlueC >= GreenC) and (BlueC >= RedC))
                        then SetaColor := DDA else
                        if ((RedC >= GreenC) and (GreenC >= BlueC))
                          then SetaColor := MDF else
                          if ((RedC >= GreenC) and (RedC >= BlueC))
                            then SetaColor := DMA else
                            if ((GreenC >= RedC) and (RedC >= BlueC))
                              then SetaColor := MLF else
                              if ((GreenC >= BlueC) and (BlueC >=
                                RedC))
                                then SetaColor := UMA
                  end {Forests and dark fields} else {Dark meanders}

                    if ((Total < (GreenSet * 6) {300}) and (BlueC >=
                      GreenC) and (GreenC >= RedC))
                      then SetaColor := DDA else
                      if ((Total < (GreenSet * 7) {350})) then
                      begin
                        if ((BlueC >= GreenC) and (BlueC >= RedC))
                          then SetaColor := DLA else
                          if ((RedC >= GreenC) and (RedC >= BlueC))
                            then SetaColor := MMA else
                            if ((GreenC >= BlueC) and (GreenC >=
                              RedC))
                              then SetaColor := DDA
                      end else
{end of Dark meanders}

       {OUTSIDE Light Meanders}{MANY LIGHT areas}
                        if ((Total < (GreenSet * 9) {450})) then
                        begin
                          if ((BlueC >= GreenC) and (GreenC >= RedC))
                            then SetaColor := MDA else
                            if ((BlueC >= GreenC) and (BlueC >= RedC))
                              then SetaColor := MMA else
                              if ((RedC >= GreenC) and (GreenC >=
                                BlueC))
                                then SetaColor := MLA else
                                if ((RedC >= GreenC) and (RedC >=
                                  BlueC))
                                  then SetaColor := LDA else
                                  if ((GreenC >= BlueC) and (BlueC >=
                                    RedC))
                                    then SetaColor := DMA else
                                    if ((GreenC >= RedC) and (GreenC
                                      >= BlueC))
                                      then SetaColor := DLA
                        end else

{Hi way}
                          if ((Total < 766)) then
                          begin
                            if ((RedC = 255) and (BlueC = 255) and
                              (GreenC = 255))
                              then SetaColor := LMU else {}
                              if ((RedC >= 250) and (BlueC >= 250)
                                and (GreenC >= 250))
                                then SetaColor := LMU else {}
                                if ((RedC >= 220) and (BlueC >= 220)
                                  and (GreenC >= 220))
                                  then SetaColor := LMU else {}

                                  if ((RedC >= BlueC) and (BlueC >=
                                    GreenC))
                                    then SetaColor := LLA else
                                    if ((RedC >= GreenC) and (RedC >=
                                      BlueC))
                                      then SetaColor := MMU else

                                      if ((Total < (GreenSet * 11)
                                        {550}) and (BlueC > GreenC)
                                          and
                                        (GreenC >= RedC))
                                        then SetaColor := LDA else
                                        if ((Total < (GreenSet * 13)
                                          {650}) and (BlueC > GreenC)
                                          and (GreenC >= RedC))
                                          then SetaColor := LMA else
                                          if ((BlueC > GreenC) and
                                            (BlueC >= RedC))
                                            then
                                            SetaColor := MLA else


                                            if ((Total < (GreenSet *
                                              11) {550}) and (GreenC
                                                >=
                                              BlueC) and (GreenC >=
                                              RedC))
                                              then
                                              SetaColor := MDA else
                                              if ((Total < (GreenSet
                                                * 13) {650}) and
                                                  (GreenC
                                                >= BlueC) and (GreenC
                                                >= RedC))
                                                then
                                                SetaColor := MMA else
                                                if ((GreenC >= BlueC)
                                                  and (GreenC >=
                                                    RedC))
                                                  then
                                                  SetaColor := MMA
                                                else
                          end else SetaColor := ColorWhite
        end; {End of  Meander scars}
{       SetPixel(hWorkDC, IW, IL,SetaColor);}
        BlueColor := GetBValue(SetaColor);
        RedColor := GetRValue(SetaColor);
        GreenColor := GetGValue(SetaColor);
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := BlueColor; lpPixelG^ := RedColor; lpPixelR^ :=
        RedColor;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
{Do_Error(1226,1227);ChangeName('K','S');}
end; {of AutoH istogram}
(*****************************************************)
(*****************************************************)

procedure Do_SOHO_Numb(ThePixel: Byte);
var
  {TheColor:Longint;}
  R_Filtered, G_Filtered, B_Filtered,
    RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
  IL, IW: Dword;
begin {Get current Window DC}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
        R_Filtered := 0;
        G_Filtered := 0;
        B_Filtered := 0;
 {        TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;

        if ThePixel = 1 then {KW  Sun Red}
        begin
          if ((RedColor >= GreenColor) and (RedColor >= BlueColor))
            then
          begin
            if RedColor < 25 then R_Filtered := 25 else
              if RedColor < 50 then R_Filtered := 50 else
                if RedColor < 100 then R_Filtered := 100 else
                  if RedColor < 150 then R_Filtered := 150 else
                    if RedColor < 200 then R_Filtered := 200 else
      {IF RedColor < 256 then} R_Filtered := 255;
          end else
          begin
            R_Filtered := 255 {RedColor};
            G_Filtered := 255 {GreenColor};
            B_Filtered := 255 {BlueColor};
          end;
        end else
          if ThePixel = 2 then {KX Moon Green}
          begin
            if ((GreenColor >= RedColor) and (GreenColor >=
              BlueColor)) then
            begin
              if GreenColor < 25 then G_Filtered := 25 else
                if GreenColor < 50 then G_Filtered := 50 else
                  if GreenColor < 100 then G_Filtered := 100 else
                    if GreenColor < 150 then G_Filtered := 150 else
                      if GreenColor < 200 then G_Filtered := 200 else
{IF GreenColor < 256 then} G_Filtered := 255;
            end else
            begin
              R_Filtered := 255 {RedColor};
              G_Filtered := 255 {GreenColor};
              B_Filtered := 255 {BlueColor};
            end;
          end else
            if ThePixel = 3 then {IO Blue}
            begin
              if ((BlueColor >= GreenColor) and (BlueColor >=
                RedColor)) then
              begin
                if BlueColor < 25 then B_Filtered := 25 else
                  if BlueColor < 50 then B_Filtered := 50 else
                    if BlueColor < 100 then B_Filtered := 100 else
                      if BlueColor < 150 then B_Filtered := 150 else
                        if BlueColor < 200 then
                          B_Filtered := 200 else
      {IF BlueColor < 256 then } B_Filtered := 255;
              end else
              begin
                R_Filtered := 255 {RedColor};
                G_Filtered := 255 {GreenColor};
                B_Filtered := 255 {BlueColor};
              end;
            end else
              if ThePixel = 4 then {Red Satellite}
              begin
{MASSIVE IR SWITCH}{Followed by non-IR}{IR}
                if (RedColor > (BlueColor + GreenColor)) then begin
                  if RedColor > 140 then R_Filtered := 250 else
                    if RedColor > 105 then R_Filtered := 225 else
                      if ((RedColor > 75) and (BlueColor < 16))
                        then R_Filtered := 125 else
                        if ((RedColor < 76) and (BlueColor < 16))
                          then R_Filtered := 25 else
                          if ((RedColor > 75) and (BlueColor < 30))
                            then R_Filtered := 175 else
                            if ((RedColor < 76) and (BlueColor < 30))
                              then R_Filtered := 50 else
                              if ((RedColor > 75) and (BlueColor >
                                29))
                                then R_Filtered := 105 else
                                if ((RedColor < 76) and (BlueColor >
                                  29))
                                  then R_Filtered := 75 else
                                  R_Filtered := 250
                end else {of IR SWITCH}
                  if ((RedColor >= GreenColor) and (RedColor >=
                    BlueColor)) then
                  begin
                    if RedColor < 25 then R_Filtered := 25 else
                      if RedColor < 50 then R_Filtered := 50 else
                        if RedColor < 100 then R_Filtered := 100 else
                          if RedColor < 150 then
                            R_Filtered := 150 else
                            if RedColor < 200 then
                              R_Filtered := 200 else
      {IF RedColor < 256 then} R_Filtered := 255;
                  end else
                  begin
                    R_Filtered := 255 {RedColor};
                    G_Filtered := 255 {GreenColor};
                    B_Filtered := 255 {BlueColor};
                  end;
              end;
{       SetPixel(hWorkDC, IW, IL,RGB(R_Filtered,G_Filtered,B_Filtered));}
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := B_Filtered; lpPixelG^ := G_Filtered; lpPixelR^
        := R_Filtered;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of }



(******************************************************)

procedure Do_Europa(E_Set: Integer);
var
 {TheColor:Longint;   }
  R_Filtered, G_Filtered, B_Filtered,
    RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
  IL, IW: Dword;
begin {Get current Window DC}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
        R_Filtered := 0;
        G_Filtered := 0;
        B_Filtered := 0;
{         TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;

        if ((RedColor >= BlueColor) and (RedColor >= GreenColor))
          then
        begin
          if RedColor < (E_Set div 2) then R_Filtered := 25 else
            if RedColor < (E_Set * 1) then R_Filtered := 50 else
              if RedColor < (E_Set * 2) then R_Filtered := 100 else
                if RedColor < (E_Set * 3) then R_Filtered := 150 else
                  if RedColor < (E_Set * 4) then
                    R_Filtered := 200 else
                    if RedColor < (E_Set * 5) then
                      R_Filtered := 225 else
                      R_Filtered := 255;
        end else
          if ((GreenColor >= BlueColor) and (GreenColor >= RedColor))
            then
          begin
            if GreenColor < (E_Set div 2) then G_Filtered := 25 else
              if GreenColor < (E_Set * 1) then G_Filtered := 50 else
                if GreenColor < (E_Set * 2) then
                  G_Filtered := 100 else
                  if GreenColor < (E_Set * 3) then
                    G_Filtered := 150 else
                    if GreenColor < (E_Set * 4) then
                      G_Filtered := 200 else
                      if GreenColor < (E_Set * 5) then
                        G_Filtered := 225 else
                        G_Filtered := 255;
          end else
            if ((BlueColor >= RedColor) and (BlueColor >= GreenColor))
              then
            begin
              if BlueColor < (E_Set div 2) then B_Filtered := 25 else
                if BlueColor < (E_Set * 1) then B_Filtered := 50 else
                  if BlueColor < (E_Set * 2) then
                    B_Filtered := 100 else
                    if BlueColor < (E_Set * 3) then
                      B_Filtered := 150 else
                      if BlueColor < (E_Set * 4) then
                        B_Filtered := 200 else
                        if BlueColor < (E_Set * 5) then
                          B_Filtered := 225 else
                          B_Filtered := 255;
            end else
            begin {if not caught, then turn white}
              R_Filtered := 255;
              G_Filtered := 255;
              B_Filtered := 255;
            end;
{       SetPixel(hWorkDC, IW, IL,RGB(R_Filtered,G_Filtered,B_Filtered));}
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := B_Filtered; lpPixelG^ := G_Filtered; lpPixelR^
        := R_Filtered;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {Europa}
(******************************************************)
(******************************************************)

procedure Do_RedSun;
(*BEGIN
Do_Error(1226,1227);  {ChangeName('K','S');} *)
  procedure Whiteout;
  begin KBRed := 255; KBGreen := 255; KBBlue := 255; end;
  procedure PurpleSand;
  begin KBRed := 255; KBBlue := 255; end;
var
 { TheColor:Longint;  }
  RedC, BlueC, GreenC: Byte;
  Total: Integer;
  IL, IW: Dword;
begin {Get current Window DC}
  MakeImage;
  if (ImageMade = TRUE) then begin
    for IL := 0 to ImageHeight do begin
      for IW := 0 to ImageWidth do begin
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueC := lpPixelB^;
        GreenC := lpPixelG^;
        RedC := lpPixelR^;

        KBRed := RedC; {0;}
        KBGreen := GreenC; {0;}
        KBBlue := BlueC; {0; }
        begin {of  Meander scars}
          Total := (GreenC + BlueC + RedC);

{Water}
          if ((BlueC < 40) and (RedC < 40) and (GreenC < 40))
            then begin
            if ((RedC < 30) and (BlueC < 30) and (GreenC < 30)
              and (BlueC >= RedC) and (BlueC >= GreenC))
                {Horseshoe Lake}
            then {KBBlue  := 255}  Whiteout else
              if ((RedC <= 30) and (BlueC <= 30) and (GreenC <= 30)
                and (RedC >= BlueC)) {Canteen ponds}
                then {KBBlue  := 250}  Whiteout else
                if ((BlueC >= GreenC) and (BlueC >= RedC)) {Ponds}
                  then {KBBlue  := 240}  Whiteout else
                  if ((RedC >= BlueC) and (RedC >= GreenC))
                    {Edelhart Lake}
                  then {KBBlue  := 200}  Whiteout else
                    if ((GreenC >= RedC) and (GreenC >= BlueC))
                      {Edges of water}
                    then {KBBlue  := 180}  Whiteout
          end
          else
            if ((BlueC < 80) and (GreenC < 60) and (RedC < 30)
              and (BlueC > GreenC) and (GreenC > RedC)) {Wet?}
              then {KBBlue  := 164}  Whiteout else

{MASSIVE IR SWITCH}{Followed by non-IR}{IR}
              if (RedC > (BlueC + GreenC)) then begin
                if RedC > 140 then {KBGreen := 240}  Whiteout else
                  if RedC > 105 then {KBGreen := 220}  Whiteout else
                    if ((RedC > 75) and (BlueC < 16))
                      then {KBGreen := 170}  Whiteout else
                      if ((RedC < 76) and (BlueC < 16))
                        then {KBGreen := 140}  Whiteout else
                        if ((RedC > 75) and (BlueC < 30))
                          then {KBGreen := 180}  Whiteout else
                          if ((RedC < 76) and (BlueC < 30))
                            then {KBGreen := 150}  Whiteout else
                            if ((RedC > 75) and (BlueC > 29))
                              then { KBGreen := 190}  Whiteout else
                              if ((RedC < 76) and (BlueC > 29))
                                then
                                  {KBGreen := 160}{CyanSand} Whiteout
                              else
  {KBGreen := 240} Whiteout;
              end else {of IR SWITCH}

{Begin of Dark Switch}
                if (Total < 255) then begin
                  if ((BlueC >= GreenC) and (GreenC >= RedC))
                    {Dark(Blue)soils}
                  then {KBGreen := 91}  Whiteout else
                    if ((BlueC >= GreenC) and (BlueC >= RedC))
                      then {KBGreen := 93}  Whiteout else
                        {Edges... scrub forests?}

                      if ((RedC >= GreenC) and (GreenC >= BlueC))
                        {Forests}
                      then {KBGreen := 51}  Whiteout else
                        if ((RedC >= GreenC) and (RedC >= BlueC))
                          then {KBGreen := 103}  Whiteout else
                            {Edges... scrub forests?}

                          if ((GreenC >= RedC) and (RedC >= BlueC))
                            then {KBGreen := 115}  Whiteout else
                              {Edges... scrub forests?}
                            if ((GreenC >= BlueC) and (BlueC >= RedC))
                              then {KBGreen := 113}  Whiteout else
                                {Edges?}
                              if ((GreenC >= BlueC) and (GreenC >=
                                RedC))
                                then
                                  {KBGreen := 113} Whiteout {NOTHING THERE??}
                              else
                                {KBGreen := 129}{PurpleSand}
                                  Whiteout;
                                {Get any left...}
                end {Forests and dark fields} else {Dark meanders}

                  if ((Total < 300) and (BlueC >= GreenC) and (GreenC
                    >= RedC))
                    then {KBGreen:= 131}  Whiteout else {Blue soils}
                    if (Total < 350) then begin
                      if ((BlueC >= GreenC) and (GreenC >= RedC))
                        then {KBGreen:= 141}  Whiteout else
                          {DK grey splotchy soil}
                        if ((RedC >= GreenC) and (RedC >= BlueC))
                          {lawns & hook Forest}
                        then {KBGreen:= 167}  Whiteout else
                          if ((GreenC >= RedC) and (GreenC >= BlueC))
                            then {KBGreen:= 139}  Whiteout {edges}
                          else {KBGreen:= 139}  Whiteout
                    end else

       {OUTSIDE Light Meanders}{MANY LIGHT areas}
                      if (Total < 450) then
                      begin
                        if ((BlueC >= GreenC) and (GreenC >= RedC))
                          {MD grey splotchy soil}
                        then
                            {KBGreen := 151}{PurpleSand} Whiteout
                        else
                          if ((BlueC >= GreenC) and (BlueC >= RedC))
                            {light Edges?}
                          then
                              {KBGreen := 153}{PurpleSand} Whiteout
                          else

                            if ((RedC >= GreenC) and (GreenC >=
                              BlueC)) {lawns}
                              then
                                {KBGreen:= 165}{PurpleSand} Whiteout
                            else
                              if ((RedC >= GreenC) and (RedC >=
                                BlueC)) {lawns }
                                then {KBGreen:= 167}  Whiteout else

                                if ((GreenC >= BlueC) and (BlueC >=
                                  RedC))
                                  then {KBGreen:= 137}  Whiteout else
                                    {edges }
                                  if ((GreenC >= RedC) and (GreenC >=
                                    BlueC))
                                    then
                                      {KBGreen:= 139} Whiteout else
                                      {edges }
  {KBGreen:= 151} Whiteout {Nothing here}
                      end else

{Hi way}
                        if (Total < 766) then
                        begin
                          if ((RedC = 255) and (BlueC = 255) and
                            (GreenC = 255))
                            then
                              {KBGreen:= 254}{PurpleSand} Whiteout
                          else {}
                            if ((RedC >= 250) and (BlueC >= 250) and
                              (GreenC >= 250))
                              then
                                {KBGreen:= 252}{PurpleSand} Whiteout
                            else {}
                              if ((RedC >= 220) and (BlueC >= 220)
                                and (GreenC >= 220))
                                then {KBGreen:= 250}  Whiteout else {}

                                if ((RedC >= BlueC) and (GreenC <=
                                  BlueC)) {edges, Red soils}
                                  then
                                    {KBGreen:= 225}{PurpleSand} Whiteout
                                else
                                  if ((RedC >= GreenC) and (RedC >=
                                    BlueC)) {mostly roads}
                                    then
                                      {KBGreen:= 253}{PurpleSand} Whiteout
                                  else {Hi roads}

                                    if ((Total < 550) and (BlueC >
                                      GreenC) and (GreenC >= RedC))
                                      then
                                        {KBGreen:= 141}{PurpleSand} Whiteout
                                    else {Blue soils}
                                      if ((Total < 650) and (BlueC >
                                        GreenC) and (GreenC >= RedC))
                                        then
                                          {KBGreen:= 181}{PurpleSand} Whiteout
                                      else {greyBlue soils}
{Fills the above}
                                        if ((BlueC >= GreenC) and
                                          (BlueC >= RedC))
                                          then
                                            {KBGreen:= 221}{PurpleSand} Whiteout
                                        else {ltgreyBlue soils}

                                          if ((Total < 550) and
                                            (GreenC >= BlueC) and
                                            (GreenC >= RedC))
                                            then
                                              {KBGreen:= 141}{PurpleSand} Whiteout
                                          else {Edges}
                                            if ((GreenC >= BlueC) and
                                              (GreenC >= RedC))
                                              then
                                                {KBGreen:= 219} Whiteout {light green Edges}
                                            else
                                              {KBGreen:= 201} Whiteout {nothing}
                        end else


{END ELSE}
                        begin {turn it white} {or Purple}
                          KBRed := {RedC;} {0;} 255;
                          KBGreen := {GreenC;} 0; {255;}
                          KBBlue := {BlueC;} 0; {255;}
                        end;
        end; {End of  Meander scars}
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := KBBlue; lpPixelG^ := KBGreen; lpPixelR^ :=
        KBRed;
      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
{BlackOut;}
    SetImage;
{IF (DeleteBitmap <> TRUE) THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of Tree}

procedure Do_GreenMoon;
{Procedure Whiteout;
begin KBRed:= 255; KBGreen:= 255; KBBlue:= 255; end;
Procedure PurpleSand;
begin KBRed:= 255;   KBBlue:= 255; end;}
var
  {TheColor:Longint;}
  RedC, BlueC, GreenC: Byte;
  Total: Integer;
  IL, IW: Dword;
begin {Get current Window DC}
  MakeImage;
  if (ImageMade = TRUE) then begin
    for IL := 0 to ImageHeight do begin
      for IW := 0 to ImageWidth do begin
        { TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedC:= GetRValue(TheColor);
         GreenC:= GetGValue(TheColor);
         BlueC:= GetBValue(TheColor); }
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueC := lpPixelB^;
        GreenC := lpPixelG^;
        RedC := lpPixelR^;

        KBRed := {RedC;} 0;
        KBGreen := {GreenC;} 0;
        KBBlue := {BlueC;} 0;
        begin {of  Meander scars}
          Total := (GreenC + BlueC + RedC);

{Water}
          if ((BlueC < 40) and (RedC < 40) and (GreenC < 40))
            then begin
            if ((RedC < 30) and (BlueC < 30) and (GreenC < 30)
              and (BlueC >= RedC) and (BlueC >= GreenC))
                {Horseshoe Lake}
            then KBBlue := 255 {Whiteout} else
              if ((RedC <= 30) and (BlueC <= 30) and (GreenC <= 30)
                and (RedC >= BlueC)) {Canteen ponds}
                then KBBlue := 250 {Whiteout} else
                if ((BlueC >= GreenC) and (BlueC >= RedC)) {Ponds}
                  then KBBlue := 240 {Whiteout} else
                  if ((RedC >= BlueC) and (RedC >= GreenC))
                    {Edelhart Lake}
                  then KBBlue := 200 {Whiteout} else
                    if ((GreenC >= RedC) and (GreenC >= BlueC))
                      {Edges of water}
                    then KBBlue := 180 {Whiteout}
          end
          else
            if ((BlueC < 80) and (GreenC < 60) and (RedC < 30)
              and (BlueC > GreenC) and (GreenC > RedC))
              then KBBlue := 164 {Whiteout} else

{MASSIVE IR SWITCH}{Followed by non-IR}{IR}
              if (RedC > (BlueC + GreenC)) then begin
                if RedC > 140 then KBGreen := 240 {Whiteout} else
                  if RedC > 105 then KBGreen := 220 {Whiteout} else
                    if ((RedC > 75) and (BlueC < 16))
                      then KBGreen := 170 {Whiteout} else
                      if ((RedC < 76) and (BlueC < 16))
                        then KBGreen := 140 {Whiteout} else
                        if ((RedC > 75) and (BlueC < 30))
                          then KBGreen := 180 {Whiteout} else
                          if ((RedC < 76) and (BlueC < 30))
                            then KBGreen := 150 {Whiteout} else
                            if ((RedC > 75) and (BlueC > 29))
                              then KBGreen := 190 {Whiteout} else
                              if ((RedC < 76) and (BlueC > 29))
                                then
                                KBGreen := 160 {CyanSand} {Whiteout}
                              else
                                KBGreen := 240 {Whiteout};
              end else {of IR SWITCH}

{Begin of Dark Switch}
                if (Total < 255) then begin
                  if ((BlueC >= GreenC) and (GreenC >= RedC))
                    {Dark(Blue)soils}
                  then KBGreen := 91 {Whiteout} else
                    if ((BlueC >= GreenC) and (BlueC >= RedC))
                      then KBGreen := 93 {Whiteout} else
                        {Edges... scrub forests?}

                      if ((RedC >= GreenC) and (GreenC >= BlueC))
                        {Forests}
                      then KBGreen := 51 {Whiteout} else
                        if ((RedC >= GreenC) and (RedC >= BlueC))
                          then KBGreen := 103 {Whiteout} else
                            {Edges... scrub forests?}

                          if ((GreenC >= RedC) and (RedC >= BlueC))
                            then KBGreen := 115 {Whiteout} else
                              {Edges... scrub forests?}
                            if ((GreenC >= BlueC) and (BlueC >= RedC))
                              then KBGreen := 113 {Whiteout} else
                                {Edges?}
                              if ((GreenC >= BlueC) and (GreenC >=
                                RedC))
                                then
                                KBGreen := 113 {Whiteout}
                                  {NOTHING THERE}
                              else
                                KBGreen := 129 {PurpleSand}
                                  {Whiteout};
                                {Get any left...}
                end {Forests and dark fields} else {Dark meanders}

                  if ((Total < 300) and (BlueC >= GreenC) and (GreenC
                    >= RedC))
                    then KBGreen := 131 {Whiteout} else {Blue soils}
                    if (Total < 350) then begin
                      if ((BlueC >= GreenC) and (BlueC >= RedC))
                        then KBGreen := 141 {Whiteout} else
                          {DK grey splotchy soil}
                        if ((RedC >= GreenC) and (RedC >= BlueC))
                          {lawns & hook Forest}
                        then KBGreen := 167 {Whiteout} else
                          if ((GreenC >= RedC) and (GreenC >= BlueC))
                            then KBGreen := 139 {Whiteout} {edges}
                          else KBGreen := 139 {Whiteout}
                    end else

       {OUTSIDE Light Meanders}{MANY LIGHT areas}
                      if (Total < 450) then
                      begin
                        if ((BlueC >= GreenC) and (GreenC >= RedC))
                          {MD grey splotchy soil}
                        then
                          KBGreen := 151 {PurpleSand} {Whiteout} else
                          if ((BlueC >= GreenC) and (BlueC >= RedC))
                            {light Edges?}
                          then
                            KBGreen := 153 {PurpleSand} {Whiteout}
                          else

                            if ((RedC >= GreenC) and (GreenC >=
                              BlueC)) {lawns}
                              then
                              KBGreen := 165 {PurpleSand} {Whiteout}
                            else
                              if ((RedC >= GreenC) and (RedC >=
                                BlueC)) {lawns }
                                then KBGreen := 167 {Whiteout} else

                                if ((GreenC >= BlueC) and (BlueC >=
                                  RedC))
                                  then KBGreen := 137 {Whiteout} else
                                    {edges }
                                  if ((GreenC >= RedC) and (GreenC >=
                                    BlueC))
                                    then
                                    KBGreen := 139 {Whiteout} else
                                      {edges }
                                    KBGreen := 151 {Whiteout}
                                      {Nothing here}
                      end else

{Hi way}
                        if (Total < 766) then
                        begin
                          if ((RedC = 255) and (BlueC = 255) and
                            (GreenC = 255))
                            then
                            KBRed := 254 {PurpleSand} {Whiteout} else
                              {}
                            if ((RedC >= 250) and (BlueC >= 250) and
                              (GreenC >= 250))
                              then
                              KBRed := 252 {PurpleSand} {Whiteout}
                            else {}
                              if ((RedC >= 220) and (BlueC >= 220)
                                and (GreenC >= 220))
                                then KBRed := 250 {Whiteout} else {}

                                if ((RedC >= BlueC) and (GreenC <=
                                  BlueC)) {edges, Red soils}
                                  then
                                  KBGreen := 225 {PurpleSand}
                                {Whiteout}else
                                  if ((RedC >= GreenC) and (RedC >=
                                    BlueC)) {mostly roads}
                                    then
                                    KBRed := 253 {PurpleSand}
                                  {Whiteout}else {Hi roads}

                                    if ((Total < 550) and (BlueC >
                                      GreenC) and (GreenC >= RedC))
                                      then
                                      KBGreen := 141 {PurpleSand}
                                    {Whiteout}else {Blue soils}
                                      if ((Total < 650) and (BlueC >
                                        GreenC) and (GreenC >= RedC))
                                        then
                                        KBGreen := 181 {PurpleSand}
                                      {Whiteout}else {greyBlue soils}
{Fills the above}
                                        if ((BlueC >= GreenC) and
                                          (BlueC >= RedC))
                                          then
                                          KBGreen := 221 {PurpleSand}
                                        {Whiteout}else {ltgreyBlue soils}

                                          if ((Total < 550) and
                                            (GreenC >= BlueC) and
                                            (GreenC >= RedC))
                                            then
                                            KBGreen := 141
                                          {PurpleSand}{Whiteout}else
                                              {Edges}
                                            if ((GreenC >= BlueC) and
                                              (GreenC >= RedC))
                                              then
                                              KBGreen := 219
                                                {Whiteout}{light green Edges}
                                            else
                                              KBGreen := 201
                                                {Whiteout}
                                              {nothing}
                        end else

{END ELSE}
                        begin {turn it white} {or Purple}
                          KBRed := {RedC;} {0;} 255;
                          KBGreen := {GreenC;} 0; {255;}
                          KBBlue := {BlueC;} {0;} 255;
                        end;
        end; {End of  Meander scars}
    {   SetPixel(hWorkDC, IW, IL,RGB(KBRed, KBGreen, KBBlue));}
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := KBBlue; lpPixelG^ := KBGreen; lpPixelR^ :=
        KBRed;
      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
{BlackOut;}
    SetImage;
{IF (DeleteBitmap <> TRUE) THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of break Tree}

(******************************************************)
(******************************************************)

procedure Do_SetSlice(Net_Set: Byte);
  procedure Whiteout;
  begin KBRed := 255; KBGreen := 255; KBBlue := 255; end;
var
{  TheColor:Longint;  }
  RedColor, BlueColor, GreenColor: Byte;
  IL, IW: Dword;
begin {Get current Window DC}
{GetSliceRGBValue; Do_SetSlice;ChangeName('K', 'V');}
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := 0 to ImageHeight do begin
      for IW := 0 to ImageWidth do begin
{         TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;

        KBRed := RedColor; {0;}
        KBGreen := GreenColor; {0;}
        KBBlue := BlueColor; {0; }

        if ((RedColor >= GreenColor) and (RedColor >= BlueColor))
          then
        begin
          if RedColor < 25
            then
            if (Net_Set = 1) {H Lake eedge & McDonough & scattered}
              then KBRed := 25 else WhiteOut else
            if RedColor < 50
              then if (Net_Set = 2) {IR, Lake 1&2, forest}
              then KBRed := 50 else WhiteOut else
              if RedColor < 100
                then if (Net_Set = 3) {IR , forest, Lake 2}
                then KBRed := 100 else WhiteOut else
                if RedColor < 150
                  then if (Net_Set = 4) {IR lawns}
                  then KBRed := 150 else WhiteOut else
                  if RedColor < 200
                    then if (Net_Set = 5) {IR lawns & roads}
                    then KBRed := 200 else WhiteOut else
                    if RedColor > 199
                      then if (Net_Set = 6) {white roads}
                      then KBRed := 255 else WhiteOut else
        end else
          if ((GreenColor >= BlueColor) and (GreenColor >= RedColor))
            then
          begin
            if GreenColor < 25
              then if (Net_Set = 7) {dots in water}
              then KBGreen := 25 else WhiteOut else
              if GreenColor < 50
                then if (Net_Set = 8) {dots in water}
                then KBGreen := 50 else WhiteOut else
                if GreenColor < 100
                  then
                  if (Net_Set = 9) {dark fields blue soil and forest}
                    then KBGreen := 100 else WhiteOut else
                  if GreenColor < 150
                    then
                    if (Net_Set = 10)
                      {dark fields blue soil and forest}
                    then KBGreen := 150 else WhiteOut else
                    if GreenColor < 200
                      then
                      if (Net_Set = 11) {meander edges & road edges}
                        then KBGreen := 200 else WhiteOut else
                      if GreenColor > 199
                        then
                        if (Net_Set = 12)
                          {light meander edges & road edges}
                        then KBGreen := 255 else WhiteOut else
          end else
            if ((BlueColor >= GreenColor) and (BlueColor >= RedColor))
              then
            begin
              if BlueColor < 25
                then if (Net_Set = 13) {H lake inner, road lake}
                then KBBlue := 25 else WhiteOut else
                if BlueColor < 50
                  then if (Net_Set = 14) {H lake outer, road lake}
                  then KBBlue := 50 else WhiteOut else
                  if BlueColor < 100
                    then
                    if (Net_Set = 15)
                      {lotta stuff, dark fields, road lake}
                    then KBBlue := 100 else WhiteOut else
                    if BlueColor < 150
                      then if (Net_Set = 16) {... & light fields}
                      then KBBlue := 150 else WhiteOut else
                      if BlueColor < 200
                        then if (Net_Set = 17) { ... and some roads}
                        then KBBlue := 200 else WhiteOut else
                        if BlueColor > 199
                          then
                          if (Net_Set = 18) {light fields and roads}
                            then KBBlue := 255 else WhiteOut else
            end else
            begin {turn it white} {or Purple}
              KBRed := {RedC;} {0;} 255;
              KBGreen := {GreenC;} 0; {255;}
              KBBlue := {BlueC;} 255;
            end;
{end;}
  {   SetPixel(hWorkDC, IW, IL,RGB(KBRed, KBGreen, KBBlue));
BlueColor:=GetBValue(SetaColor);
RedColor:=GetBValue(SetaColor);
GreenColor:=GetBValue(SetaColor); }
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := KBBlue; lpPixelG^ := KBGreen; lpPixelR^ :=
        KBRed;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of }
(******************************************************)
(******************************************************)

procedure Do_SetandSlice(Net_Set: Byte; E_Set: Integer);
  procedure Whiteout;
  begin KBRed := 255; KBGreen := 255; KBBlue := 255; end;
var
  {TheColor:Longint; }
  RedColor, BlueColor, GreenColor: Byte;
  IL, IW: Dword;
begin {Get current Window DC}
{GetLandValue;GetSliceRGBValue;Do_SetandSlice;ChangeName('K', 'V');}
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := 0 to ImageHeight do begin
      for IW := 0 to ImageWidth do begin
{         TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;

        KBRed := RedColor; {0;}
        KBGreen := GreenColor; {0;}
        KBBlue := BlueColor; {0; }

        if ((RedColor >= GreenColor) and (RedColor >= BlueColor))
          then
        begin
          if RedColor < (E_Set div 2) {25}
            then if (Net_Set = 1) {}
            then KBRed := 25 else WhiteOut else
            if RedColor < (E_Set * 1) {50}
              then if (Net_Set = 2) {}
              then KBRed := 50 else WhiteOut else
              if RedColor < (E_Set * 2) {100}
                then if (Net_Set = 3) {}
                then KBRed := 100 else WhiteOut else
                if RedColor < (E_Set * 3) {150}
                  then if (Net_Set = 4) {}
                  then KBRed := 150 else WhiteOut else
                  if RedColor < (E_Set * 4) {200}
                    then if (Net_Set = 5) {}
                    then KBRed := 200 else WhiteOut else
                    if RedColor > 199
                      then if (Net_Set = 6) {}
                      then KBRed := 255 else WhiteOut else
        end else
          if ((GreenColor >= BlueColor) and (GreenColor >= RedColor))
            then
          begin
            if GreenColor < (E_Set div 2) {25}
              then if (Net_Set = 7) {}
              then KBGreen := 25 else WhiteOut else
              if GreenColor < (E_Set * 1) {50}
                then if (Net_Set = 8) {}
                then KBGreen := 50 else WhiteOut else
                if GreenColor < (E_Set * 2) {100}
                  then if (Net_Set = 9) {}
                  then KBGreen := 100 else WhiteOut else
                  if GreenColor < (E_Set * 3) {150}
                    then if (Net_Set = 10) {}
                    then KBGreen := 150 else WhiteOut else
                    if GreenColor < (E_Set * 4) {200}
                      then if (Net_Set = 11) {}
                      then KBGreen := 200 else WhiteOut else
                      if GreenColor > +(E_Set * 4)
                        then if (Net_Set = 12) {}
                        then KBGreen := 255 else WhiteOut else
          end else
            if ((BlueColor >= GreenColor) and (BlueColor >= RedColor))
              then
            begin
              if BlueColor < (E_Set div 2) {25}
                then if (Net_Set = 13) {}
                then KBBlue := 25 else WhiteOut else
                if BlueColor < (E_Set * 1) {50}
                  then if (Net_Set = 14) {}
                  then KBBlue := 50 else WhiteOut else
                  if BlueColor < (E_Set * 2) {100}
                    then if (Net_Set = 15) {}
                    then KBBlue := 100 else WhiteOut else
                    if BlueColor < (E_Set * 3) {150}
                      then if (Net_Set = 16) {}
                      then KBBlue := 150 else WhiteOut else
                      if BlueColor < (E_Set * 4) {200}
                        then if (Net_Set = 17) {}
                        then KBBlue := 200 else WhiteOut else
                        if BlueColor >= (E_Set * 4)
                          then if (Net_Set = 18) {}
                          then KBBlue := 255 else WhiteOut end else
            begin {turn it white} {or Purple}
              KBRed := {RedC;} {0;} 255;
              KBGreen := {GreenC;} 0; {255;}
              KBBlue := {BlueC;} 255;
            end;
    { SetPixel(hWorkDC, IW, IL,RGB(KBRed, KBGreen, KBBlue));
BlueColor:=GetBValue(SetaColor);
RedColor:=GetBValue(SetaColor);
GreenColor:=GetBValue(SetaColor); }
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := KBBlue; lpPixelG^ := KBGreen; lpPixelR^ :=
        KBRed;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of }
(******************************************************)
(******************************************************)

(******************************************************)

procedure Do_Class(E_Set: Integer);
var
  SetaColor {, TheColor}: Longint;
  RedColor, BlueColor, GreenColor: Byte;
  IL, IW: Dword;
begin {Get current Window DC}

  MakeImage;
  if ImageMade = TRUE then begin
    for IL := 0 to ImageHeight do begin
      for IW := 0 to ImageWidth do begin
{         TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;

        if ((RedColor >= BlueColor) and (RedColor >= GreenColor))
          then
        begin
          if RedColor < (E_Set div 2) then SetaColor := UMU else
            if RedColor < (E_Set * 1) then SetaColor := DDU else
              if RedColor < (E_Set * 2) then SetaColor := DLU else
                if RedColor < (E_Set * 3) then SetaColor := MMU else
                  if RedColor < (E_Set * 4) then
                    SetaColor := LDU else
                    if RedColor < (E_Set * 5) then
                      SetaColor := LMU else
                      SetaColor := LLU;
        end else
          if ((GreenColor >= BlueColor) and (GreenColor >= RedColor))
            then
          begin
            if GreenColor < (E_Set div 2) then SetaColor := ULF else
              if GreenColor < (E_Set * 1) then SetaColor := DMF else
                if GreenColor < (E_Set * 2) then
                  SetaColor := MDF else
                  if GreenColor < (E_Set * 3) then
                    SetaColor := MMF else
                    if GreenColor < (E_Set * 4) then
                      SetaColor := MLF else
                      if GreenColor < (E_Set * 5) then
                        SetaColor := LMF else
                        SetaColor := LLF
          end else
            if ((BlueColor >= RedColor) and (BlueColor >= GreenColor))
              then
            begin
              if BlueColor < (E_Set div 2) then SetaColor := UMW else
                if BlueColor < (E_Set * 1) then SetaColor := DDW else
                  if BlueColor < (E_Set * 2) then
                    SetaColor := DMW else
                    if BlueColor < (E_Set * 3) then
                      SetaColor := MDW else
                      if BlueColor < (E_Set * 4) then
                        SetaColor := MMW else
                        if BlueColor < (E_Set * 5) then
                          SetaColor := LMW else
                          SetaColor := LLW;
            end else SetaColor := LLS;
{       SetPixel(hWorkDC, IW, IL,SetaColor);}
        BlueColor := GetBValue(SetaColor);
        RedColor := GetRValue(SetaColor);
        GreenColor := GetGValue(SetaColor);
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := BlueColor; lpPixelG^ := GreenColor; lpPixelR^ :=
        RedColor;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {}
(******************************************************)
(******************************************************)

procedure Do_Tone(E_Set: Integer);
var
  SetaColor {, TheColor}: Longint;
  RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
  IL, IW: Dword;
begin {Get current Window DC}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
{         TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;

        if ((RedColor >= BlueColor) and (RedColor >= GreenColor))
          then
        begin
          if RedColor < (E_Set div 2) then SetaColor := UMA else
            if RedColor < (E_Set * 1) then SetaColor := DDA else
              if RedColor < (E_Set * 2) then SetaColor := DLA else
                if RedColor < (E_Set * 3) then SetaColor := MMA else
                  if RedColor < (E_Set * 4) then
                    SetaColor := LDA else
                    if RedColor < (E_Set * 5) then
                      SetaColor := LLA else
                      SetaColor := LLS;
        end else
          if ((GreenColor >= BlueColor) and (GreenColor >= RedColor))
            then
          begin
            if GreenColor < (E_Set div 2) then SetaColor := UMA else
              if GreenColor < (E_Set * 1) then SetaColor := DDA else
                if GreenColor < (E_Set * 2) then
                  SetaColor := DLA else
                  if GreenColor < (E_Set * 3) then
                    SetaColor := MMA else
                    if GreenColor < (E_Set * 4) then
                      SetaColor := LDA else
                      if GreenColor < (E_Set * 5) then
                        SetaColor := LLA else
                        SetaColor := LLS;
          end else
            if ((BlueColor >= RedColor) and (BlueColor >= GreenColor))
              then
            begin
              if BlueColor < (E_Set div 2) then SetaColor := UMA else
                if BlueColor < (E_Set * 1) then SetaColor := DDA else
                  if BlueColor < (E_Set * 2) then
                    SetaColor := DLA else
                    if BlueColor < (E_Set * 3) then
                      SetaColor := MMA else
                      if BlueColor < (E_Set * 4) then
                        SetaColor := LDA else
                        if BlueColor < (E_Set * 5) then
                          SetaColor := LLA else
                          SetaColor := LLS;
            end else SetaColor := LLS;
      { SetPixel(hWorkDC, IW, IL,SetaColor);   }
        BlueColor := GetBValue(SetaColor);
        RedColor := GetRValue(SetaColor);
        GreenColor := GetGValue(SetaColor);
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := BlueColor; lpPixelG^ := GreenColor; lpPixelR^ :=
        RedColor;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {}
(******************************************************)
(******************************************************)


(******************************************************)
(******************************************************)
(******************************************************)

procedure Do_DODO_Numb(ThePixel: Byte);
var
  {TheColor:Longint;}
  R_Filtered, G_Filtered, B_Filtered,
    RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
  IL, IW: Dword;
begin {Get current Window DC}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
        R_Filtered := 0;
        G_Filtered := 0;
        B_Filtered := 0;
{         TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;

        if ThePixel = 1 then {}
        begin
          if ((RedColor >= BlueColor) and (BlueColor >= GreenColor))
            then
          begin
            if RedColor < 25 then B_Filtered := 25 else
              if RedColor < 50 then B_Filtered := 50 else
                if RedColor < 100 then B_Filtered := 100 else
                  if RedColor < 150 then B_Filtered := 150 else
                    if RedColor < 200 then B_Filtered := 200 else
                      if RedColor > 199 then B_Filtered := 255;
          end else
            if ((RedColor >= GreenColor) and (GreenColor >=
              BlueColor)) then
            begin
              if RedColor < 25 then G_Filtered := 25 else
                if RedColor < 50 then G_Filtered := 50 else
                  if RedColor < 100 then G_Filtered := 100 else
                    if RedColor < 150 then G_Filtered := 150 else
                      if RedColor < 200 then G_Filtered := 200 else
                        if RedColor > 199 then G_Filtered := 255;
            end else
            begin
              R_Filtered := 255 {RedColor};
              G_Filtered := 255 {GreenColor};
              B_Filtered := 255 {BlueColor};
            end;
        end else
          if ThePixel = 2 then {}
          begin
            if ((GreenColor >= BlueColor) and (BlueColor >= RedColor))
              then
            begin
              if GreenColor < 25 then B_Filtered := 25 else
                if GreenColor < 50 then B_Filtered := 50 else
                  if GreenColor < 100 then B_Filtered := 100 else
                    if GreenColor < 150 then B_Filtered := 150 else
                      if GreenColor < 200 then B_Filtered := 200 else
                        if GreenColor > 199 then B_Filtered := 255;
            end else
              if ((GreenColor >= RedColor) and (RedColor >=
                BlueColor)) then
              begin
                if GreenColor < 25 then R_Filtered := 25 else
                  if GreenColor < 50 then R_Filtered := 50 else
                    if GreenColor < 100 then R_Filtered := 100 else
                      if GreenColor < 150 then R_Filtered := 150 else
                        if GreenColor < 200 then
                          R_Filtered := 200 else
                          if GreenColor > 199 then R_Filtered := 255;
              end else
              begin
                R_Filtered := 255 {RedColor};
                G_Filtered := 255 {GreenColor};
                B_Filtered := 255 {BlueColor};
              end;
          end else
            if ThePixel = 3 then {}
            begin
              if ((BlueColor >= RedColor) and (RedColor >=
                GreenColor)) then
              begin
                if BlueColor < 25 then R_Filtered := 25 else
                  if BlueColor < 50 then R_Filtered := 50 else
                    if BlueColor < 100 then R_Filtered := 100 else
                      if BlueColor < 150 then R_Filtered := 150 else
                        if BlueColor < 200 then
                          R_Filtered := 200 else
                          if BlueColor > 199 then R_Filtered := 255;
              end else
                if ((BlueColor >= GreenColor) and (GreenColor >=
                  RedColor)) then
                begin
                  if BlueColor < 25 then G_Filtered := 25 else
                    if BlueColor < 50 then G_Filtered := 50 else
                      if BlueColor < 100 then G_Filtered := 100 else
                        if BlueColor < 150 then
                          G_Filtered := 150 else
                          if BlueColor < 200 then
                            G_Filtered := 200 else
                            if BlueColor > 199 then
                              G_Filtered := 255;
                end else
                begin
                  R_Filtered := 255 {RedColor};
                  G_Filtered := 255 {GreenColor};
                  B_Filtered := 255 {BlueColor};
                end;
            end;
{       SetPixel(hWorkDC, IW, IL,RGB(R_Filtered,G_Filtered,B_Filtered));}
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := B_Filtered; lpPixelG^ := G_Filtered; lpPixelR^
        := R_Filtered;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of }
(******************************************************)

procedure Do_DoDo(E_Set: Integer);
var
 {TheColor:Longint;}
  R_Filtered, G_Filtered, B_Filtered,
    RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
  IL, IW: Dword;
begin {Get current Window DC}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
        R_Filtered := 0;
        G_Filtered := 0;
        B_Filtered := 0;
{         TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;

        if ((RedColor >= BlueColor) and (BlueColor >= GreenColor))
          then
        begin
          if RedColor < (E_Set div 2) then B_Filtered := 25 else
            if RedColor < (E_Set * 1) then B_Filtered := 50 else
              if RedColor < (E_Set * 2) then B_Filtered := 100 else
                if RedColor < (E_Set * 3) then B_Filtered := 150 else
                  if RedColor < (E_Set * 4) then
                    B_Filtered := 200 else
                    if RedColor < (E_Set * 5) then
                      B_Filtered := 225 else
                      B_Filtered := 255;
        end else
          if ((RedColor >= GreenColor) and (GreenColor >= BlueColor))
            then
          begin
            if RedColor < (E_Set div 2) then G_Filtered := 25 else
              if RedColor < (E_Set * 1) then G_Filtered := 50 else
                if RedColor < (E_Set * 2) then G_Filtered := 100 else
                  if RedColor < (E_Set * 3) then
                    G_Filtered := 150 else
                    if RedColor < (E_Set * 4) then
                      G_Filtered := 200 else
                      if RedColor < (E_Set * 5) then
                        G_Filtered := 225 else
                        G_Filtered := 255;
          end else
            if ((GreenColor >= BlueColor) and (BlueColor >= RedColor))
              then
            begin
              if GreenColor < (E_Set div 2) then
                B_Filtered := 25 else
                if GreenColor < (E_Set * 1) then
                  B_Filtered := 50 else
                  if GreenColor < (E_Set * 2) then
                    B_Filtered := 100 else
                    if GreenColor < (E_Set * 3) then
                      B_Filtered := 150 else
                      if GreenColor < (E_Set * 4) then
                        B_Filtered := 200 else
                        if GreenColor < (E_Set * 5) then
                          B_Filtered := 225 else
                          B_Filtered := 255;
            end else
              if ((GreenColor >= RedColor) and (RedColor >=
                BlueColor)) then
              begin
                if GreenColor < (E_Set div 2) then
                  R_Filtered := 25 else
                  if GreenColor < (E_Set * 1) then
                    R_Filtered := 50 else
                    if GreenColor < (E_Set * 2) then
                      R_Filtered := 100 else
                      if GreenColor < (E_Set * 3) then
                        R_Filtered := 150 else
                        if GreenColor < (E_Set * 4) then
                          R_Filtered := 200 else
                          if GreenColor < (E_Set * 5) then
                            R_Filtered := 225 else
                            R_Filtered := 255;
              end else
                if ((BlueColor >= RedColor) and (RedColor >=
                  GreenColor)) then
                begin
                  if BlueColor < (E_Set div 2) then
                    R_Filtered := 25 else
                    if BlueColor < (E_Set * 1) then
                      R_Filtered := 50 else
                      if BlueColor < (E_Set * 2) then
                        R_Filtered := 100 else
                        if BlueColor < (E_Set * 3) then
                          R_Filtered := 150 else
                          if BlueColor < (E_Set * 4) then
                            R_Filtered := 200 else
                            if BlueColor < (E_Set * 5) then
                              R_Filtered := 225 else
                              R_Filtered := 255;
                end else
                  if ((BlueColor >= GreenColor) and (GreenColor >=
                    RedColor)) then
                  begin
                    if BlueColor < (E_Set div 2) then
                      G_Filtered := 25 else
                      if BlueColor < (E_Set * 1) then
                        G_Filtered := 50 else
                        if BlueColor < (E_Set * 2) then
                          G_Filtered := 100 else
                          if BlueColor < (E_Set * 3) then
                            G_Filtered := 150 else
                            if BlueColor < (E_Set * 4) then
                              G_Filtered := 200 else
                              if BlueColor < (E_Set * 5) then
                                G_Filtered := 225 else
                                G_Filtered := 255;
                  end else
                  begin {if not caught, then turn white}
                    R_Filtered := 255;
                    G_Filtered := 255;
                    B_Filtered := 255;
                  end;
{       SetPixel(hWorkDC, IW, IL,RGB(R_Filtered,G_Filtered,B_Filtered));}
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := B_Filtered; lpPixelG^ := G_Filtered; lpPixelR^
        := R_Filtered;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (Imageheight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {}
(******************************************************)

procedure Do_SetOSlice(Net_Set: Byte);
  procedure Whiteout;
  begin KBRed := 255; KBGreen := 255; KBBlue := 255; end;
var
  {TheColor:Longint;}
  RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
  IL, IW: Dword;
begin {Get current Window DC}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
{         TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;

        KBRed := RedColor; {0;}
        KBGreen := GreenColor; {0;}
        KBBlue := BlueColor; {0; }

        if ((RedColor >= BlueColor) and (BlueColor >= GreenColor))
          then
        begin
          if RedColor < 25 {This is SetSlice in 2 parts}
            then if (Net_Set = 1) {H lake} {Red   1..6 : 7..12}
            then KBBlue := 25 else WhiteOut else
              {Green 13..18 : 19..24}
            if RedColor < 50 {Blue  25..30 : 31..36}
              then if (Net_Set = 2) {partial}
              then KBBlue := 50 else WhiteOut else
              if RedColor < 100
                then if (Net_Set = 3) {forest, NOT lake}
                then KBBlue := 100 else WhiteOut else
                if RedColor < 150
                  then if (Net_Set = 4) {like set}
                  then KBBlue := 150 else WhiteOut else
                  if RedColor < 200
                    then if (Net_Set = 5) {like set}
                    then KBBlue := 200 else WhiteOut else
                    if RedColor > 199
                      then if (Net_Set = 6) {like set}
                      then KBBlue := 255 else WhiteOut else
        end else
          if ((RedColor >= GreenColor) and (GreenColor >= BlueColor))
            then
          begin
            if RedColor < 25
              then if (Net_Set = 7) {McDonough}
              then KBGreen := 25 else WhiteOut else
              if RedColor < 50
                then if (Net_Set = 8) {lake and forest}
                then KBGreen := 50 else WhiteOut else
                if RedColor < 100
                  then if (Net_Set = 9) {IR, Lake2, forest}
                  then KBGreen := 100 else WhiteOut else
                  if RedColor < 150
                    then if (Net_Set = 10) {IR lawns}
                    then KBGreen := 150 else WhiteOut else
                    if RedColor < 200
                      then if (Net_Set = 11) {roads}
                      then KBGreen := 200 else WhiteOut else
                      if RedColor > 199
                        then if (Net_Set = 12) {white, roads}
                        then KBGreen := 255 else WhiteOut else
          end else
            if ((GreenColor >= BlueColor) and (BlueColor >= RedColor))
              then
            begin
              if GreenColor < 25
                then if (Net_Set = 13) {like set}
                then KBBlue := 25 else WhiteOut else
                if GreenColor < 50
                  then if (Net_Set = 14) {like set}
                  then KBBlue := 50 else WhiteOut else
                  if GreenColor < 100
                    then if (Net_Set = 15) {like set}
                    then KBBlue := 100 else WhiteOut else
                    if GreenColor < 150
                      then if (Net_Set = 16) {like set}
                      then KBBlue := 150 else WhiteOut else
                      if GreenColor < 200
                        then if (Net_Set = 17) {like set}
                        then KBBlue := 200 else WhiteOut else
                        if GreenColor > 199
                          then if (Net_Set = 18) {like set}
                          then KBBlue := 255 else WhiteOut else
            end else
              if ((GreenColor >= RedColor) and (RedColor >=
                BlueColor)) then
              begin
                if GreenColor < 25
                  then if (Net_Set = 19) {very few }
                  then KBRed := 25 else WhiteOut else
                  if GreenColor < 50
                    then if (Net_Set = 20) {like set}
                    then KBRed := 50 else WhiteOut else
                    if GreenColor < 100
                      then if (Net_Set = 21) {forest, road edge}
                      then KBRed := 100 else WhiteOut else
                      if GreenColor < 150
                        then
                        if (Net_Set = 22) {slight forest, &road edge}
                          then KBRed := 150 else WhiteOut else
                        if GreenColor < 200
                          then
                          if (Net_Set = 23)
                            {slight forest, &road edge}
                          then KBRed := 200 else WhiteOut else
                          if GreenColor > 199
                            then if (Net_Set = 24) {white & roads}
                            then KBRed := 255 else WhiteOut else
              end else

                if ((BlueColor >= RedColor) and (RedColor >=
                  GreenColor)) then
                begin
                  if BlueColor < 25
                    then if (Net_Set = 25) {like set}
                    then KBRed := 25 else WhiteOut else
                    if BlueColor < 50
                      then if (Net_Set = 26) {like set}
                      then KBRed := 50 else WhiteOut else
                      if BlueColor < 100
                        then if (Net_Set = 27) {like set}
                        then KBRed := 100 else WhiteOut else
                        if BlueColor < 150
                          then if (Net_Set = 28) {like set}
                          then KBRed := 150 else WhiteOut else
                          if BlueColor < 200
                            then if (Net_Set = 29) {like set}
                            then KBRed := 200 else WhiteOut else
                            if BlueColor > 199
                              then
                              if (Net_Set = 30)
                                {light fields im meander area}
                              then KBRed := 255 else WhiteOut else
                end else
                  if ((BlueColor >= GreenColor) and (GreenColor >=
                    RedColor)) then
                  begin
                    if BlueColor < 25
                      then if (Net_Set = 31) {other half lake}
                      then KBGreen := 25 else WhiteOut else
                      if BlueColor < 50
                        then if (Net_Set = 32) {lake}
                        then KBGreen := 50 else WhiteOut else
                        if BlueColor < 100
                          then if (Net_Set = 33) {dark fields}
                          then KBGreen := 100 else WhiteOut else
                          if BlueColor < 150
                            then if (Net_Set = 34) {light fields}
                            then KBGreen := 150 else WhiteOut else
                            if BlueColor < 200
                              then
                              if (Net_Set = 35) {fields & some roads}
                                then KBGreen := 200 else
                                  WhiteOut else
                              if BlueColor > 199
                                then if (Net_Set = 36) {fields & road}
                                then KBGreen := 255 else
                                  WhiteOut end else
                  begin {turn it white} {or Purple}
                    KBRed := {RedC;} {0;} 255;
                    KBGreen := {GreenC;} 0; {255;}
                    KBBlue := {BlueC;} 255;
                  end;
{     SetPixel(hWorkDC, IW, IL,RGB(KBRed, KBGreen, KBBlue));}
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := KBBlue; lpPixelG^ := KBGreen; lpPixelR^ :=
        KBRed;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of }
(******************************************************)


(******************************************************)

procedure Do_SetOSIlice(Net_Set: Byte; E_Set: Integer);
  procedure Whiteout;
  begin KBRed := 255; KBGreen := 255; KBBlue := 255; end;
var
  TheColor: Longint;
  RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
  IL, IW: Dword;
begin {Get current Window DC}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
{         TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;

        KBRed := RedColor; {0;}
        KBGreen := GreenColor; {0;}
        KBBlue := BlueColor; {0; }

        if ((RedColor >= BlueColor) and (BlueColor >= GreenColor))
          then
        begin
          if RedColor < (E_Set div 2)
            then if (Net_Set = 1) {}
            then KBBlue := 25 else WhiteOut else
            if RedColor < (E_Set * 1)
              then if (Net_Set = 2) {}
              then KBBlue := 50 else WhiteOut else
              if RedColor < (E_Set * 2)
                then if (Net_Set = 3) {}
                then KBBlue := 100 else WhiteOut else
                if RedColor < (E_Set * 3)
                  then if (Net_Set = 4) {}
                  then KBBlue := 150 else WhiteOut else
                  if RedColor < (E_Set * 4)
                    then if (Net_Set = 5) {}
                    then KBBlue := 200 else WhiteOut else
                    if RedColor > 199
                      then if (Net_Set = 6) {}
                      then KBBlue := 255 else WhiteOut else
        end else
          if ((RedColor >= GreenColor) and (GreenColor >= BlueColor))
            then
          begin
            if RedColor < (E_Set div 2)
              then if (Net_Set = 7) {}
              then KBGreen := 25 else WhiteOut else
              if RedColor < (E_Set * 1)
                then if (Net_Set = 8) {}
                then KBGreen := 50 else WhiteOut else
                if RedColor < (E_Set * 2)
                  then if (Net_Set = 9) {}
                  then KBGreen := 100 else WhiteOut else
                  if RedColor < (E_Set * 3)
                    then if (Net_Set = 10) {}
                    then KBGreen := 150 else WhiteOut else
                    if RedColor < (E_Set * 4)
                      then if (Net_Set = 11) {}
                      then KBGreen := 200 else WhiteOut else
                      if RedColor > 199
                        then if (Net_Set = 12) {}
                        then KBGreen := 255 else WhiteOut else
          end else
            if ((GreenColor >= BlueColor) and (BlueColor >= RedColor))
              then
            begin
              if GreenColor < (E_Set div 2)
                then if (Net_Set = 13) {}
                then KBBlue := 25 else WhiteOut else
                if GreenColor < (E_Set * 1)
                  then if (Net_Set = 14) {}
                  then KBBlue := 50 else WhiteOut else
                  if GreenColor < (E_Set * 2)
                    then if (Net_Set = 15) {}
                    then KBBlue := 100 else WhiteOut else
                    if GreenColor < (E_Set * 3)
                      then if (Net_Set = 16) {}
                      then KBBlue := 150 else WhiteOut else
                      if GreenColor < (E_Set * 4)
                        then if (Net_Set = 17) {}
                        then KBBlue := 200 else WhiteOut else
                        if GreenColor > 199
                          then if (Net_Set = 18) {}
                          then KBBlue := 255 else WhiteOut else
            end else
              if ((GreenColor >= RedColor) and (RedColor >=
                BlueColor)) then
              begin
                if GreenColor < (E_Set div 2)
                  then if (Net_Set = 19) {}
                  then KBRed := 25 else WhiteOut else
                  if GreenColor < (E_Set * 1)
                    then if (Net_Set = 20) {}
                    then KBRed := 50 else WhiteOut else
                    if GreenColor < (E_Set * 2)
                      then if (Net_Set = 21) {}
                      then KBRed := 100 else WhiteOut else
                      if GreenColor < (E_Set * 3)
                        then if (Net_Set = 22) {}
                        then KBRed := 150 else WhiteOut else
                        if GreenColor < (E_Set * 4)
                          then if (Net_Set = 23) {}
                          then KBRed := 200 else WhiteOut else
                          if GreenColor > 199
                            then if (Net_Set = 24) {}
                            then KBRed := 255 else WhiteOut else
              end else

                if ((BlueColor >= RedColor) and (RedColor >=
                  GreenColor)) then
                begin
                  if BlueColor < (E_Set div 2)
                    then if (Net_Set = 25) {}
                    then KBRed := 25 else WhiteOut else
                    if BlueColor < (E_Set * 1)
                      then if (Net_Set = 26) {}
                      then KBRed := 50 else WhiteOut else
                      if BlueColor < (E_Set * 2)
                        then if (Net_Set = 27) {}
                        then KBRed := 100 else WhiteOut else
                        if BlueColor < (E_Set * 3)
                          then if (Net_Set = 28) {}
                          then KBRed := 150 else WhiteOut else
                          if BlueColor < (E_Set * 4)
                            then if (Net_Set = 29) {}
                            then KBRed := 200 else WhiteOut else
                            if BlueColor > 199
                              then if (Net_Set = 30) {}
                              then KBRed := 255 else WhiteOut else
                end else
                  if ((BlueColor >= GreenColor) and (GreenColor >=
                    RedColor)) then
                  begin
                    if BlueColor < (E_Set div 2)
                      then if (Net_Set = 31) {}
                      then KBGreen := 25 else WhiteOut else
                      if BlueColor < (E_Set * 1)
                        then if (Net_Set = 32) {}
                        then KBGreen := 50 else WhiteOut else
                        if BlueColor < (E_Set * 2)
                          then if (Net_Set = 33) {}
                          then KBGreen := 100 else WhiteOut else
                          if BlueColor < (E_Set * 3)
                            then if (Net_Set = 34) {}
                            then KBGreen := 150 else WhiteOut else
                            if BlueColor < (E_Set * 4)
                              then if (Net_Set = 35) {}
                              then KBGreen := 200 else WhiteOut else
                              if BlueColor > 199
                                then if (Net_Set = 36) {}
                                then KBGreen := 255 else
                                  WhiteOut end else
                  begin {turn it white} {or Purple}
                    KBRed := {RedC;} {0;} 255;
                    KBGreen := {GreenC;} 0; {255;}
                    KBBlue := {BlueC;} 255;
                  end;
{     SetPixel(hWorkDC, IW, IL,RGB(KBRed, KBGreen, KBBlue));}
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := KBBlue; lpPixelG^ := KBGreen; lpPixelR^ :=
        KBRed;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of }
(******************************************************)
(******************************************************)

procedure Do_DoDoClass(E_Set: Integer);
var
{ TheColor:Longint; }
  R_Filtered, G_Filtered, B_Filtered,
    RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
  IL, IW: Dword;
begin {Get current Window DC}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
        R_Filtered := 0;
        G_Filtered := 0;
        B_Filtered := 0;
{         TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;

        if ((RedColor >= BlueColor) and (BlueColor >= GreenColor))
          then
        begin
          if RedColor < (E_Set div 2) then B_Filtered := 25 else
            if RedColor < (E_Set * 1) then B_Filtered := 50 else
              if RedColor < (E_Set * 2) then B_Filtered := 100 else
                if RedColor < (E_Set * 3) then B_Filtered := 150 else
                  if RedColor < (E_Set * 4) then
                    B_Filtered := 200 else
                    if RedColor < (E_Set * 5) then
                      B_Filtered := 225 else
                      B_Filtered := 255;
        end else
          if ((RedColor >= GreenColor) and (GreenColor >= BlueColor))
            then
          begin
            if RedColor < (E_Set div 2) then G_Filtered := 25 else
              if RedColor < (E_Set * 1) then G_Filtered := 50 else
                if RedColor < (E_Set * 2) then G_Filtered := 100 else
                  if RedColor < (E_Set * 3) then
                    G_Filtered := 150 else
                    if RedColor < (E_Set * 4) then
                      G_Filtered := 200 else
                      if RedColor < (E_Set * 5) then
                        G_Filtered := 225 else
                        G_Filtered := 255;
          end else
            if ((GreenColor >= BlueColor) and (BlueColor >= RedColor))
              then
            begin
              if GreenColor < (E_Set div 2) then
                B_Filtered := 25 else
                if GreenColor < (E_Set * 1) then
                  B_Filtered := 50 else
                  if GreenColor < (E_Set * 2) then
                    B_Filtered := 100 else
                    if GreenColor < (E_Set * 3) then
                      B_Filtered := 150 else
                      if GreenColor < (E_Set * 4) then
                        B_Filtered := 200 else
                        if GreenColor < (E_Set * 5) then
                          B_Filtered := 225 else
                          B_Filtered := 255;
            end else
              if ((GreenColor >= RedColor) and (RedColor >=
                BlueColor)) then
              begin
                if GreenColor < (E_Set div 2) then
                  R_Filtered := 25 else
                  if GreenColor < (E_Set * 1) then
                    R_Filtered := 50 else
                    if GreenColor < (E_Set * 2) then
                      R_Filtered := 100 else
                      if GreenColor < (E_Set * 3) then
                        R_Filtered := 150 else
                        if GreenColor < (E_Set * 4) then
                          R_Filtered := 200 else
                          if GreenColor < (E_Set * 5) then
                            R_Filtered := 225 else
                            R_Filtered := 255;
              end else
                if ((BlueColor >= RedColor) and (RedColor >=
                  GreenColor)) then
                begin
                  if BlueColor < (E_Set div 2) then
                    R_Filtered := 25 else
                    if BlueColor < (E_Set * 1) then
                      R_Filtered := 50 else
                      if BlueColor < (E_Set * 2) then
                        R_Filtered := 100 else
                        if BlueColor < (E_Set * 3) then
                          R_Filtered := 150 else
                          if BlueColor < (E_Set * 4) then
                            R_Filtered := 200 else
                            if BlueColor < (E_Set * 5) then
                              R_Filtered := 225 else
                              R_Filtered := 255;
                end else
                  if ((BlueColor >= GreenColor) and (GreenColor >=
                    RedColor)) then
                  begin
                    if BlueColor < (E_Set div 2) then
                      G_Filtered := 25 else
                      if BlueColor < (E_Set * 1) then
                        G_Filtered := 50 else
                        if BlueColor < (E_Set * 2) then
                          G_Filtered := 100 else
                          if BlueColor < (E_Set * 3) then
                            G_Filtered := 150 else
                            if BlueColor < (E_Set * 4) then
                              G_Filtered := 200 else
                              if BlueColor < (E_Set * 5) then
                                G_Filtered := 225 else
                                G_Filtered := 255;
                  end else
                  begin {if not caught, then turn white}
                    R_Filtered := 255;
                    G_Filtered := 255;
                    B_Filtered := 255;
                  end;
  (*     SetPixel(hWorkDC, IW, IL,RGB(R_Filtered,G_Filtered,B_Filtered));*)
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := B_Filtered; lpPixelG^ := G_Filtered; lpPixelR^
        := R_Filtered;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {}
(******************************************************)
(******************************************************)

(******************************************************)

procedure Do_Perc(A_Perc: Byte);
var
{  TheColor:Longint;  }
  R_Filtered, G_Filtered, B_Filtered: Byte;
  IL, IW: Dword;
  Total, RP, GP, BP, RedColor, BlueColor, GreenColor: Double;
begin {Get current Window DC}

  MakeImage;
  if ImageMade = TRUE then begin
    for IL := 0 to ImageHeight do begin
      for IW := 0 to ImageWidth do begin
        R_Filtered := 0;
        G_Filtered := 0;
        B_Filtered := 0;
       {  TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);  }
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;

        Total := (RedColor + GreenColor + BlueColor + 0.1);
        RP := (RedColor / Total);
        GP := (GreenColor / Total);
        BP := (BlueColor / Total);

        if A_Perc = 1 then
        begin
          if ((RedColor >= GreenColor) and (RedColor >= BlueColor))
            then
          begin
            if RP < 0.30 then R_Filtered := 25 else
              if RP < 0.35 then R_Filtered := 50 else
                if RP < 0.40 then R_Filtered := 100 else
                  if RP < 0.45 then R_Filtered := 150 else
                    if RP < 0.60 then R_Filtered := 200 else
                      if RP < 1.0 then R_Filtered := 255;
          end else
          begin
            R_Filtered := 255 {RedColor};
            G_Filtered := 255 {GreenColor};
            B_Filtered := 255 {BlueColor};
          end;
        end else
          if A_Perc = 2 then
          begin
            if ((GreenColor >= RedColor) and (GreenColor >=
              BlueColor)) then
            begin
              if GP < 0.30 then G_Filtered := 25 else
                if GP < 0.35 then G_Filtered := 50 else
                  if GP < 0.40 then G_Filtered := 100 else
                    if GP < 0.45 then G_Filtered := 150 else
                      if GP < 0.6 then G_Filtered := 200 else
                        if GP < 1.0 then G_Filtered := 255;
            end else
            begin
              R_Filtered := 255 {RedColor};
              G_Filtered := 255 {GreenColor};
              B_Filtered := 255 {BlueColor};
            end;
          end else
            if A_Perc = 3 then
            begin
              if ((BlueColor >= GreenColor) and (BlueColor >=
                RedColor)) then
              begin
                if BP < 0.30 then B_Filtered := 25 else
                  if BP < 0.35 then B_Filtered := 50 else
                    if BP < 0.40 then B_Filtered := 100 else
                      if BP < 0.45 then B_Filtered := 150 else
                        if BP < 0.6 then B_Filtered := 200 else
                          if BP < 1.0 then B_Filtered := 255;
              end else
              begin
                R_Filtered := 255 {RedColor};
                G_Filtered := 255 {GreenColor};
                B_Filtered := 255 {BlueColor};
              end;
            end else
              if A_Perc = 4 then
              begin
                if ((RedColor >= GreenColor) and (RedColor >=
                  BlueColor)) then
                begin
                  if RP < 0.34 then R_Filtered := 25 else
                    if RP < 0.37 then R_Filtered := 50 else
                      if RP < 0.40 then R_Filtered := 100 else
                        if RP < 0.45 then R_Filtered := 150 else
                          if RP < 0.55 then R_Filtered := 200 else
                            if RP < 1.0 then R_Filtered := 255;
                end else
                  if ((GreenColor >= RedColor) and (GreenColor >=
                    BlueColor)) then
                  begin
                    if GP < 0.34 then G_Filtered := 25 else
                      if GP < 0.37 then G_Filtered := 50 else
                        if GP < 0.40 then G_Filtered := 100 else
                          if GP < 0.45 then G_Filtered := 150 else
                            if GP < 0.55 then G_Filtered := 200 else
                              if GP < 1.0 then G_Filtered := 255;
                  end else
                    if ((BlueColor >= GreenColor) and (BlueColor >=
                      RedColor)) then
                    begin
                      if BP < 0.34 then B_Filtered := 25 else
                        if BP < 0.37 then B_Filtered := 50 else
                          if BP < 0.40 then B_Filtered := 100 else
                            if BP < 0.45 then B_Filtered := 150 else
                              if BP < 0.55 then
                                B_Filtered := 200 else
                                if BP < 1.0 then B_Filtered := 255;
                    end else
                    begin
                      R_Filtered := 255 {RedColor};
                      G_Filtered := 255 {GreenColor};
                      B_Filtered := 255 {BlueColor};
                    end;
              end;
(*       SetPixel(hWorkDC, IW, IL,RGB(R_Filtered,G_Filtered,B_Filtered)); *)
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := B_Filtered; lpPixelG^ := G_Filtered; lpPixelR^
        := R_Filtered;

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of }
(******************************************************)

(******************************************************)
(******************************************************)
(******************************************************)
(******************************************************)
end.
