{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gUPrepare;
{load and process images other than pvc,bmp,png,etc}
{
Principal Component Analysis (PCA)
  Created FileName: .pc1.. pcn
Multiple Discriminant Analysis (MDA)
  Created FileName: .pd1.. pdn
Multi Band File Algebra (FA)
   .paa, .pas, .pam, .pad
Vegetation Indices
  file: .pv1..pv6
Tassled cap (KT)(3D)
  FileName: .pts, .ptg, .pty, .ptn


Single Math
Fill Every [  ] Line (psf)
Average Every [  ] Line (psv)
Add [ ] to every pixel (psa)
Subract [ ] from every pixel (pss)
Multiply every pixel by [ ] (psm)
Divide every pixel by [ ] (psd)

Derez: 16 to 8 Bits
  pz8
Register to Image...
  pg1
Histogram Correction
  .ph1

Radar HSV-RGB
  3 Data Files.prr, .prg, .prb
}
               
interface

{ Place a USES declaration here }
uses
  gGlobal, SysUtils,
  Windows,
{ WinTypes,}{Data types}
  Graphics, {GetDibSizes}
  Controls, {Cursor names}
  Forms, {Screen}
  Math, {Min max}
  PNGImage,
  Dialogs; {MessageDlg}
{ Place CONST, TYPE, and VAR declarations here }
type
  TReal = Double;
{ Place PROCEDURE and FUNCTION declarations here }
procedure Do_BandstoRGBImage;
procedure Do_JER_Radar;
procedure Save_BandstoRGBImage;

procedure Do_ImageMath(Which, What: Integer);
procedure Do_FillLine(Which: Integer);
procedure Do_AverageLine(Which: Integer);

procedure Do_PMB_MBFA(Which: Integer; AutoRange: Boolean);

procedure Do_PMB_PVI(Which: Integer);
procedure Do_PMB_PVI5;
procedure Do_PMB_PVI6;

procedure Do_PMB_KT3D(Band1: Integer;
  SBIE1, SBIE2, SBIE3, SBIE4, SBIE5, SBIE7,
  GVI1, GVI2, GVI3, GVI4, GVI5, GVI7,
  YVI1, YVI2, YVI3, YVI4, YVI5, YVI7,
  NSI1, NSI2, NSI3, NSI4, NSI5, NSI7: Double);
procedure Do_PMB_PCA(Counter:Integer);   {line 1648}



procedure Do_RGBtoHSV;
procedure RGBToHSV(const R, G, B: TReal; var H, S, V: TReal);
procedure HSVtoRGB(const H, S, V: TReal; var R, G, B: TReal);
function RGBtoRGBTriple(const red, green, blue: BYTE): TRGBTriple;


procedure Do_PixelSizer(Pixels: Integer);
procedure Do_QuadDivide2H;
procedure Do_QuadDivide2V;
procedure Do_QuadDivide4(WideMany, HeightMany: Integer);
procedure Do_QuadDivide8(WideMany, HeightMany: Integer);
procedure Do_QuadDivide16(WideMany, HeightMany: Integer);
procedure Do_QuadDivide32(WideMany, HeightMany: Integer);
procedure Do_QuadDivide64(WideMany, HeightMany: Integer);
procedure Do_CombineImageFiles2V;
procedure Do_CombineImageFiles2H;
procedure Do_CombineImageFiles4;

implementation

{ Place a second USES declaration here }
uses
{    IEEE754,  }// NaN, IsNaN
  gGrip, gPBands, gDisProFrm;



function RGBtoRGBTriple(const red, green, blue: BYTE): TRGBTriple;
begin
  with RESULT do
  begin
    rgbtRed := red;
    rgbtGreen := green;
    rgbtBlue := blue
  end
end {RGBTriple};

{ Place private LABEL, CONST, TYPE, and VAR declarations here }

{ Place PROCEDURE and FUNCTION bodies here }
{Used for huge pointer math}
(*
function GetBigPointer(lp : pointer;
                       Offset : Longint) : Pointer;
begin
 {$IFDEF WIN32}
  GetBigPointer := @PHugeByteArray(lp)^[Offset];
 {$ELSE}
  Offset := Offset + TPtrRec(lp).Lo;
  GetBigPointer := Ptr(TPtrRec(lp).Hi + TPtrRec(Offset).Hi *
                       SelectorInc,
                       TPtrRec(Offset).Lo);
 {$ENDIF}
end;
*)

procedure Do_BandstoRGBImage;
{BandFile1,BandFile2,BandFile3,BandFileSaveAsStr,
LeftColumn,RightColumn,TopRow,BottomRow}
{Blockread}
var
  RedF, GreenF, BlueF: file;
{guaged,} NumRead {, NumWritten}: Integer;
  temp, tempath: string;
  hPixelBuffer: THandle; {Handle to the pixel buffer}
  lpPixelBuffer: pointer; {pointer to the pixel buffer}
{  lpPalBuffer : PLogPalette;}{The palette buffer}
  lpBitmapInfo: PBitmapInfo; {The bitmap info header}
  BitmapInfoSize: longint; {Size of the bitmap info header}
  IL, IW, LineSize,
    guaged,
    Height, Width,
    BitmapSize: DWord; {longint;} {Size of the pixel array}
 { PaletteSize : integer;}{Size of the palette buffer}
  {IL,IW,LineSize,} templ: longint;
{  i : longint;}{loop variable}
{  j : longint; }{loop variable}
{  OldPal : hPalette;}{temp palette}
{  hPal : hPalette; }{handle to our palette}
  hBm: hBitmap; {handle to our bitmap}
  Bm: TBitmap; {temporary TBitmap}
  Dc: hdc; {used to convert the DOB to a DDB}
{  IsPaletteDevice : bool;}
begin
  Application.ProcessMessages;
{$IFOPT R+}
{$DEFINE CKRANGE}
{$R-}
{$ENDIF}
  try
    BitmapInfoSize := sizeof(TBitmapInfo);
 {The bitmap size must be the width of the bitmap rounded}
 {up to the nearest 32 bit boundary}
{LeftColumn,RightColumn,TopRow,BottomRow}
    Width := ((RightColumn - LeftColumn) + 1);
    Height := ((BottomRow - TopRow) + 1);
    templ := trunc(((Width * 24) + 31) / 32);
    BytesPerLine := (templ * 4);
    BitmapSize := ((sizeof(byte) * Height) * BytesPerLine);
{  BitmapSize := (sizeof(byte) * 256) * 256;}

    LineSize := (sizeof(byte) * Width);
 {Get the memory for the BitmapInfo, the PixelBuffer,and RGB lines }
    GetMem(lpBitmapInfo, BitmapInfoSize);
    hPixelBuffer := GlobalAlloc(GHND, BitmapSize);
    lpPixelBuffer := GlobalLock(hPixelBuffer);
    hRedBitmap := GlobalAlloc(GHND, LineSize);
    hGreenBitmap := GlobalAlloc(GHND, LineSize);
    hBlueBitmap := GlobalAlloc(GHND, LineSize);
    RedBitmap := GlobalLock(hRedBitmap);
    GreenBitmap := GlobalLock(hGreenBitmap);
    BlueBitmap := GlobalLock(hBlueBitmap);

 {Zero out the BitmapInfo, the PixelBuffer, and the Palette}
    FillChar(lpBitmapInfo^, BitmapInfoSize, #0);
    FillChar(lpPixelBuffer^, BitmapSize, #0);
 {Fill in the BitmapInfo structure}
    lpBitmapInfo^.bmiHeader.biSize := sizeof(TBitmapInfoHeader);
    lpBitmapInfo^.bmiHeader.biWidth := Width;
    lpBitmapInfo^.bmiHeader.biHeight := Height;
    lpBitmapInfo^.bmiHeader.biPlanes := 1;
    lpBitmapInfo^.bmiHeader.biBitCount := 24;
    lpBitmapInfo^.bmiHeader.biCompression := BI_RGB;
    lpBitmapInfo^.bmiHeader.biSizeImage := BitmapSize;
    lpBitmapInfo^.bmiHeader.biXPelsPerMeter := 0;
    lpBitmapInfo^.bmiHeader.biYPelsPerMeter := 0;
    lpBitmapInfo^.bmiHeader.biClrUsed := 0;
    lpBitmapInfo^.bmiHeader.biClrImportant := 0;
    try

 {Fill in the pixel buffer array from loaded images}
{  for i := 0 to Height-1 do
    for j := 0 to Width-1 do
     Byte(GetBigPointer(lpPixelBuffer, i + (j * 256))^) := j;}

      AssignFile(RedF, BandFile1);
      Reset(RedF, LineSize);
      AssignFile(GreenF, BandFile2);
      Reset(GreenF, LineSize);
      AssignFile(BlueF, BandFile3);
      Reset(BlueF, LineSize);
      guaged := 1;
      for IL := Height - 1 downto 0 do begin
        SetP_Done1(((guaged div Height) * 100));
        Application.ProcessMessages; inc(guaged);
        BlockRead(RedF, RedBitmap^, 1, NumRead);
        BlockRead(GreenF, GreenBitmap^, 1, NumRead);
        BlockRead(BlueF, BlueBitmap^, 1, NumRead);
        for IW := 0 to Width - 1 do begin
          WherePixel := ((IW * 3) + (IL * BytesPerLine));
          lpPixelB := @PHugeByteArray(lpPixelBuffer)^[WherePixel];
          lpPixelG := @PHugeByteArray(lpPixelBuffer)^[WherePixel +
            1];
          lpPixelR := @PHugeByteArray(lpPixelBuffer)^[WherePixel +
            2];
          lpPixelB^ := PHugeByteArray(BlueBitmap)^[IW];
          lpPixelG^ := PHugeByteArray(GreenBitmap)^[IW];
          lpPixelR^ := PHugeByteArray(RedBitmap)^[IW];
        end; end;
      CloseFile(RedF);
      CloseFile(GreenF);
      CloseFile(BlueF);

 {Get the screen's dc to use for the conversion since}
 {memory dc's are not reliable to use for conversions}
      dc := GetDc(0); {Do the conversion}
      hBm := CreateDiBitmap(dc, lpBitmapInfo^.bmiHeader,
        CBM_INIT, pChar(lpPixelBuffer), lpBitmapInfo^,
        DIB_RGB_COLORS);
{  dc :=} ReleaseDc(0, dc); {Give back the screen dc}
      bm := TBitmap.Create; {Create a temporory TBitmap}

      bm.Handle := hBm; {Assign the handle}
 {Size Image1}
      GRIPForm.Image1.Width := Width;
      GRIPForm.Image1.Height := Height;
 {Assign the bitmap}
      GRIPForm.Image1.Picture.Bitmap := bm; {Assign the bitmap}
      SelectPalette(GRIPForm.Image1.Picture.Bitmap.Canvas.Handle,
        GRIPForm.Image1.Picture.Bitmap.Palette,
        false);
      bm.free;
      tempath := ImagePath + GRIPFileName;
      temp := ExtractFileExt(GRIPFileName);
      if ((temp = '.PNG') or (temp = '.png')) then
        Save_BandstoRGBImage;
{  WriteBitmapToPngFile(tempath, RasterForm.Image1.Picture.Bitmap,clNone);}
{   RasterForm.Image1.SaveAsPNG(tempath);}
  {reset the gauge to 0  Gauge1.Progress:=0;}
    finally
 {Free up the memory we used}
      GlobalUnlock(hPixelBuffer);
      GlobalFree(hPixelBuffer);
      FreeMem(lpBitmapInfo, BitmapInfoSize);
    end;
  finally
    GlobalUnLock(hRedBitmap); GlobalFree(hRedBitmap);
    GlobalUnLock(hGreenBitmap); GlobalFree(hGreenBitmap);
    GlobalUnLock(hBlueBitmap); GlobalFree(hBlueBitmap);
{Turn range checking back on if it was on when we started}
{$IFDEF CKRANGE}
{$UNDEF CKRANGE}
{$R+}
{$ENDIF}
  end;
end;

procedure Do_JER_Radar;
var
  RedF: file;
  NumRead {, NumWritten}: Integer;
  temp {,tempath}: string;
  hPixelBuffer: THandle; {Handle to the pixel buffer}
  lpPixelBuffer: pointer; {pointer to the pixel buffer}
{  lpPalBuffer : PLogPalette; }{The palette buffer}
  lpBitmapInfo: PBitmapInfo; {The bitmap info header}
  BitmapInfoSize: longint; {Size of the bitmap info header}
  BitmapSize: longint; {Size of the pixel array}
{  PaletteSize : integer;}{Size of the palette buffer}
  Guaged, Height, Width, IL, IW, LineSize: Dword;
  templ: longint; {loop variable}
{  j : longint;}{loop variable}
{  OldPal : hPalette;}{temp palette}
{  hPal : hPalette; }{handle to our palette}
  hBm: hBitmap; {handle to our bitmap}
  Bm: TBitmap; {temporary TBitmap}
  Dc: hdc; {used to convert the DOB to a DDB}
{  IsPaletteDevice : bool;  }
begin
  Application.ProcessMessages;
{$IFOPT R+}
{$DEFINE CKRANGE}
{$R-}
{$ENDIF}
  try
    BitmapInfoSize := sizeof(TBitmapInfo);
 {The bitmap size must be the width of the bitmap rounded}
 {up to the nearest 32 bit boundary}
{LeftColumn,RightColumn,TopRow,BottomRow}
    Width := ((RightColumn - LeftColumn) + 1);
    Height := ((BottomRow - TopRow) + 1);
    templ := trunc(((Width * 24) + 31) / 32);
    BytesPerLine := (templ * 4);
    BitmapSize := ((sizeof(byte) * Height) * BytesPerLine);
    LineSize := (sizeof(byte) * Width);
 {Get the memory for the BitmapInfo, the PixelBuffer,and RGB lines }
    GetMem(lpBitmapInfo, BitmapInfoSize);
    hPixelBuffer := GlobalAlloc(GHND, BitmapSize);
    if (hPixelBuffer = 0) then
    begin
      FreeMem(lpBitmapInfo, BitmapInfoSize);
      GlobalFree(hPixelBuffer);
      DoMessages(39977);
      exit;
    end else
    begin
      lpPixelBuffer := GlobalLock(hPixelBuffer);
      hRedBitmap := GlobalAlloc(GHND, LineSize);
      if (hRedBitmap = 0) then
      begin
        GlobalUnlock(hPixelBuffer);
        GlobalFree(hPixelBuffer);
        FreeMem(lpBitmapInfo, BitmapInfoSize);
        GlobalFree(hRedBitmap);
        DoMessages(39977);
        exit;
      end else
      begin
        RedBitmap := GlobalLock(hRedBitmap);
      end;
    end;
 {Zero out the BitmapInfo, the PixelBuffer, and the Palette}
    FillChar(lpBitmapInfo^, BitmapInfoSize, #0);
    FillChar(lpPixelBuffer^, BitmapSize, #0);
 {Fill in the BitmapInfo structure}
    lpBitmapInfo^.bmiHeader.biSize := sizeof(TBitmapInfoHeader);
    lpBitmapInfo^.bmiHeader.biWidth := Width;
    lpBitmapInfo^.bmiHeader.biHeight := Height;
    lpBitmapInfo^.bmiHeader.biPlanes := 1;
    lpBitmapInfo^.bmiHeader.biBitCount := 24;
    lpBitmapInfo^.bmiHeader.biCompression := BI_RGB;
    lpBitmapInfo^.bmiHeader.biSizeImage := BitmapSize;
    lpBitmapInfo^.bmiHeader.biXPelsPerMeter := 0;
    lpBitmapInfo^.bmiHeader.biYPelsPerMeter := 0;
    lpBitmapInfo^.bmiHeader.biClrUsed := 0;
    lpBitmapInfo^.bmiHeader.biClrImportant := 0;

    AssignFile(RedF, GRIPFileName);
    Reset(RedF, LineSize);
    begin guaged := 1;
      for IL := Height - 1 downto 0 do begin
        SetP_Done1(((guaged div Height) * 100));
        Application.ProcessMessages; inc(guaged);
        BlockRead(RedF, RedBitmap^, 1, NumRead);
        for IW := 0 to Width - 1 do begin
          WherePixel := ((IW * 3) + (IL * BytesPerLine));
          lpPixelB := @PHugeByteArray(lpPixelBuffer)^[WherePixel];
          lpPixelG := @PHugeByteArray(lpPixelBuffer)^[WherePixel +
            1];
          lpPixelR := @PHugeByteArray(lpPixelBuffer)^[WherePixel +
            2];
          lpPixelB^ := PHugeByteArray(RedBitmap)^[IW];
          lpPixelG^ := PHugeByteArray(RedBitmap)^[IW];
          lpPixelR^ := PHugeByteArray(RedBitmap)^[IW];
        end; end;
    end;
    CloseFile(RedF);
 {Get the screen's dc to use for the conversion since}
 {memory dc's are not reliable to use for conversions}
    dc := GetDc(0); {Do the conversion}
    hBm := CreateDiBitmap(dc, lpBitmapInfo^.bmiHeader,
      CBM_INIT, pChar(lpPixelBuffer), lpBitmapInfo^, DIB_RGB_COLORS);
{  dc := } ReleaseDc(0, dc); {Give back the screen dc}
    bm := TBitmap.Create; {Create a temporory TBitmap}
    bm.Handle := hBm; {Assign the handle}
 {Size Image1}
    GRIPForm.Image1.Width := Width;
    GRIPForm.Image1.Height := Height;
 {Assign the bitmap}
    GRIPForm.Image1.Picture.Bitmap := bm; {Assign the bitmap}
    SelectPalette(GRIPForm.Image1.Picture.Bitmap.Canvas.Handle,
      GRIPForm.Image1.Picture.Bitmap.Palette,
      false);
    temp := ChangeFileExt(GRIPFileName, '.png');
    GRIPFileName := extractfilename(temp);
    ImagePath := extractfilepath(temp);
{  WriteBitmapToPngFile(temp,
  RasterForm.Image1.Picture.Bitmap,clNone);}
    Save_BandstoRGBImage;
{  RasterForm.Image1.SaveAsPNG(temp); }
    SetFileName(temp);
    bm.free;
    GlobalUnlock(hPixelBuffer);
    GlobalFree(hPixelBuffer);
    GlobalUnLock(hRedBitmap); GlobalFree(hRedBitmap);
    FreeMem(lpBitmapInfo, BitmapInfoSize);

  finally
{Turn range checking back on if it was on when we started}

  end;
{$IFDEF CKRANGE}
{$UNDEF CKRANGE}
{$R+}
{$ENDIF}
  {reset the gauge to 0  Gauge1.Progress:=0;}
end;


procedure Save_BandstoRGBImage;
(*var
{  SaveFilters: TEncodeFilterSet;}
  Tempo: Double;
var {temp,}  tempath: string;*)
begin
  GRIPForm.SaveImage;
(*
  tempath := FilePath + FileName;
  Tempo := GetTickCount;
  {with TPNGImage.Create do  }
  begin
    {SaveFilters := [efUp];
    Filter := SaveFilters;}
    {Assign(GRIPForm.Image1.Picture.Graphic); }
    {FilePath + FileName;}
    GRIPForm.Image1.Picture.SaveToFile(tempath);
    {SaveToFile(tempath);}
    GRIPForm.StatusBar1.Panels[1].Text := format('%n s',
      [(GetTickCount - Tempo) / 1000]);
{    free;}
  end;*)
end;
{Title
Author
Description
Copyright
Creation Time
Software
Disclaimer
Warning
Source
Comment}
{Create and input Text Chunks}
{
DIH  file name  Name of DIH
DIH X           Master data Width
DIH Y           Height
DIS file name     DIS subset image file name
X1= LC
X2= RC    Desired image starting positions:
Y1= TR
Y2= BR    Height and Width...
Number of Bands
1   Band File Names
2
3
4
5
6
7
Bands that become which RGB channels
Red: Band ?
Green: Band ?
Blue: Band ?
}

(*
{When the Text TMEMO for editing the tEXt chunk}
{is changed, change the chunk}
procedure TFrInfo.TextExit(Sender: TObject);
var
  TEXTC: TChunkText;
  ZTXTC: TChunkZTXT;
begin

  if TPNGIMAGE(RasterForm.Image1.Picture.Graphic).Chunks[ChunkList.Selected.Index] is
    TChunkText then
  begin
    {Copy pointer to the chunk}
    TEXTC := TChunkTEXT(TPNGIMAGE(RasterForm.Image1.Picture.Graphic).Chunks[
      ChunkList.Selected.Index]);

    {Change the value}
    TEXTC.Keyword := Keyword.Text;
    TEXTC.Text := Text.Lines.Text;

    ChunkList.Selected.SubItems[0] := inttostr(TEXTC.Size) + ' bytes';
  end
  else
  begin
    {Copy pointer to the chunk}
    ZTXTC := TChunkZTXT(TPNGIMAGE(RasterForm.Image1.Picture.Graphic).Chunks[
      ChunkList.Selected.Index]);

    {Change the value}
    ZTXTC.Keyword := Keyword.Text;
    ZTXTC.Text := Text.Lines.Text;

    ChunkList.Selected.SubItems[0] := inttostr(ZTXTC.Size) + ' bytes';
  end;
end;

*)
(******************************************************)
(******************************************************)



(******************************************************)
(******************************************************)

procedure Do_ImageMath(Which, What: Integer);
var
  F1, F2: file;
  BlueColor: Byte;
  LineSize, I, Temp, IV: Integer;
  InFileName, OutFileName: string;
begin
{Do a math operation on ONE band
BCBandFileEdit
BCNewFileEdit}
  LineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  DisProcessForm.RadarGauge.Progress := 1;
  hBlueBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  BlueBitmap := GlobalLock(hBlueBitmap);
  hRedBitmap := GlobalAlloc(GHND, LineSize); {New file}
  RedBitmap := GlobalLock(hRedBitmap);

  InFileName := ImagePath + (DisProcessForm.BCBandFileEdit.Text);
  AssignFile(F1, InFileName);
  Reset(F1, LineSize);
  case DisProcessForm.SingleBandMathRG.ItemIndex of
    2: OutFileName := ImagePath +
      (ChangeFileExt(DisProcessForm.BCNewFileEdit.Text, '.psa'));
    3: OutFileName := ImagePath +
      (ChangeFileExt(DisProcessForm.BCNewFileEdit.Text, '.pss'));
    4: OutFileName := ImagePath +
      (ChangeFileExt(DisProcessForm.BCNewFileEdit.Text, '.psm'));
    5: OutFileName := ImagePath +
      (ChangeFileExt(DisProcessForm.BCNewFileEdit.Text, '.psd'));
  end; {  OutFileName:=FilePath +(PBands.BCNewFileEdit.Text);}
  AssignFile(F2, OutFileName);
  Rewrite(F2, 1);
  DisProcessForm.IM_Hints.Caption := 'Processing Band 1';

  for IV := TopRow to BottomRow - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div BottomRow);
    Application.ProcessMessages;
    BlockRead(F1, BlueBitmap^, 1);
    for I := LeftColumn to RightColumn - 1 do
    begin
      lpPixelR := @PHugeByteArray(BlueBitmap)^[I];
      BlueColor := lpPixelR^;
      case Which of
        2: begin
            Temp := BlueColor + What;
            if Temp > 255 then Temp := 255 else
              if Temp < 0 then Temp := 0;
            BlueColor := Temp;
          end;
        3: begin
            Temp := BlueColor - What;
            if Temp > 255 then Temp := 255 else
              if Temp < 0 then Temp := 0;
            BlueColor := Temp;
          end;
        4: begin
            Temp := BlueColor * What;
            if Temp > 255 then Temp := 255 else
              if Temp < 0 then Temp := 0;
            BlueColor := Temp;
          end;
        5: begin
            Temp := BlueColor div what;
            if Temp > 255 then Temp := 255 else
              if Temp < 0 then Temp := 0;
            BlueColor := Temp;
          end;
      end;
      lpPixelB := @PHugeByteArray(RedBitmap)^[I];
      lpPixelB^ := BlueColor;
{      PHugeByteArray(RedBitmap)^[I]:=PHugeByteArray(BlueBitmap)^[I]; }
    end;
    BlockWrite(F2, RedBitmap^, ((RightColumn - LeftColumn) + 1));
  end;
  CloseFile(F2);
  CloseFile(F1);
  DisProcessForm.RadarGauge.Progress := 0;
  GlobalUnlock(hRedBitmap);
  GlobalFree(hRedBitmap);
  GlobalUnlock(hBlueBitmap);
  GlobalFree(hBlueBitmap);
end;


procedure Do_FillLine(Which: Integer);
var
  F1, F2: file;
  BlueColor, GreenColor, RedColor: Byte;
  LineSize, I, Temp, IV: Integer;
  hNewBitmap: DWord;
  NewBitmap: Pointer;
  lpPixelNew: ^Byte;
  InFileName, OutFileName: string;
begin
  LineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  DisProcessForm.RadarGauge.Progress := 1;
  hBlueBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  BlueBitmap := GlobalLock(hBlueBitmap);
  hGreenBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  GreenBitmap := GlobalLock(hGreenBitmap);
  hRedBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  RedBitmap := GlobalLock(hRedBitmap);
  hNewBitmap := GlobalAlloc(GHND, LineSize); {New file}
  NewBitmap := GlobalLock(hNewBitmap);

  InFileName := ImagePath + (DisProcessForm.BCBandFileEdit.Text);
  AssignFile(F1, InFileName);
  Reset(F1, LineSize);
  OutFileName := ImagePath + ChangeFileExt(DisProcessForm.BCNewFileEdit.Text,
    '.psf');
  AssignFile(F2, OutFileName);
  Rewrite(F2, 1);
  DisProcessForm.IM_Hints.Caption := 'Processing Band 1';
  BlockRead(F1, BlueBitmap^, 1);
  BlockWrite(F2, BlueBitmap^, ((RightColumn - LeftColumn) + 1));
  BlockRead(F1, GreenBitmap^, 1);
  for IV := TopRow + 2 to BottomRow - 1 do
  begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div BottomRow);
    Application.ProcessMessages;
    BlockRead(F1, RedBitmap^, 1);
    if ((IV mod Which) = 0) then
    begin
      for I := LeftColumn to RightColumn - 1 do
      begin
        lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
        BlueColor := lpPixelB^;
       {lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
        GreenColor  := lpPixelG^;}
        lpPixelR := @PHugeByteArray(RedBitmap)^[I];
        RedColor := lpPixelR^;
        Temp := (BlueColor + RedColor div 2);
        if Temp > 255 then Temp := 255 else
          if Temp < 0 then Temp := 0;
        GreenColor := Temp;
        lpPixelNew := @PHugeByteArray(NewBitmap)^[I];
        lpPixelNew^ := GreenColor;
      end;
    end else
    begin
      for I := LeftColumn to RightColumn - 1 do
      begin
        lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
        GreenColor := lpPixelG^;
        lpPixelNew := @PHugeByteArray(NewBitmap)^[I];
        lpPixelNew^ := GreenColor;
      end;
    end; {Which line}
    BlockWrite(F2, NewBitmap^, ((RightColumn - LeftColumn) + 1));
    for I := LeftColumn to RightColumn - 1 do
    begin
      lpPixelR := @PHugeByteArray(RedBitmap)^[I];
      RedColor := lpPixelR^;
      lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
      GreenColor := lpPixelG^;
      lpPixelG^ := RedColor;
      lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
      lpPixelB^ := GreenColor;
      {BlueBitmap^:=GreenBitmap^;
      GreenBitmap^:=RedBitmap^;  }
    end;
  end;
   {Fill the last line}
  BlockWrite(F2, RedBitmap^, ((RightColumn - LeftColumn) + 1));
  CloseFile(F2);
  CloseFile(F1);
  DisProcessForm.RadarGauge.Progress := 0;
  GlobalUnlock(hRedBitmap);
  GlobalFree(hRedBitmap);
  GlobalUnlock(hGreenBitmap);
  GlobalFree(hGreenBitmap);
  GlobalUnlock(hNewBitmap);
  GlobalFree(hNewBitmap);
  GlobalUnlock(hBlueBitmap);
  GlobalFree(hBlueBitmap);
end;



procedure Do_AverageLine(Which: Integer);
var
  F1, F2: file;
  BlueColor, GreenColor, RedColor, NewColor: Byte;
  TempFloat3: Double;
  LineSize, I, Temp, IV: Integer;
  hNewBitmap: DWord;
  NewBitmap: Pointer;
  lpPixelNew: ^Byte;
  InFileName, OutFileName: string;
begin
  LineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  DisProcessForm.RadarGauge.Progress := 1;
  hBlueBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  BlueBitmap := GlobalLock(hBlueBitmap);
  hGreenBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  GreenBitmap := GlobalLock(hGreenBitmap);
  hRedBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  RedBitmap := GlobalLock(hRedBitmap);
  hNewBitmap := GlobalAlloc(GHND, LineSize); {New file}
  NewBitmap := GlobalLock(hNewBitmap);

  InFileName := ImagePath + (DisProcessForm.BCBandFileEdit.Text);
  AssignFile(F1, InFileName);
  Reset(F1, LineSize);
  OutFileName := ImagePath + ChangeFileExt(DisProcessForm.BCNewFileEdit.Text,
    '.psv');
  AssignFile(F2, OutFileName);
  Rewrite(F2, 1);
  DisProcessForm.IM_Hints.Caption := 'Processing Band 1';
  BlockRead(F1, BlueBitmap^, 1);
  BlockWrite(F2, BlueBitmap^, ((RightColumn - LeftColumn) + 1));
  BlockRead(F1, GreenBitmap^, 1);
  for IV := TopRow + 2 to BottomRow - 1 do
  begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div BottomRow);
    Application.ProcessMessages;
    BlockRead(F1, RedBitmap^, 1);
    if ((IV mod Which) = 0) then
    begin
      for I := LeftColumn to RightColumn - 1 do
      begin
        lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
        BlueColor := lpPixelB^;
        lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
        GreenColor := lpPixelG^;
        lpPixelR := @PHugeByteArray(RedBitmap)^[I];
        RedColor := lpPixelR^;
{       TempFloat1:=(BlueColor-GreenColor);
       TempFloat2:=(RedColor-GreenColor);
       TempFloat3:=TempFloat1+TempFloat2;
       TempFloat3:=(TempFloat3/2);
       Temp :=GreenColor+round(TempFloat3);}
        TempFloat3 := ((RedColor + BlueColor + GreenColor) / 3);
        Temp := round(TempFloat3);
        if Temp > 255 then Temp := 255 else
          if Temp < 0 then Temp := 0;
        NewColor := Temp;
        lpPixelNew := @PHugeByteArray(NewBitmap)^[I];
        lpPixelNew^ := NewColor;
      end;
    end else
    begin
      for I := LeftColumn to RightColumn - 1 do
      begin
        lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
        GreenColor := lpPixelG^;
        lpPixelNew := @PHugeByteArray(NewBitmap)^[I];
        lpPixelNew^ := GreenColor;
      end;
    end; {Which line}
    BlockWrite(F2, NewBitmap^, ((RightColumn - LeftColumn) + 1));
    for I := LeftColumn to RightColumn - 1 do
    begin
      lpPixelR := @PHugeByteArray(RedBitmap)^[I];
      RedColor := lpPixelR^;
      lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
      GreenColor := lpPixelG^;
      lpPixelG^ := RedColor;
      lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
      lpPixelB^ := GreenColor;
      {BlueBitmap^:=GreenBitmap^;
      GreenBitmap^:=RedBitmap^;  }
    end;
  end;
   {Fill the last line}
  BlockWrite(F2, RedBitmap^, ((RightColumn - LeftColumn) + 1));
  CloseFile(F2);
  CloseFile(F1);
  DisProcessForm.RadarGauge.Progress := 0;
  GlobalUnlock(hRedBitmap);
  GlobalFree(hRedBitmap);
  GlobalUnlock(hGreenBitmap);
  GlobalFree(hGreenBitmap);
  GlobalUnlock(hNewBitmap);
  GlobalFree(hNewBitmap);
  GlobalUnlock(hBlueBitmap);
  GlobalFree(hBlueBitmap);
end;
(******************************************************)
(******************************************************)



(******************************************************)
(******************************************************)

procedure Do_PMB_MBFA(Which: Integer; AutoRange: Boolean);
var
  F1, F2, FOut: file;
  RedColor, GreenColor, BlueColor: Byte;
{  CropLineSize, iLCol, iRCol, iTRow,iBRow, }
  Range, AutoTimes,
 {MBFAMax,MBFAMin,} LineSize, I, Temp, IV: Integer;
  R_Min, G_Min, B_Min: Double;
  R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    Input, IsOne, R_Filtered, G_Filtered, B_Filtered: Double;
  InFile1Name, InFile2Name, OutFileName: string;
{  TempFileName,temp,LCol, RCol,TRow,BRow:String;}
begin
{Do a math operation on 2bands BandFile1,BandFile1= BCNewFileEdit}
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
  if AutoRange then AutoTimes := 1 else AutoTimes := 0;
  LineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  DisProcessForm.RadarGauge.Progress := 1;
  hBlueBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  BlueBitmap := GlobalLock(hBlueBitmap);
  hGreenBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  GreenBitmap := GlobalLock(hGreenBitmap);
  hRedBitmap := GlobalAlloc(GHND, LineSize); {New file}
  RedBitmap := GlobalLock(hRedBitmap);
  case DisProcessForm.MBFAARG.Itemindex of
    0: InFile1Name := BandFile1;
    1: InFile1Name := BandFile2;
    2: InFile1Name := BandFile3;
    3: InFile1Name := BandFile4;
    4: InFile1Name := BandFile5;
    5: InFile1Name := BandFile6L;
    6: InFile1Name := BandFile6H;
    7: InFile1Name := BandFile7;
    8: InFile1Name := BandFile8;
  end;
  AssignFile(F1, InFile1Name);

  case DisProcessForm.MBFAARG.Itemindex of
    0: InFile2Name := BandFile1;
    1: InFile2Name := BandFile2;
    2: InFile2Name := BandFile3;
    3: InFile2Name := BandFile4;
    4: InFile2Name := BandFile5;
    5: InFile2Name := BandFile6L;
    6: InFile2Name := BandFile6H;
    7: InFile2Name := BandFile7;
    8: InFile2Name := BandFile8;
  end;
  AssignFile(F2, InFile2Name);
  case DisProcessForm.MBFAAopBRG.Itemindex of
    0: OutFileName := ImagePath +
      ChangeFileExt(DisProcessForm.MBFAFileEdit.Text, '.pfa');
    1: OutFileName := ImagePath +
      ChangeFileExt(DisProcessForm.MBFAFileEdit.Text, '.pfs');
    2: OutFileName := ImagePath +
      ChangeFileExt(DisProcessForm.MBFAFileEdit.Text, '.pfm');
    3: OutFileName := ImagePath +
      ChangeFileExt(DisProcessForm.MBFAFileEdit.Text, '.pfd');
  end;
  AssignFile(FOut, OutFileName);

  DisProcessForm.IM_Hints.Caption := 'Processing MBFA';
  for RANGE := 0 to AutoTimes do begin
    R_Range := R_Max - R_Min;
    R_Range := R_Range / 255; {or 256?}
    Reset(F1, LineSize);
    Reset(F2, LineSize);
    if (not (AUTORANGE)) then Rewrite(FOut, 1)
    else if ((AUTORANGE) and (Range = 1)) then Rewrite(FOut, 1);


    for IV := TopRow to BottomRow - 1 do begin
      DisProcessForm.RadarGauge.Progress := ((IV * 100) div BottomRow);
      Application.ProcessMessages;
      BlockRead(F1, BlueBitmap^, 1);
      BlockRead(F2, GreenBitmap^, 1);
      for I := LeftColumn to RightColumn - 1 do
      begin
        lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
        BlueColor := lpPixelB^;
        lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
        GreenColor := lpPixelG^;
        case Which of
          0: R_Filtered := BlueColor + GreenColor;
          1: R_Filtered := BlueColor - GreenColor;
          2: R_Filtered := BlueColor * GreenColor;
        {3}else R_Filtered := BlueColor div GreenColor;
        end; {Case}

        if AUTORANGE then begin
          if Range = 0 then begin
            if R_Filtered > R_Max then R_Max := R_Filtered;
            if R_Filtered < R_Min then R_Min := R_Filtered;
          end;
          if Range = 1 then begin
            R_Filtered := (R_Filtered - (R_Min)) / R_Range;
            if R_Filtered > 255 then R_Filtered := 255;
            if R_Filtered < 0 then R_Filtered := 0;
            RedColor := Round(R_Filtered);
            lpPixelR := @PHugeByteArray(RedBitmap)^[I];
            lpPixelR^ := RedColor;
          end;
        end else
        begin
          if R_Filtered > 255 then R_Filtered := 255;
          if R_Filtered < 0 then R_Filtered := 0;
          RedColor := Round(R_Filtered);
          lpPixelR := @PHugeByteArray(RedBitmap)^[I];
          lpPixelR^ := RedColor;
        end;
      end; {Wide}
      if ((AUTORANGE) and (Range = 1)) then
      begin
        BlockWrite(F2, RedBitmap^, ((RightColumn - LeftColumn) + 1))
      end
      else if (not (AUTORANGE)) then
      begin
        BlockWrite(F2, RedBitmap^, ((RightColumn - LeftColumn) + 1));
      end;

    end; {Tall}
  end; {Autotimes}
  CloseFile(F2);
  CloseFile(F1);
  CloseFile(FOut);
  DisProcessForm.RadarGauge.Progress := 0;
  GlobalUnlock(hRedBitmap);
  GlobalFree(hRedBitmap);
  GlobalUnlock(hBlueBitmap);
  GlobalFree(hBlueBitmap);
  GlobalUnlock(hGreenBitmap);
  GlobalFree(hGreenBitmap);
end;
(******************************************************)
(******************************************************)




(******************************************************)
(******************************************************)

procedure Do_PMB_PVI(Which: Integer);
var
  AutoRange: Boolean;
  F1, F2, FOut: file;
  RedColor, GreenColor, BlueColor: Byte;
  Range, AutoTimes, Errorcode,
    LineSize, I, Temp, IV: Integer;
  R_Min, G_Min, B_Min: Double;
  R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    Input, IsOne, R_Filtered, G_Filtered, B_Filtered: Double;
  TempFloat1, TempFloat2,
    FakeFloat1, FakeFloat2, FakeFloat3,
    FakeFloat4, FakeFloat5, FakeFloat6: Double;
  InFile1Name, InFile2Name, OutFileName: string;
begin
  AutoRange := DisProcessForm.VIPAutoRangeCB.Checked;
  val(DisProcessForm.VIPV1Edit.Text, FakeFloat1, Errorcode);
  val(DisProcessForm.VIPV2Edit.Text, FakeFloat2, Errorcode);
  val(DisProcessForm.VIPV3Edit.Text, FakeFloat3, Errorcode);
  val(DisProcessForm.VIPV4Edit.Text, FakeFloat4, Errorcode);
  val(DisProcessForm.VIPV5Edit.Text, FakeFloat5, Errorcode);
  val(DisProcessForm.VIPV6Edit.Text, FakeFloat6, Errorcode);
{Which:=0;}{Delete}
{Do a math operation on 2bands BandFile1,BandFile1= BCNewFileEdit}
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
  if AutoRange then AutoTimes := 1 else AutoTimes := 0;
  LineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  DisProcessForm.RadarGauge.Progress := 1;
  hBlueBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  BlueBitmap := GlobalLock(hBlueBitmap);
  hGreenBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  GreenBitmap := GlobalLock(hGreenBitmap);
  hRedBitmap := GlobalAlloc(GHND, LineSize); {New file}
  RedBitmap := GlobalLock(hRedBitmap);
  InFile1Name := BandFile1;
  AssignFile(F1, InFile1Name);
  InFile2Name := BandFile2;
  AssignFile(F2, InFile2Name);
  case Which of {output file}
    1: OutFileName := ImagePath +
      ChangeFileExt((DisProcessForm.VIPFileEdit.Text), '.pv1');
    2: OutFileName := ImagePath +
      ChangeFileExt((DisProcessForm.VIPFileEdit.Text), '.pv2');
    3: OutFileName := ImagePath +
      ChangeFileExt((DisProcessForm.VIPFileEdit.Text), '.pv3');
  else
    OutFileName := ImagePath +
      ChangeFileExt((DisProcessForm.VIPFileEdit.Text),
      '.pv4');
  end;
  AssignFile(FOut, OutFileName);

  DisProcessForm.IM_Hints.Caption := 'Processing VIP';
  for RANGE := 0 to AutoTimes do begin
    R_Range := R_Max - R_Min;
    R_Range := R_Range / 255; {or 256?}
    Reset(F1, LineSize);
    Reset(F2, LineSize);
    if (not (AUTORANGE)) then Rewrite(FOut, 1)
    else if ((AUTORANGE) and (Range = 1)) then Rewrite(FOut, 1);


    for IV := TopRow to BottomRow - 1 do begin
      DisProcessForm.RadarGauge.Progress := ((IV * 100) div BottomRow);
      Application.ProcessMessages;
      BlockRead(F1, BlueBitmap^, 1);
      BlockRead(F2, GreenBitmap^, 1);
      for I := LeftColumn to RightColumn - 1 do
      begin
        lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
        BlueColor := lpPixelB^;
        lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
        GreenColor := lpPixelG^;
        case Which of
          1: begin
              B_Filtered := BlueColor - GreenColor;
              G_Filtered := BlueColor + GreenColor;
              R_Filtered := (B_Filtered / G_Filtered);
            end;
          2: R_Filtered := ((FakeFloat1 * BlueColor) - GreenColor);
          3: begin
        {SQRT( SQ(V1*A - V2*B)
              + SQ(V3*B - V4*A) )}
              B_Filtered := FakeFloat1 * BlueColor;
              G_Filtered := FakeFloat2 * GreenColor;
              FakeFloat5 := Sqr(B_Filtered - G_Filtered);
              B_Filtered := FakeFloat3 * BlueColor;
              G_Filtered := FakeFloat4 * GreenColor;
              FakeFloat6 := Sqr(B_Filtered - G_Filtered);
              R_Filtered := SQRT(FakeFloat5 + FakeFloat6);
            end;
          4: begin
{SQRT(   SQ(V1 - V2*A + V3*B)
       + SQ(V4+ V5*A - V6*B) )TempFloat1,}
              B_Filtered := FakeFloat2 * BlueColor;
              G_Filtered := FakeFloat3 * GreenColor;
              TempFloat1 := Sqr(FakeFloat1 - B_Filtered +
                G_Filtered);
              B_Filtered := FakeFloat5 * BlueColor;
              G_Filtered := FakeFloat6 * GreenColor;
              TempFloat2 := Sqr(FakeFloat4 + B_Filtered -
                G_Filtered);
              R_Filtered := SQRT(TempFloat1 + TempFloat2);
            end;
        {3}else R_Filtered := BlueColor div GreenColor;
        end; {Case}

        if AUTORANGE then begin
          if Range = 0 then begin
            if R_Filtered > R_Max then R_Max := R_Filtered;
            if R_Filtered < R_Min then R_Min := R_Filtered;
          end;
          if Range = 1 then begin
            R_Filtered := (R_Filtered - (R_Min)) / R_Range;
            if R_Filtered > 255 then R_Filtered := 255;
            if R_Filtered < 0 then R_Filtered := 0;
            RedColor := Round(R_Filtered);
            lpPixelR := @PHugeByteArray(RedBitmap)^[I];
            lpPixelR^ := RedColor;
          end;
        end else
        begin
          if R_Filtered > 255 then R_Filtered := 255;
          if R_Filtered < 0 then R_Filtered := 0;
          RedColor := Round(R_Filtered);
          lpPixelR := @PHugeByteArray(RedBitmap)^[I];
          lpPixelR^ := RedColor;
        end;
      end; {Wide}
      if ((AUTORANGE) and (Range = 1)) then
      begin
        BlockWrite(F2, RedBitmap^, ((RightColumn - LeftColumn) + 1))
      end
      else if (not (AUTORANGE)) then
      begin
        BlockWrite(F2, RedBitmap^, ((RightColumn - LeftColumn) + 1));
      end;

    end; {Tall}
  end; {Autotimes}
  CloseFile(F1);
  CloseFile(F2);
  CloseFile(FOut);
  DisProcessForm.RadarGauge.Progress := 0;
  GlobalUnlock(hRedBitmap);
  GlobalFree(hRedBitmap);
  GlobalUnlock(hBlueBitmap);
  GlobalFree(hBlueBitmap);
  GlobalUnlock(hGreenBitmap);
  GlobalFree(hGreenBitmap);
end;


procedure Do_PMB_PVI5; {4 Bands 4 Variables}
var
  AutoRange: Boolean;
  F1, F2, F3, F4, FOut: file;
  GreenColor2, BlueColor2,
    RedColor, GreenColor, BlueColor: Byte;
  Range, AutoTimes, Errorcode,
    LineSize, I, Temp, IV: Integer;
  R_Min, G_Min, B_Min: Double;
  R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    Input, IsOne, R_Filtered, G_Filtered, B_Filtered: Double;
  TempFloat1, TempFloat2,
    FakeFloat1, FakeFloat2, FakeFloat3,
    FakeFloat4, FakeFloat5, FakeFloat6: Double;
  InFile3Name, InFile4Name,
    InFile1Name, InFile2Name, OutFileName: string;
  lpPixelB2, lpPixelG2: ^Byte;
  GreenBitmap2, BlueBitmap2: Pointer;
  hGreenBitmap2, hBlueBitmap2: DWord;
begin
  AutoRange := DisProcessForm.VIPAutoRangeCB.Checked;
  val(DisProcessForm.VIPV1Edit.Text, FakeFloat1, Errorcode);
  val(DisProcessForm.VIPV2Edit.Text, FakeFloat2, Errorcode);
  val(DisProcessForm.VIPV3Edit.Text, FakeFloat3, Errorcode);
  val(DisProcessForm.VIPV4Edit.Text, FakeFloat4, Errorcode);

{Which:=0;}{Delete}
{Do a math operation on 2bands BandFile1,BandFile1= BCNewFileEdit}
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
  if AutoRange then AutoTimes := 1 else AutoTimes := 0;
  LineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  DisProcessForm.RadarGauge.Progress := 1;
  hBlueBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  BlueBitmap := GlobalLock(hBlueBitmap);
  hGreenBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  GreenBitmap := GlobalLock(hGreenBitmap);
  hBlueBitmap2 := GlobalAlloc(GHND, LineSize); {Line snatcher}
  BlueBitmap2 := GlobalLock(hBlueBitmap2);
  hGreenBitmap2 := GlobalAlloc(GHND, LineSize); {Line snatcher}
  GreenBitmap2 := GlobalLock(hGreenBitmap2);
  hRedBitmap := GlobalAlloc(GHND, LineSize); {New file}
  RedBitmap := GlobalLock(hRedBitmap);
  InFile1Name := BandFile1;
  AssignFile(F1, InFile1Name);
  InFile2Name := BandFile2;
  AssignFile(F2, InFile2Name);
  InFile3Name := BandFile3;
  AssignFile(F3, InFile3Name);
  InFile4Name := BandFile4;
  AssignFile(F4, InFile4Name);
  OutFileName := ImagePath + ChangeFileExt((DisProcessForm.VIPFileEdit.Text),
    '.pv5');
  AssignFile(FOut, OutFileName);

  DisProcessForm.IM_Hints.Caption := 'Processing VIP';
  for RANGE := 0 to AutoTimes do begin
    R_Range := R_Max - R_Min;
    R_Range := R_Range / 255; {or 256?}
    Reset(F1, LineSize);
    Reset(F2, LineSize);
    Reset(F3, LineSize);
    Reset(F4, LineSize);
    if (not (AUTORANGE)) then Rewrite(FOut, 1)
    else if ((AUTORANGE) and (Range = 1)) then Rewrite(FOut, 1);


    for IV := TopRow to BottomRow - 1 do begin
      DisProcessForm.RadarGauge.Progress := ((IV * 100) div BottomRow);
      Application.ProcessMessages;
      BlockRead(F1, BlueBitmap^, 1);
      BlockRead(F2, GreenBitmap^, 1);
      BlockRead(F3, BlueBitmap2^, 1);
      BlockRead(F4, GreenBitmap2^, 1);
      for I := LeftColumn to RightColumn - 1 do
      begin
        lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
        BlueColor := lpPixelB^;
        lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
        GreenColor := lpPixelG^;
        lpPixelB2 := @PHugeByteArray(BlueBitmap2)^[I];
        BlueColor2 := lpPixelB2^;
        lpPixelG2 := @PHugeByteArray(GreenBitmap2)^[I];
        GreenColor2 := lpPixelG2^;

        B_Filtered := FakeFloat1 * BlueColor;
        G_Filtered := FakeFloat2 * GreenColor;
        TempFloat1 := FakeFloat3 * BlueColor2;
        TempFloat2 := FakeFloat4 * GreenColor2;
        R_Filtered := (B_Filtered + G_Filtered + TempFloat1 +
          TempFloat2);

        if AUTORANGE then begin
          if Range = 0 then begin
            if R_Filtered > R_Max then R_Max := R_Filtered;
            if R_Filtered < R_Min then R_Min := R_Filtered;
          end;
          if Range = 1 then begin
            R_Filtered := (R_Filtered - (R_Min)) / R_Range;
            if R_Filtered > 255 then R_Filtered := 255;
            if R_Filtered < 0 then R_Filtered := 0;
            RedColor := Round(R_Filtered);
            lpPixelR := @PHugeByteArray(RedBitmap)^[I];
            lpPixelR^ := RedColor;
          end;
        end else
        begin
          if R_Filtered > 255 then R_Filtered := 255;
          if R_Filtered < 0 then R_Filtered := 0;
          RedColor := Round(R_Filtered);
          lpPixelR := @PHugeByteArray(RedBitmap)^[I];
          lpPixelR^ := RedColor;
        end;
      end; {Wide}
      if ((AUTORANGE) and (Range = 1)) then
      begin
        BlockWrite(F2, RedBitmap^, ((RightColumn - LeftColumn) + 1))
      end
      else if (not (AUTORANGE)) then
      begin
        BlockWrite(F2, RedBitmap^, ((RightColumn - LeftColumn) + 1));
      end;

    end; {Tall}
  end; {Autotimes}
  CloseFile(F1);
  CloseFile(F2);
  CloseFile(FOut);
  DisProcessForm.RadarGauge.Progress := 0;
  GlobalUnlock(hRedBitmap);
  GlobalFree(hRedBitmap);
  GlobalUnlock(hBlueBitmap);
  GlobalFree(hBlueBitmap);
  GlobalUnlock(hGreenBitmap);
  GlobalFree(hGreenBitmap);
end;
{    DISProcessMemo.Lines.Append('Band A: '+BandFile1);
    DISProcessMemo.Lines.Append('Band B: '+BandFile2);
    DISProcessMemo.Lines.Append('Band C: '+BandFile3);
    DISProcessMemo.Lines.Append('Band D: '+BandFile4);}
{val(VIPV1Edit.Text,FakeFloat1,Errorcode1);
val(VIPV2Edit.Text,FakeFloat2,Errorcode2);
val(VIPV3Edit.Text,FakeFloat3,Errorcode3);
val(VIPV4Edit.Text,FakeFloat4,Errorcode4);
val(VIPV5Edit.Text,FakeFloat5,Errorcode5);
val(VIPV6Edit.Text,FakeFloat6,Errorcode6);}
{FakeFloat1,FakeFloat2,FakeFloat3,
FakeFloat4,FakeFloat5,FakeFloat6:Double;}
{VIPAutoRangeCB.Checked
VIPFileEdit.Text output    }

procedure Do_PMB_PVI6; {1 band 1 variable}
var
  AutoRange: Boolean;
  F1, F2, FOut: file;
  RedColor, BlueColor: Byte;
  Range, AutoTimes, Errorcode, LineSize, I, IV: Integer;
  R_Min, R_Range, R_Max, R_Filtered, FakeFloat1: Double;
  InFile1Name, OutFileName: string;
begin
  AutoRange := DisProcessForm.VIPAutoRangeCB.Checked;
  val(DisProcessForm.VIPV1Edit.Text, FakeFloat1, Errorcode);
  {Do a math operation on BandFile1= BCNewFileEdit}
  R_Max := 0;
  R_Min := 255;
  if AutoRange then AutoTimes := 1 else AutoTimes := 0;
  LineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  DisProcessForm.RadarGauge.Progress := 1;
  hBlueBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  BlueBitmap := GlobalLock(hBlueBitmap);
  hRedBitmap := GlobalAlloc(GHND, LineSize); {New file}
  RedBitmap := GlobalLock(hRedBitmap);
  InFile1Name := BandFile1;
  AssignFile(F1, InFile1Name);
  OutFileName := ImagePath
     + ChangeFileExt((DisProcessForm.VIPFileEdit.Text),'.pv6');
  AssignFile(FOut, OutFileName);

  DisProcessForm.IM_Hints.Caption := 'Processing VIP';
  for RANGE := 0 to AutoTimes do begin
    R_Range := R_Max - R_Min;
    R_Range := R_Range / 255; {or 256?}
    Reset(F1, LineSize);
    if (not (AUTORANGE)) then Rewrite(FOut, 1)
    else if ((AUTORANGE) and (Range = 1)) then Rewrite(FOut, 1);

    for IV := TopRow to BottomRow - 1 do begin
      DisProcessForm.RadarGauge.Progress := ((IV * 100) div BottomRow);
      Application.ProcessMessages;
      BlockRead(F1, BlueBitmap^, 1);
      for I := LeftColumn to RightColumn - 1 do
      begin
        lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
        BlueColor := lpPixelB^;
        R_Filtered := SQRT(FakeFloat1 + BlueColor);

        if AUTORANGE then begin
          if Range = 0 then begin
            if R_Filtered > R_Max then R_Max := R_Filtered;
            if R_Filtered < R_Min then R_Min := R_Filtered;
          end;
          if Range = 1 then begin
            R_Filtered := (R_Filtered - (R_Min)) / R_Range;
            if R_Filtered > 255 then R_Filtered := 255;
            if R_Filtered < 0 then R_Filtered := 0;
            RedColor := Round(R_Filtered);
            lpPixelR := @PHugeByteArray(RedBitmap)^[I];
            lpPixelR^ := RedColor;
          end;
        end else
        begin
          if R_Filtered > 255 then R_Filtered := 255;
          if R_Filtered < 0 then R_Filtered := 0;
          RedColor := Round(R_Filtered);
          lpPixelR := @PHugeByteArray(RedBitmap)^[I];
          lpPixelR^ := RedColor;
        end;
      end; {Wide}
      if ((AUTORANGE) and (Range = 1)) then
      begin
        BlockWrite(F2, RedBitmap^, ((RightColumn - LeftColumn) + 1))
      end
      else if (not (AUTORANGE)) then
      begin
        BlockWrite(F2, RedBitmap^, ((RightColumn - LeftColumn) + 1));
      end;

    end; {Tall}
  end; {Autotimes}
  CloseFile(F1);
  CloseFile(FOut);
  DisProcessForm.RadarGauge.Progress := 0;
  GlobalUnlock(hRedBitmap);
  GlobalFree(hRedBitmap);
  GlobalUnlock(hBlueBitmap);
  GlobalFree(hBlueBitmap);
end;
(******************************************************)
(******************************************************)


(******************************************************)
(******************************************************)

procedure Do_PMB_KT3D(Band1: Integer;
  SBIE1, SBIE2, SBIE3, SBIE4, SBIE5, SBIE7,
  GVI1, GVI2, GVI3, GVI4, GVI5, GVI7,
  YVI1, YVI2, YVI3, YVI4, YVI5, YVI7,
  NSI1, NSI2, NSI3, NSI4, NSI5, NSI7: Double);
{PROCEDURE Do_ImageMath(Which,What:Integer);}
var
  F1Out, F2Out, F3Out, F4Out,
    F1, F2, F3, F4, F5, F7: file;
  Color1Out, Color2Out, Color3Out, Color4Out,
    Color1, Color2, Color3, Color4, Color5, Color7: Byte;
  LineSize, I, Temp, IV: Integer;
  SBIFiltered, GVIFiltered, YVIFiltered, NSIFiltered,
    Filtered1, Filtered2, Filtered3,
    Filtered4, Filtered5, Filtered7: Double;
  InFileName1, InFileName2,
    InFileName3, InFileName4,
    InFileName5, InFileName7,
    OutFileName1, OutFileName2,
    OutFileName3, OutFileName4: string;
  Which: Integer;
  hBitmap1, hBitmap2, hBitmap3,
    hBitmap4, hBitmap5, hBitmap7,
    hBitmapOut1, hBitmapOut2, hBitmapOut3, hBitmapOut4: DWord;
  Bitmap1, Bitmap2, Bitmap3,
    Bitmap4, Bitmap5, Bitmap7,
    OutBitmap1, OutBitmap2, OutBitmap3, OutBitmap4: Pointer;
  lpPixel1, lpPixel2, lpPixel3,
    lpPixel4, lpPixel5, lpPixel7,
    lpPixelOut1, lpPixelOut2, lpPixelOut3, lpPixelOut4: ^Byte;
begin
  LineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  DisProcessForm.RadarGauge.Progress := 1;
  {Line snatchers}
  hBitmap2 := GlobalAlloc(GHND, LineSize);
  Bitmap2 := GlobalLock(hBitmap2);
  InFileName2 := BandFile2;
  AssignFile(F2, InFileName2);
  Reset(F2, LineSize);

  hBitmap3 := GlobalAlloc(GHND, LineSize);
  Bitmap3 := GlobalLock(hBitmap3);
  InFileName3 := BandFile3;
  AssignFile(F3, InFileName3);
  Reset(F3, LineSize);

  hBitmap4 := GlobalAlloc(GHND, LineSize);
  Bitmap4 := GlobalLock(hBitmap4);
  InFileName4 := BandFile4;
  AssignFile(F4, InFileName4);
  Reset(F4, LineSize);

  hBitmap5 := GlobalAlloc(GHND, LineSize);
  Bitmap5 := GlobalLock(hBitmap5);
  InFileName5 := BandFile5;
  AssignFile(F5, InFileName5);
  Reset(F5, LineSize);

  if (Band1 < 5) then
  begin
  {MSS New files}
    Which := 1;
  end else
  begin
  {TM New files}
    Which := 2;
    hBitmap1 := GlobalAlloc(GHND, LineSize);
    Bitmap1 := GlobalLock(hBitmap1);
    InFileName1 := BandFile1;
    AssignFile(F1, InFileName1);
    Reset(F1, LineSize);

    hBitmap7 := GlobalAlloc(GHND, LineSize);
    Bitmap7 := GlobalLock(hBitmap7);
    InFileName7 := BandFile7;
    AssignFile(F7, InFileName7);
    Reset(F7, LineSize);
  end;
  OutFileName4 := ImagePath +
    ChangeFileExt((DisProcessForm.TCFileNameEdit.Text), '.ptn');
  hBitmapOut4 := GlobalAlloc(GHND, LineSize);
  OutBitmap4 := GlobalLock(hBitmapOut4);
  AssignFile(F4Out, OutFileName4);
  Rewrite(F4Out, 1);

  OutFileName3 := ImagePath +
    ChangeFileExt((DisProcessForm.TCFileNameEdit.Text), '.pty');
  hBitmapOut3 := GlobalAlloc(GHND, LineSize);
  OutBitmap3 := GlobalLock(hBitmapOut3);
  AssignFile(F3Out, OutFileName3);
  Rewrite(F3Out, 1);
  {Both-Base New files}
  hBitmapOut1 := GlobalAlloc(GHND, LineSize);
  OutBitmap1 := GlobalLock(hBitmapOut1);
  OutFileName1 := ImagePath +
    ChangeFileExt((DisProcessForm.TCFileNameEdit.Text), '.pts');
  AssignFile(F1Out, OutFileName1);
  Rewrite(F1Out, 1);
  hBitmapOut2 := GlobalAlloc(GHND, LineSize);
  OutBitmap2 := GlobalLock(hBitmapOut2);
  OutFileName2 := ImagePath +
    ChangeFileExt((DisProcessForm.TCFileNameEdit.Text), '.ptg');
  AssignFile(F2Out, OutFileName2);
  Rewrite(F2Out, 1);

  DisProcessForm.IM_Hints.Caption := 'Processing Tassled Cap';

  for IV := TopRow to BottomRow - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div BottomRow);
    Application.ProcessMessages;
    BlockRead(F2, Bitmap2^, 1);
    BlockRead(F3, Bitmap3^, 1);
    BlockRead(F4, Bitmap4^, 1);
    BlockRead(F5, Bitmap5^, 1);
    case Which of
      2: begin
          BlockRead(F1, Bitmap1^, 1);
          BlockRead(F7, Bitmap7^, 1);
        end; end;
    for I := LeftColumn to RightColumn - 1 do
    begin
      lpPixel2 := @PHugeByteArray(Bitmap2)^[I];
      Color2 := lpPixel2^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[I];
      Color3 := lpPixel3^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[I];
      Color4 := lpPixel4^;
      lpPixel5 := @PHugeByteArray(Bitmap5)^[I];
      Color5 := lpPixel5^;
      case Which of
        2: begin
            lpPixel1 := @PHugeByteArray(Bitmap1)^[I];
            Color1 := lpPixel1^;
            lpPixel7 := @PHugeByteArray(Bitmap7)^[I];
            Color7 := lpPixel7^;
          end;
      else {Compiler complainer}
        begin
          Color1 := 0;
          Color7 := 0;
        end; end;

      case Which of
        1: begin {MSS}
            Filtered2 := (Color2 * SBIE2);
            Filtered3 := (Color3 * SBIE3);
            Filtered4 := (Color4 * SBIE4);
            Filtered5 := (Color5 * SBIE5);
            SBIFiltered := Filtered2 + Filtered3 + Filtered4 +
              Filtered5;
            if SBIFiltered > 255 then SBIFiltered := 255 else
              if SBIFiltered < 0 then SBIFiltered := 0;
            Color1Out := Round(SBIFiltered);
            Filtered2 := (Color2 * GVI2);
            Filtered3 := (Color3 * GVI3);
            Filtered4 := (Color4 * GVI4);
            Filtered5 := (Color5 * GVI5);
            GVIFiltered := Filtered2 + Filtered3 + Filtered4 +
              Filtered5;
            if GVIFiltered > 255 then GVIFiltered := 255 else
              if GVIFiltered < 0 then GVIFiltered := 0;
            Color2Out := Round(GVIFiltered);
            Filtered2 := (Color2 * YVI2);
            Filtered3 := (Color3 * YVI3);
            Filtered4 := (Color4 * YVI4);
            Filtered5 := (Color5 * YVI5);
            YVIFiltered := Filtered2 + Filtered3 + Filtered4 +
              Filtered5;
            if YVIFiltered > 255 then YVIFiltered := 255 else
              if YVIFiltered < 0 then YVIFiltered := 0;
            Color3Out := Round(YVIFiltered);

            Filtered2 := (Color2 * NSI2);
            Filtered3 := (Color3 * NSI3);
            Filtered4 := (Color4 * NSI4);
            Filtered5 := (Color5 * NSI5);
            NSIFiltered := Filtered2 + Filtered3 + Filtered4 +
              Filtered5;
            if NSIFiltered > 255 then NSIFiltered := 255 else
              if NSIFiltered < 0 then NSIFiltered := 0;
            Color4Out := Round(NSIFiltered);
          end;
      else
        begin {TM}
          Filtered1 := (Color1 * SBIE1);
          Filtered2 := (Color2 * SBIE2);
          Filtered3 := (Color3 * SBIE3);
          Filtered4 := (Color4 * SBIE4);
          Filtered5 := (Color5 * SBIE5);
          Filtered7 := (Color7 * SBIE7);
          SBIFiltered := Filtered1 + Filtered2 + Filtered3 + Filtered4
            + Filtered5 + Filtered7;
          if SBIFiltered > 255 then SBIFiltered := 255 else
            if SBIFiltered < 0 then SBIFiltered := 0;
          Color1Out := Round(SBIFiltered);
          Filtered1 := (Color1 * GVI1);
          Filtered2 := (Color2 * GVI2);
          Filtered3 := (Color3 * GVI3);
          Filtered4 := (Color4 * GVI4);
          Filtered5 := (Color5 * GVI5);
          Filtered7 := (Color7 * GVI7);
          GVIFiltered := Filtered1 + Filtered2 + Filtered3 + Filtered4
            + Filtered5 + Filtered7;
          if GVIFiltered > 255 then GVIFiltered := 255 else
            if GVIFiltered < 0 then GVIFiltered := 0;
          Color2Out := Round(GVIFiltered);

          Filtered1 := (Color1 * YVI1);
          Filtered2 := (Color2 * YVI2);
          Filtered3 := (Color3 * YVI3);
          Filtered4 := (Color4 * YVI4);
          Filtered5 := (Color5 * YVI5);
          Filtered7 := (Color7 * YVI7);
          YVIFiltered := Filtered1 + Filtered2 + Filtered3 + Filtered4
            + Filtered5 + Filtered7;
          if YVIFiltered > 255 then YVIFiltered := 255 else
            if YVIFiltered < 0 then YVIFiltered := 0;
          Color3Out := Round(YVIFiltered);

          Filtered1 := (Color1 * NSI1);
          Filtered2 := (Color2 * NSI2);
          Filtered3 := (Color3 * NSI3);
          Filtered4 := (Color4 * NSI4);
          Filtered5 := (Color5 * NSI5);
          Filtered7 := (Color7 * NSI7);
          NSIFiltered := Filtered1 + Filtered2 + Filtered3 + Filtered4
            + Filtered5 + Filtered7;
          if NSIFiltered > 255 then NSIFiltered := 255 else
            if NSIFiltered < 0 then NSIFiltered := 0;
          Color4Out := Round(NSIFiltered);
        end;
      end; {Case}
      lpPixelOut1 := @PHugeByteArray(OutBitmap1)^[I];
      lpPixelOut1^ := Color1Out;
      lpPixelOut2 := @PHugeByteArray(OutBitmap2)^[I];
      lpPixelOut2^ := Color2Out;
      lpPixelOut3 := @PHugeByteArray(OutBitmap3)^[I];
      lpPixelOut3^ := Color3Out;
      lpPixelOut4 := @PHugeByteArray(OutBitmap4)^[I];
      lpPixelOut4^ := Color4Out;
    end; {pixel}
    BlockWrite(F1Out, OutBitmap1^, ((RightColumn - LeftColumn) + 1));
    BlockWrite(F2Out, OutBitmap2^, ((RightColumn - LeftColumn) + 1));
    BlockWrite(F3Out, OutBitmap3^, ((RightColumn - LeftColumn) + 1));
    BlockWrite(F4Out, OutBitmap4^, ((RightColumn - LeftColumn) + 1));
  end; {line}
  DisProcessForm.RadarGauge.Progress := 0;
  CloseFile(F2);
  GlobalUnlock(hBitmap2);
  GlobalFree(hBitmap2);
  CloseFile(F3);
  GlobalUnlock(hBitmap3);
  GlobalFree(hBitmap3);
  CloseFile(F4);
  GlobalUnlock(hBitmap4);
  GlobalFree(hBitmap4);
  CloseFile(F5);
  GlobalUnlock(hBitmap5);
  GlobalFree(hBitmap5);

  CloseFile(F1Out);
  GlobalUnlock(hBitmapOut1);
  GlobalFree(hBitmapOut1);
  CloseFile(F2Out);
  GlobalUnlock(hBitmapOut2);
  GlobalFree(hBitmapOut2);
  CloseFile(F3Out);
  GlobalUnlock(hBitmapOut3);
  GlobalFree(hBitmapOut3);
  CloseFile(F4Out);
  GlobalUnlock(hBitmapOut4);
  GlobalFree(hBitmapOut4);
  case Which of
  2: begin
        CloseFile(F1);
        GlobalUnlock(hBitmap1);
        GlobalFree(hBitmap1);
        CloseFile(F7);
        GlobalUnlock(hBitmap7);
        GlobalFree(hBitmap7);
    end;
  end;
end;
(******************************************************)
procedure Do_PMB_PCA(Counter:Integer);
var
  F1Out, F2Out, F3Out, F4Out, F5Out, F6Out, F7Out, F8Out, F9Out,FnOut,
  F1, F2, F3, F4, F5, F6, F7, F8, F9: file;
  Color1Out, Color2Out, Color3Out, Color4Out, ColornOut,
  Color5Out, Color6Out, Color7Out, Color8Out, Color9Out,
  Color7, Color8, Color9,
  Color1, Color2, Color3, Color4, Color5, Color6: Byte;
MiniMax,  LineSize, I, Temp, IV: Integer;
  PCA9Max, PCA9Min,PCAnMax, PCAnMin,
  PCA1Max, PCA1Min, PCA2Max, PCA2Min, PCA3Max, PCA3Min, PCA4Max, PCA4Min,
  PCA5Max, PCA5Min, PCA6Max, PCA6Min, PCA7Max, PCA7Min, PCA8Max, PCA8Min,
  PCA1Filtered,PCA2Filtered,PCA3Filtered,PCA4Filtered,PCA5Filtered,
  PCA6Filtered,PCA7Filtered,PCA8Filtered,PCA9Filtered,PCAnFiltered,
    Filtered1, Filtered2, Filtered3, Filtered4, Filtered5, Filtered6,
    Filtered7, Filtered8, Filtered9,Filtered9n: Double;
    InFileName1, InFileName2, InFileName3, InFileName4,
    InFileName5, InFileName6, InFileName7, InFileName8,InFileName9,
    OutFileName1, OutFileName2, OutFileName3, OutFileName4,
    OutFileName5, OutFileName6, OutFileName7, OutFileName8,
    OutFileName9,OutFileNamen: string;
    Which: Integer;
    hBitmap1, hBitmap2, hBitmap3,
    hBitmap4, hBitmap5, hBitmap6, hBitmap7, hBitmap8, hBitmap9,hBitmapn,
    hBitmapOut1, hBitmapOut2, hBitmapOut3, hBitmapOut4, hBitmapOut5,
    hBitmapOut6, hBitmapOut7, hBitmapOut8, hBitmapOut9, hBitmapOutn: DWord;
    Bitmap1, Bitmap2, Bitmap3, Bitmap4, Bitmap5, Bitmap6,
    Bitmap7, Bitmap8, Bitmap9,Bitmapn,
    OutBitmap1, OutBitmap2, OutBitmap3, OutBitmap4, OutBitmap5,
    OutBitmap6, OutBitmap7, OutBitmap8, OutBitmap9,OutBitmapn: Pointer;
    lpPixel1, lpPixel2, lpPixel3,
    lpPixel4, lpPixel5, lpPixel6, lpPixel7, lpPixel8, lpPixel9,lpPixeln,
    lpPixelOut1, lpPixelOut2, lpPixelOut3, lpPixelOut4, lpPixelOut5,
    lpPixelOut6, lpPixelOut7, lpPixelOut8, lpPixelOut9,lpPixelOutn: ^Byte;
    LocalMatrix:Array[1..9,1..9] of Double;
    JacobiMatrix:Array[1..9] of Double;
begin
  Try
  Which := (Counter+1); {another what floor are you on question? }
  For I:=1 to 9 do
    For IV:=1 to 9 do
      LocalMatrix[I,IV]:=0;
  For I:=0 to Counter-1 do
    For IV:=0 to Counter-1 do
      LocalMatrix[I+1,IV+1]:=StatsArray[I].CoVariance[IV];
  For I:=1 to 9 do
      JacobiMatrix[I]:=0;
  For I:=0 to Counter-1 do
      JacobiMatrix[I+1]:=StatsArray[I].JacobiEigenvalues;

  LineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  DisProcessForm.IM_Hints.Caption := 'Processing PCA';
  DisProcessForm.RadarGauge.Progress := 1;
  Application.ProcessMessages;
  {Line snatchers}
  If Which > 1 then begin
    hBitmap1 := GlobalAlloc(GHND, LineSize);
    Bitmap1 := GlobalLock(hBitmap1);
    InFileName1 := DisProcessForm.PCAMemo.Lines[0];
    AssignFile(F1, InFileName1);
    Reset(F1, LineSize);
  end;
  If Which > 2 then begin
  hBitmap2 := GlobalAlloc(GHND, LineSize);
  Bitmap2 := GlobalLock(hBitmap2);
  InFileName2 :=  DisProcessForm.PCAMemo.Lines[1];
  AssignFile(F2, InFileName2);
  Reset(F2, LineSize); {LineSize determines the size of transfer}
  end;
  If Which > 3 then begin
  hBitmap3 := GlobalAlloc(GHND, LineSize);
  Bitmap3 := GlobalLock(hBitmap3);
  InFileName3 :=  DisProcessForm.PCAMemo.Lines[2];
  AssignFile(F3, InFileName3);
  Reset(F3, LineSize);
  end;
  If Which > 4 then begin
  hBitmap4 := GlobalAlloc(GHND, LineSize);
  Bitmap4 := GlobalLock(hBitmap4);
  InFileName4 :=  DisProcessForm.PCAMemo.Lines[3];
  AssignFile(F4, InFileName4);
  Reset(F4, LineSize);
  end;
  If Which > 5 then begin
  hBitmap5 := GlobalAlloc(GHND, LineSize);
  Bitmap5 := GlobalLock(hBitmap5);
  InFileName5 :=  DisProcessForm.PCAMemo.Lines[4];
  AssignFile(F5, InFileName5);
  Reset(F5, LineSize);
  end;
  If Which > 6 then begin
    hBitmap6 := GlobalAlloc(GHND, LineSize);
    Bitmap6 := GlobalLock(hBitmap6);
    InFileName6 :=  DisProcessForm.PCAMemo.Lines[5];
    AssignFile(F6, InFileName6);
    Reset(F6, LineSize);
  end;
  If Which > 7 then begin
    hBitmap7 := GlobalAlloc(GHND, LineSize);
    Bitmap7 := GlobalLock(hBitmap7);
    InFileName7 :=  DisProcessForm.PCAMemo.Lines[6];
    AssignFile(F7, InFileName7);
    Reset(F7, LineSize);
  end;
  If Which > 8 then begin
    hBitmap8 := GlobalAlloc(GHND, LineSize);
    Bitmap8 := GlobalLock(hBitmap8);
    InFileName8 :=  DisProcessForm.PCAMemo.Lines[7];
    AssignFile(F8, InFileName8);
    Reset(F8, LineSize);
  end;
  If Which > 9 then begin
    hBitmap9 := GlobalAlloc(GHND, LineSize);
    Bitmap9 := GlobalLock(hBitmap9);
    InFileName9 :=  DisProcessForm.PCAMemo.Lines[8];
    AssignFile(F9, InFileName9);
    Reset(F9, LineSize);
  end;

  If Which > 1 then begin
  hBitmapOut1 := GlobalAlloc(GHND, LineSize);
  OutBitmap1 := GlobalLock(hBitmapOut1);
  OutFileName1 :=
    ChangeFileExt(DisProcessForm.PCAMemo.Lines[0], '.pc1');
  AssignFile(F1Out, OutFileName1);
  Rewrite(F1Out, 1);
  end;
  If Which > 2 then begin
  hBitmapOut2 := GlobalAlloc(GHND, LineSize);
  OutBitmap2 := GlobalLock(hBitmapOut2);
  OutFileName2 :=
    ChangeFileExt(DisProcessForm.PCAMemo.Lines[1], '.pc2');
  AssignFile(F2Out, OutFileName2);
  Rewrite(F2Out, 1);
  end;
  If Which > 3 then begin
  hBitmapOut3 := GlobalAlloc(GHND, LineSize);
  OutBitmap3 := GlobalLock(hBitmapOut3);
  OutFileName3 :=
    ChangeFileExt(DisProcessForm.PCAMemo.Lines[2], '.pc3');
  AssignFile(F3Out, OutFileName3);
  Rewrite(F3Out, 1);
  end;
  If Which > 4 then begin
  hBitmapOut4 := GlobalAlloc(GHND, LineSize);
  OutBitmap4 := GlobalLock(hBitmapOut4);
  OutFileName4 :=
    ChangeFileExt(DisProcessForm.PCAMemo.Lines[3], '.pc4');
  AssignFile(F4Out, OutFileName4);
  Rewrite(F4Out, 1);
  end;
  If Which > 5 then begin
  hBitmapOut5 := GlobalAlloc(GHND, LineSize);
  OutBitmap5 := GlobalLock(hBitmapOut5);
  OutFileName5 :=
    ChangeFileExt(DisProcessForm.PCAMemo.Lines[4], '.pc5');
  AssignFile(F5Out, OutFileName5);
  Rewrite(F5Out, 1);
  end;
  If Which > 6 then begin
  hBitmapOut6 := GlobalAlloc(GHND, LineSize);
  OutBitmap6 := GlobalLock(hBitmapOut6);
  OutFileName6 :=
    ChangeFileExt(DisProcessForm.PCAMemo.Lines[5], '.pc6');
  AssignFile(F6Out, OutFileName6);
  Rewrite(F6Out, 1);
  end;
  If Which > 7 then begin
  hBitmapOut7 := GlobalAlloc(GHND, LineSize);
  OutBitmap7 := GlobalLock(hBitmapOut7);
  OutFileName7 :=
    ChangeFileExt(DisProcessForm.PCAMemo.Lines[6], '.pc7');
  AssignFile(F7Out, OutFileName7);
  Rewrite(F7Out, 1);
  end;
  If Which > 8 then begin
  hBitmapOut8 := GlobalAlloc(GHND, LineSize);
  OutBitmap8 := GlobalLock(hBitmapOut8);
  OutFileName8 :=
    ChangeFileExt(DisProcessForm.PCAMemo.Lines[7], '.pc8');
  AssignFile(F8Out, OutFileName8);
  Rewrite(F8Out, 1);
  end;
  If Which > 9 then begin
  hBitmapOut9 := GlobalAlloc(GHND, LineSize);
  OutBitmap9 := GlobalLock(hBitmapOut9);
  OutFileName9 :=
    ChangeFileExt(DisProcessForm.PCAMemo.Lines[8], '.pc9');
  AssignFile(F9Out, OutFileName9);
  Rewrite(F9Out, 1);
  end;
  hBitmapOutn := GlobalAlloc(GHND, LineSize);
  OutBitmapn := GlobalLock(hBitmapOutn);
  OutFileNamen :=
    ChangeFileExt(DisProcessForm.PCAMemo.Lines[0], '.pcn');
  AssignFile(FnOut, OutFileNamen);
  Rewrite(FnOut, 1);
  {Set up for missing data = never changed if not called}
  Color1 := 0; Color2 := 0; Color3 := 0;Color4 := 0;Color5 := 0;
  Color6 := 0;Color7 := 0; Color8 := 0; Color9 := 0;
  {Filtered1 :=0;}
  Filtered2 :=0; Filtered3 :=0; Filtered4 :=0; Filtered5 :=0;
  Filtered6 :=0; Filtered7 :=0; Filtered8 :=0; Filtered9 :=0;
  PCA9Max:=5.0 * power(10, -324);PCAnMax:=5.0 * power(10, -324);
  PCA9Min:=1.7 * power(10,308); PCAnMin:=1.7 * power(10,308);
  PCA1Max:=5.0 * power(10, -324); PCA1Min:=1.7 * power(10,308); PCA2Max:=5.0 * power(10, -324); PCA2Min:=1.7 * power(10,308); PCA3Max:=5.0 * power(10, -324); PCA3Min:=1.7 * power(10,308); PCA4Max:=5.0 * power(10, -324); PCA4Min:=1.7 * power(10,308);
  PCA5Max:=5.0 * power(10, -324); PCA5Min:=1.7 * power(10,308); PCA6Max:=5.0 * power(10, -324); PCA6Min:=1.7 * power(10,308); PCA7Max:=5.0 * power(10, -324); PCA7Min:=1.7 * power(10,308); PCA8Max:=5.0 * power(10, -324); PCA8Min:=1.7 * power(10,308);

for MiniMax:=1 to 2 do begin
If MiniMax=2 then begin
  If Which > 1 then Reset(F1, LineSize);
  If Which > 2 then Reset(F2, LineSize);
  If Which > 3 then Reset(F3, LineSize);
  If Which > 4 then Reset(F4, LineSize);
  If Which > 5 then Reset(F5, LineSize);
  If Which > 6 then Reset(F6, LineSize);
  If Which > 7 then Reset(F7, LineSize);
  If Which > 8 then Reset(F8, LineSize);
  If Which > 9 then Reset(F9, LineSize);
end;
  for IV := TopRow to BottomRow - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div BottomRow);
    Application.ProcessMessages;

    If Which > 1 then BlockRead(F1, Bitmap1^, 1);
    If Which > 2 then BlockRead(F2, Bitmap2^, 1);
    If Which > 3 then BlockRead(F3, Bitmap3^, 1);
    If Which > 4 then BlockRead(F4, Bitmap4^, 1);
    If Which > 5 then BlockRead(F5, Bitmap5^, 1);
    If Which > 6 then BlockRead(F6, Bitmap6^, 1);
    If Which > 7 then BlockRead(F7, Bitmap7^, 1);
    If Which > 8 then BlockRead(F8, Bitmap8^, 1);
    If Which > 9 then BlockRead(F9, Bitmap9^, 1);

    for I := LeftColumn to RightColumn - 1 do
    begin
      If Which > 1 then begin
      lpPixel1 := @PHugeByteArray(Bitmap1)^[I];
      Color1 := lpPixel1^; end;
      If Which > 2 then begin
      lpPixel2 := @PHugeByteArray(Bitmap2)^[I];
      Color2 := lpPixel2^; end;
      If Which > 3 then begin
      lpPixel3 := @PHugeByteArray(Bitmap3)^[I];
      Color3 := lpPixel3^; end;
      If Which > 4 then begin
      lpPixel4 := @PHugeByteArray(Bitmap4)^[I];
      Color4 := lpPixel4^; end;
      If Which > 5 then begin
      lpPixel5 := @PHugeByteArray(Bitmap5)^[I];
      Color5 := lpPixel5^; end;
      If Which > 6 then begin
      lpPixel6 := @PHugeByteArray(Bitmap6)^[I];
      Color6 := lpPixel6^; end;
      If Which > 7 then begin
      lpPixel7 := @PHugeByteArray(Bitmap7)^[I];
      Color7 := lpPixel7^; end;
      If Which > 8 then begin
      lpPixel8 := @PHugeByteArray(Bitmap8)^[I];
      Color8 := lpPixel8^; end;
      If Which > 9 then begin
      lpPixel9 := @PHugeByteArray(Bitmap9)^[I];
      Color9 := lpPixel9^; end;

      begin
      Filtered1 := (Color1 * JacobiMatrix[1]{ LocalMatrix[1,1]});
      If Which > 2  then Filtered2 := (Color2 * JacobiMatrix[2]{LocalMatrix[1,2]});
      If Which > 3 then Filtered3 := (Color3 * JacobiMatrix[3]{LocalMatrix[1,3]});
      If Which > 4 then Filtered4 := (Color4 * JacobiMatrix[4]{LocalMatrix[1,4]});
      If Which > 5 then Filtered5 := (Color5 * JacobiMatrix[5]{LocalMatrix[1,5]});
      If Which > 6 then Filtered6 := (Color6 * JacobiMatrix[6]{LocalMatrix[1,6]});
      If Which > 7 then Filtered7 := (Color7 * JacobiMatrix[7]{LocalMatrix[1,7]});
      If Which > 8 then Filtered8 := (Color8 * JacobiMatrix[8]{LocalMatrix[1,8]});
      If Which > 9 then Filtered9 := (Color9 * JacobiMatrix[9]{LocalMatrix[1,9]});
      PCAnFiltered := Filtered1 + Filtered2 + Filtered3 + Filtered4
         + Filtered5 + Filtered6+ Filtered7+ Filtered8+ Filtered9;
        If PCAnMin > PCAnFiltered then PCAnMin:= PCAnFiltered;
        if PCAnFiltered > PCAnMax then PCAnMax:= PCAnFiltered;
      If MiniMax=2 then begin
      PCAnFiltered:=round(255*(PCAnFiltered-PCAnMin )/(PCAnMax -PCAnMin ));
      if PCAnFiltered > 255 then PCAnFiltered := 255 else
         if PCAnFiltered < 0 then PCAnFiltered := 0;
      ColornOut := Round(PCAnFiltered);
      lpPixelOutn := @PHugeByteArray(OutBitmapn)^[I];
      lpPixelOutn^ := ColornOut;
      end;
      end;

      If Which > 1 then begin
      Filtered1 := (Color1 * {JacobiMatrix[1]} LocalMatrix[1,1]);
      If Which > 2  then Filtered2 := (Color2 * {JacobiMatrix[2]}LocalMatrix[1,2]);
      If Which > 3 then Filtered3 := (Color3 * {JacobiMatrix[3]}LocalMatrix[1,3]);
      If Which > 4 then Filtered4 := (Color4 * {JacobiMatrix[4]}LocalMatrix[1,4]);
      If Which > 5 then Filtered5 := (Color5 * {JacobiMatrix[5]}LocalMatrix[1,5]);
      If Which > 6 then Filtered6 := (Color6 * {JacobiMatrix[6]}LocalMatrix[1,6]);
      If Which > 7 then Filtered7 := (Color7 * {JacobiMatrix[7]}LocalMatrix[1,7]);
      If Which > 8 then Filtered8 := (Color8 * {JacobiMatrix[8]}LocalMatrix[1,8]);
      If Which > 9 then Filtered9 := (Color9 * {JacobiMatrix[9]}LocalMatrix[1,9]);
      PCA1Filtered := Filtered1 + Filtered2 + Filtered3 + Filtered4
         + Filtered5 + Filtered6+ Filtered7+ Filtered8+ Filtered9;
        If PCA1Min > PCA1Filtered then PCA1Min:= PCA1Filtered;
        if PCA1Filtered > PCA1Max then PCA1Max:= PCA1Filtered;
      If MiniMax=2 then begin
      PCA1Filtered:=round(255*(PCA1Filtered-PCA1Min )/(PCA1Max -PCA1Min ));
      if PCA1Filtered > 255 then PCA1Filtered := 255 else
         if PCA1Filtered < 0 then PCA1Filtered := 0;
      Color1Out := Round(PCA1Filtered);
      lpPixelOut1 := @PHugeByteArray(OutBitmap1)^[I];
      lpPixelOut1^ := Color1Out;
      end;
      end;
      If Which > 2 then begin
      Filtered1 := (Color1 * {JacobiMatrix[1]}LocalMatrix[2,1]);
      Filtered2 := (Color2 * {JacobiMatrix[2]}LocalMatrix[2,2]);
      If Which > 3 then Filtered3 := (Color3 * {JacobiMatrix[3]}LocalMatrix[2,3]);
      If Which > 4 then Filtered4 := (Color4 * {JacobiMatrix[4]}LocalMatrix[2,4]);
      If Which > 5 then Filtered5 := (Color5 * {JacobiMatrix[5]}LocalMatrix[2,5]);
      If Which > 6 then Filtered6 := (Color6 * {JacobiMatrix[6]}LocalMatrix[2,6]);
      If Which > 7 then Filtered7 := (Color7 * {JacobiMatrix[7]}LocalMatrix[2,7]);
      If Which > 8 then Filtered8 := (Color8 * {JacobiMatrix[8]}LocalMatrix[2,8]);
      If Which > 9 then Filtered9 := (Color9 * {JacobiMatrix[9]}LocalMatrix[2,9]);
      PCA2Filtered := Filtered1 + Filtered2 + Filtered3 + Filtered4
            + Filtered5 + Filtered6+ Filtered7+ Filtered8+ Filtered9;
        If PCA2Min > PCA2Filtered then PCA2Min:= PCA2Filtered;
        if PCA2Filtered > PCA2Max then PCA2Max:= PCA2Filtered;
      If MiniMax=2 then begin
      PCA2Filtered:=round(255*(PCA2Filtered-PCA2Min )/(PCA2Max -PCA2Min ));
      if PCA2Filtered > 255 then PCA2Filtered := 255 else
            if PCA2Filtered < 0 then PCA2Filtered := 0;
      Color2Out := Round(PCA2Filtered);
      lpPixelOut2 := @PHugeByteArray(OutBitmap2)^[I];
      lpPixelOut2^ := Color2Out;
      end;end;
      If Which > 3 then begin
      Filtered1 := (Color1 * {JacobiMatrix[1]}LocalMatrix[3,1]);
      Filtered2 := (Color2 * {JacobiMatrix[2]}LocalMatrix[3,2]);
      Filtered3 := (Color3 * {JacobiMatrix[3]}LocalMatrix[3,3]);
      If Which > 4 then Filtered4 := (Color4 * {JacobiMatrix[4]}LocalMatrix[3,4]);
      If Which > 5 then Filtered5 := (Color5 * {JacobiMatrix[5]}LocalMatrix[3,5]);
      If Which > 6 then Filtered6 := (Color6 * {JacobiMatrix[6]}LocalMatrix[3,6]);
      If Which > 7 then Filtered7 := (Color7 * {JacobiMatrix[7]}LocalMatrix[3,7]);
      If Which > 8 then Filtered8 := (Color8 * {JacobiMatrix[8]}LocalMatrix[3,8]);
      If Which > 9 then Filtered9 := (Color9 * {JacobiMatrix[9]}LocalMatrix[3,9]);
      PCA3Filtered := Filtered1 + Filtered2 + Filtered3 + Filtered4
            + Filtered5 + Filtered6+ Filtered7+ Filtered8+ Filtered9;
        If PCA3Min > PCA3Filtered then PCA3Min:= PCA3Filtered;
        if PCA3Filtered > PCA3Max then PCA3Max:= PCA3Filtered;
      If MiniMax=2 then begin
      PCA3Filtered:=round(255*(PCA3Filtered-PCA3Min )/(PCA3Max -PCA3Min ));
      if PCA3Filtered > 255 then PCA3Filtered := 255 else
            if PCA3Filtered < 0 then PCA3Filtered := 0;
      Color3Out := Round(PCA3Filtered);
      lpPixelOut3 := @PHugeByteArray(OutBitmap3)^[I];
      lpPixelOut3^ := Color3Out;
      end;end;
      If Which > 4 then begin
      Filtered1 := (Color1 * {JacobiMatrix[1]}LocalMatrix[4,1]);
      Filtered2 := (Color2 * {JacobiMatrix[2]}LocalMatrix[4,2]);
      Filtered3 := (Color3 * {JacobiMatrix[3]}LocalMatrix[4,3]);
      Filtered4 := (Color4 * {JacobiMatrix[4]}LocalMatrix[4,4]);
      If Which > 5 then Filtered5 := (Color5 * {JacobiMatrix[5]}LocalMatrix[4,5]);
      If Which > 6 then Filtered6 := (Color6 * {JacobiMatrix[6]}LocalMatrix[4,6]);
      If Which > 7 then Filtered7 := (Color7 * {JacobiMatrix[7]}LocalMatrix[4,7]);
      If Which > 8 then Filtered8 := (Color8 * {JacobiMatrix[8]}LocalMatrix[4,8]);
      If Which > 9 then Filtered9 := (Color9 * {JacobiMatrix[9]}LocalMatrix[4,9]);
      PCA4Filtered := Filtered1 + Filtered2 + Filtered3 + Filtered4
            + Filtered5 + Filtered6+ Filtered7+ Filtered8+ Filtered9;
        If PCA4Min > PCA4Filtered then PCA4Min:= PCA4Filtered;
        if PCA4Filtered > PCA4Max then PCA4Max:= PCA4Filtered;
      If MiniMax=2 then begin
      PCA4Filtered:=round(255*(PCA4Filtered-PCA4Min )/(PCA4Max -PCA4Min ));
      if PCA4Filtered > 255 then PCA4Filtered := 255 else
            if PCA4Filtered < 0 then PCA4Filtered := 0;
      Color4Out := Round(PCA4Filtered);
      lpPixelOut4 := @PHugeByteArray(OutBitmap4)^[I];
      lpPixelOut4^ := Color4Out;
      end;end;
      If Which > 5 then begin
      Filtered1 := (Color1 * {JacobiMatrix[1]}LocalMatrix[5,1]);
      Filtered2 := (Color2 * {JacobiMatrix[2]}LocalMatrix[5,2]);
      Filtered3 := (Color3 * {JacobiMatrix[3]}LocalMatrix[5,3]);
      Filtered4 := (Color4 * {JacobiMatrix[4]}LocalMatrix[5,4]);
      Filtered5 := (Color5 * {JacobiMatrix[5]}LocalMatrix[5,5]);
      If Which > 6 then Filtered6 := (Color6 * {JacobiMatrix[6]}LocalMatrix[5,6]);
      If Which > 7 then Filtered7 := (Color7 * {JacobiMatrix[7]}LocalMatrix[5,7]);
      If Which > 8 then Filtered8 := (Color8 * {JacobiMatrix[8]}LocalMatrix[5,8]);
      If Which > 9 then Filtered9 := (Color9 * {JacobiMatrix[9]}LocalMatrix[5,9]);
      PCA5Filtered := Filtered1 + Filtered2 + Filtered3 + Filtered4
            + Filtered5 + Filtered6+ Filtered7+ Filtered8+ Filtered9;
        If PCA5Min > PCA5Filtered then PCA5Min:= PCA5Filtered;
        if PCA5Filtered > PCA5Max then PCA5Max:= PCA5Filtered;
      If MiniMax=2 then begin
      PCA5Filtered:=round(255*(PCA5Filtered-PCA5Min )/(PCA5Max -PCA5Min ));
      if PCA5Filtered > 255 then PCA5Filtered := 255 else
            if PCA5Filtered < 0 then PCA5Filtered := 0;
      Color5Out := Round(PCA5Filtered);
      lpPixelOut5 := @PHugeByteArray(OutBitmap5)^[I];
      lpPixelOut5^ := Color5Out;
      end;end;
      If Which > 6 then begin
      Filtered1 := (Color1 * {JacobiMatrix[1]}LocalMatrix[6,1]);
      Filtered2 := (Color2 * {JacobiMatrix[2]}LocalMatrix[6,2]);
      Filtered3 := (Color3 * {JacobiMatrix[3]}LocalMatrix[6,3]);
      Filtered4 := (Color4 * {JacobiMatrix[4]}LocalMatrix[6,4]);
      Filtered5 := (Color5 * {JacobiMatrix[5]}LocalMatrix[6,5]);
      Filtered6 := (Color6 * {JacobiMatrix[6]}LocalMatrix[6,6]);
      If Which > 7 then Filtered7 := (Color7 * {JacobiMatrix[7]}LocalMatrix[6,7]);
      If Which > 8 then Filtered8 := (Color8 * {JacobiMatrix[8]}LocalMatrix[6,8]);
      If Which > 9 then Filtered9 := (Color9 * {JacobiMatrix[9]}LocalMatrix[6,9]);
      PCA6Filtered := Filtered1 + Filtered2 + Filtered3 + Filtered4
            + Filtered5 + Filtered6+ Filtered7+ Filtered8+ Filtered9;
        If PCA6Min > PCA6Filtered then PCA6Min:= PCA6Filtered;
        if PCA6Filtered > PCA6Max then PCA6Max:= PCA6Filtered;
      If MiniMax=2 then begin
      PCA6Filtered:=round(255*(PCA6Filtered-PCA6Min )/(PCA6Max -PCA6Min ));
      if PCA6Filtered > 255 then PCA6Filtered := 255 else
            if PCA6Filtered < 0 then PCA6Filtered := 0;
      Color6Out := Round(PCA6Filtered);
      lpPixelOut6 := @PHugeByteArray(OutBitmap6)^[I];
      lpPixelOut6^ := Color6Out;
      end;end;
      If Which > 7 then begin
      Filtered1 := (Color1 * {JacobiMatrix[1]}LocalMatrix[7,1]);
      Filtered2 := (Color2 * {JacobiMatrix[2]}LocalMatrix[7,2]);
      Filtered3 := (Color3 * {JacobiMatrix[3]}LocalMatrix[7,3]);
      Filtered4 := (Color4 * {JacobiMatrix[4]}LocalMatrix[7,4]);
      Filtered5 := (Color5 * {JacobiMatrix[5]}LocalMatrix[7,5]);
      Filtered6 := (Color6 * {JacobiMatrix[6]}LocalMatrix[7,6]);
      Filtered7 := (Color7 * {JacobiMatrix[7]}LocalMatrix[7,7]);
      If Which > 8 then Filtered8 := (Color8 * {JacobiMatrix[8]}LocalMatrix[7,8]);
      If Which > 9 then Filtered9 := (Color9 * {JacobiMatrix[9]}LocalMatrix[7,9]);
      PCA7Filtered := Filtered1 + Filtered2 + Filtered3 + Filtered4
            + Filtered5 + Filtered6+ Filtered7+ Filtered8+ Filtered9;
        If PCA7Min > PCA7Filtered then PCA7Min:= PCA7Filtered;
        if PCA7Filtered > PCA7Max then PCA7Max:= PCA7Filtered;
      If MiniMax=2 then begin
      PCA7Filtered:=round(255*(PCA7Filtered-PCA7Min )/(PCA7Max -PCA7Min ));
      if PCA7Filtered > 255 then PCA7Filtered := 255 else
            if PCA7Filtered < 0 then PCA7Filtered := 0;
      Color7Out := Round(PCA7Filtered);
      lpPixelOut7 := @PHugeByteArray(OutBitmap7)^[I];
      lpPixelOut7^ := Color7Out;
      end;end;
      If Which > 8 then begin
      Filtered1 := (Color1 * {JacobiMatrix[1]}LocalMatrix[8,1]);
      Filtered2 := (Color2 * {JacobiMatrix[2]}LocalMatrix[8,2]);
      Filtered3 := (Color3 * {JacobiMatrix[3]}LocalMatrix[8,3]);
      Filtered4 := (Color4 * {JacobiMatrix[4]}LocalMatrix[8,4]);
      Filtered5 := (Color5 * {JacobiMatrix[5]}LocalMatrix[8,5]);
      Filtered6 := (Color6 * {JacobiMatrix[6]}LocalMatrix[8,6]);
      Filtered7 := (Color7 * {JacobiMatrix[7]}LocalMatrix[8,7]);
      Filtered8 := (Color8 * {JacobiMatrix[8]}LocalMatrix[8,8]);
      If Which > 9 then Filtered9 := (Color9 * {JacobiMatrix[9]}LocalMatrix[8,9]);
      PCA8Filtered := Filtered1 + Filtered2 + Filtered3 + Filtered4
            + Filtered5 + Filtered6+ Filtered7+ Filtered8+ Filtered9;
        If PCA8Min > PCA8Filtered then PCA8Min:= PCA8Filtered;
        if PCA8Filtered > PCA8Max then PCA8Max:= PCA8Filtered;
      If MiniMax=2 then begin
      PCA8Filtered:=round(255*(PCA8Filtered-PCA8Min )/(PCA8Max -PCA8Min ));
      if PCA8Filtered > 255 then PCA8Filtered := 255 else
            if PCA8Filtered < 0 then PCA8Filtered := 0;
      Color8Out := Round(PCA8Filtered);
      lpPixelOut8 := @PHugeByteArray(OutBitmap8)^[I];
      lpPixelOut8^ := Color8Out;
      end;end;
      If Which > 9 then begin
      Filtered1 := (Color1 * {JacobiMatrix[1]}LocalMatrix[9,1]);
      Filtered2 := (Color2 * {JacobiMatrix[2]}LocalMatrix[9,2]);
      Filtered3 := (Color3 * {JacobiMatrix[3]}LocalMatrix[9,3]);
      Filtered4 := (Color4 * {JacobiMatrix[4]}LocalMatrix[9,4]);
      Filtered5 := (Color5 * {JacobiMatrix[5]}LocalMatrix[9,5]);
      Filtered6 := (Color6 * {JacobiMatrix[6]}LocalMatrix[9,6]);
      Filtered7 := (Color7 * {JacobiMatrix[7]}LocalMatrix[9,7]);
      Filtered8 := (Color8 * {JacobiMatrix[8]}LocalMatrix[9,8]);
      Filtered9 := (Color9 * {JacobiMatrix[9]}LocalMatrix[8,9]);
      PCA9Filtered := Filtered1 + Filtered2 + Filtered3 + Filtered4
            + Filtered5 + Filtered6+ Filtered7+ Filtered8+ Filtered9;
        If PCA9Min > PCA9Filtered then PCA9Min:= PCA9Filtered;
        if PCA9Filtered > PCA9Max then PCA9Max:= PCA9Filtered;
      If MiniMax=2 then begin
      PCA9Filtered:=round(255*(PCA9Filtered-PCA9Min )/(PCA9Max -PCA9Min ));
      if PCA9Filtered > 255 then PCA9Filtered := 255 else
            if PCA9Filtered < 0 then PCA9Filtered := 0;
      Color9Out := Round(PCA9Filtered);
      lpPixelOut9 := @PHugeByteArray(OutBitmap9)^[I];
      lpPixelOut9^ := Color9Out;
      end;end;
    end; {I pixel}
If MiniMax = 2 then
begin
    BlockWrite(FnOut, OutBitmapn^, ((RightColumn - LeftColumn) + 1));
    If Which > 1 then BlockWrite(F1Out, OutBitmap1^, ((RightColumn - LeftColumn) + 1));
    If Which > 2 then BlockWrite(F2Out, OutBitmap2^, ((RightColumn - LeftColumn) + 1));
    If Which > 3 then BlockWrite(F3Out, OutBitmap3^, ((RightColumn - LeftColumn) + 1));
    If Which > 4 then BlockWrite(F4Out, OutBitmap4^, ((RightColumn - LeftColumn) + 1));
    If Which > 5 then BlockWrite(F5Out, OutBitmap5^, ((RightColumn - LeftColumn) + 1));
    If Which > 6 then BlockWrite(F6Out, OutBitmap6^, ((RightColumn - LeftColumn) + 1));
    If Which > 7 then BlockWrite(F7Out, OutBitmap7^, ((RightColumn - LeftColumn) + 1));
    If Which > 8 then BlockWrite(F8Out, OutBitmap8^, ((RightColumn - LeftColumn) + 1));
    If Which > 9 then BlockWrite(F9Out, OutBitmap9^, ((RightColumn - LeftColumn) + 1));
end;
  end; {IV line}
end;{Minimax range control}
  DisProcessForm.RadarGauge.Progress := 0;
  CloseFile(FnOut);
  GlobalUnlock(hBitmapOutn);
  GlobalFree(hBitmapOutn);
  If Which > 1 then begin
  CloseFile(F1);
  GlobalUnlock(hBitmap1);
  GlobalFree(hBitmap1);
  CloseFile(F1Out);
  GlobalUnlock(hBitmapOut1);
  GlobalFree(hBitmapOut1);
  end;
  If Which > 2 then begin
  CloseFile(F2);
  GlobalUnlock(hBitmap2);
  GlobalFree(hBitmap2);
  CloseFile(F2Out);
  GlobalUnlock(hBitmapOut2);
  GlobalFree(hBitmapOut2);
  end;
  If Which > 3 then begin
  CloseFile(F3);
  GlobalUnlock(hBitmap3);
  GlobalFree(hBitmap3);
  CloseFile(F3Out);
  GlobalUnlock(hBitmapOut3);
  GlobalFree(hBitmapOut3);
  end;
  If Which > 4 then begin
  CloseFile(F4);
  GlobalUnlock(hBitmap4);
  GlobalFree(hBitmap4);
  CloseFile(F4Out);
  GlobalUnlock(hBitmapOut4);
  GlobalFree(hBitmapOut4);
  end;
  If Which > 5 then begin
  CloseFile(F5);
  GlobalUnlock(hBitmap5);
  GlobalFree(hBitmap5);
  CloseFile(F5Out);
  GlobalUnlock(hBitmapOut5);
  GlobalFree(hBitmapOut5);
  end;
  If Which > 6 then begin
  CloseFile(F6);
  GlobalUnlock(hBitmap6);
  GlobalFree(hBitmap6);
  CloseFile(F6Out);
  GlobalUnlock(hBitmapOut6);
  GlobalFree(hBitmapOut6);
  end;
  If Which > 7 then begin
  CloseFile(F7);
  GlobalUnlock(hBitmap7);
  GlobalFree(hBitmap7);
  CloseFile(F7Out);
  GlobalUnlock(hBitmapOut7);
  GlobalFree(hBitmapOut7);
  end;
  If Which > 8 then begin
  CloseFile(F8);
  GlobalUnlock(hBitmap8);
  GlobalFree(hBitmap8);
  CloseFile(F8Out);
  GlobalUnlock(hBitmapOut8);
  GlobalFree(hBitmapOut8);
  end;
  If Which > 9 then begin
  CloseFile(F9);
  GlobalUnlock(hBitmap9);
  GlobalFree(hBitmap9);
  CloseFile(F9Out);
  GlobalUnlock(hBitmapOut9);
  GlobalFree(hBitmapOut9);
  end;

  Except
    {Error message}
  end;
end;
(******************************************************)

(******************************************************)
  {Convert 1,2,3 to HSV, substitute 4 for V
  Change back to RGB}
{BandFile1);
BandFile2);
BandFile3);
BandFile4);
ChangeFileExt(SRFileH1Edit.Text,'.prh'));
ChangeFileExt(SRFileS2Edit.Text,'.prs'));
ChangeFileExt(SRFileV3Edit.Text,'.prv'));}
(******************************************************)

procedure Do_RGBtoHSV;
var
  F1Out, F2Out, F3Out,
    F1, F2, F3, F4: file;
  Color1Out, Color2Out, Color3Out,
    Color1, Color2, Color3, Color4: Byte;
  LineSize, I, Temp, IV: Integer;
  SBIFiltered, GVIFiltered, YVIFiltered, NSIFiltered,
    Filtered1, Filtered2, Filtered3,
    Filtered4, Filtered5, Filtered7: Double;
  InFileName1, InFileName2,
    InFileName3, InFileName4,
    OutFileName1, OutFileName2,
    OutFileName3: string;
  Which: Integer;
  hBitmap1, hBitmap2, hBitmap3,
    hBitmap4,
    hBitmapOut1, hBitmapOut2, hBitmapOut3: DWord;
  Bitmap1, Bitmap2, Bitmap3,
    Bitmap4,
    OutBitmap1, OutBitmap2, OutBitmap3: Pointer;
  lpPixel1, lpPixel2, lpPixel3,
    lpPixel4,
    lpPixelOut1, lpPixelOut2, lpPixelOut3: ^Byte;
begin
  LineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  DisProcessForm.RadarGauge.Progress := 1;
  {Line snatchers}
  hBitmap1 := GlobalAlloc(GHND, LineSize);
  Bitmap1 := GlobalLock(hBitmap1);
  InFileName1 := BandFile1;
  AssignFile(F1, InFileName1);
  Reset(F1, LineSize);
  hBitmap2 := GlobalAlloc(GHND, LineSize);
  Bitmap2 := GlobalLock(hBitmap2);
  InFileName2 := BandFile2;
  AssignFile(F2, InFileName2);
  Reset(F2, LineSize);
  hBitmap3 := GlobalAlloc(GHND, LineSize);
  Bitmap3 := GlobalLock(hBitmap3);
  InFileName3 := BandFile3;
  AssignFile(F3, InFileName3);
  Reset(F3, LineSize);
  hBitmap4 := GlobalAlloc(GHND, LineSize);
  Bitmap4 := GlobalLock(hBitmap4);
  InFileName4 := BandFile4;
  AssignFile(F4, InFileName4);
  Reset(F4, LineSize);

  hBitmapOut1 := GlobalAlloc(GHND, LineSize);
  OutBitmap1 := GlobalLock(hBitmapOut1);
  OutFileName1 := ImagePath +
    ChangeFileExt((DisProcessForm.TCFileNameEdit.Text), '.prr');
  AssignFile(F1Out, OutFileName1);
  Rewrite(F1Out, 1);
  hBitmapOut2 := GlobalAlloc(GHND, LineSize);
  OutBitmap2 := GlobalLock(hBitmapOut2);
  OutFileName2 := ImagePath +
    ChangeFileExt((DisProcessForm.TCFileNameEdit.Text), '.prg');
  AssignFile(F2Out, OutFileName2);
  Rewrite(F2Out, 1);
  hBitmapOut3 := GlobalAlloc(GHND, LineSize);
  OutBitmap3 := GlobalLock(hBitmapOut3);
  OutFileName3 := ImagePath +
    ChangeFileExt((DisProcessForm.TCFileNameEdit.Text), '.prb');
  AssignFile(F3Out, OutFileName3);
  Rewrite(F3Out, 1);

  DisProcessForm.IM_Hints.Caption := 'Processing RGB - HSV - RGB';

  for IV := TopRow to BottomRow - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div BottomRow);
    Application.ProcessMessages;
    BlockRead(F1, Bitmap1^, 1);
    BlockRead(F2, Bitmap2^, 1);
    BlockRead(F3, Bitmap3^, 1);
    BlockRead(F4, Bitmap4^, 1);

    for I := LeftColumn to RightColumn - 1 do
    begin
      lpPixel1 := @PHugeByteArray(Bitmap1)^[I];
      Color1 := lpPixel1^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[I];
      Color2 := lpPixel2^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[I];
      Color3 := lpPixel3^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[I];
      Color4 := lpPixel4^;
      Filtered4 := Color4;
{RGBToHSV (CONST R,G,B:  TReal; VAR H,S,V:  TReal);}
      RGBToHSV(Color1, Color2, Color3,
        Filtered1 {H}, Filtered2 {S}, Filtered3 {V});

{HSVtoRGB (CONST H,S,V:  TReal;VAR R,G,B:  TReal);}
      HSVtoRGB(Filtered1 {H}, Filtered2 {S}, Filtered4,
        SBIFiltered,
        GVIFiltered,
        YVIFiltered);

      if SBIFiltered > 255 then SBIFiltered := 255 else
        if SBIFiltered < 0 then SBIFiltered := 0;
      Color1Out := Round(SBIFiltered);
      if GVIFiltered > 255 then GVIFiltered := 255 else
        if GVIFiltered < 0 then GVIFiltered := 0;
      Color2Out := Round(GVIFiltered);
      if YVIFiltered > 255 then YVIFiltered := 255 else
        if YVIFiltered < 0 then YVIFiltered := 0;
      Color3Out := Round(YVIFiltered);
      lpPixelOut1 := @PHugeByteArray(OutBitmap1)^[I];
      lpPixelOut1^ := Color1Out;
      lpPixelOut2 := @PHugeByteArray(OutBitmap2)^[I];
      lpPixelOut2^ := Color2Out;
      lpPixelOut3 := @PHugeByteArray(OutBitmap3)^[I];
      lpPixelOut3^ := Color3Out;
    end; {pixel}
    BlockWrite(F1Out, OutBitmap1^, ((RightColumn - LeftColumn) + 1));
    BlockWrite(F2Out, OutBitmap2^, ((RightColumn - LeftColumn) + 1));
    BlockWrite(F3Out, OutBitmap3^, ((RightColumn - LeftColumn) + 1));
  end; {line}
  DisProcessForm.RadarGauge.Progress := 0;
  CloseFile(F1);
  GlobalUnlock(hBitmap1);
  GlobalFree(hBitmap1);
  CloseFile(F2);
  GlobalUnlock(hBitmap2);
  GlobalFree(hBitmap2);
  CloseFile(F3);
  GlobalUnlock(hBitmap3);
  GlobalFree(hBitmap3);
  CloseFile(F4);
  GlobalUnlock(hBitmap4);
  GlobalFree(hBitmap4);

  CloseFile(F1Out);
  GlobalUnlock(hBitmapOut1);
  GlobalFree(hBitmapOut1);
  CloseFile(F2Out);
  GlobalUnlock(hBitmapOut2);
  GlobalFree(hBitmapOut2);
  CloseFile(F3Out);
  GlobalUnlock(hBitmapOut3);
  GlobalFree(hBitmapOut3);
end;
  // RGB, each 0 to 255, to HSV.
  //   H = 0.0 to 360.0 (corresponding to 0..360.0 degrees around hexcone)
  //   S = 0.0 (shade of gray) to 1.0 (pure color)
  //   V = 0.0 (black) to 1.0 {white)

  // Based on C Code in "Computer Graphics -- Principles and Practice,"
  // Foley et al, 1996, p. 592.
  //Floating point fractions, 0..1, replaced with
  // integer values, 0..255.

procedure RGBToHSV(const R, G, B: TReal; var H, S, V: TReal);
var
  Delta: TReal;
  Min: TReal;
begin
  Min := MinValue([R, G, B]);
  V := MaxValue([R, G, B]);
  Delta := V - Min;
    // Calculate saturation:  saturation is 0 if r, g and b are all 0
  if V = 0.0
    then S := 0
  else S := Delta / V;

  if S = 0.0
    then H := 0 { NaN} // Achromatic:  When s = 0, h is undefined
  else begin // Chromatic
    if R = V
      then // between yellow and magenta [degrees]
      H := 60.0 * (G - B) / Delta
    else
      if G = V
        then // between cyan and yellow
        H := 120.0 + 60.0 * (B - R) / Delta
      else
        if B = V
          then // between magenta and cyan
          H := 240.0 + 60.0 * (R - G) / Delta;

    if H < 0.0
      then H := H + 360.0
  end
end {RGBtoHSV};


  //////////////////////////////////////////////////////////////////
  // Floating-Point Routines
  // Based on C Code in "Computer Graphics -- Principles and Practice,"
  // Foley et al, 1996, p. 593.
  //  H = 0.0 to 360.0 (corresponding to 0..360 degrees around hexcone)
  //      NaN (undefined) for S = 0
  //  S = 0.0 (shade of gray) to 1.0 (pure color)
  //  V = 0.0 (black)         to 1.0 (white)

procedure HSVtoRGB(const H, S, V: TReal; var R, G, B: TReal);
var
  f: TReal;
  i: INTEGER;
  hTemp: TReal; // since H is CONST parameter
  p, q, t: TReal;
begin
  if S = 0.0 // color is on black-and-white center line
    then begin
    if H = 0 {IsNaN(H)}
      then begin
      R := V; // achromatic:  shades of gray
      G := V;
      B := V
    end
{      ELSE RAISE EColorError.Create('HSVtoRGB:  S = 0 and H has a value')};
  end

  else begin // chromatic color
    if H = 360.0 // 360 degrees same as 0 degrees
      then hTemp := 0.0
    else hTemp := H;

    hTemp := hTemp / 60; // h is now IN [0,6)
    i := TRUNC(hTemp); // largest integer <= h
    f := hTemp - i; // fractional part of h

    p := V * (1.0 - S);
    q := V * (1.0 - (S * f));
    t := V * (1.0 - (S * (1.0 - f)));

    case i of
      0: begin R := V; G := t; B := p end;
      1: begin R := q; G := V; B := p end;
      2: begin R := p; G := V; B := t end;
      3: begin R := p; G := q; B := V end;
      4: begin R := t; G := p; B := V end;
      5: begin R := V; G := p; B := q end
    end
  end
end {HSVtoRGB};


  ///////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////
 // Floating point fractions, 0..1, replaced with integer values, 0..255.
  // Use integer conversion ONLY for one-way, or a single final conversions.
  // Use floating-point for converting reversibly (see HSVtoRGB above).
  //
  //  H = 0 to 360 (corresponding to 0..360 degrees around hexcone)
  //      0 (undefined) for S = 0
  //  S = 0 (shade of gray) to 255 (pure color)
  //  V = 0 (black) to 255 (white)

function HSVtoRGBTriple(const H, S, V: INTEGER): TRGBTriple;
const
  divisor: INTEGER = 255 * 60;
var
  f: INTEGER;
  hTemp: INTEGER;
  p, q, t: INTEGER;
  VS: INTEGER;
begin
  if S = 0
    then
    RESULT := RGBtoRGBTriple(V, V, V) // achromatic:  shades of gray
  else begin // chromatic color
    if H = 360
      then hTemp := 0
    else hTemp := H;

    f := hTemp mod 60; // f is IN [0, 59]
    hTemp := hTemp div 60; // h is now IN [0,6)

    VS := V * S;
    p := V - VS div 255; // p = v * (1 - s)
    q := V - (VS * f) div divisor; // q = v * (1 - s*f)
    t := V - (VS * (60 - f)) div divisor; // t = v * (1 - s * (1 - f))

    case hTemp of
      0: RESULT := RGBtoRGBTriple(V, t, p);
      1: RESULT := RGBtoRGBTriple(q, V, p);
      2: RESULT := RGBtoRGBTriple(p, V, t);
      3: RESULT := RGBtoRGBTriple(p, q, V);
      4: RESULT := RGBtoRGBTriple(t, p, V);
      5: RESULT := RGBtoRGBTriple(V, p, q);
    else RESULT := RGBtoRGBTriple(0, 0, 0) // should never happen;
                                              // avoid compiler warning
    end
  end
end {HSVtoRGBTriple};


   // RGB, each 0 to 255, to HSV.
  //   H = 0 to 360 (corresponding to 0..360 degrees around hexcone)
  //   S = 0 (shade of gray) to 255 (pure color)
  //   V = 0 (black) to 255 {white)

  // Based on C Code in "Computer Graphics -- Principles and Practice,"
  // Foley et al, 1996, p. 592.
  // Floating point fractions, 0..1, replaced with
  // integer values, 0..255.
                            {r, g and b IN [0..255]}

procedure RGBTripleToHSV(const RGBTriple: TRGBTriple;
  var H, S, V: INTEGER);
var {h IN 0..359; s,v IN 0..255}
  Delta: INTEGER;
  Min: INTEGER;
begin
  with RGBTriple do
  begin
    Min := MinIntValue([rgbtRed, rgbtGreen, rgbtBlue]);
    V := MaxIntValue([rgbtRed, rgbtGreen, rgbtBlue])
  end;
  Delta := V - Min;
    // Calculate saturation:  saturation is 0 if r, g and b are all 0
  if V = 0
    then S := 0
  else S := MulDiv(Delta, 255, V);

  if S = 0
    then H := 0
    // Achromatic:  When s = 0, h is undefined but assigned the value 0
  else begin // Chromatic

    with RGBTriple do
    begin
      if rgbtRed = V
        then // degrees -- between yellow and magenta
        H := MulDiv(rgbtGreen - rgbtBlue, 60, Delta)
      else
        if rgbtGreen = V
          then // between cyan and yellow
          H := 120 + MulDiv(rgbtBlue - rgbtRed, 60, Delta)
        else
          if rgbtBlue = V
            then // between magenta and cyan
            H := 240 + MulDiv(rgbtRed - rgbtGreen, 60, Delta);
    end;

    if H < 0
      then H := H + 360;

  end
end {RGBTripleToHSV};



  ///////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////
(******************************************************)
(******************************************************)




(******************************************************)
(******************************************************)

procedure Do_PixelSizer(Pixels: Integer);
var
  F1, F2: file;
  BlueColor: Byte;
  IPixel,
{  LineCount,Temp,} LineSize, OutLineSize, I, IV: Integer;
  InFileName, OutFileName: string;
begin
  DisProcessForm.RadarGauge.Progress := 1;
  DisProcessForm.IM_Hints.Caption := 'Processing pixel Band';
  LineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  hBlueBitmap := GlobalAlloc(GHND, LineSize); {Line snatcher}
  BlueBitmap := GlobalLock(hBlueBitmap);
  case Pixels of
    0: begin {2x2=1 Decrease Pixels}
        OutLineSize := ((RightColumn - LeftColumn) + 1) div 2;
{LineCount:=(((BottomRow-TopRow)+1) div 2);}
      end;
    1: begin {3x3=1 Decrease Pixels}
        OutLineSize := ((RightColumn - LeftColumn) + 1) div 3;
{LineCount:=(((BottomRow-TopRow)+1) div 3);}
      end;
    2: begin {1=2x2 Increase Pixels}
        OutLineSize := ((RightColumn - LeftColumn) + 1) * 2;
{LineCount:=(((BottomRow-TopRow)+1) * 2);}
      end;
  else begin {1=3x3 Increase Pixels}
      OutLineSize := ((RightColumn - LeftColumn) + 1) * 3;
{LineCount:=(((BottomRow-TopRow)+1) *3);}
    end;
  end; {Case}
  hRedBitmap := GlobalAlloc(GHND, OutLineSize); {New file}
  RedBitmap := GlobalLock(hRedBitmap);

  InFileName := ImagePath + (DisProcessForm.BCBandFileEdit.Text);
  AssignFile(F1, InFileName);
  Reset(F1, LineSize);
  OutFileName := ImagePath + (ChangeFileExt(DisProcessForm.BCNewFileEdit.Text,
    '.pps'));
  AssignFile(F2, OutFileName);
  Rewrite(F2, 1);

  for IV := TopRow to BottomRow - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div BottomRow);
    Application.ProcessMessages;
    BlockRead(F1, BlueBitmap^, 1);
    IPixel := 0;
    for I := LeftColumn to RightColumn - 1 do
    begin
      lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
      BlueColor := lpPixelB^;
      case Pixels of
        0: begin {2x2=1 Decrease Pixels}
            if ((I mod 2) = 0) then
            begin
              lpPixelR := @PHugeByteArray(RedBitmap)^[IPixel];
              lpPixelR^ := BlueColor;
              inc(IPixel);
            end;
          end;
        1: begin {3x3=1 Decrease Pixels}
            if ((I mod 3) = 0) then
            begin
              lpPixelR := @PHugeByteArray(RedBitmap)^[IPixel];
              lpPixelR^ := BlueColor;
              inc(IPixel);
            end;
          end;
        2: begin {1=2x2 Increase Pixels}
            lpPixelR := @PHugeByteArray(RedBitmap)^[IPixel];
            lpPixelR^ := BlueColor;
            inc(IPixel);
            lpPixelR := @PHugeByteArray(RedBitmap)^[IPixel];
            lpPixelR^ := BlueColor;
            inc(IPixel);
          end;
      else begin {1=3x3 Increase Pixels}
          lpPixelR := @PHugeByteArray(RedBitmap)^[IPixel];
          lpPixelR^ := BlueColor;
          inc(IPixel);
          lpPixelR := @PHugeByteArray(RedBitmap)^[IPixel];
          lpPixelR^ := BlueColor;
          inc(IPixel);
          lpPixelR := @PHugeByteArray(RedBitmap)^[IPixel];
          lpPixelR^ := BlueColor;
          inc(IPixel);
        end;
      end; {Case}
    end;
    case Pixels of
      0: begin {2x2=1 Decrease Pixels}
          if ((IV mod 2) = 0) then
            BlockWrite(F2, RedBitmap^, OutLineSize);
        end;
      1: begin {3x3=1 Decrease Pixels}
          if ((IV mod 3) = 0) then
            BlockWrite(F2, RedBitmap^, OutLineSize);
        end;
      2: begin {1=2x2 Increase Pixels}
          BlockWrite(F2, RedBitmap^, OutLineSize);
          BlockWrite(F2, RedBitmap^, OutLineSize);
        end;
    else begin {1=3x3 Increase Pixels}
        BlockWrite(F2, RedBitmap^, OutLineSize);
        BlockWrite(F2, RedBitmap^, OutLineSize);
        BlockWrite(F2, RedBitmap^, OutLineSize);
      end;
    end; {Case}
  end;
  CloseFile(F2);
  CloseFile(F1);
  DisProcessForm.RadarGauge.Progress := 0;
  GlobalUnlock(hRedBitmap);
  GlobalFree(hRedBitmap);
  GlobalUnlock(hBlueBitmap);
  GlobalFree(hBlueBitmap);
end;

(******************************************************)

procedure Do_QuadDivide2V; {1=2 Height changes}
var
  InF1, OutF1, OutF2: file;
  BlueColor: Byte;
  QHeight1, QHeight2, QWide, {QHeight,}
    InLineSize, {OutLineSize1,OutLineSize2,} I, IV {,IiV}: Integer;
  InFileName, OutFileName1, OutFileName2: string;
begin
  DisProcessForm.RadarGauge.Progress := 1;
  DisProcessForm.IM_Hints.Caption := 'Processing Band 1';
{QHeight:=((BottomRow-TopRow) +1);}
  QHeight1 := (((BottomRow - TopRow) + 1) div 2);
  QHeight2 := ((((BottomRow - TopRow) + 1) div 2)
    + (((BottomRow - TopRow) + 1) mod 2));
  QWide := ((RightColumn - LeftColumn) + 1);

  InLineSize := (sizeof(byte) * QWide);
  hBlueBitmap := GlobalAlloc(GHND, InLineSize); {Line snatcher}
  BlueBitmap := GlobalLock(hBlueBitmap);
  hGreenBitmap := GlobalAlloc(GHND, InLineSize); {New file 1}
  GreenBitmap := GlobalLock(hGreenBitmap);
  hRedBitmap := GlobalAlloc(GHND, InLineSize); {New file 2}
  RedBitmap := GlobalLock(hRedBitmap);
  InFileName := BandFile1;
  AssignFile(InF1, InFileName);
  Reset(InF1, InLineSize);
  GRIPFileName := ExtractFileName(BandFile1);
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);


  for IV := TopRow to QHeight1 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight1);
    Application.ProcessMessages;
    BlockRead(InF1, BlueBitmap^, 1);
    for I := LeftColumn to RightColumn - 1 do
    begin
      lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
      BlueColor := lpPixelB^;
      lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
      lpPixelG^ := BlueColor;
    end;
    BlockWrite(OutF1, GreenBitmap^, QWide);
  end;
  for IV := QHeight1 to QHeight2 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight1);
    Application.ProcessMessages;
    BlockRead(InF1, BlueBitmap^, 1);
    for I := LeftColumn to RightColumn - 1 do
    begin
      lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
      BlueColor := lpPixelB^;
      lpPixelR := @PHugeByteArray(RedBitmap)^[I];
      lpPixelR^ := BlueColor;
    end;
    BlockWrite(OutF2, RedBitmap^, QWide);
  end;

  CloseFile(OutF2);
  CloseFile(OutF1);
  CloseFile(InF1);
  DisProcessForm.RadarGauge.Progress := 0;
  GlobalUnlock(hRedBitmap);
  GlobalFree(hRedBitmap);
  GlobalUnlock(hGreenBitmap);
  GlobalFree(hGreenBitmap);
  GlobalUnlock(hBlueBitmap);
  GlobalFree(hBlueBitmap);
end;


procedure Do_QuadDivide2H; {1=2 width changes}
var
  InF1, OutF1, OutF2: file;
  BlueColor: Byte;
  QWide1, QWide2, QWide, QHeight,
    InLineSize, OutLineSize1, OutLineSize2, I, IV, IiV: Integer;
  InFileName, OutFileName1, OutFileName2: string;
begin
  DisProcessForm.RadarGauge.Progress := 1;
  DisProcessForm.IM_Hints.Caption := 'Processing Band 1';
  QHeight := ((BottomRow - TopRow) + 1);
  QWide := ((RightColumn - LeftColumn) + 1);
  QWide1 := (((RightColumn - LeftColumn) + 1) div 2);
  QWide2 := ((((RightColumn - LeftColumn) + 1) div 2)
    + (((RightColumn - LeftColumn) + 1) mod 2));
  InLineSize := (sizeof(byte) * QWide);
  OutLineSize1 := (sizeof(byte) * QWide1);
  OutLineSize2 := (sizeof(byte) * QWide2);
  hBlueBitmap := GlobalAlloc(GHND, InLineSize); {Line snatcher}
  BlueBitmap := GlobalLock(hBlueBitmap);
  hGreenBitmap := GlobalAlloc(GHND, OutLineSize1); {New file 1}
  GreenBitmap := GlobalLock(hGreenBitmap);
  hRedBitmap := GlobalAlloc(GHND, OutLineSize2); {New file 2}
  RedBitmap := GlobalLock(hRedBitmap);
  InFileName := BandFile1;
  AssignFile(InF1, InFileName);
  Reset(InF1, InLineSize);
  GRIPFileName := ExtractFileName(BandFile1);
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);


  for IV := TopRow to BottomRow - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div BottomRow);
    Application.ProcessMessages;
    BlockRead(InF1, BlueBitmap^, 1);
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
      BlueColor := lpPixelB^;
      lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
      lpPixelG^ := BlueColor;
    end;
    IiV := 0;
    for I := QWide1 to RightColumn - 1 do
    begin
      lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
      BlueColor := lpPixelB^;
      lpPixelR := @PHugeByteArray(RedBitmap)^[IiV];
      lpPixelR^ := BlueColor;
      inc(IiV);
    end;
    BlockWrite(OutF1, GreenBitmap^, QWide1);
    BlockWrite(OutF2, RedBitmap^, QWide2);
  end;
  CloseFile(OutF2);
  CloseFile(OutF1);
  CloseFile(InF1);
  DisProcessForm.RadarGauge.Progress := 0;
  GlobalUnlock(hRedBitmap);
  GlobalFree(hRedBitmap);
  GlobalUnlock(hGreenBitmap);
  GlobalFree(hGreenBitmap);
  GlobalUnlock(hBlueBitmap);
  GlobalFree(hBlueBitmap);
end;
(******************************************************)



(******************************************************)

procedure Do_QuadDivide4(WideMany, HeightMany: Integer);
var {@x2}
  BlueColor: Byte;
  InF1, OutF1, OutF2: file;
  QHeight1, QHeight2,
    QWide1, QWide2,
    InLineSize,
    OutLineSize1, OutLineSize2,
    I, IV, QWideV: Integer;
  InFileName,
    OutFileName1, OutFileName2: string;
  hBitmap1, hBitmap2,
    hBitmapIn: DWord;
  Bitmap1, Bitmap2,
    InBitmap: Pointer;
  lpPixel1, lpPixel2,
    lpPixelIn: ^Byte;
begin
  DisProcessForm.RadarGauge.Progress := 1;
  DisProcessForm.IM_Hints.Caption := 'Processing Band';
{QHeight:=((BottomRow-TopRow) +1);}
  QHeight1 := (((BottomRow - TopRow) + 1) div 8);
  QHeight2 := ((((BottomRow - TopRow) + 1) div 8)
    + (((BottomRow - TopRow) + 1) mod 8));
  QWide1 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide2 := ((((RightColumn - LeftColumn) + 1) div 8)
    + (((RightColumn - LeftColumn) + 1) mod 8));
  InLineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  OutLineSize1 := (sizeof(byte) * QWide1);
  OutLineSize2 := (sizeof(byte) * QWide2);
  hBitmapIn := GlobalAlloc(GHND, InLineSize); {Line snatcher}
  InBitmap := GlobalLock(hBitmapIn);
  hBitmap1 := GlobalAlloc(GHND, OutLineSize1); {New file 1}
  Bitmap1 := GlobalLock(hBitmap1);
  hBitmap2 := GlobalAlloc(GHND, OutLineSize2);
  Bitmap2 := GlobalLock(hBitmap2);

  InFileName := BandFile1;
  AssignFile(InF1, InFileName);
  Reset(InF1, InLineSize);

  GRIPFileName := ExtractFileName(BandFile1);

{Group 1 of 2}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);

  for IV := TopRow to QHeight1 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight1);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  {RENAME and EVERYTHING}


{Group 2 of 2}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);

  for IV := QHeight1 to QHeight2 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight2);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  {RENAME and EVERYTHING}
  DisProcessForm.RadarGauge.Progress := 0;
  CloseFile(InF1);
  GlobalUnlock(hBitmapIn);
  GlobalFree(hBitmapIn);
  GlobalUnlock(hBitmap1);
  GlobalFree(hBitmap1);
  GlobalUnlock(hBitmap2);
  GlobalFree(hBitmap2);
end;
(******************************************************)


(******************************************************)

procedure Do_QuadDivide8(WideMany, HeightMany: Integer);
var {4x2}
  BlueColor: Byte;
  InF1, OutF1, OutF2, OutF3, OutF4: file;
  QHeight1, QHeight2,
    QWide1, QWide2, QWide3, QWide4,
    InLineSize,
    OutLineSize1, OutLineSize2, OutLineSize3, OutLineSize4,
    I, IV, QWideV: Integer;
  InFileName,
    OutFileName1, OutFileName2, OutFileName3, OutFileName4: string;
  hBitmap1, hBitmap2, hBitmap3, hBitmap4,
    hBitmapIn: DWord;
  Bitmap1, Bitmap2, Bitmap3, Bitmap4,
    InBitmap: Pointer;
  lpPixel1, lpPixel2, lpPixel3, lpPixel4,
    lpPixelIn: ^Byte;
begin
  DisProcessForm.RadarGauge.Progress := 1;
  DisProcessForm.IM_Hints.Caption := 'Processing Band';
{QHeight:=((BottomRow-TopRow) +1);}
  QHeight1 := (((BottomRow - TopRow) + 1) div 8);
  QHeight2 := ((((BottomRow - TopRow) + 1) div 8)
    + (((BottomRow - TopRow) + 1) mod 8));
  QWide1 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide2 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide3 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide4 := ((((RightColumn - LeftColumn) + 1) div 8)
    + (((RightColumn - LeftColumn) + 1) mod 8));
  InLineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  OutLineSize1 := (sizeof(byte) * QWide1);
  OutLineSize2 := (sizeof(byte) * QWide2);
  OutLineSize3 := (sizeof(byte) * QWide3);
  OutLineSize4 := (sizeof(byte) * QWide4);
  hBitmapIn := GlobalAlloc(GHND, InLineSize); {Line snatcher}
  InBitmap := GlobalLock(hBitmapIn);
  hBitmap1 := GlobalAlloc(GHND, OutLineSize1); {New file 1}
  Bitmap1 := GlobalLock(hBitmap1);
  hBitmap2 := GlobalAlloc(GHND, OutLineSize2);
  Bitmap2 := GlobalLock(hBitmap2);
  hBitmap3 := GlobalAlloc(GHND, OutLineSize3);
  Bitmap3 := GlobalLock(hBitmap3);
  hBitmap4 := GlobalAlloc(GHND, OutLineSize4);
  Bitmap4 := GlobalLock(hBitmap4);

  InFileName := BandFile1;
  AssignFile(InF1, InFileName);
  Reset(InF1, InLineSize);
  GRIPFileName := ExtractFileName(BandFile1);

{Group 1 of 2}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);

  for IV := TopRow to QHeight1 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight1);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  {RENAME and EVERYTHING}


{Group 2 of 2}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);

  for IV := QHeight1 to QHeight2 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight2);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  {RENAME and EVERYTHING}

  DisProcessForm.RadarGauge.Progress := 0;
  CloseFile(InF1);
  GlobalUnlock(hBitmapIn);
  GlobalFree(hBitmapIn);
  GlobalUnlock(hBitmap1);
  GlobalFree(hBitmap1);
  GlobalUnlock(hBitmap2);
  GlobalFree(hBitmap2);
  GlobalUnlock(hBitmap3);
  GlobalFree(hBitmap3);
  GlobalUnlock(hBitmap4);
  GlobalFree(hBitmap4);
end;
(******************************************************)


(******************************************************)

procedure Do_QuadDivide16(WideMany, HeightMany: Integer);
var {4x4}
  BlueColor: Byte;
  InF1, OutF1, OutF2, OutF3, OutF4: file;
  QHeight1, QHeight2, QHeight3, QHeight4,
    QWide1, QWide2, QWide3, QWide4,
    InLineSize,
    OutLineSize1, OutLineSize2, OutLineSize3, OutLineSize4,
    I, IV, QWideV: Integer;
  InFileName,
    OutFileName1, OutFileName2, OutFileName3, OutFileName4: string;
  hBitmap1, hBitmap2, hBitmap3, hBitmap4,
    hBitmapIn: DWord;
  Bitmap1, Bitmap2, Bitmap3, Bitmap4,
    InBitmap: Pointer;
  lpPixel1, lpPixel2, lpPixel3, lpPixel4,
    lpPixelIn: ^Byte;
begin
  DisProcessForm.RadarGauge.Progress := 1;
  DisProcessForm.IM_Hints.Caption := 'Processing Band';
{QHeight:=((BottomRow-TopRow) +1);}
  QHeight1 := (((BottomRow - TopRow) + 1) div 8);
  QHeight2 := (((BottomRow - TopRow) + 1) div 8);
  QHeight3 := (((BottomRow - TopRow) + 1) div 8);
  QHeight4 := ((((BottomRow - TopRow) + 1) div 8)
    + (((BottomRow - TopRow) + 1) mod 8));
  QWide1 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide2 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide3 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide4 := ((((RightColumn - LeftColumn) + 1) div 8)
    + (((RightColumn - LeftColumn) + 1) mod 8));
  InLineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  OutLineSize1 := (sizeof(byte) * QWide1);
  OutLineSize2 := (sizeof(byte) * QWide2);
  OutLineSize3 := (sizeof(byte) * QWide3);
  OutLineSize4 := (sizeof(byte) * QWide4);
  hBitmapIn := GlobalAlloc(GHND, InLineSize); {Line snatcher}
  InBitmap := GlobalLock(hBitmapIn);
  hBitmap1 := GlobalAlloc(GHND, OutLineSize1); {New file 1}
  Bitmap1 := GlobalLock(hBitmap1);
  hBitmap2 := GlobalAlloc(GHND, OutLineSize2);
  Bitmap2 := GlobalLock(hBitmap2);
  hBitmap3 := GlobalAlloc(GHND, OutLineSize3);
  Bitmap3 := GlobalLock(hBitmap3);
  hBitmap4 := GlobalAlloc(GHND, OutLineSize4);
  Bitmap4 := GlobalLock(hBitmap4);
  InFileName := BandFile1;
  AssignFile(InF1, InFileName);
  Reset(InF1, InLineSize);

  GRIPFileName := ExtractFileName(BandFile1);

{Group 1 of 4}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);

  for IV := TopRow to QHeight1 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight1);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  {RENAME and EVERYTHING}


{Group 2 of 4}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);

  for IV := QHeight1 to QHeight2 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight2);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  {RENAME and EVERYTHING}


{Group 3 of 4}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);

  for IV := QHeight2 to QHeight3 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight3);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  {RENAME and EVERYTHING}


{Group 4 of 4}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);

  for IV := QHeight3 to QHeight4 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight4);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  {RENAME and EVERYTHING 4of4}

  DisProcessForm.RadarGauge.Progress := 0;
  CloseFile(InF1);
  GlobalUnlock(hBitmapIn);
  GlobalFree(hBitmapIn);
  GlobalUnlock(hBitmap1);
  GlobalFree(hBitmap1);
  GlobalUnlock(hBitmap2);
  GlobalFree(hBitmap2);
  GlobalUnlock(hBitmap3);
  GlobalFree(hBitmap3);
  GlobalUnlock(hBitmap4);
  GlobalFree(hBitmap4);
end;
(******************************************************)


(******************************************************)

procedure Do_QuadDivide32(WideMany, HeightMany: Integer);
var {8x4}
  BlueColor: Byte;
  InF1, OutF1, OutF2, OutF3, OutF4, OutF5, OutF6, OutF7, OutF8: file;
  QHeight1, QHeight2, QHeight3, QHeight4,
    QWide1, QWide2, QWide3, QWide4, QWide5, QWide6, QWide7, QWide8,
    InLineSize,
    OutLineSize1, OutLineSize2, OutLineSize3, OutLineSize4,
    OutLineSize5, OutLineSize6, OutLineSize7, OutLineSize8,
    I, IV, QWideV: Integer;
  InFileName,
    OutFileName1, OutFileName2, OutFileName3, OutFileName4,
    OutFileName5, OutFileName6, OutFileName7, OutFileName8: string;
  hBitmap1, hBitmap2, hBitmap3, hBitmap4,
    hBitmap5, hBitmap6, hBitmap7, hBitmap8,
    hBitmapIn: DWord;
  Bitmap1, Bitmap2, Bitmap3, Bitmap4,
    Bitmap5, Bitmap6, Bitmap7, Bitmap8,
    InBitmap: Pointer;
  lpPixel1, lpPixel2, lpPixel3, lpPixel4,
    lpPixel5, lpPixel6, lpPixel7, lpPixel8,
    lpPixelIn: ^Byte;
begin
  DisProcessForm.RadarGauge.Progress := 1;
  DisProcessForm.IM_Hints.Caption := 'Processing Band';
{QHeight:=((BottomRow-TopRow) +1);}
  QHeight1 := (((BottomRow - TopRow) + 1) div 8);
  QHeight2 := (((BottomRow - TopRow) + 1) div 8);
  QHeight3 := (((BottomRow - TopRow) + 1) div 8);
  QHeight4 := ((((BottomRow - TopRow) + 1) div 8)
    + (((BottomRow - TopRow) + 1) mod 8));
  QWide1 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide2 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide3 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide4 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide5 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide6 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide7 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide8 := ((((RightColumn - LeftColumn) + 1) div 8)
    + (((RightColumn - LeftColumn) + 1) mod 8));
  InLineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  OutLineSize1 := (sizeof(byte) * QWide1);
  OutLineSize2 := (sizeof(byte) * QWide2);
  OutLineSize3 := (sizeof(byte) * QWide3);
  OutLineSize4 := (sizeof(byte) * QWide4);
  OutLineSize5 := (sizeof(byte) * QWide5);
  OutLineSize6 := (sizeof(byte) * QWide6);
  OutLineSize7 := (sizeof(byte) * QWide7);
  OutLineSize8 := (sizeof(byte) * QWide8);
  hBitmapIn := GlobalAlloc(GHND, InLineSize); {Line snatcher}
  InBitmap := GlobalLock(hBitmapIn);
  hBitmap1 := GlobalAlloc(GHND, OutLineSize1); {New file 1}
  Bitmap1 := GlobalLock(hBitmap1);
  hBitmap2 := GlobalAlloc(GHND, OutLineSize2);
  Bitmap2 := GlobalLock(hBitmap2);
  hBitmap3 := GlobalAlloc(GHND, OutLineSize3);
  Bitmap3 := GlobalLock(hBitmap3);
  hBitmap4 := GlobalAlloc(GHND, OutLineSize4);
  Bitmap4 := GlobalLock(hBitmap4);
  hBitmap5 := GlobalAlloc(GHND, OutLineSize5);
  Bitmap5 := GlobalLock(hBitmap5);
  hBitmap6 := GlobalAlloc(GHND, OutLineSize6);
  Bitmap6 := GlobalLock(hBitmap6);
  hBitmap7 := GlobalAlloc(GHND, OutLineSize7);
  Bitmap7 := GlobalLock(hBitmap7);
  hBitmap8 := GlobalAlloc(GHND, OutLineSize8);
  Bitmap8 := GlobalLock(hBitmap8);
  InFileName := BandFile1;
  AssignFile(InF1, InFileName);
  Reset(InF1, InLineSize);

  GRIPFileName := ExtractFileName(BandFile1);

{Group 1 of 4}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);
  NumberName;
  OutFileName5 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide5));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF5, OutFileName5);
  Rewrite(OutF5, 1);
  NumberName;
  OutFileName6 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide6));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF6, OutFileName6);
  Rewrite(OutF6, 1);
  NumberName;
  OutFileName7 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide7));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF7, OutFileName7);
  Rewrite(OutF7, 1);
  NumberName;
  OutFileName8 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide8));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF8, OutFileName8);
  Rewrite(OutF8, 1);

  for IV := TopRow to QHeight1 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight1);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide4 to QWide5 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel5 := @PHugeByteArray(Bitmap5)^[QWideV];
      lpPixel5^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide5 to QWide6 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel6 := @PHugeByteArray(Bitmap6)^[QWideV];
      lpPixel6^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide6 to QWide7 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel7 := @PHugeByteArray(Bitmap7)^[QWideV];
      lpPixel7^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide7 to QWide8 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel8 := @PHugeByteArray(Bitmap8)^[QWideV];
      lpPixel8^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
    BlockWrite(OutF1, Bitmap5^, QWide5);
    BlockWrite(OutF2, Bitmap6^, QWide6);
    BlockWrite(OutF1, Bitmap7^, QWide7);
    BlockWrite(OutF2, Bitmap8^, QWide8);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  CloseFile(OutF5);
  CloseFile(OutF6);
  CloseFile(OutF7);
  CloseFile(OutF8);
  {RENAME and EVERYTHING}


{Group 2 of 4}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);
  NumberName;
  OutFileName5 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide5));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF5, OutFileName5);
  Rewrite(OutF5, 1);
  NumberName;
  OutFileName6 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide6));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF6, OutFileName6);
  Rewrite(OutF6, 1);
  NumberName;
  OutFileName7 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide7));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF7, OutFileName7);
  Rewrite(OutF7, 1);
  NumberName;
  OutFileName8 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide8));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF8, OutFileName8);
  Rewrite(OutF8, 1);

  for IV := QHeight1 to QHeight2 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight2);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide4 to QWide5 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel5 := @PHugeByteArray(Bitmap5)^[QWideV];
      lpPixel5^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide5 to QWide6 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel6 := @PHugeByteArray(Bitmap6)^[QWideV];
      lpPixel6^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide6 to QWide7 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel7 := @PHugeByteArray(Bitmap7)^[QWideV];
      lpPixel7^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide7 to QWide8 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel8 := @PHugeByteArray(Bitmap8)^[QWideV];
      lpPixel8^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
    BlockWrite(OutF1, Bitmap5^, QWide5);
    BlockWrite(OutF2, Bitmap6^, QWide6);
    BlockWrite(OutF1, Bitmap7^, QWide7);
    BlockWrite(OutF2, Bitmap8^, QWide8);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  CloseFile(OutF5);
  CloseFile(OutF6);
  CloseFile(OutF7);
  CloseFile(OutF8);
  {RENAME and EVERYTHING}


{Group 3 of 4}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);
  NumberName;
  OutFileName5 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide5));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF5, OutFileName5);
  Rewrite(OutF5, 1);
  NumberName;
  OutFileName6 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide6));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF6, OutFileName6);
  Rewrite(OutF6, 1);
  NumberName;
  OutFileName7 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide7));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF7, OutFileName7);
  Rewrite(OutF7, 1);
  NumberName;
  OutFileName8 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide8));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF8, OutFileName8);
  Rewrite(OutF8, 1);

  for IV := QHeight2 to QHeight3 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight3);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide4 to QWide5 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel5 := @PHugeByteArray(Bitmap5)^[QWideV];
      lpPixel5^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide5 to QWide6 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel6 := @PHugeByteArray(Bitmap6)^[QWideV];
      lpPixel6^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide6 to QWide7 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel7 := @PHugeByteArray(Bitmap7)^[QWideV];
      lpPixel7^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide7 to QWide8 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel8 := @PHugeByteArray(Bitmap8)^[QWideV];
      lpPixel8^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
    BlockWrite(OutF1, Bitmap5^, QWide5);
    BlockWrite(OutF2, Bitmap6^, QWide6);
    BlockWrite(OutF1, Bitmap7^, QWide7);
    BlockWrite(OutF2, Bitmap8^, QWide8);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  CloseFile(OutF5);
  CloseFile(OutF6);
  CloseFile(OutF7);
  CloseFile(OutF8);
  {RENAME and EVERYTHING}


{Group 4 of 4}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);
  NumberName;
  OutFileName5 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide5));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF5, OutFileName5);
  Rewrite(OutF5, 1);
  NumberName;
  OutFileName6 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide6));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF6, OutFileName6);
  Rewrite(OutF6, 1);
  NumberName;
  OutFileName7 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide7));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF7, OutFileName7);
  Rewrite(OutF7, 1);
  NumberName;
  OutFileName8 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide8));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF8, OutFileName8);
  Rewrite(OutF8, 1);

  for IV := QHeight3 to QHeight4 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight4);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide4 to QWide5 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel5 := @PHugeByteArray(Bitmap5)^[QWideV];
      lpPixel5^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide5 to QWide6 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel6 := @PHugeByteArray(Bitmap6)^[QWideV];
      lpPixel6^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide6 to QWide7 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel7 := @PHugeByteArray(Bitmap7)^[QWideV];
      lpPixel7^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide7 to QWide8 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel8 := @PHugeByteArray(Bitmap8)^[QWideV];
      lpPixel8^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
    BlockWrite(OutF1, Bitmap5^, QWide5);
    BlockWrite(OutF2, Bitmap6^, QWide6);
    BlockWrite(OutF1, Bitmap7^, QWide7);
    BlockWrite(OutF2, Bitmap8^, QWide8);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  CloseFile(OutF5);
  CloseFile(OutF6);
  CloseFile(OutF7);
  CloseFile(OutF8);
  {RENAME and EVERYTHING 4of4}

  DisProcessForm.RadarGauge.Progress := 0;
  CloseFile(InF1);
  GlobalUnlock(hBitmapIn);
  GlobalFree(hBitmapIn);
  GlobalUnlock(hBitmap1);
  GlobalFree(hBitmap1);
  GlobalUnlock(hBitmap2);
  GlobalFree(hBitmap2);
  GlobalUnlock(hBitmap3);
  GlobalFree(hBitmap3);
  GlobalUnlock(hBitmap4);
  GlobalFree(hBitmap4);
  GlobalUnlock(hBitmap5);
  GlobalFree(hBitmap5);
  GlobalUnlock(hBitmap6);
  GlobalFree(hBitmap6);
  GlobalUnlock(hBitmap7);
  GlobalFree(hBitmap7);
  GlobalUnlock(hBitmap8);
  GlobalFree(hBitmap8);
end;
(******************************************************)


(******************************************************)

procedure Do_QuadDivide64(WideMany, HeightMany: Integer);
var {8x8}
  BlueColor: Byte;
  InF1, OutF1, OutF2, OutF3, OutF4, OutF5, OutF6, OutF7, OutF8: file;
  QHeight1, QHeight2, QHeight3, QHeight4,
    QHeight5, QHeight6, QHeight7, QHeight8,
    QWide1, QWide2, QWide3, QWide4, QWide5, QWide6, QWide7, QWide8,
    InLineSize,
    OutLineSize1, OutLineSize2, OutLineSize3, OutLineSize4,
    OutLineSize5, OutLineSize6, OutLineSize7, OutLineSize8,
    I, IV, QWideV: Integer;
  InFileName,
    OutFileName1, OutFileName2, OutFileName3, OutFileName4,
    OutFileName5, OutFileName6, OutFileName7, OutFileName8: string;
  hBitmap1, hBitmap2, hBitmap3, hBitmap4,
    hBitmap5, hBitmap6, hBitmap7, hBitmap8,
    hBitmapIn: DWord;
  Bitmap1, Bitmap2, Bitmap3, Bitmap4,
    Bitmap5, Bitmap6, Bitmap7, Bitmap8,
    InBitmap: Pointer;
  lpPixel1, lpPixel2, lpPixel3, lpPixel4,
    lpPixel5, lpPixel6, lpPixel7, lpPixel8,
    lpPixelIn: ^Byte;
begin
  DisProcessForm.RadarGauge.Progress := 1;
  DisProcessForm.IM_Hints.Caption := 'Processing Band';
{QHeight:=((BottomRow-TopRow) +1);}
  QHeight1 := (((BottomRow - TopRow) + 1) div 8);
  QHeight2 := (((BottomRow - TopRow) + 1) div 8);
  QHeight3 := (((BottomRow - TopRow) + 1) div 8);
  QHeight4 := (((BottomRow - TopRow) + 1) div 8);
  QHeight5 := (((BottomRow - TopRow) + 1) div 8);
  QHeight6 := (((BottomRow - TopRow) + 1) div 8);
  QHeight7 := (((BottomRow - TopRow) + 1) div 8);
  QHeight8 := ((((BottomRow - TopRow) + 1) div 8)
    + (((BottomRow - TopRow) + 1) mod 8));
  QWide1 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide2 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide3 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide4 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide5 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide6 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide7 := (((RightColumn - LeftColumn) + 1) div 8);
  QWide8 := ((((RightColumn - LeftColumn) + 1) div 8)
    + (((RightColumn - LeftColumn) + 1) mod 8));
  InLineSize := (sizeof(byte) * ((RightColumn - LeftColumn) + 1));
  OutLineSize1 := (sizeof(byte) * QWide1);
  OutLineSize2 := (sizeof(byte) * QWide2);
  OutLineSize3 := (sizeof(byte) * QWide3);
  OutLineSize4 := (sizeof(byte) * QWide4);
  OutLineSize5 := (sizeof(byte) * QWide5);
  OutLineSize6 := (sizeof(byte) * QWide6);
  OutLineSize7 := (sizeof(byte) * QWide7);
  OutLineSize8 := (sizeof(byte) * QWide8);
  hBitmapIn := GlobalAlloc(GHND, InLineSize); {Line snatcher}
  InBitmap := GlobalLock(hBitmapIn);
  hBitmap1 := GlobalAlloc(GHND, OutLineSize1); {New file 1}
  Bitmap1 := GlobalLock(hBitmap1);
  hBitmap2 := GlobalAlloc(GHND, OutLineSize2);
  Bitmap2 := GlobalLock(hBitmap2);
  hBitmap3 := GlobalAlloc(GHND, OutLineSize3);
  Bitmap3 := GlobalLock(hBitmap3);
  hBitmap4 := GlobalAlloc(GHND, OutLineSize4);
  Bitmap4 := GlobalLock(hBitmap4);
  hBitmap5 := GlobalAlloc(GHND, OutLineSize5);
  Bitmap5 := GlobalLock(hBitmap5);
  hBitmap6 := GlobalAlloc(GHND, OutLineSize6);
  Bitmap6 := GlobalLock(hBitmap6);
  hBitmap7 := GlobalAlloc(GHND, OutLineSize7);
  Bitmap7 := GlobalLock(hBitmap7);
  hBitmap8 := GlobalAlloc(GHND, OutLineSize8);
  Bitmap8 := GlobalLock(hBitmap8);
  InFileName := BandFile1;
  AssignFile(InF1, InFileName);
  Reset(InF1, InLineSize);

  GRIPFileName := ExtractFileName(BandFile1);

{Group 1 of 8}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);
  NumberName;
  OutFileName5 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide5));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF5, OutFileName5);
  Rewrite(OutF5, 1);
  NumberName;
  OutFileName6 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide6));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF6, OutFileName6);
  Rewrite(OutF6, 1);
  NumberName;
  OutFileName7 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide7));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF7, OutFileName7);
  Rewrite(OutF7, 1);
  NumberName;
  OutFileName8 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide8));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight1));
  AssignFile(OutF8, OutFileName8);
  Rewrite(OutF8, 1);

  for IV := TopRow to QHeight1 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight1);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide4 to QWide5 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel5 := @PHugeByteArray(Bitmap5)^[QWideV];
      lpPixel5^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide5 to QWide6 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel6 := @PHugeByteArray(Bitmap6)^[QWideV];
      lpPixel6^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide6 to QWide7 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel7 := @PHugeByteArray(Bitmap7)^[QWideV];
      lpPixel7^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide7 to QWide8 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel8 := @PHugeByteArray(Bitmap8)^[QWideV];
      lpPixel8^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
    BlockWrite(OutF1, Bitmap5^, QWide5);
    BlockWrite(OutF2, Bitmap6^, QWide6);
    BlockWrite(OutF1, Bitmap7^, QWide7);
    BlockWrite(OutF2, Bitmap8^, QWide8);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  CloseFile(OutF5);
  CloseFile(OutF6);
  CloseFile(OutF7);
  CloseFile(OutF8);
  {RENAME and EVERYTHING}


{Group 2 of 8}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);
  NumberName;
  OutFileName5 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide5));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF5, OutFileName5);
  Rewrite(OutF5, 1);
  NumberName;
  OutFileName6 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide6));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF6, OutFileName6);
  Rewrite(OutF6, 1);
  NumberName;
  OutFileName7 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide7));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF7, OutFileName7);
  Rewrite(OutF7, 1);
  NumberName;
  OutFileName8 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide8));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight2));
  AssignFile(OutF8, OutFileName8);
  Rewrite(OutF8, 1);

  for IV := QHeight1 to QHeight2 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight2);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide4 to QWide5 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel5 := @PHugeByteArray(Bitmap5)^[QWideV];
      lpPixel5^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide5 to QWide6 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel6 := @PHugeByteArray(Bitmap6)^[QWideV];
      lpPixel6^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide6 to QWide7 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel7 := @PHugeByteArray(Bitmap7)^[QWideV];
      lpPixel7^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide7 to QWide8 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel8 := @PHugeByteArray(Bitmap8)^[QWideV];
      lpPixel8^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
    BlockWrite(OutF1, Bitmap5^, QWide5);
    BlockWrite(OutF2, Bitmap6^, QWide6);
    BlockWrite(OutF1, Bitmap7^, QWide7);
    BlockWrite(OutF2, Bitmap8^, QWide8);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  CloseFile(OutF5);
  CloseFile(OutF6);
  CloseFile(OutF7);
  CloseFile(OutF8);
  {RENAME and EVERYTHING}


{Group 3 of 8}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);
  NumberName;
  OutFileName5 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide5));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF5, OutFileName5);
  Rewrite(OutF5, 1);
  NumberName;
  OutFileName6 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide6));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF6, OutFileName6);
  Rewrite(OutF6, 1);
  NumberName;
  OutFileName7 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide7));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF7, OutFileName7);
  Rewrite(OutF7, 1);
  NumberName;
  OutFileName8 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide8));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight3));
  AssignFile(OutF8, OutFileName8);
  Rewrite(OutF8, 1);

  for IV := QHeight2 to QHeight3 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight3);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide4 to QWide5 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel5 := @PHugeByteArray(Bitmap5)^[QWideV];
      lpPixel5^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide5 to QWide6 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel6 := @PHugeByteArray(Bitmap6)^[QWideV];
      lpPixel6^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide6 to QWide7 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel7 := @PHugeByteArray(Bitmap7)^[QWideV];
      lpPixel7^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide7 to QWide8 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel8 := @PHugeByteArray(Bitmap8)^[QWideV];
      lpPixel8^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
    BlockWrite(OutF1, Bitmap5^, QWide5);
    BlockWrite(OutF2, Bitmap6^, QWide6);
    BlockWrite(OutF1, Bitmap7^, QWide7);
    BlockWrite(OutF2, Bitmap8^, QWide8);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  CloseFile(OutF5);
  CloseFile(OutF6);
  CloseFile(OutF7);
  CloseFile(OutF8);
  {RENAME and EVERYTHING}


{Group 4 of 8}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);
  NumberName;
  OutFileName5 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide5));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF5, OutFileName5);
  Rewrite(OutF5, 1);
  NumberName;
  OutFileName6 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide6));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF6, OutFileName6);
  Rewrite(OutF6, 1);
  NumberName;
  OutFileName7 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide7));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF7, OutFileName7);
  Rewrite(OutF7, 1);
  NumberName;
  OutFileName8 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide8));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight4));
  AssignFile(OutF8, OutFileName8);
  Rewrite(OutF8, 1);

  for IV := QHeight3 to QHeight4 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight4);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide4 to QWide5 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel5 := @PHugeByteArray(Bitmap5)^[QWideV];
      lpPixel5^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide5 to QWide6 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel6 := @PHugeByteArray(Bitmap6)^[QWideV];
      lpPixel6^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide6 to QWide7 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel7 := @PHugeByteArray(Bitmap7)^[QWideV];
      lpPixel7^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide7 to QWide8 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel8 := @PHugeByteArray(Bitmap8)^[QWideV];
      lpPixel8^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
    BlockWrite(OutF1, Bitmap5^, QWide5);
    BlockWrite(OutF2, Bitmap6^, QWide6);
    BlockWrite(OutF1, Bitmap7^, QWide7);
    BlockWrite(OutF2, Bitmap8^, QWide8);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  CloseFile(OutF5);
  CloseFile(OutF6);
  CloseFile(OutF7);
  CloseFile(OutF8);
  {RENAME and EVERYTHING 4of8}

{Group 5 of 8}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight5));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight5));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight5));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight5));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);
  NumberName;
  OutFileName5 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide5));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight5));
  AssignFile(OutF5, OutFileName5);
  Rewrite(OutF5, 1);
  NumberName;
  OutFileName6 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide6));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight5));
  AssignFile(OutF6, OutFileName6);
  Rewrite(OutF6, 1);
  NumberName;
  OutFileName7 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide7));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight5));
  AssignFile(OutF7, OutFileName7);
  Rewrite(OutF7, 1);
  NumberName;
  OutFileName8 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide8));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight5));
  AssignFile(OutF8, OutFileName8);
  Rewrite(OutF8, 1);

  for IV := QHeight4 to QHeight5 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight5);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide4 to QWide5 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel5 := @PHugeByteArray(Bitmap5)^[QWideV];
      lpPixel5^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide5 to QWide6 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel6 := @PHugeByteArray(Bitmap6)^[QWideV];
      lpPixel6^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide6 to QWide7 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel7 := @PHugeByteArray(Bitmap7)^[QWideV];
      lpPixel7^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide7 to QWide8 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel8 := @PHugeByteArray(Bitmap8)^[QWideV];
      lpPixel8^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
    BlockWrite(OutF1, Bitmap5^, QWide5);
    BlockWrite(OutF2, Bitmap6^, QWide6);
    BlockWrite(OutF1, Bitmap7^, QWide7);
    BlockWrite(OutF2, Bitmap8^, QWide8);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  CloseFile(OutF5);
  CloseFile(OutF6);
  CloseFile(OutF7);
  CloseFile(OutF8);
  {RENAME and EVERYTHING 5of8}

{Group 6 of 8}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight6));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight6));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight6));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight6));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);
  NumberName;
  OutFileName5 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide5));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight6));
  AssignFile(OutF5, OutFileName5);
  Rewrite(OutF5, 1);
  NumberName;
  OutFileName6 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide6));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight6));
  AssignFile(OutF6, OutFileName6);
  Rewrite(OutF6, 1);
  NumberName;
  OutFileName7 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide7));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight6));
  AssignFile(OutF7, OutFileName7);
  Rewrite(OutF7, 1);
  NumberName;
  OutFileName8 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide8));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight6));
  AssignFile(OutF8, OutFileName8);
  Rewrite(OutF8, 1);

  for IV := QHeight5 to QHeight6 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight6);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide4 to QWide5 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel5 := @PHugeByteArray(Bitmap5)^[QWideV];
      lpPixel5^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide5 to QWide6 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel6 := @PHugeByteArray(Bitmap6)^[QWideV];
      lpPixel6^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide6 to QWide7 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel7 := @PHugeByteArray(Bitmap7)^[QWideV];
      lpPixel7^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide7 to QWide8 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel8 := @PHugeByteArray(Bitmap8)^[QWideV];
      lpPixel8^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
    BlockWrite(OutF1, Bitmap5^, QWide5);
    BlockWrite(OutF2, Bitmap6^, QWide6);
    BlockWrite(OutF1, Bitmap7^, QWide7);
    BlockWrite(OutF2, Bitmap8^, QWide8);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  CloseFile(OutF5);
  CloseFile(OutF6);
  CloseFile(OutF7);
  CloseFile(OutF8);
  {RENAME and EVERYTHING 6of8}


{Group 7 of 8}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight7));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight7));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight7));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight7));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);
  NumberName;
  OutFileName5 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide5));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight7));
  AssignFile(OutF5, OutFileName5);
  Rewrite(OutF5, 1);
  NumberName;
  OutFileName6 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide6));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight7));
  AssignFile(OutF6, OutFileName6);
  Rewrite(OutF6, 1);
  NumberName;
  OutFileName7 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide7));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight7));
  AssignFile(OutF7, OutFileName7);
  Rewrite(OutF7, 1);
  NumberName;
  OutFileName8 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide8));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight7));
  AssignFile(OutF8, OutFileName8);
  Rewrite(OutF8, 1);

  for IV := QHeight6 to QHeight7 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight7);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide4 to QWide5 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel5 := @PHugeByteArray(Bitmap5)^[QWideV];
      lpPixel5^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide5 to QWide6 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel6 := @PHugeByteArray(Bitmap6)^[QWideV];
      lpPixel6^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide6 to QWide7 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel7 := @PHugeByteArray(Bitmap7)^[QWideV];
      lpPixel7^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide7 to QWide8 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel8 := @PHugeByteArray(Bitmap8)^[QWideV];
      lpPixel8^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
    BlockWrite(OutF1, Bitmap5^, QWide5);
    BlockWrite(OutF2, Bitmap6^, QWide6);
    BlockWrite(OutF1, Bitmap7^, QWide7);
    BlockWrite(OutF2, Bitmap8^, QWide8);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  CloseFile(OutF5);
  CloseFile(OutF6);
  CloseFile(OutF7);
  CloseFile(OutF8);
  {RENAME and EVERYTHING 7of8}


{Group 8 of 8}
  NumberName;
  OutFileName1 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight8));
  AssignFile(OutF1, OutFileName1);
  Rewrite(OutF1, 1);
  NumberName;
  OutFileName2 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide2));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight8));
  AssignFile(OutF2, OutFileName2);
  Rewrite(OutF2, 1);
  NumberName;
  OutFileName3 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide3));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight8));
  AssignFile(OutF3, OutFileName3);
  Rewrite(OutF3, 1);
  NumberName;
  OutFileName4 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide4));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight8));
  AssignFile(OutF4, OutFileName4);
  Rewrite(OutF4, 1);
  NumberName;
  OutFileName5 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide5));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight8));
  AssignFile(OutF5, OutFileName5);
  Rewrite(OutF5, 1);
  NumberName;
  OutFileName6 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide6));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight8));
  AssignFile(OutF6, OutFileName6);
  Rewrite(OutF6, 1);
  NumberName;
  OutFileName7 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide7));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight8));
  AssignFile(OutF7, OutFileName7);
  Rewrite(OutF7, 1);
  NumberName;
  OutFileName8 := ImagePath + GRIPFileName;
  PBands.DISDividedMemo.Lines.Append(GRIPFileName);
  PBands.DISDividedMemo.Lines.Append(IntToStr(QWide8));
  PBands.DISDividedMemo.Lines.Append(IntToStr(QHeight8));
  AssignFile(OutF8, OutFileName8);
  Rewrite(OutF8, 1);

  for IV := QHeight7 to QHeight8 - 1 do begin
    DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight8);
    Application.ProcessMessages;
    BlockRead(InF1, InBitmap^, 1);
    QWideV := 0;
    for I := LeftColumn to QWide1 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel1 := @PHugeByteArray(Bitmap1)^[QWideV];
      lpPixel1^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide1 to QWide2 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel2 := @PHugeByteArray(Bitmap2)^[QWideV];
      lpPixel2^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide2 to QWide3 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel3 := @PHugeByteArray(Bitmap3)^[QWideV];
      lpPixel3^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide3 to QWide4 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel4 := @PHugeByteArray(Bitmap4)^[QWideV];
      lpPixel4^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide4 to QWide5 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel5 := @PHugeByteArray(Bitmap5)^[QWideV];
      lpPixel5^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide5 to QWide6 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel6 := @PHugeByteArray(Bitmap6)^[QWideV];
      lpPixel6^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide6 to QWide7 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel7 := @PHugeByteArray(Bitmap7)^[QWideV];
      lpPixel7^ := BlueColor;
      inc(QWideV);
    end;
    QWideV := 0;
    for I := QWide7 to QWide8 - 1 do
    begin
      lpPixelIn := @PHugeByteArray(InBitmap)^[I];
      BlueColor := lpPixelIn^;
      lpPixel8 := @PHugeByteArray(Bitmap8)^[QWideV];
      lpPixel8^ := BlueColor;
      inc(QWideV);
    end;
    BlockWrite(OutF1, Bitmap1^, QWide1);
    BlockWrite(OutF2, Bitmap2^, QWide2);
    BlockWrite(OutF1, Bitmap3^, QWide3);
    BlockWrite(OutF2, Bitmap4^, QWide4);
    BlockWrite(OutF1, Bitmap5^, QWide5);
    BlockWrite(OutF2, Bitmap6^, QWide6);
    BlockWrite(OutF1, Bitmap7^, QWide7);
    BlockWrite(OutF2, Bitmap8^, QWide8);
  end;
  CloseFile(OutF1);
  CloseFile(OutF2);
  CloseFile(OutF3);
  CloseFile(OutF4);
  CloseFile(OutF5);
  CloseFile(OutF6);
  CloseFile(OutF7);
  CloseFile(OutF8);
  {RENAME and EVERYTHING 8of8}


  DisProcessForm.RadarGauge.Progress := 0;
  CloseFile(InF1);
  GlobalUnlock(hBitmapIn);
  GlobalFree(hBitmapIn);
  GlobalUnlock(hBitmap1);
  GlobalFree(hBitmap1);
  GlobalUnlock(hBitmap2);
  GlobalFree(hBitmap2);
  GlobalUnlock(hBitmap3);
  GlobalFree(hBitmap3);
  GlobalUnlock(hBitmap4);
  GlobalFree(hBitmap4);
  GlobalUnlock(hBitmap5);
  GlobalFree(hBitmap5);
  GlobalUnlock(hBitmap6);
  GlobalFree(hBitmap6);
  GlobalUnlock(hBitmap7);
  GlobalFree(hBitmap7);
  GlobalUnlock(hBitmap8);
  GlobalFree(hBitmap8);
end;
(******************************************************)


(******************************************************)
(******************************************************)
{Get the file names and the Width and Height info from
  PBands.DISDividedMemo.Lines.Append(FileName);
  PBands.DISDividedMemo.Lines.Append( IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append( IntToStr(QHeight1));  }
{  DISProcessMemo.Lines.Append(CombinedFileEdit.Text);}
{BandFile1
BandFile2}

procedure Do_CombineImageFiles2V;
var
  QWide1, QHeight1, QWide2, QHeight2, I: Integer;
  OutF1, F1, F2: file;
  BlueColor: Byte;
  InLineSize1, InLineSize2, LineSize, IV: Integer;
  InFileName1, InFileName2, OutFileName: string;
begin
  QWide1 := 0;
  QHeight1 := 0;
  QWide2 := 0;
  QHeight2 := 0;
  for I := 0 to PBands.DISDividedMemo.Lines.Count - 1 do
  begin
    if (PBands.DISDividedMemo.Lines[I] = ExtractFileName(BandFile1))
      then
    begin
      QWide1 := StrToInt(PBands.DISDividedMemo.Lines[I + 1]);
      QHeight1 := StrToInt(PBands.DISDividedMemo.Lines[I + 2]);
    end;
  end;
  for I := 0 to PBands.DISDividedMemo.Lines.Count - 1 do
  begin
    if (PBands.DISDividedMemo.Lines[I] = ExtractFileName(BandFile2))
      then
    begin
      QWide2 := StrToInt(PBands.DISDividedMemo.Lines[I + 1]);
      QHeight2 := StrToInt(PBands.DISDividedMemo.Lines[I + 2]);
    end;
  end;
  if ((QWide1 > 0) and (QWide2 > 0) and (QWide1 = QWide2)) then
  begin
    DisProcessForm.RadarGauge.Progress := 1;
    DisProcessForm.IM_Hints.Caption := 'Processing Band 1';
    InLineSize1 := (sizeof(byte) * ((QWide1)));
    InLineSize2 := (sizeof(byte) * ((QWide2)));
    LineSize := (sizeof(byte) * ((QWide1 + QWide2)));

    hBlueBitmap := GlobalAlloc(GHND, InLineSize1);
    BlueBitmap := GlobalLock(hBlueBitmap);
    hGreenBitmap := GlobalAlloc(GHND, InLineSize2);
    GreenBitmap := GlobalLock(hGreenBitmap);
    hRedBitmap := GlobalAlloc(GHND, LineSize); {New file}
    RedBitmap := GlobalLock(hRedBitmap);
    InFileName1 := BandFile1;
    AssignFile(F1, InFileName1);
    Reset(F1, InLineSize1);
    InFileName2 := BandFile2;
    AssignFile(F2, InFileName2);
    Reset(F2, InLineSize2);

    GRIPFileName := DisProcessForm.CombinedFileEdit.Text;
    NumberName;
    PBands.DISProcessMemo.Lines.Append(GRIPFileName);
    DisProcessForm.CombinedFileEdit.Text := GRIPFileName;
    OutFileName := ImagePath + GRIPFileName;
    AssignFile(OutF1, OutFileName);
    Rewrite(OutF1, 1);


    for IV := 0 to QHeight1 - 1 do
    begin
      DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight1);
      Application.ProcessMessages;
      BlockRead(F1, BlueBitmap^, 1);
      for I := 0 to QWide1 - 1 do
      begin
        lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
        BlueColor := lpPixelB^;
        lpPixelR := @PHugeByteArray(RedBitmap)^[I];
        lpPixelR^ := BlueColor;
      end;
      BlockWrite(F2, RedBitmap^, QWide1);
    end;
    CloseFile(F2);
    for IV := 0 to QHeight2 - 1 do
    begin
      DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight2);
      Application.ProcessMessages;
      BlockRead(F1, GreenBitmap^, 1);
      for I := 0 to QWide2 - 1 do
      begin
        lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
        BlueColor := lpPixelG^;
        lpPixelR := @PHugeByteArray(RedBitmap)^[I];
        lpPixelR^ := BlueColor;
      end;
      BlockWrite(F2, RedBitmap^, QWide2);
    end;
    CloseFile(F1);
    CloseFile(OutF1);
    DisProcessForm.RadarGauge.Progress := 0;
    GlobalUnlock(hGreenBitmap);
    GlobalFree(hGreenBitmap);
    GlobalUnlock(hRedBitmap);
    GlobalFree(hRedBitmap);
    GlobalUnlock(hBlueBitmap);
    GlobalFree(hBlueBitmap);
  end else DoMessages(39992);
end;

procedure Do_CombineImageFiles2H;
var
  Horz2, {OutWide,} QWide1, QHeight1, QWide2, QHeight2, I: Integer;
  OutF1, F1, F2: file;
  BlueColor: Byte;
  InLineSize1, InLineSize2, LineSize, IV: Integer;
  InFileName1, InFileName2, OutFileName: string;
begin
  QWide1 := 0;
  QHeight1 := 0;
  QWide2 := 0;
  QHeight2 := 0;
  for I := 0 to PBands.DISDividedMemo.Lines.Count - 1 do
  begin
    if (PBands.DISDividedMemo.Lines[I] = ExtractFileName(BandFile1))
      then
    begin
      QWide1 := StrToInt(PBands.DISDividedMemo.Lines[I + 1]);
      QHeight1 := StrToInt(PBands.DISDividedMemo.Lines[I + 2]);
    end;
  end;
  for I := 0 to PBands.DISDividedMemo.Lines.Count - 1 do
  begin
    if (PBands.DISDividedMemo.Lines[I] = ExtractFileName(BandFile2))
      then
    begin
      QWide2 := StrToInt(PBands.DISDividedMemo.Lines[I + 1]);
      QHeight2 := StrToInt(PBands.DISDividedMemo.Lines[I + 2]);
    end;
  end;
  if ((QHeight1 > 0) and (QHeight2 > 0) and (QHeight1 = QHeight2))
    then
  begin
{OutWide:= QWide1+QWide2; }
    DisProcessForm.RadarGauge.Progress := 1;
    DisProcessForm.IM_Hints.Caption := 'Processing Band 1';
    InLineSize1 := (sizeof(byte) * ((QWide1)));
    InLineSize2 := (sizeof(byte) * ((QWide2)));
    LineSize := (sizeof(byte) * ((QWide1 + QWide2)));

    hBlueBitmap := GlobalAlloc(GHND, InLineSize1);
    BlueBitmap := GlobalLock(hBlueBitmap);
    hGreenBitmap := GlobalAlloc(GHND, InLineSize2);
    GreenBitmap := GlobalLock(hGreenBitmap);
    hRedBitmap := GlobalAlloc(GHND, LineSize); {New file}
    RedBitmap := GlobalLock(hRedBitmap);
    InFileName1 := BandFile1;
    AssignFile(F1, InFileName1);
    Reset(F1, InLineSize1);
    InFileName2 := BandFile2;
    AssignFile(F2, InFileName2);
    Reset(F2, InLineSize2);

    GRIPFileName := DisProcessForm.CombinedFileEdit.Text;
    NumberName;
    PBands.DISProcessMemo.Lines.Append(GRIPFileName);
    DisProcessForm.CombinedFileEdit.Text := GRIPFileName;
    OutFileName := ImagePath + GRIPFileName;
    AssignFile(OutF1, OutFileName);
    Rewrite(OutF1, 1);


    for IV := 0 to QHeight1 - 1 do
    begin
      DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight1);
      Application.ProcessMessages;
      BlockRead(F1, BlueBitmap^, 1);
      for I := 0 to QWide1 - 1 do
      begin
        lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
        BlueColor := lpPixelB^;
        lpPixelR := @PHugeByteArray(RedBitmap)^[I];
        lpPixelR^ := BlueColor;
      end;
      Horz2 := QWide1;
      BlockRead(F1, GreenBitmap^, 1);
      for I := 0 to QWide2 - 1 do
      begin
        lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
        BlueColor := lpPixelG^;
        lpPixelR := @PHugeByteArray(RedBitmap)^[Horz2];
        lpPixelR^ := BlueColor;
        inc(Horz2);
      end;
      BlockWrite(F2, RedBitmap^, LineSize);
    end;
    CloseFile(F2);
(*   For IV := 0 to QHeight2-1 Do
   begin
      PBands.RadarGauge.Progress:= (( IV*100) div QHeight2);
      Application.ProcessMessages;
      BlockRead(F1, GreenBitmap^,1);
      For I := 0 to QWide2-1 do
      Begin
      lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
      BlueColor  := lpPixelG^;
      lpPixelR := @PHugeByteArray(RedBitmap)^[I];
      lpPixelR^ := BlueColor;
      end;
      BlockWrite(F2, RedBitmap^,QWide2);
   end;*)
    CloseFile(F1);
    CloseFile(OutF1);
    DisProcessForm.RadarGauge.Progress := 0;
    GlobalUnlock(hGreenBitmap);
    GlobalFree(hGreenBitmap);
    GlobalUnlock(hRedBitmap);
    GlobalFree(hRedBitmap);
    GlobalUnlock(hBlueBitmap);
    GlobalFree(hBlueBitmap);
  end else DoMessages(39991);
end;

{Get the file names and the Width and Height info from
  PBands.DISDividedMemo.Lines.Append(FileName);
  PBands.DISDividedMemo.Lines.Append( IntToStr(QWide1));
  PBands.DISDividedMemo.Lines.Append( IntToStr(QHeight1));  }
{  DISProcessMemo.Lines.Append(CombinedFileEdit.Text);}
{BandFile1  BandFile2
BandFile3   BandFile4
1+3  2+4 =same width
1+2  3+4  same height}

procedure Do_CombineImageFiles4;
var
  Horz2, {OutWide,}
    QWide1, QHeight1, QWide2, QHeight2,
    QWide3, QHeight3, QWide4, QHeight4, I: Integer;
  OutF1, F1, F2 {,F3,F4}: file;
  BlueColor: Byte;
  InLineSize1, InLineSize2,
  {InLineSize3,InLineSize4,} LineSize, IV: Integer;
  InFileName1, InFileName2,
  {InFileName3,InFileName4,} OutFileName: string;
begin
  QWide1 := 0; QHeight1 := 0;
  QWide2 := 0; QHeight2 := 0;
  QWide3 := 0; QHeight3 := 0;
  QWide4 := 0; QHeight4 := 0;
  for I := 0 to PBands.DISDividedMemo.Lines.Count - 1 do
  begin
    if (PBands.DISDividedMemo.Lines[I] = ExtractFileName(BandFile1))
      then
    begin
      QWide1 := StrToInt(PBands.DISDividedMemo.Lines[I + 1]);
      QHeight1 := StrToInt(PBands.DISDividedMemo.Lines[I + 2]);
    end;
  end;
  for I := 0 to PBands.DISDividedMemo.Lines.Count - 1 do
  begin
    if (PBands.DISDividedMemo.Lines[I] = ExtractFileName(BandFile2))
      then
    begin
      QWide2 := StrToInt(PBands.DISDividedMemo.Lines[I + 1]);
      QHeight2 := StrToInt(PBands.DISDividedMemo.Lines[I + 2]);
    end;
  end;
  for I := 0 to PBands.DISDividedMemo.Lines.Count - 1 do
  begin
    if (PBands.DISDividedMemo.Lines[I] = ExtractFileName(BandFile3))
      then
    begin
      QWide3 := StrToInt(PBands.DISDividedMemo.Lines[I + 1]);
      QHeight3 := StrToInt(PBands.DISDividedMemo.Lines[I + 2]);
    end;
  end;
  for I := 0 to PBands.DISDividedMemo.Lines.Count - 1 do
  begin
    if (PBands.DISDividedMemo.Lines[I] = ExtractFileName(BandFile4))
      then
    begin
      QWide4 := StrToInt(PBands.DISDividedMemo.Lines[I + 1]);
      QHeight4 := StrToInt(PBands.DISDividedMemo.Lines[I + 2]);
    end;
  end;
{BandFile1  BandFile2
BandFile3   BandFile4
1+3  2+4 =same width
1+2  3+4  same height}
  if ((QHeight1 > 0)
    and (QHeight2 > 0)
    and (QHeight3 > 0)
    and (QHeight4 > 0)
    and (QHeight1 = QHeight2)
    and (QHeight3 = QHeight4)
    and (QWide1 = QWide3)
    and (QWide2 = QWide4)) then
  begin
{OutWide:= QWide1+QWide2; }
    DisProcessForm.RadarGauge.Progress := 1;
    DisProcessForm.IM_Hints.Caption := 'Combining 4 Bands';
    InLineSize1 := (sizeof(byte) * ((QWide1)));
    InLineSize2 := (sizeof(byte) * ((QWide2)));
    LineSize := (sizeof(byte) * ((QWide1 + QWide2)));

    hBlueBitmap := GlobalAlloc(GHND, InLineSize1);
    BlueBitmap := GlobalLock(hBlueBitmap);
    hGreenBitmap := GlobalAlloc(GHND, InLineSize2);
    GreenBitmap := GlobalLock(hGreenBitmap);
    hRedBitmap := GlobalAlloc(GHND, LineSize); {New file}
    RedBitmap := GlobalLock(hRedBitmap);
    InFileName1 := BandFile1;
    AssignFile(F1, InFileName1);
    Reset(F1, InLineSize1);
    InFileName2 := BandFile2;
    AssignFile(F2, InFileName2);
    Reset(F2, InLineSize2);

    GRIPFileName := DisProcessForm.CombinedFileEdit.Text;
    NumberName;
    PBands.DISProcessMemo.Lines.Append(GRIPFileName);
    DisProcessForm.CombinedFileEdit.Text := GRIPFileName;
    OutFileName := ImagePath + GRIPFileName;
    AssignFile(OutF1, OutFileName);
    Rewrite(OutF1, 1);


    for IV := 0 to QHeight1 - 1 do
    begin
      DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight1);
      Application.ProcessMessages;
      BlockRead(F1, BlueBitmap^, 1);
      for I := 0 to QWide1 - 1 do
      begin
        lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
        BlueColor := lpPixelB^;
        lpPixelR := @PHugeByteArray(RedBitmap)^[I];
        lpPixelR^ := BlueColor;
      end;
      Horz2 := QWide1;
      BlockRead(F2, GreenBitmap^, 1);
      for I := 0 to QWide2 - 1 do
      begin
        lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
        BlueColor := lpPixelG^;
        lpPixelR := @PHugeByteArray(RedBitmap)^[Horz2];
        lpPixelR^ := BlueColor;
        inc(Horz2);
      end;
      BlockWrite(OutF1, RedBitmap^, LineSize);
    end;
    CloseFile(F1);
    CloseFile(F2);

    InFileName1 := BandFile3;
    AssignFile(F1, InFileName1);
    Reset(F1, InLineSize1);
    InFileName2 := BandFile4;
    AssignFile(F2, InFileName2);
    Reset(F2, InLineSize2);
    for IV := 0 to QHeight3 - 1 do
    begin
      DisProcessForm.RadarGauge.Progress := ((IV * 100) div QHeight3);
      Application.ProcessMessages;
      BlockRead(F1, BlueBitmap^, 1);
      for I := 0 to QWide1 - 1 do
      begin
        lpPixelB := @PHugeByteArray(BlueBitmap)^[I];
        BlueColor := lpPixelB^;
        lpPixelR := @PHugeByteArray(RedBitmap)^[I];
        lpPixelR^ := BlueColor;
      end;
      Horz2 := QWide1;
      BlockRead(F2, GreenBitmap^, 1);
      for I := 0 to QWide2 - 1 do
      begin
        lpPixelG := @PHugeByteArray(GreenBitmap)^[I];
        BlueColor := lpPixelG^;
        lpPixelR := @PHugeByteArray(RedBitmap)^[Horz2];
        lpPixelR^ := BlueColor;
        inc(Horz2);
      end;
      BlockWrite(OutF1, RedBitmap^, LineSize);
    end;


    CloseFile(F1);
    CloseFile(F2);
    CloseFile(OutF1);
    DisProcessForm.RadarGauge.Progress := 0;
    GlobalUnlock(hGreenBitmap);
    GlobalFree(hGreenBitmap);
    GlobalUnlock(hRedBitmap);
    GlobalFree(hRedBitmap);
    GlobalUnlock(hBlueBitmap);
    GlobalFree(hBlueBitmap);
  end else DoMessages(39990);
end;
(******************************************************)
(******************************************************)


(******************************************************)
(******************************************************)


(******************************************************)
(******************************************************)




{BEGIN   optional }
{ Insert initialization statements here }
end.
